#ifndef	_CRI_LSC_H_INCLUDED
#define	_CRI_LSC_H_INCLUDED
/****************************************************************************/
/*																			*/
/*			$title$ AXg[Rg[ Cu					*/
/*				LSC (Linking Stream Controller) Library						*/
/*																			*/
/*			Copyright (c) 1999 CSK Research Institute						*/
/*				1998.7.12		written by S.Hosaka							*/
/*																			*/
/****************************************************************************/

/****************************************************************************/
/*	CN[ht@C													*/
/****************************************************************************/

#include	<sj.h>

/****************************************************************************/
/*	萔}N																*/
/****************************************************************************/

/*	Version No.					*/
#define	LSC_VER				"1.10"

/*	őXg[			*/
#define	LSC_STM_MAX			(16)

/*	nȟ				*/
#define	LSC_OBJ_MAX			(8)

/*	t@C̍ő啶		*/
#define	LSC_FNAME_MAX		(40)

/*						*/
#define	LSC_STAT_STOP		(0)
#define	LSC_STAT_WAIT		(1)
#define	LSC_STAT_EXEC		(2)
#define	LSC_STAT_ERR		(3)

/*	Xg[ǂݍ݂̏	*/
#define	LSC_STM_STAT_WAIT	(0)
#define	LSC_STM_STAT_READ	(1)
#define	LSC_STM_STAT_END	(2)

/*	t@C^Cv	*/
#define	LSC_FTYPE_ISO		(0)
#define	LSC_FTYPE_AFS		(1)

/****************************************************************************/
/*	񋓒萔																*/
/****************************************************************************/

/****************************************************************************/
/*	}N																*/
/****************************************************************************/

/****************************************************************************/
/*	f[^^																*/
/****************************************************************************/

/*	G[o^֐				*/
typedef void (*LSC_ERRFN)(void *obj, char *msg);
typedef void (*LSC_STATFN)(void *obj1, void *obj2);

/*	Xg[				*/
#ifndef LSC_SINFO_DEFINED
#define LSC_SINFO_DEFINED
typedef struct _lsc_sinfo {
	long		sid;						/*	Xg[ID				*/
	char		fname[LSC_FNAME_MAX];		/*	t@C					*/
	void		*dir;						/*	fBNg			*/
	long		ofst;						/*	t@C̃ItZbg		*/
	long		fsct;						/*	t@CTCY				*/
	long		stat;						/*	Xg[̓ǂݍݏ	*/
	long		rdsct;						/*	ǂݍ݃ZN^			*/
} LSC_SINFO;
#endif

#ifndef LSC_FP_DEFINED
#define LSC_FP_DEFINED
typedef void	*LSC_FP;
#endif

/*	nh					*/
#ifndef LSC_DEFINED
#define LSC_DEFINED
typedef struct _lsc_obj {
	char		used;						/*	gpۂ				*/
	char		stat;						/*	nh				*/
	char		rdflg;
	char		lpflg;
	char		pause;
	char		rsv1;
	short		rsv2;
	SJ			sj;							/*	Xg[WCg		*/
	SJCK		ck;
	long		bufmin;						/*	obt@ʉl			*/
	long		bsize;
	long		wpos;
	long		rpos;
	long		nstm;						/*	o^Xg[			*/
	LSC_FP		fp;
	long		fsct;
	long		reqsct;
	long		errcnt;
	LSC_SINFO	sinfo[LSC_STM_MAX];			/*	ǂݍݒ̃Xg[	*/
} LSC_OBJ;
typedef LSC_OBJ *LSC;
#endif

/****************************************************************************/
/*	ϐ錾																*/
/****************************************************************************/

/****************************************************************************/
/*	֐錾																*/
/****************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/*						*/
void LSC_Init(void);

/*	I				*/
void LSC_Finish(void);

/*	G[֐̓o^	*/
void LSC_EntryErrFunc(LSC_ERRFN errfn, void *obj);

/*	nh̐			*/
LSC LSC_Create(SJ sj);

/*	nh̏			*/
void LSC_Destroy(LSC lsc);

/*	Xg[̓o^		*/
long LSC_EntryFname(LSC lsc, char *fname);

long LSC_EntryFileRange(LSC lsc, char *fname, void *dir, long ofst, long nsct);

/*	ǂݍ݊Jn			*/
void LSC_Start(LSC lsc);

/*	ǂݍݒ~			*/
void LSC_Stop(LSC lsc);

/*	|[YE|[Y		*/
void LSC_Pause(LSC lsc, long sw);

/*	T[o֐				*/
void LSC_ExecServer(void);

/*	nhԂ̎擾		*/
long LSC_GetStat(LSC lsc);

/*	o^Xg[̎擾	*/
long LSC_GetNumStm(LSC lsc);

/*	ǂݍݒ̃Xg[ID̎擾	*/
long LSC_GetStmId(LSC lsc, long no);

/*	t@C̎擾	*/
char *LSC_GetStmFname(LSC lsc, long sid);

/*	Xg[ǂݍ݂̏Ԏ擾	*/
long LSC_GetStmStat(LSC lsc, long sid);

/*	ǂݍ񂾃f[^TCY̎擾(sector)	*/
long LSC_GetStmRdSct(LSC lsc, long sid);

/*	obt@ʉl̐ݒ	*/
void LSC_SetFlowLimit(LSC lsc, long min);

/*	obt@ʉl̎擾	*/
long LSC_GetFlowLimit(LSC lsc);


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif	/* _CRI_LSC_H_INCLUDED */
