#ifndef	_CRI_SAN_H_INCLUDED
#define	_CRI_SAN_H_INCLUDED
/****************************************************************************/
/*																			*/
/*			$title$ ȈՃAj[V Cu							*/
/*				SAN (Simple Animation) Library								*/
/*																			*/
/*			Copyright (c) 1999 CSK Research Institute						*/
/*				1998.7.28		written by S.Hosaka							*/
/*																			*/
/****************************************************************************/

/****************************************************************************/
/*      CN[ht@C												*/
/*      Include file														*/
/****************************************************************************/

/****************************************************************************/
/*		萔}N															*/
/*		MACRO CONSTANT														*/
/****************************************************************************/

/*	Version No.					*/
#define	SAN_VER					"1.09"

/*	nȟ				*/
/*	Maximum number of handle	*/
#define	SAN_OBJ_MAX				(4)

/*	[h					*/
/*	Composite mode				*/
#define SAN_COMPO_OPEQ			(0x0000)	/*	s						*/
											/*	Opaque						*/
#define SAN_COMPO_TRNSP			(0x0001)	/*	 (_̂)			*/
											/*	Translucent					*/
#define SAN_COMPO_ADD			(0x0002)	/*	Z					*/
											/*	Add							*/
#define SAN_COMPO_LUMI			(0x0004)	/*	~lbZX			*/
											/*	Luminous					*/
#define SAN_COMPO_ALPH3			(0x0005)	/*	3lAt@				*/
											/*	3 step alpha				*/
#define SAN_COMPO_ALPH5			(0x0006)	/*	5lAt@				*/
											/*	5 step alpha				*/
#define SAN_COMPO_ALPH256		(0x0007)	/*	tAt@			*/
											/*	256 step alpha				*/
#define SAN_COMPO_MIX			SAN_COMPO_LUMI
											/*	Mixing composite mode		*/

/*	Px						*/
/*	Brightness					*/
#define	SAN_BRIGHT_MAX			(255)
#define	SAN_BRIGHT_MIN			(0)
#define	SAN_BRIGHT_SRF_MAX		(1.0f)
#define	SAN_BRIGHT_SRF_MIN		(0.0f)

/*	Px̃ftHgl									*/
/*	Sofdec̃ftHgl(sfdfx_mw.hŒ`)				*/
/*	Default value of brightness							*/
/*	It is same with Sofdec(definition in sfdfx_mw.h)	*/
#ifndef MWD_DFL_BRIGHT
#define MWD_DFL_BRIGHT			(0xe0)
#endif

/*	PxItZbg̃ftHgl						*/
/*	Sofdec̃ftHgl(sfdfx_mw.hŒ`)				*/
/*	Default value of brightness offset					*/
/*	It is same with Sofdec(definition in sfdfx_mw.h)	*/
#ifndef MWD_DFL_BRIGHT_OFST
#define MWD_DFL_BRIGHT_OFST		(6)
#endif

/*	\XN[̉s	*/
/*	Depth of screen			*/
#define	SAN_DLZ_MAX				(65536.0f)	/*								*/
											/*	inmost						*/
#define	SAN_DLZ_MIN				(1.0f)		/*	O						*/
											/*	this side					*/

/*	\XN[̉s̃ftHgl		*/
/*	Default value of screen depth				*/
#define SAN_DEF_DLZ				(65536.0f)

/****************************************************************************/
/*		񋓒萔															*/
/*		Enumarate Constants													*/
/****************************************************************************/

/****************************************************************************/
/*		}N															*/
/*		Process MACRO														*/
/****************************************************************************/

/****************************************************************************/
/*		f[^^															*/
/*      Data type declaration												*/
/****************************************************************************/

/*	ȈՃAj[Vt@Cwb_	*/
/*	SAN file header						*/
typedef struct {
	char id_hdr[4];						/*	wb_`NID("SAN ")		*/
										/*	Header chunk ID ("SAN ")		*/
	long len_hdr;						/*	wb_`NTCY			*/
										/*	Header chunk size				*/
	char id_fmt[4];						/*	tH[}bgID					*/
										/*	Format ID						*/
	long npic;							/*	sN`						*/
										/*	Number of picture				*/
	long sx;							/*	̃TCY					*/
										/*	Width of video					*/
	long sy;							/*	c̃TCY					*/
										/*	Height of video					*/
	long psize;							/*	PsN`̃oCg			*/
										/*	Byte per picture				*/
	long vsize;							/*	ff[^̃oCg			*/
										/*	Video size (byte)				*/
	long msize;							/*	}XNf[^̃oCg			*/
										/*	Mask size (byte)				*/
	char mskflg;						/*	}XNf[^邩ۂ		*/
										/*	Mask data flag					*/
	char valph;							/*	ff[^̃l(0 or 3 or 5)	*/
										/*	Alpha value in video data(0/3/5)*/
	short compo_mode;					/*	[h						*/
										/*	Composite mode					*/
	long rsv2[4];						/*	\̈ 2						*/
										/*	Reserved						*/
	char id_dat[4];						/*	f[^`NID				*/
										/*	Data chunk ID					*/
	long len_dat;						/*	f[^`NTCY			*/
										/*	Data chunk size (byte)			*/
	long data;							/*	f[^{						*/
										/*	Data							*/
} SAN_HDR;
typedef	SAN_HDR	*SANHDR;

/*	ȈՃAj[Vnh			*/
/*	SAN handle							*/
#ifndef SAN_DEFINED
#define SAN_DEFINED
typedef void *SAN;
#endif

/*	T[tFX\				*/
/*	Surface information					*/
typedef struct {
	void	*srf;						/*	T[tFX						*/
										/*	Surface							*/
	long	width;						/*	LT[tFXTCY 			*/
										/*	Width of valid surface			*/
	long	height;						/*	LT[tFXTCY 		*/
										/*	Height of valid surface			*/
} SAN_PIC;

/*	G[o^֐						*/
/*	Error entry function				*/
typedef void (*SAN_ERRFN)(void *obj, char *msg);

/****************************************************************************/
/*		ϐ錾															*/
/*		Variable Declaration												*/
/****************************************************************************/

/****************************************************************************/
/*		֐̐錾															*/
/*      Function Declaration												*/
/****************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*==========================================================================*/
/*	ƏI														*/
/*	Initialize and Finalize of Library										*/
/*==========================================================================*/

/*	Cȕ						*/
/*  Initialization of library				*/
void SAN_Init(void);

/*	CȕI					*/
/*  Termination of library					*/
void SAN_Finish(void);

/*	Cȕ(for Kamui)			*/
/*  Initialization of library(for Kaumi)	*/
void SAN_InitKm(void);

/*	CȕI(for Kamui)			*/
/*  Termination of library(for Kaumi)		*/
void SAN_FinishKm(void);

/*	_obt@̐ݒ	*/
/*	Set vertex buffer	*/
void SAN_SetVertexBuffer(void *vbuf);

/*==========================================================================*/
/*	{																*/
/*	Basic Control															*/
/*==========================================================================*/

/*	Ɨ̈TCY̌vZ					*/
/*	Calculation of working area size		*/
long SAN_CalcWorkSize(long ntex);

/*	Ɨ̈TCY̌vZ(for alpha)				*/
/*	Calculation of working area size(for alpha)	*/
long SAN_CalcWorkSizeAlph(long ntex, long alph_flg);

/*	nh̐							*/
/*	Creation of Handle						*/
SAN SAN_Create(void *sandat, long ntex, void *wk);

/*	nh̏							*/
/*	Destroy of Handle						*/
void SAN_Destroy(SAN san);

/*	YUV420f[^V-RAMւ̓]				*/
/*	Transfer YUV420 data to V-RAM			*/
void SAN_LoadTex(SAN san, long sno, long dno);

/*	eNX`̕\						*/
/*	Draw texture							*/
void SAN_Draw(SAN san, long dno);

/*	sN`̎擾						*/
/*	Get number of picture in SAN data		*/
long SAN_GetNumPic(SAN san);

/*==========================================================================*/
/*	\																*/
/*	Display Control															*/
/*==========================================================================*/

/*	\ʒu̐ݒ							*/
/*	Set location of the display				*/
void SAN_SetDispPos(SAN san, float lx, float ly);

/*	\TCY̐ݒ						*/
/*	Set size of the display					*/
void SAN_SetDispSize(SAN san, float sx, float sy);

/*	\XN[̉sl̐ݒ			*/
/*	Get Z coordinary of screen				*/
void SAN_SetDispZ(SAN san, float z);

/*	\XN[̉sl̎擾	(z:1.0-65536.0)	*/
/*	Get Z coordinary of screen	(z:1.0-65536.0)		*/
float SAN_GetDispZ(SAN san);

/*	Px̐ݒ (val= 0-255)					*/
/*	Set brightness (val= 0-255)				*/
void SAN_SetDispBright(SAN san, long val);

/*	Px̎擾								*/
/*	Get brightness							*/
long SAN_GetDispBright(SAN san);

/*	Px̃ItZbgݒ (val= 0-255)		*/
/*	Set brightness offset (value= 0-255)	*/
void SAN_SetDispBrightOfst(SAN san, long val);

/*	PxItZbg̎擾					*/
/*	Get brightness offset					*/
long SAN_GetDispBrightOfst(SAN san);

/*==========================================================================*/
/*	T[tFX															*/
/*	Surface Control															*/
/*==========================================================================*/

/*	T[tFX|Cgpobt@TCY̌vZ	*/
/*	Calcuration size of surface point buffer 	*/
long SAN_CalcSrfBufSize(SAN san, long npnt);

/*	T[tFX|Cgpobt@̐ݒ			*/
/*	Set surface point buffer					*/
void SAN_SetSrfPntBuf(SAN san, long npnt, void *buf, long bsize);

/*	\ʒu̐ݒ								*/
/*	Set display position of surface point		*/
void SAN_SetSrfPos(SAN san, unsigned long no, float lx, float ly, float lz);

/*	\ʒu̎擾								*/
/*	Get display position of surface point		*/
void SAN_GetSrfPos(SAN san, unsigned long no, float *lx, float *ly, float *lz);

/*	Px̐ݒ									*/
/*	Set brightness of surface point				*/
void SAN_SetSrfBright(SAN san, unsigned long no,
									float a, float r, float g, float b);

/*	Px̎擾									*/
/*	Get brightness of surface point				*/
void SAN_GetSrfBright(SAN san, unsigned long no,
									float *a, float *r, float *g, float *b);

/*	PxItZbg̐ݒ						*/
/*	Set brightness offset of surface point		*/
void SAN_SetSrfBrightOfst(SAN san, unsigned long no,
									float a, float r, float g, float b);

/*	PxItZbg̎擾						*/
/*	Get brightness offset of surface point		*/
void SAN_GetSrfBrightOfst(SAN san, unsigned long no,
									float *a, float *r, float *g, float *b);

/*	C[Wʒu̐ݒ							*/
/*	Set image position of surface point			*/
void SAN_SetImgPos(SAN san, unsigned long no, float lx, float ly);

/*	C[Wʒu̎擾							*/
/*	Get image position of surface point			*/
void SAN_GetImgPos(SAN san, unsigned long no, float *lx, float *ly);

/*	C[WTCY̎擾						*/
/*	Get image size								*/
void SAN_GetImgSize(SAN san, long *isx, long *isy);

/*==========================================================================*/
/*	eNX`																*/
/*	Texture																	*/
/*==========================================================================*/

/*	rfIsN`̎擾	*/
void SAN_GetVideoPic(SAN san, long dno, SAN_PIC *pic);

/*	}XNsN`̎擾	*/
void SAN_GetMskPic(SAN san, long dno, SAN_PIC *pic);

/*==========================================================================*/
/*	G[																*/
/*	Error																	*/
/*==========================================================================*/

/*	G[֐̓o^						*/
/*	Entrying function when error happened		*/
void SAN_EntryErrFunc(SAN_ERRFN errfn, void *obj);


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif	/* _CRI_SAN_H_INCLUDED */
