#ifndef _CLASSES_H
#define _CLASSES_H

#include "basapi.h"



#define ERR_INVALID_CLASSNAME      ( ERRORID ) 120

/* Type definitions ***********************************************************/

typedef PVOID PCLASSES;             /* @type PCLASSES | Class names data buffer. */
typedef struct HCLASSES__ *HCLASSES, **PHCLASSES; /* @type HCLASSES | Class names instance handle. */
                                    /* @type PHCLASSES | Pointer to a <t HCLASSES>. */

/*@doc ASRADDED
*/

/* @func This function closes a class names instance. */
/* @rdesc Error code. */
/* @comm This function frees all used resources and invalidates the class names
  instance handle. */
ERRORID CasrCloseClasses(
  HCLASSES hClasses /* @parm <t HCLASSES> | hClasses | Class names instance handle [INPUT]. */
);

/* @func This function imports a class names data buffer. */
/* @rdesc Error code. */
/* @comm The class names data buffer contains a.o. class names and class ID cross-references.
  <nl>This data buffer can be obtained from the PC and conversion tools.
  <nl>A class names instance handle is associated with the imported data. */
ERRORID CasrImportClasses(
  HAPI hApi,
  PCLASSES pClasses,  /* @parm <t PCLASSES> | pClasses | Class names data buffer [INPUT]. */
  PHCLASSES phClasses /* @parm <t PHCLASSES> | phClasses | Class names instance handle [OUTPUT]. */
);

#endif
