#ifndef _MERGE_H
#define _MERGE_H

#include "basapi.h"

#define ERR_INCOMPATIBLE_CONTEXTS  ( ERRORID ) 130
#define ERR_DOUBLE_CLASSNAMES      ( ERRORID ) 131
/*@doc ASRADDED ASRERR 
*/

/*@type ERR_INCOMPATIBLE_CONTEXTS | (130) contexts are of a different type.*/
/*@type ERR_DOUBLE_CLASSNAMES | (131) contexts which contain equal classnames can not be merged.*/

/*@doc ASRADDED
*/

/* @func This function merges two context buffers and their corresponding class buffers. */
/* @rdesc Error code. */
/* @comm The only purpose of this function is to make it possible to use two contexts
         at the same time. It is however not possible to merge two contexts which have
		 classes with the same name.
*/
ERRORID CasrMergeContextsAndClasses(
  HCONT hCont1,  /* @parm <t HCONT> | hCont1 | Context instance handle [INPUT]. */
  HCONT hCont2, /* @parm <t HCONT> | hCont2 | Context instance handle [INPUT]. */
  HCLASSES hClasses1, /* @parm <t PHCLASSES> | phClasses1 | Class names instance handle [INPUT]. */
  HCLASSES hClasses2, /* @parm <t PHCLASSES> | phClasses2 | Class names instance handle [INPUT]. */
  PHCONT phContResult, /*@parm <t PHCONT> | phContResult | Pointer to the context handle [OUTPUT].*/
  PHCLASSES phClassesResult /* @parm <t PHCLASSES> | phClassesResult | Class names instance handle [OUTPUT].*/
);

#endif
