/*
	Ninja Library
	
	COPYRIGHT (C) SEGA ENTERPRISES,LTD.

*/
#ifndef _NJ_CNK_INTENSITY_H_
#define _NJ_CNK_INTENSITY_H_

typedef enum {
	NJD_CNK_INTENSITY_MODE_DIR,
	NJD_CNK_INTENSITY_MODE_POINT,
	NJD_CNK_INTENSITY_MODE_DIR_POINT
} NJD_CNK_INTENSITY_MODE;

typedef enum {
	NJD_CNK_INTENSITY_LIGHT_0,
	NJD_CNK_INTENSITY_LIGHT_1,
	NJD_CNK_INTENSITY_LIGHT_2,
	NJD_CNK_INTENSITY_LIGHT_3,
	NJD_CNK_INTENSITY_LIGHT_4,
	NJD_CNK_INTENSITY_LIGHT_5,
	NJD_CNK_INTENSITY_LIGHT_6,
	NJD_CNK_INTENSITY_LIGHT_7
} NJD_CNK_INTENSITY_LIGHT;

typedef enum {
	NJD_CNK_INTENSITY_EXP_16,
	NJD_CNK_INTENSITY_EXP_32
} NJD_CNK_INTENSITY_EXP;

typedef struct {
	Float	fZ;						// 3DZW
	Float	fX;						// XN[XW
	Float	fY;						// XN[YW
	Float	fW;						// XN[WW
	Float	fDiff;					// Base Intensity
	Float	fSpec;					// Offset Intensity
	Float	fNx;					// @X
	Float	fNy;					// @Y
} NJS_CNK_INTENSITY_BUF;

typedef struct {
	NJD_CNK_INTENSITY_MODE eMode;
	Float		fX0;				// ֐ŃZbg郏[N(Vector/Point)
	Float		fY0;
	Float		fZ0;
	Float		fX1;				// DIR_POINT̂ƂɎg[NB
	Float		fY1;				// Matrices֐Ă΂ꂽƂɏ܂
	Float		fZ1;
	Uint32		pad[1];
} NJS_CNK_INTENSITY_W0;

typedef struct {
	Float		fX;					// ŏIIɌvZɎg[NB
	Float		fY;					// DIR/POINTMatrices֐ŏ܂
	Float		fZ;					// DIR_POINT̂Ƃ͊KwƂɏ܂
	Float		fFar;				// FAR~b^[
	Float		fNear;				// NEAR~b^[
	Float		fDiff;
	Float		fSpec;
	Uint32		pad[1];
} NJS_CNK_INTENSITY_W1;

typedef struct {
	Uint32		nFlags;				// %0000 = END/CONT | EXP32/16 | POINT/DIR | ON/OFF
	Float		fDiffR;				// Global Diff Color R
	Float		fDiffG;				// Global Diff Color G
	Float		fDiffB;				// Global Diff Color B
	Float		fOffsDiff;			// fBt[Y։Zl
	Float		fOffsSpec;			// XyL[։Zl
	Uint32		nTSP;				// meNX`ɒeNX`p[^
	Uint32		nTCW;				// meNX`ɒeNX`p[^
	Float		fConstDiff;			// @Ȃ_̂Ƃ̃fBt[Yl
	Float		fConstSpec;			// @Ȃ_̂Ƃ̃XyL[l
	Float		fEnvRatioU;			// }bvUl̔䗦
	Float		fEnvRatioV;			// }bvVl̔䗦
	Float		fSpecR;				// Global Spec Color R
	Float		fSpecG;				// Global Spec Color G
	Float		fSpecB;				// Global Spec Color B
	Uint32		pad[1];				// 32 Byte Align
	NJS_CNK_INTENSITY_W1 sW1[8];
	NJS_CNK_INTENSITY_W0 sW0[8];
} NJS_CNK_INTENSITY_WORK;

extern NJS_CNK_INTENSITY_WORK _nj_cnk_intensity_;

void	njCnkIntensityLoadTexture( void );
void	njCnkIntensityReleaseTexture( void );
void	njCnkIntensityLightInit( Uint32 nNum );

void	njCnkSetIntensityLightDiffColor( Float fR, Float fG, Float fB );
void	njCnkSetIntensityLightSpecColor( Float fR, Float fG, Float fB );
void	njCnkSetIntensityLightOffset( Float fOffsSpec, Float fOffsDiff );
void	njCnkSetIntensityLightConst( Float fConstSpec, Float fConstDiff );
void	njCnkSetIntensityLightEnvRatio( Float fU, Float fV );

void	njCnkSetIntensityLightMode( NJD_CNK_INTENSITY_LIGHT eLight, NJD_CNK_INTENSITY_MODE eMode );
void	njCnkSetIntensityLightSwitch( NJD_CNK_INTENSITY_LIGHT eLight, Sint32 bSwitch );
void	njCnkSetIntensityLightVector( NJD_CNK_INTENSITY_LIGHT eLight, Float fX, Float fY, Float fZ );
void	njCnkSetIntensityLightPoint( NJD_CNK_INTENSITY_LIGHT eLight, Float fX, Float fY, Float fZ );
void	njCnkSetIntensityLightExp( NJD_CNK_INTENSITY_LIGHT eLight, NJD_CNK_INTENSITY_EXP eExp );
void	njCnkSetIntensityLightSet( NJD_CNK_INTENSITY_LIGHT eLight, Float fSpec, Float fDiff );
void	njCnkSetIntensityLightRange( NJD_CNK_INTENSITY_LIGHT eLight, Float fNear, Float fFar );

void	njCnkSetIntensityLightMatrices( void );
Sint32  njCnkIntensityDrawModel( NJS_CNK_MODEL *model );
void    njCnkIntensityDrawObject( NJS_CNK_OBJECT *object );

#endif
