#ifndef	_CRI_ADXF_H_INCLUDED
#define	_CRI_ADXF_H_INCLUDED
/****************************************************************************/
/*																			*/
/*			$title$ `cwt@CVXe Cu						*/
/*				ADXF (ADX File System) Library								*/
/*																			*/
/*			Copyright (c) 1998 CSK Research Institute						*/
/*				1998.7.3		written by S.Hosaka							*/
/*																			*/
/****************************************************************************/

/****************************************************************************/
/*      CN[ht@C												*/
/*      Include file														*/
/****************************************************************************/

#include	<sj.h>

/****************************************************************************/
/*		萔}N															*/
/*		MACRO CONSTANT														*/
/****************************************************************************/

/*	Version number of ADX File System	*/
#define	ADXF_VER				"5.77"

/*	t@C̕				*/
/*	Maximum number of file name strings	*/
#define ADXF_FNAME_MAX    		(40)

/*	őp[eBV				*/
/*	Maximum number of partition			*/
#define	ADXF_PART_MAX			(256)

/*	őt@C						*/
/*	Maximum number of file				*/
#define	ADXF_FILE_MAX			(65536)

/*	ADXFnhIuWFNǧ		*/
/*	Maximum number of ADXF handle		*/
#define	ADXF_OBJ_MAX			(16)

/*	nh̏						*/
/*	Status of handle					*/
#define	ADXF_STAT_STOP			(1)			/*	~						*/
											/*	During standstill			*/
#define ADXF_STAT_READING		(2)			/*	f[^ǂݍݒ			*/
											/*	During data read-in			*/
#define ADXF_STAT_READEND		(3)			/*	f[^ǂݍݏI			*/
											/*	Data read-in end			*/
#define ADXF_STAT_ERROR			(4)			/*	ǂݍ݃G[			*/
											/*	Read-in error outbreak state*/

/*	V[N^Cv						*/
/*	Type of seek						*/
#define	ADXF_SEEK_SET			(0)			/*	t@C̐擪				*/
											/*	The beginning of file		*/
#define ADXF_SEEK_CUR			(1)			/*	݂̈ʒu					*/
											/*	The current position		*/
#define ADXF_SEEK_END			(2)			/*	t@C̏I[				*/
											/*	The end of file				*/

/*	G[R[h						*/
/*	Error code							*/
#define	ADXF_ERR_OK				(0)			/*	I					*/
											/*	Successful					*/
#define	ADXF_ERR_FATAL			(-1)		/*	ÕG[				*/
											/*	Fatal error					*/
#define	ADXF_ERR_INTERNAL		(-2)		/*	̃G[				*/
											/*	Internal error				*/
#define	ADXF_ERR_PRM			(-3)		/*	sȃp[^			*/
											/*	Illegal parameter			*/
#define	ADXF_ERR_AFS_FILE		(-4)		/*	sAFSt@C			*/
											/*	Illegal AFS file			*/

/*	l								*/
/*	Default value						*/
#define	ADXF_DEF_SCT_SIZE		(2048)		/*	CD-ROM̃ZN^TCY		*/
											/*	Sector size in CD-ROM		*/
#define	ADXF_DEF_DMA_ALIGN		(32)		/*	DMÃACg			*/
											/*	Alignment of DMA transfer	*/

#define	ADXF_DEF_REQ_RD_SCT		(512)		/*	[hNGXgTCY		*/
											/*	read request size			*/

/*	fobOp	*/
/*	for Debug	*/
#define	ADXF_CMD_HSTRY_MAX		(256)		/*	R}ȟ			*/
											/*	Number of command history	*/

#define	ADXF_CMD_OPEN			(1)			/*	ADXF_Open					*/
#define	ADXF_CMD_OPEN_AFS		(2)			/*	ADXF_OpenAfs				*/
#define	ADXF_CMD_CLOSE			(3)			/*	ADXF_Close					*/
#define	ADXF_CMD_READ_NW32		(4)			/*	ADXF_ReadNw32				*/
#define	ADXF_CMD_STOP			(5)			/*	ADXF_Stop					*/
#define	ADXF_CMD_SEEK			(6)			/*	ADXF_Seek					*/

#define	ADXF_CMD_NUM_MAX		(16)

/****************************************************************************/
/*		񋓒萔															*/
/*		Enumarate Constants													*/
/****************************************************************************/

/****************************************************************************/
/*		}N															*/
/*		Process MACRO														*/
/****************************************************************************/

/*	p[eBVɕKvȗ̈̌vZ						*/
/*	Calculation of necessary area for partition information		*/

/*	ADXSTM_OpenRange -> ADXSTM_OpenFileRange(1999.8.19)	*/
#if 0
#define	ADXF_PTIF_CMN_SZ		(5*sizeof(long))
#else
//#define	ADXF_PTIF_CMN_SZ		\
//						((4*sizeof(long))+(ADXF_FNAME_MAX*sizeof(char)))
/*	add 'curdir' in ptinfo(2000.4.25)	*/
#define	ADXF_PTIF_CMN_SZ		\
						((5*sizeof(long))+(ADXF_FNAME_MAX*sizeof(char)))
#endif

#define	ADXF_CALC_PTINFO_REAL_SIZE(n)	\
								(ADXF_PTIF_CMN_SZ+(((n)+1)*sizeof(short)))

#define	ADXF_CALC_PTINFO_SIZE(n)	\
					((ADXF_CALC_PTINFO_REAL_SIZE(n)+sizeof(short))/4*4)

#define	ADXF_CALC_ADD_PTINFO_SIZE(n)	\
					(ADXF_PTIF_CMN_SZ+((n)*(2*sizeof(short)+sizeof(long))))

/****************************************************************************/
/*		f[^^															*/
/*      Data type declaration												*/
/****************************************************************************/

#ifndef ADXSTM_DEFINED
#define ADXSTM_DEFINED
typedef void *ADXSTM;
#endif

/*	ADXFnh		*/
/*	ADXF handle			*/
#ifndef ADXF_DEFINED
#define	ADXF_DEFINED
typedef	struct _adx_fs {
	char	used;					/*	gpۂ						*/
	char	stat;					/*	nh̏						*/
	char	sjflag;					/*	Oݒ肳ꂽSJۂ			*/
	char	rev;					/*	\̈							*/
	ADXSTM	stm;					/*	ADXSTMnh						*/
	SJ		sj;						/*	Xg[WCg				*/
#if 0
	/*	ADXSTM_OpenRange -> ADXSTM_OpenFileRange(1999.8.19)	*/
*	long	fad;					/*	t@CAhX					*/
#endif
	long	fnsct;					/*	t@CTCY(ZN^)				*/
	long	fsize;					/*	t@CTCY(oCg)				*/
	long	skpos;					/*	ANZX|C^̈ʒu				*/
	long	rdstpos;				/*	ǂݍ݊Jnʒu					*/
	long	rqsct;					/*	ǂݍݗvf[^(ZN^)		*/
	long	rdsct;					/*	ǂݍ񂾃f[^(ZN^)			*/
	char	*buf;					/*	obt@̃AhX(oCg)			*/
	long	bsize;					/*	obt@̃TCY(oCg)			*/
	long	rqrdsct;				/*	ۂɓǂݍݗv(ZN^)	*/
	/*	ADXSTM_OpenRange -> ADXSTM_OpenFileRange(1999.8.19)	*/
	long	ofst;					/*	ǂݍ݃t@Cւ̃ItZbg		*/
	char	fname[ADXF_FNAME_MAX];	/*	t@C							*/
	void	*dir;
} ADX_FS;
typedef	ADX_FS	*ADXF;
#endif

/*	p[eBV		*/
/*	Partition information	*/
#ifndef ADXF_PTINFO_DEFINED
#define ADXF_PTINFO_DEFINED
typedef struct _adxf_ptinfo {
	struct _adxf_ptinfo	*next;		/*	̃p[eBV(NULL:IWi)	*/
	long				size;		/*	p[eBV̈TCY		*/
#if 0
	/*	ADXSTM_OpenRange -> ADXSTM_OpenFileRange(1999.8.19)	*/
*	long				fad;		/*	p[eBV̐擪FAD				*/
#endif
	long				nfile;		/*	p[eBṼt@C		*/
	unsigned short		nentry;		/*	p[eBV̓o^t@C	*/
	char				type;		/*	IWiǋL̃tO			*/
	char				rev;		/*	\̈							*/
	/*	ADXSTM_OpenRange -> ADXSTM_OpenFileRange(1999.8.19)	*/
	char				fname[ADXF_FNAME_MAX];	/*	AFSt@C			*/
	void				*curdir;
	long				top;		/*	t@C̐擪					*/
} ADXF_PTINFO;
#endif

/*	ǋLt@C̏				*/
/*	Information of postscript file	*/
#ifndef ADXF_ADD_DEFINED
#define ADXF_ADD_DEFINED
typedef struct _adxf_add_info {
	unsigned short	flid;			/*	t@CID							*/
	unsigned short	fnsct;			/*	t@CTCY						*/
	long			ofst;			/*	ItZbg							*/
} ADXF_ADD_INFO;
#endif

#ifndef ADXF_CMD_HSTRY_DEFINED
#define ADXF_CMD_HSTRY_DEFINED
typedef struct _adxf_cmd_hstry {
	unsigned char	cmdid;			/*	R}h(֐)ID					*/
	unsigned char	fg;				/*	֐̓otO	*/
	unsigned short	ncall;			/*	R}ȟĂяo				*/
	long	prm[3];					/*	R}hp[^					*/
} ADXF_CMD_HSTRY;
#endif

/****************************************************************************/
/*		ϐ錾															*/
/*		Variable Declaration												*/
/****************************************************************************/

/****************************************************************************/
/*		֐̐錾															*/
/*      Function Declaration												*/
/****************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*==========================================================================
		CȕƏI
 		Initialize and Finalize of Library
  ==========================================================================*/

/*  Cȕ
 * [@] void ADXF_Init( void );
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] CuB
 *  Initialization of library
 * [Inputs  ] None
 * [Outputs ] None
 * [Return  ] None
 * [Function] Initializes library.
 */
void ADXF_Init(void);

/* CȕI
 * [@] void ADXF_Finish(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] CȕIB
 *  Termination of library
 * [Inputs  ] None
 * [Outputs ] None
 * [Return  ] None
 * [Function] Finalizes library.
 */
void ADXF_Finish(void);

/*  p[eBṼ[h
 * [@] long ADXF_LoadPartition(long ptid, char *fname, 
 *													void *ptinfo, long nfile);
 * [@] ptid	:p[eBVID
 *			fname	:AFSt@C̖O
 *			ptinfo	:p[eBVǂݍݗ̈
 *			nfile	:t@C
 * [o@] Ȃ
 * [֐l] G[R[h
 * [@@\] AFSt@CǂݍŁAp[eBVIDɐݒ肷B
 *  Load of the partition
 * [Inputs  ] ptid   :Partition ID
 *			  fname  :Name of AFS file
 *            ptinfo :Area of partition information
 *            nfile  :The number of files
 * [Outputs ] None
 * [Return  ] Error code
 * [Function] Loads AFS file and sets partition ID.
 */
long ADXF_LoadPartition(long ptid, char *fname, void *ptinfo, long nfile);

/*  p[eBṼ[h(fBNg`FWΉ)
 * [@] long ADXF_LoadPartitionEx(long ptid, char *fname, 
 * 													void *dir, void *ptinfo);
 * [@] ptid	:p[eBVID
 *			fname	:AFSt@C̖O
 *			dir		:fBNg (GDFS:GDFS_DIRREC)
 *			ptinfo	:p[eBVǂݍݗ̈
 * [o@] Ȃ
 * [֐l] G[R[h
 * [@@\] AFSt@CǂݍŁAp[eBVIDɐݒ肷B
 *  Load of the partition(Support directory change)
 * [Inputs  ] ptid   :Partition ID
 *			  fname  :Name of AFS file
 *            dir	 :Directory information (GDFS:GDFS_DIRREC)
 *            ptinfo :Area of partition information
 * [Outputs ] None
 * [Return  ] Error code
 * [Function] Loads AFS file and sets partition ID.
 */
long ADXF_LoadPartitionEx(long ptid, char *fname, void *dir, void *ptinfo);

/*  A^p[eBṼ[h
 * [@] long ADXF_LoadPartitionNw(long ptid, char *fname, 
 * 													void *dir, void *ptinfo);
 * [@] ptid	:p[eBVID
 *			fname	:AFSt@C̖O
 *			dir		:fBNg (GDFS:GDFS_DIRREC)
 *			ptinfo	:p[eBVǂݍݗ̈
 * [o@] Ȃ
 * [֐l] G[R[h
 * [@@\] AFSt@CǂݍŁAp[eBVIDɐݒ肷B
 *  Load of the partition(No wait)
 * [Inputs  ] ptid   :Partition ID
 *			  fname  :Name of AFS file
 *            dir	 :Directory information (GDFS:GDFS_DIRREC)
 *            ptinfo :Area of partition information
 * [Outputs ] None
 * [Return  ] Error code
 * [Function] Loads AFS file and sets partition ID.
 */
long ADXF_LoadPartitionNw(long ptid, char *fname, void *dir, void *ptinfo);

/*  p[eBV̓ǂݍݏԂ̎擾
 * [@] long ADXF_GetPtStat(long ptid);
 * [@] ptid	:p[eBVID
 * [o@] Ȃ
 * [֐l] p[eBV̓ǂݍݏ
 * [@@\] AFSt@CǂݍŁAp[eBVIDɐݒ肷B
 *  Get partition loading state
 * [Inputs  ] ptid   :Partition ID
 * [Outputs ] None
 * [Return  ] Partition loading state
 * [Function] Gets partition loading state.
 */
long ADXF_GetPtStat(long ptid);

/*  p[eBV̒ǉ
 * [@] long ADXF_AddPartition(long ptid, char *fname, 
 *													void *ptinfo, long nfile);
 * [@] ptid	:p[eBVID
 *			fname	:AFSt@C̖O
 *			ptinfo	:p[eBVǂݍݗ̈
 *			nfile	:t@C
 * [o@] Ȃ
 * [֐l] G[R[h
 * [@@\] w肳ꂽp[eBVIDAFSt@CǉB
 *  Additon of the partition
 * [Inputs  ] ptid   :Partition ID
 *			  fname  :Name of AFS file
 *            ptinfo :Area of partition information
 *            nfile  :The number of files
 * [Outputs ] None
 * [Return  ] Error code
 * [Function] Adds AFS file to the partition ID.
 */
long ADXF_AddPartition(long ptid, char *fname, void *ptinfo, long nfile);

/*  p[eBVTCY̎擾
 * [@] long ADXF_GetPtinfoSize(long ptid);
 * [@] ptid	:p[eBVID
 * [o@] Ȃ
 * [֐l] p[eBVTCY(PʁFoCg)
 * [@@\] p[eBV̈̃TCY擾B
 *  Get size of partition information
 * [Inputs  ] ptid   :Partition ID
 * [Outputs ] None
 * [Return  ] Size of the partition information(byte)
 * [Function] Gets size of the partition information.
 */
long ADXF_GetPtinfoSize(long ptid);

/*==========================================================================
		t@C̓ǂݍ
		Read file
  ==========================================================================*/

/*	t@C̃I[v(ISO9660̃t@C)
 * [@] ADXF ADXF_Open(char *fname, void *atr);
 * [@] fname	: t@C
 *			atr		: t@C̑
 * [o@] Ȃ
 * [֐l] ADXFnhAG[̏ꍇNULL
 * [@@\] w̃t@CI[vAADXFnhԂB
 *  Open file(ISO9660 format)
 * [Inputs  ] fname  : File name
 *			  atr    : File attribute
 * [Outputs ] None
 * [Return  ] ADXF handle
 *			  (If the operation was unsuccessful, this function returns NULL.)
 * [Function] Opens a file of ISO9660 format.
 */
ADXF ADXF_Open(char *fname, void *atr);

/*	t@C̃I[v(AFStH[}bg)
 * [@] ADXF ADXF_OpenAfs(long ptid, long flid);
 * [@] ptid	: p[eBVID
 *			flid	: t@CID
 * [o@] Ȃ
 * [֐l] ADXFnhAG[̏ꍇNULL
 * [@@\] p[eBVIDƃt@CIDŎw肳ꂽAFSt@CI[vA
 *			ADXFnhԂB
 *  Open file(AFS format)
 * [Inputs  ] ptid   : Partition ID
 *			  flid   : File ID
 * [Outputs ] None
 * [Return  ] ADXF handle
 *			  (If the operation was unsuccessful, this function returns NULL.)
 * [Function] Opens a file of AFS format.
 */
ADXF ADXF_OpenAfs(long ptid, long flid);

/* t@C̃N[Y
 * [@] void ADXF_Close(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] w肳ꂽADXFnh̃t@CN[YB
 *  Close file
 * [Inputs  ] adxf   : ADXF handle
 * [Outputs ] None
 * [Return  ] None
 * [Function] Closes a file of specific ADXF handle.
 */
void ADXF_Close(ADXF adxf);

/* SẴt@CN[Y
 * [@] void ADXF_CloseAll(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ADXFnh̃t@CSăN[YB
 *  Close file
 * [Inputs  ] None
 * [Outputs ] None
 * [Return  ] None
 * [Function] Closes all file of ADXF handle.
 */
void ADXF_CloseAll(void);

/*  SJւ̃f[^ǂݍ݊Jn
 * [@] void ADXF_ReadSj32(ADXF adxf, long nsct, SJ sj);
 * [@] adxf	: ADXFnh
 *			nsct	: ǂݍ݃f[^̗(PʁFZN^)
 *			SJ		: Xg[WCg
 * [o@] Ȃ
 * [֐l] ǂݍ݃f[^(PʁFZN^)
 * [@@\] Xg[WCgɃf[^ǂݍ݂̃NGXg𔭍sB
 *			Xg[WCg̃obt@TCÝAZN^̐{łȂ
 *			ȂȂB
 *			Xg[WCg烆[Uf[^ǂݏoƁAIɃXg[ *			WCgɃf[^ǂݍ܂B
 *			NGXgANZX삪ƁAANZX|C^
 *			nsctZN^iށB
 *  Read-in start to Stream Joint
 * [Inputs  ] adxf   : ADXF handle
 *			  nsct   : Number of read-in sectors to request
 *			  SJ     : Stream Joint
 * [Outputs ] None
 * [Return  ] Number of sectors to read
 * [Function] Requests data read-in to Stream Joint.
 *			  Buffer size of Stream Joint must be multiples of integer.
 *			  If you read data from Stream Joint, data are read into Stream 
 *			  Joint automatically.
 *			  The access pointer moves 'nsct' sector minute when the request 
 *			  was completed.
 */
long ADXF_ReadSj32(ADXF adxf, long nsct, SJ sj);

/* f[^̓ǂݍ݊Jn
 * [@] void ADXF_ReadNw32(ADXF adxf, long nsct, void *buf);
 * [@] adxf	: ADXFnh
 *			nsct	: ǂݍ݃f[^̗(PʁFZN^)
 *			buf		: ǂݍݗ̈
 * [o@] Ȃ
 * [֐l] ǂݍ݃f[^(PʁFZN^)
 * [@@\] f[^ǂݍ݂̃NGXg𔭍sB
 *			NGXgANZX삪ƁAANZX|C^
 *			nsctZN^iށB
 *  Read-in start
 * [Inputs  ] adxf   : ADXF handle
 *			  nsct   : Number of read-in sectors to request
 *			  buf    : Pointer to buffer into which the data is read
 * [Outputs ] None
 * [Return  ] Number of sectors to read
 * [Function] Requests data read-in to Stream Joint.
 *			  The access pointer moves 'nsct' sector minute when the request 
 *			  was completed.
 */
long ADXF_ReadNw32(ADXF adxf, long nsct, void *buf);

/* f[^̓ǂݍݒ~
 * [@] long ADXF_Stop(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] ~_ł̃ANZX|C^̈ʒu
 * [@@\] f[^̓ǂݍ݂𒆎~B
 *  Read-in stop
 * [Inputs  ] adxf   : ADXF handle
 * [Outputs ] None
 * [Return  ] The location of access pointer when you stop to read
 * [Function] Stops to read data.
 */
long ADXF_Stop(ADXF adxf);

/* T[o֐
 * [@] void ADXF_ExecServer(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ԂXVB
 *  Server function
 * [Inputs  ] None
 * [Outputs ] None
 * [Return  ] None
 * [Function] Update the inside status of library.
 */
void ADXF_ExecServer(void);

/*==========================================================================
		ANZX|C^̐
		Control access pointer
  ==========================================================================*/

/*  ANZX|C^̈ړ
 * [@] long ADXF_Seek(ADXF adxf, long pos, long type);
 * [@] adxf	: ADXFnh
 *			pos		: ANZX|C^̈ړ(PʁFZN^)
 *			type	: ړ(V[N^CvFADXF_SEEK_`)
 * [o@] Ȃ
 * [֐l] ANZX|C^̈ʒuA̒l̓G[R[h
 * [@@\] ANZX|C^typeposZN^ꂽʒuɈړB
 *  Move access pointer
 * [Inputs  ] adxf   : ADXF handle
 *			  pos    : Offset relative to 'type'
 *			  type   : Specified the origin for the offset
 * [Outputs ] None
 * [Return  ] Location containing new seek pointer
 * [Function] Changes the seek pointer to a new location relative to the 
 *			  beginning of the file, to the end of the file, or to the current 
 *			  seek pointer.
 */
long ADXF_Seek(ADXF adxf, long pos, long type);

/*  ANZX|C^̎擾
 * [@] long ADXF_Tell(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] ANZX|C^̈ʒu
 * [@@\] ANZX|C^̈ʒu擾B
 *  Get the access pointer
 * [Inputs  ] adxf   : ADXF handle
 * [Outputs ] None
 * [Return  ] Access pointer
 * [Function] Gets the access pointer.
 */
long ADXF_Tell(ADXF adxf);

/*==========================================================================
		̎擾
		Get information
  ==========================================================================*/

/*  t@CTCY̎擾
 * [@] long ADXF_GetFsizeSct(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] t@CTCY(PʁFZN^)
 * [@@\] w肳ꂽt@C̃TCYZN^PʂŎ擾B
 *  Get file size
 * [Inputs  ] adxf   : ADXF handle
 * [Outputs ] None
 * [Return  ] File size(sector)
 * [Function] Obtains the size of the specified file.
 */
long ADXF_GetFsizeSct(ADXF adxf);

/*  t@CTCY̎擾
 * [@] long ADXF_GetFsizeByte(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] t@CTCY(PʁFoCg)
 * [@@\] w肳ꂽt@C̃TCYoCgPʂŎ擾B
 *  Get file size
 * [Inputs  ] adxf   : ADXF handle
 * [Outputs ] None
 * [Return  ] File size(byte)
 * [Function] Obtains the size of the specified file.
 */
long ADXF_GetFsizeByte(ADXF adxf);

/*  ǂݍݗv̎擾
 * [@] long ADXF_GetNumReqSct(ADXF adxf, long *seekpos);
 * [@] adxf	: ADXFnh
 * [o@] seekpos	: ǂݍ݈ʒu
 * [֐l] vǂݍ݃f[^(PʁFZN^)
 * [@@\] vǂݍ݈ʒuƃf[^ʂ擾B
 *  Get request information
 * [Inputs  ] adxf   : ADXF handle
 * [Outputs ] seekpos: location of start to read
 * [Return  ] Request data size(sector)
 * [Function] Obtains read-in start position and the read-in size that 
 *			  demanded.
 */
long ADXF_GetNumReqSct(ADXF adxf, long *seekpos);

/*  ۂɓǂݍ񂾃ZN^̎擾
 * [@] long ADXF_GetNumReadSct(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] ǂݍ񂾃f[^(PʁFZN^)
 * [@@\] ۂɓǂݍ񂾃f[^ʂ擾B
 *  Get the number of sectors read
 * [Inputs  ] adxf   : ADXF handle
 * [Outputs ] None
 * [Return  ] Size of read data(sector)
 * [Function] Obtains the size of data that read actually.
 */
long ADXF_GetNumReadSct(ADXF adxf);

/*  nh̏Ԃ̎擾
 * [@] long ADXF_GetStat(ADXF adxf);
 * [@] adxf	: ADXFnh
 * [o@] Ȃ
 * [֐l] ADXFnh̓(ԁFADXF_STAT_`)
 * [@@\] ADXFnh̓Ԃ擾B
 *  Get status of handle
 * [Inputs  ] adxf   : ADXF handle
 * [Outputs ] None
 * [Return  ] Status of handle
 * [Function] Gets status of handle.
 */
long ADXF_GetStat(ADXF adxf);

#if 0
/*  FADƃt@CTCY̎擾
 * [@] long ADXF_GetAfsRange(long ptid, long flid, 
 *													long *fad, long *fnsct);
 * [@] ptid	: p[eBVID
 *			flid	: t@CID
 * [o@] fad		: t@CAhX
 *			nsct	: t@CTCY(P:ZN^)
 * [֐l] G[R[h
 * [@@\] p[eBṼt@C̃t@CAhXƃTCY擾B
 *  Get FAD and file size
 * [Inputs  ] ptid   : Partition ID
 *			  flid   : File ID
 * [Outputs ] fad    : File address
 *			  nsct   : File size(sector)
 * [Return  ] Error code
 * [Function] Obtains address and size of file in the partition.
 */
long ADXF_GetFileRange(long ptid, long flid, long *fad, long *fnsct);
#else
long ADXF_GetFnameRange(long ptid, long flid, 
									char *fname, long *ofst, long *fnsct);
#endif

long ADXF_GetFnameRangeEx(long ptid, long flid, 
					char *fname, void **dir, long *ofst, long *fnsct);


/*@[hNGXg̃TCY̐ݒ
 * [@] void ADXF_SetReqRdSct(ADXF adxf, long nsct);
 * [@] adxf    ; ADXFnh
 *			nsct    ; ZN^
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ɓǂݍރTCYݒ肵܂B
 *  Set size of read request
 * [Inputs  ] adxf   : ADXF handle
 *			  nsct   : size(sector)
 * [Outputs ] None
 * [Return  ] None
 * [Function] Sets size of read request(one time).
 */
void ADXF_SetReqRdSct(ADXF adxf, long nsct);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif	/* _CRI_ADXF_H_INCLUDED */
