#ifndef	_ADXT_H_INCLUDED
#define	_ADXT_H_INCLUDED
/****************************************************************************/
/*																			*/
/*			$title$ `cwf[^Đ Cu								*/
/*					ADXT (ADX TALK) Library									*/
/*																			*/
/*				1997.2.25		written M.Oshimi							*/
/*																			*/
/****************************************************************************/

/*	Version number of ADXT library 		*/
#define	ADXT_VER	"5.93"

/*	Xg[WCg				*/
/*	Stream Joint						*/
#ifndef SJ_DEFINED
#define SJ_DEFINED
typedef void *SJ;
#endif


/*	Xg[Rg[				*/
/*	Stream Controller					*/
#ifndef ADXSTM_DEFINED
#define ADXSTM_DEFINED
typedef	void	*ADXSTM;
#endif

/*	Xg[WCgfR[_		*/
/*	Stream Joint decoder				*/
#ifndef ADXSJD_DEFINED
#define ADXSJD_DEFINED
typedef void	*ADXSJD;
#endif

/*	I[fBI_					*/
/*	Audio Renderer						*/
#ifndef ADXRNA_DEFINED
#define ADXRNA_DEFINED
typedef void	*ADXRNA;
#endif

#ifndef TRUE
#define TRUE	1
#endif
#ifndef FALSE
#define FALSE	0
#endif

/****************************************************************************/
/*		萔}N															*/
/*		MACRO CONSTANT														*/
/****************************************************************************/

/*	ő哯						*/
/*	Maximum number of ADXT handle		*/
#define	ADXT_MAX_OBJ		(8)

/*	őf[^TCY					*/
/*	Maximum data size					*/
#define	ADXT_MAX_DATASIZE	(0x40000000)

/*	̓obt@̃GLXg̈̑傫	*/
/*	Size of Extra area in input buffer		*/
#define ADXT_IBUF_XLEN (36)

/*	ADX Talk ̏o̓obt@̑傫@iTvPʁj	*/
/*	Output buffer size of ADX Talk (unit:sample)		*/
#define	ADXT_OBUF_SIZE	(0x2000)
#define	ADXT_OBUF_DIST	(0x2020)

/*	őTvOg				*/
/*	Maximum sampling frequency			*/
#define	ADXT_MAX_SFREQ	(44100)

/*	ADX Talk̍Đ	(ADXT_CALC_WORK}NŎgp)		*/
/*	Play method of ADX Talk (used 'ADXT_CALC_WORK' macro)	*/
#define ADXT_PLY_MEM	(0)			/*	̍Đ					*/
									/*	Play memory data					*/
#define ADXT_PLY_STM	(1)			/*	CD̃Xg[Đ				*/
									/*	Stream play from CD-ROM				*/

#define ADXT_CALC_IBUFSIZE0(nch, sfreq)	(25000*(nch)*((sfreq)/1000)/44)

#define ADXT_CALC_IBUFSIZE(nch, nstm, sfreq)	\
	((ADXT_CALC_IBUFSIZE0(nch, sfreq)*((nstm)+1)+2048)/2048*2048+ADXT_IBUF_XLEN)
#define ADXT_CALC_OBUFSIZE(nch)	\
	( ADXT_OBUF_DIST*(nch)*sizeof(short))
#define ADXT_CALC_WORK(nch, stmflg, nstm, sfreq)	\
	(ADXT_CALC_IBUFSIZE(nch, nstm, sfreq)*(stmflg) + ADXT_CALC_OBUFSIZE(nch) + 32)

/*	f[^eʂ̌vZ		*/
/*	Calc ADX Data size		*/
#define	ADXT_CalcDataLen(sec, nch, sfreq)	(sec*nch*sfreq*18/32 + 256)

/*	̓obt@ւ̓ǂݍݗ						*/
/*	Number of sectors to read into the input buffer	*/
#define ADXT_MAX_CDBSCT		(75)
#define ADXT_MIN_CDBSCT		(65)
#define ADXT_PREP_RDSCT		(25)

/*	$define$ ADX Talk̓(ADXT_STAT_`)	*/
/*	Status of ADX Talk							*/
#define	ADXT_STAT_STOP		(0)		/*	~ 								*/
									/*	During standstill					*/
#define ADXT_STAT_DECINFO	(1)		/*	`cw ̃wb_擾			*/
									/*	Getting header information			*/
#define ADXT_STAT_PREP		(2)		/*	Đ 							*/
									/*	During play preparation				*/
#define ADXT_STAT_PLAYING	(3)		/*	fR[hĐ 					*/
									/*	During decode and play				*/
#define ADXT_STAT_DECEND	(4)		/*	fR[hI 						*/
									/*	Decode end							*/
#define ADXT_STAT_PLAYEND	(5)		/*	ĐI 							*/
									/*	Play end							*/

/*	$define$ ADX Talk̃G[R[h@(ADXT_ERR_`)	*/
/*	Error code of ADX Talk							*/
#define	ADXT_ERR_OK			(0)		/*	 								*/
									/*	Normality							*/
#define ADXT_ERR_SHRTBUF	(-1)	/*	̓obt@GveB				*/
									/*	The input buffer is empty			*/
#define ADXT_ERR_SNDBLK		(-2)	/*	TEhubNG[				*/
									/*	Error of sound block				*/

/*	$define$ tB^[h	(ADXT_FLTMODE_`)		*/
/*	Filter mode										*/
#define	ADXT_FLTMODE_CPU	(0)		/*	botɂWJ[h				*/
									/*	by CPU								*/
#define	ADXT_FLTMODE_SCSP	(1)		/*	AICA-DSPɂWJ[h			*/
									/*	by AICA-DSP							*/

/*	$define$ Đ[h	(ADXT_PMODE_`)				*/
/*	Play mode										*/
#define	ADXT_PMODE_FNAME	(0)		/*	t@C܂ FID ɂw		*/
									/*	Play specified file name or file ID	*/
#define	ADXT_PMODE_AFS		(1)		/*	AFS ɂw						*/
									/*	Play specified AFS file				*/
#define	ADXT_PMODE_MEM		(2)		/*	Đ							*/
									/*	Play data from memory				*/
#define	ADXT_PMODE_SJ		(3)		/*	Xg[WCgĐ			*/
									/*	Play data from StreamJoint			*/
#define	ADXT_PMODE_SLFILE	(4)		/*	V[XAĐit@Cj		*/
									/*	Seamless continuous play from file	*/

/*	$define$ G[Jo[[h	(ADXT_RMODE_`)	*/
/*	Mode of error recovery							*/
#define	ADXT_RMODE_NOACT	(0)		/*	Jo[Ȃ					*/
									/*	Do not recover						*/
#define	ADXT_RMODE_STOP		(1)		/*	~							*/
									/*	Automatic stop						*/
#define	ADXT_RMODE_REPLAY	(2)		/*	ăvC						*/
									/*	Automatic replay					*/

/*	p|bg̐ݒl		*/
/*	Panpot parameter		*/
#define	ADXT_PAN_LEFT		(-15)
#define	ADXT_PAN_CENTER		(0)
#define	ADXT_PAN_RIGHT		(15)
#define	ADXT_PAN_AUTO		(-128)	/*	MONO/STE ɂĎIɐ؂ւ	*/
									/*	Changes automatically by data		*/

/*	XeIĐ̃`lԍ		*/
/*	Channel number playing stereo data	*/
/*	ADXT_CH_L:left, ADXT_CH_R:right		*/
#define	ADXT_CH_L			(0)
#define	ADXT_CH_R			(1)

/*	őĐ`l				*/
/*	Maximum number of play channel		*/
#define	ADXT_MAX_NCH		(2)

/*	T[o֐̌Ăяopx̋Kl@60i/bj				*/
/*	Default value of frequency called server function(times/sec)	*/
#define ADXT_DEF_SVRFREQ	(60)

/*	Default value of output volume(dB)	*/
#define	ADXT_DEF_OUTVOL		(0)

/*	̓obt@̉l (G[pAPʃoCgj				*/
/*	Minimum data in the input buffer(byte) (for coping with error)	*/
#define	ADXT_MIN_BUFDATA	(64)

/*	G[ʎԁ@iP:b)			*/
/*	Error distinction time(sec)			*/
#define	ADXT_EWAIT_PLY		(5)
#define	ADXT_EWAIT_NOTPLY	(20)

/*	CfbNX̍ő吔				*/
/*	Maximum number of index				*/
#define	ADXT_MAX_IDX		(0xFFFF)

/****************************************************************************/
/*		f[^^															*/
/*      Data type declaration												*/
/****************************************************************************/

/*	ADX Talk IuWFNg\		*/
/*	Structure of ADX Talk object	*/
typedef	struct _adx_talk {
	char	used;						/*	gpۂ					*/
	char	stat;						/*							*/
	char	pmode;						/*	Đ[h						*/
	char	maxnch;						/*	őĐ`l			*/
	ADXSJD	sjd;						/*	ADXXg[WCgfR[_	*/
	ADXSTM	stm;						/*	̓Xg[Rg[		*/
	ADXRNA	rna;						/*	I[fBI_				*/
	SJ		sjf;						/*	t@C̓Xg[WCg*/
	SJ		sji;						/*	̓Xg[WCg		*/
	SJ		sjo[ADXT_MAX_NCH];			/*	o̓Xg[WCg		*/
	char	*ibuf;						/*	̓obt@					*/
	long	ibuflen;					/*	̓obt@TCYioCgP)	*/
	long	ibufxlen;					/*	̓obt@GNXgTCY	*/
	short	*obuf;						/*	o̓obt@					*/
	long	obufsize;					/*	o̓obt@TCYiTvj	*/
	long	obufdist;					/*	o̓obt@ԊuiTvj	*/
	long	svrfreq;					/*	T[o֐Ăяopx			*/
	short	maxsct;						/*	̓obt@̍ōZN^	*/
	short	minsct;						/*	̓obt@̍ŒZN^	*/
	short	outvol;						/*	o̓{[					*/
	short	outpan[ADXT_MAX_NCH];		/*	o̓p|bg̐ݒl			*/
	long	maxdecsmpl;					/*	őfR[hTv			*/
	long	lpcnt;						/*	[vJE^					*/
	long	lp_skiplen;					/*	[vXLbvoCg			*/
	long	trp;						/*	gX|[Y (Zg)		*/
	long	wpos;						/*	fBȀ݈ʒu		*/
	long	mofst;						/*	fBÃItZbg			*/
	short	ercode;						/*	G[R[h					*/
	long	edecpos;					/*	G[opfR[hʒu		*/
	short	edeccnt;					/*	fR[hʒuJE^			*/
	short	eshrtcnt;					/*	ޯ̧è			*/
	char	lpflg;						/*	[v邩ۂ				*/
	char	autorcvr;					/*	IɃG[A邩ۂ	*/
	char	fltmode;					/*	tB^[h					*/
	char	execflag;					/*	T[os邩ۂ			*/
	char	pstwait_flag;				/*	o͊Jn҂tO			*/
	char	pstready_flag;				/*	o͏tO			*/
	char	pause_flag;					/*	ꎞ~tO					*/
	void	*amp;						/*	Uo						*/
	SJ		ampsji[ADXT_MAX_NCH];		/*	UopSJ				*/
	SJ		ampsjo[ADXT_MAX_NCH];		/*	UopoSJ				*/
	long	time_ofst;					/*	̃ItZbg				*/
	long	lesct;						/*	[vĐ̍ŏIZN^ԍ	*/
	long	trpnsmpl;					/*			gbvTvԍ	*/
	void	*lsc;						/*	AXg[Rg[		*/
	char	lnkflg;						/*	AĐtO					*/
	char	rsv;						/*	\							*/
	short	rsv2;						/*	\Q							*/
	unsigned long tvofst;				/*	X^[gԃItZbg			*/
	unsigned long svcnt;				/*	X^[gV-SyncJEg			*/
} ADX_TALK;
typedef	ADX_TALK	*ADXT;

/*	CfbNXf[^	*/
/*	Index data			*/
typedef struct _adxt_idx {
	unsigned short nidx;
	unsigned short top;
} ADXT_IDX;

/****************************************************************************/
/*		֐̐錾															*/
/*      Function Declaration												*/
/****************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

/* $func$ ADX Talk ̏
 * [@] void ADXT_Init(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ADX Talk B
 *			ϐ̈̏sB
 *  Initialization of ADX Talk
 * [Inputs  ] None
 * [Outputs ] None
 * [Return  ] None
 * [Function] Initializes ADX Talk. Initializes variable.
 */
void ADXT_Init(void);

/* $func$ ADX Talk ̏ (WinCEp)
 * [@] void ADXT_InitWce(void *obj);
 * [@] obj@: TEhIuWFNg
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ADX Talk B
 *  Initialization of ADX Talk
 * [Inputs  ] obj : DirectSound Object
 * [Outputs ] None
 * [Return  ] None
 * [Function] Initializes ADX Talk. Initializes variable.
 */
void ADXT_InitWce(void *obj);
  
/* $func$ ADX Cu̍ď
 * [@] void ADXT_ResetLibrary(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ADX Talk ďB
 *			ϐ̈̏sB
 *  Reset ADX Talk
 * [Inputs  ] None
 * [Outputs ] None
 * [Return  ] None
 * [Function] Resets ADX Talk. Initializes variable.
 */
void ADXT_ResetLibrary(void);

/* $func$ ADX Talk̏I
 * [@] void ADXT_Finish(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ADX Talk ̏IB
 *  Termination of ADX Talk
 * [Inputs  ] None
 * [Outputs ] None
 * [Return  ] None
 * [Function] Finalizes ADX Talk.
 */
void ADXT_Finish(void);

/*	$func$ ׂĂADXTnh̏
 * [@] void ADXT_DestroyAll(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ׂĂADXTnhB
 * [Inputs  ] None
 * [Outputs ] None
 * [Return  ] None
 * [Function] You can destroy all ADXT handles.
 */
void ADXT_DestroyAll(void);

/*	$func$ ׂĂADXTADXFnh̏
 * [@] void ADXT_CloseAllHandles(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ׂĂADXTnhADXFnhB
 * [Inputs  ] None
 * [Outputs ] None
 * [Return  ] None
 * [Function] You can destroy all ADXT handles and close all ADXF handles.
 * [Source  ]
 *			void ADXT_CloseAllHandles(void)
 *			{
 *				ADXT_DestroyAll();
 *				ADXF_CloseAll();
 *			}
 */
void ADXT_CloseAllHandles(void);

/*	$func$ ADXTnh ̐
 * [@] ADXT ADXT_Create(long maxnch, void *work, long worksize);
 * [@] maxnch	: őĐ`lim݂̂PFXeIQj
 *			work	: [N̈
 *			worksize: [N̈̃TCY
 * [o@] Ȃ
 * [֐l] ADXTnh
 * [@@\] ADXTnh𐶐B
 *			work̈̃TCÝAADXT_CALC_WORK}Nɂċ߂B
 *  Creation of ADXT handle
 * [Inputs  ] maxnch  : Number of maximum channels(monoral:1, stereo:2)
 *			  work    : Working area
 *			  worksize: Size of working area(byte)
 * [Outputs ] None
 * [Return  ] ADXT handle
 * [Function] Creates ADXT handle.
 * [Remarks ] You calculate size of working area used 'ADXT_CALC_WORK' macro. 
 */
ADXT ADXT_Create(long maxnch, void *work, long worksize);

/* $func$ ADXTnh ̏
 * [@] void ADXT_Destroy(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] w肳ꂽ ADXTnhB
 *  Destroy of ADXT handle
 * [Inputs  ] adxt   : ADXT handle
 * [Outputs ] None
 * [Return  ] None
 * [Function] Destroys specified ADXT handle.
 */
void ADXT_Destroy(ADXT adxt);

/* $func$ FID wɂĐ̊Jn
 * [@] void ADXT_StartAfs(ADXT adxt, long patid, long fid);
 * [@] adxt	: ADXTnh
 *			patid	: p[eBVʎq
 *			fid		: t@Cʎq
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] p[eBVʎqƃt@CʎqŎw肳ꂽ`cwt@C
 *			ĐJnB
 *  Play start of ADX data by specified file ID
 * [Inputs  ] adxt	: ADXT handl
 *			  patid	: Partition ID
 *			  fid	: File ID
 * [Outputs ] None
 * [Return  ] None
 * [Function] Starts to play ADX file when you specify partition ID and file ID.
 */
void ADXT_StartAfs(ADXT adxt, long patid, long fid);

/* $func$ t@CwɂĐ̊Jn
 * [@] void ADXT_StartFname(ADXT adxt, char *fname);
 * [@] adxt	: ADXTnh
 *			fname	: t@C
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] fname Ŏw肳ꂽ`cwt@C̍ĐJnB
 *  Play start of ADX data specified file name
 * [Inputs  ] adxt	: ADXT handle
 *			  fname	: File name
 * [Outputs ] None
 * [Return  ] None
 * [Function] Starts to play ADX file when you specify file name.
 */
void ADXT_StartFname(ADXT adxt, char *fname);

/* $func$ Xg[WCgɂĐ̊Jn
 * [@] void ADXT_StartSj(ADXT adxt, SJ sj);
 * [@] adxt	: ADXTnh
 *			sj		: Xg[WCg
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] Xg[WCg瓾f[^ĐB
 *  Play start of ADX data from Stream Joint
 * [Inputs  ] adxt	: ADXT handle
 *			  sj	: Stream Joint
 * [Outputs ] None
 * [Return  ] None
 * [Function] Starts to play ADX file when you specify Stream Joint.
 */
void ADXT_StartSj(ADXT adxt, SJ sj);

/* $func$ wɂĐ̊Jn
 * [@] void ADXT_StartMem(ADXT adxt, void *adxdat);
 * [@] adxt	: ADXTnh
 *			adxdat	: `cwf[^̃AhX
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] adxdatŎw肳ꂽ`cwf[^ĐB
 *  Play start of ADX data on memory
 * [Inputs  ] adxt	: ADXT handle
 *			  adxdat: Address of ADX data
 * [Outputs ] None
 * [Return  ] None
 * [Function] Starts to play ADX data on memory when you specify address.
 */
void ADXT_StartMem(ADXT adxt, void *adxdat);

/* $func$ wɂĐ̊Jn
 * [@] void ADXT_StartMem2(ADXT adxt, void *adxdat, long datlen);
 * [@] adxt	: ADXTnh
 *			adxdat	: `cwf[^̃AhX
 *			datlen	: `cwf[^̑傫
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] adxdata Ŏw肳ꂽ`cwf[^ĐB
 *  Play start of ADX data on memory (TYPE 2)
 * [Inputs  ] adxt	: ADXT handle
 *			  adxdat: Address of ADX data
 *			  datlen: Length of playing ADX data
 * [Outputs ] None
 * [Return  ] None
 * [Function] Starts to play ADX data on memory. Plays to specified length.
 */
void ADXT_StartMem2(ADXT adxt, void *adxdat, long datlen);

/* $func$ wɂĐ̊Jn
 * [@] void ADXT_StartMemIdx(ADXT adxt, void *acx, long no);
 * [@] adxt	: ADXTnh
 *			acx		: `bwf[^̃AhX
 *			no		: CfbNXԍ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] acx Ŏw肳ꂽ`bwf[^noԖڂ̃f[^ĐB
 *  Play start of ACX data
 * [Inputs  ] adxt	: ADXT handle
 *			  acx	: Address of ACX data
 *			  no	: Index number
 * [Outputs ] None
 * [Return  ] None
 * [Function] Starts to play a part of ACX data when you specify index number.
 */
void ADXT_StartMemIdx(ADXT adxt, void *acx, long no);

/* $func$ Đ̒~
 * [@] void ADXT_Stop(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] `cw̍Đ~B
 *  Play stop
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] None
 * [Function] Stops to play ADX data.
 */
void ADXT_Stop(ADXT adxt);

/* $func$ Ԃ̎擾
 * [@] long ADXT_GetStat( ADXT adxt );
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] ݂ ADXTnh̏Ԃ\萔
 * 				ADXT_STAT_STOP	 :	~
 *				ADXT_STAT_DECINFO:	`cw ̃wb_擾
 *				ADXT_STAT_PREP	 :	Đ
 *				ADXT_STAT_PLAYING:	fR[hĐ
 *				ADXT_STAT_DECEND :	fR[hI
 *				ADXT_STAT_PLAYEND:	ĐI
 * [@@\] ݂ADXTnh̏Ԃ擾B
 *  Get status
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] Status of ADXT handle
 * [Function] Obtains status of ADXT handle.
 */
long ADXT_GetStat(ADXT adxt);

/* $func$ TvPʂł̍Đ̎擾
 * [@] void ADXT_GetTime( ADXT adxt, long *ncount, long *tscale );
 * [@] adxt	: ADXTnh
 * [o@] ncount	: ĐTv
 *			tscale	: TvOg [ Hz ]
 * [֐l] Ȃ
 * [@@\] TvPʂōĐ擾B
 *  Get play time by sample unit
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] ncount: Number of play sample
 *			  tscale: Sampling frequency(Hz)
 * [Return  ] None
 * [Function] Obtains play time by sample unit.
 */
void ADXT_GetTime(ADXT adxt, long *ncount, long *tscale);

/* $func$ Ԃł̍Đ̎擾
 * [@] long ADXT_GetTimeReal(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Đ [ 1/100sec ]
 * [@@\] ԂōĐ擾B
 *  Get play time in real time
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] Play time(1/100sec)
 * [Function] Obtains play time in real time.
 */
long ADXT_GetTimeReal(ADXT adxt);

/* $func$ f[^̑Tv̎擾
 * [@] long ADXT_GetNumSmpl( ADXT adxt );
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] f[^̑Tv
 * [@@\] Đ `cw f[^̑Tv擾B
 * [@l] ԂAĐ(ADXT_STAT_PREP)ĐI(ADXT_STAT_PLAYEND)
 *			܂ł̎Ɏ擾\B
 *  Get a general sample number of sound data
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] General sample number of sound data
 * [Function] Obtains a general sample number of sound data.
 * [Remarks ] You can obtain a time between status of preparation
 *			  (ADXT_STAT_PREP) and status of play end(ADXT_STAT_PLAYEND).
 */
long ADXT_GetNumSmpl(ADXT adxt);

/* $func$ f[^̃TvOg̎擾
 * [@] long ADXT_GetSfreq(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] f[^̃TvOg
 * [@@\] Đ TvOg߂B
 * [@l] ԂAĐ(ADXT_STAT_PREP)ĐI(ADXT_STAT_PLAYEND)
 *			܂ł̎Ɏ擾\B
 *  Get sampling frequecy
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] Sampling frequency
 * [Function] Obtains sampling frequency.
 * [Remarks ] You can obtain a sampling frequency between status of preparation
 *			 (ADXT_STAT_PREP) and status of play end(ADXT_STAT_PLAYEND).
 */
long ADXT_GetSfreq(ADXT adxt);

/* $func$ f[^̃`l̎擾
 * [@] long ADXT_GetNumChan(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] f[^̃`l̎擾
 * [@@\] Đ̉̃`l߂B
 * [@l] ԂAĐ(ADXT_STAT_PREP)ĐI(ADXT_STAT_PLAYEND)
 *			܂ł̎Ɏ擾\B
 */
long ADXT_GetNumChan(ADXT adxt);

/* $func$ wb_̎擾
 * [@] long long ADXT_GetHdrLen(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] f[^̃wb_
 * [@@\] Đ̉̃wb_߂B
 * [@l] ԂAĐ(ADXT_STAT_PREP)ĐI(ADXT_STAT_PLAYEND)
 *			܂ł̎Ɏ擾\B
 */
long ADXT_GetHdrLen(ADXT adxt);

/* $func$ f[^̗ʎq̎擾
 * [@] long ADXT_GetFmtBps(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] f[^̗ʎqrbg
 * [@@\] Đ̗̉ʎqrbg߂B
 * [@l] ԂAĐ(ADXT_STAT_PREP)ĐI(ADXT_STAT_PLAYEND)
 *			܂ł̎Ɏ擾\B
 */
long ADXT_GetFmtBps(ADXT adxt);

/*	$func$ p|bg̐ݒ
 * [@] void ADXT_SetOutPan(ADXT adxt, long ch, long pan);
 * [@] adxt	: ADXTnh
 *			ch		: `lԍ (0, 1)
 *						ADXT_CH_L=0, ADXT_CH_R=1
 *			pan		: pݒl (-15`+15, -128)
 *						ADXT_PAN_LEFT=-15, ADXT_PAN_CENTER=0
 *						ADXT_PAN_RIGHT=15, ADXT_PAN_AUTO=-128
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] o̓p|bgݒ肷B
 *			AUTO ̏ꍇ́AADX f[^mXeIɂĎI
 *			pݒ肳B
 *  Set panpot
 * [Inputs  ] adxt	: ADXT handle
 *			  ch	: Channel number(ADXT_CH_L:0, ADXT_CH_R:1)
 *			  pan	: Panpot(from -15 to +15, -128)
 *						ADXT_PAN_LEFT=-15, ADXT_PAN_CENTER=0
 *						ADXT_PAN_RIGHT=15, ADXT_PAN_AUTO=-128
 * [Outputs ] None
 * [Return  ] None
 * [Function] Sets panpot of specified channel number.
 *			 Sets automatically panpot by data, monoral or stereo, when you 
 *			 specified 'ADXT_PAN_AUTO'.
 */
void ADXT_SetOutPan(ADXT adxt, long ch, long pan);

/*	$func$ p|bg̎擾
 * [@] void ADXT_GetOutPan(ADXT adxt, long ch);
 * [@] adxt	: ADXTnh
 *			ch		: `lԍ (0, 1)
 *						ADXT_CH_L=0, ADXT_CH_R=1
 * [o@] Ȃ
 * [֐l] p|bg̐ݒl
 * [@@\] o̓p|bg擾B
 *  Get panpot
 * [Inputs  ] adxt	: ADXT handle
 *			  ch	: Channel number(ADXT_CH_L:0, ADXT_CH_R:1)
 * [Outputs ] None
 * [Return  ] Panpot
 * [Function] Obtains panpot of specified channel number.
 */
long ADXT_GetOutPan(ADXT adxt, long ch);

/*	$func$ o̓{[̐ݒ
 * [@] void ADXT_SetOutVol(ADXT adxt, long vol);
 * [@] adxt	: ADXTnh
 *			vol		: x@(0:-0dB, -960:-96dB)
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] o̓{[ݒ肷B
 *			vol̐ݒl	0    :  -0dB  Ȃ
 *						-30  :  -3dB  70%
 *						-60  :  -6dB  50%
 *						-960 : -96dB  ő̌
 *  Set volume
 * [Inputs  ] adxt	: ADXT handle
 *			  vol	: Volume (0:-dB, -960:-96dB)
 * [Outputs ] None
 * [Return  ] None
 * [Function] Sets the volume of a ADXT handle.
 *			 'vol'value	0    :  -0dB  No attenuation
 *						-30  :  -3dB  about 70%
 *						-60  :  -6dB  about 50%
 *						-960 : -96dB  Maximum attenuation
 */
void ADXT_SetOutVol(ADXT adxt, long vol);

/*	$func$ o̓{[̎擾
 * [@] void ADXT_GetOutVol(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] o̓{[̐ݒl@(0:-0dB ` -960:-96dB)
 * [@@\] o̓{[擾B
 *  Get volume
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] Volume (0:-0dB, -960:-96dB)
 * [Function] Obtains the volume for a ADXT handle.
 */
long ADXT_GetOutVol(ADXT adxt);

/*	$func$ T[o֐̌Ăяopx̐ݒ	(Pb̌Ăяo)
 * [@] void ADXT_SetSvrFreq(ADXT adxt, long freq);
 * [@] adxt	: ADXTnh
 *			freq	: T[o֐̌Ăяopx (Pb̌Ăяo)
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] T[o֐(ADXT_ExecServer֐)̌Ăяopx̐ݒ肷B
 *			ftHgł́A60ݒ肳ĂB
 *			ʏAݒ肷Kv͂ȂB
 *  Set the frequency called server function(times/sec)
 * [Inputs  ] adxt	: ADXT handle
 *			  freq	: Frequency called server function(times/sec)
 * [Outputs ] None
 * [Return  ] None
 * [Function] Sets the frequency called server function(ADXT_ExecServer).
 *			 You do not need to set it usually. Default value is 60.
 */
void ADXT_SetSvrFreq(ADXT adxt, long freq);

/*	$func$ ēǂݍ݊JnԂ̐ݒ
 * [@] void ADXT_SetReloadTime(ADXT adxt,float time,long nch,long sfreq);
 * [@] adxt	: ADXTnh
 *			time	: ēǂݍ݊Jn
 *			nch		: `l
 *			sfreq	: TvOg
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ̓obt@ւ̍ēǂݍ݊JnԂݒ肷B
 *			bcobt@̗ʂ time b菭ȂȂƂbc
 *			f[^ǂݍށB
 *  Set the time of start sector to reload
 * [Inputs  ] adxt	: ADXT handle
 *			  time  : start remain time
 *			  nch   : number of channel
 *			  sfreq : sampling frequency
 * [Outputs ] None
 * [Return  ] None
 * [Function] Sets of the time of start sector to reload into input buffer.
 *			 Reads data from CD-ROM when a quantity of data in the input 
 *			 buffer becomes less than 'time' [second].
 */
void ADXT_SetReloadTime(ADXT adxt, float time, long nch, long sfreq);

/*	$func$ ēǂݍ݊JnZN^̐ݒ
 * [@] void ADXT_SetReloadSct(ADXT adxt, long minsct);
 * [@] adxt	: ADXTnh
 *			minsct	: ēǂݍ݊JnZN^
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ̓obt@ւ̍ēǂݍ݊JnZN^ݒ肷B
 *			̓obt@̃f[^ʂ minsct ZN^菭ȂȂƂbc
 *			f[^ǂݍށB
 *  Set the number of start sector to reload
 * [Inputs  ] adxt	: ADXT handle
 *			  minsct: start sector number
 * [Outputs ] None
 * [Return  ] None
 * [Function] Sets of the number of start sector to reload into input buffer.
 *			 Reads data from CD-ROM when a quantity of data in the input 
 *			 buffer becomes less than 'minsct' [sector].
 */
void ADXT_SetReloadSct(ADXT adxt, long minsct);

/*	$func$ ̓obt@̃ZN^̎擾
 * [@] long ADXT_GetNumSctIbuf(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] ZN^
 * [@@\] ̓obt@ɓǂݍ܂ĂZN^擾B
 *  Get the amount of data stored in input buffer(sector)
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] Number of sector
 * [Function] Obtains the amount of data that is stored in input buffer.
 */
long ADXT_GetNumSctIbuf(ADXT adxt);

/*	$func$ ̓obt@Đ
 * [@] float ADXT_GetIbufRemainTime(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Đ\ԁ@(PʁFb)
 * [@@\] ̓obt@ɂf[^ōĐ\ȎԂ擾B
 *			ADXf[^̂ݑΉB
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] Playable time (sec)
 * [Function] Obtains playable time using only data in input buffer.
 *			  You can use this function only playing ADX data.
 */
float ADXT_GetIbufRemainTime(ADXT adxt);

/*	$func$ ̓obt@ɏ\ȃf[^邩ۂ̌
 * [@] long ADXT_IsIbufSafety(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] TRUE(1):\ȃf[^AFALSE(0):f[^s
 * [@@\] ̓obt@ɏ\ȃf[^邩ۂB
 *			ADXT_SetReloadSct֐ɂĎw肳ꂽēǂݍ݊JnZN^ȏ
 *			f[^̓obt@ɑ݂ꍇATRUEԂB
 *  Check whether the input buffer is having enough data or not
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] TRUE(1):Has enough data, FALSE(0):Data are insufficient
 * [Function] Checks whether the input buffer is having enough data or not.
 *			  Returns 'TRUE' when data more than the number of sector appointed
 *			  exist in the input buffer.
 */
long ADXT_IsIbufSafety(ADXT adxt);

/*	$func$ G[Jo[[h̎w
 * [@] void ADXT_SetAutoRcvr(ADXT adxt, long rmode);
 * [@] adxt	: ADXTnh
 *			rmode	: G[Jo[̕@
 *					  ADXT_RMODE_NOACT, ADXT_RMODE_STOP, ADXT_RMODE_REPLAY
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] G[Jo[̕@ݒ肷B
 *			ADXT_RMODE_NOACT : G[Jo[Ȃ
 *			ADXT_RMODE_STOP  : Iɒ~AԂADXT_STAT_STOPɂȂB
 *			ADXT_RMODE_REPLAY: CD̃f[^̋r؂ꂽƂɁAI
 *							   t@C̐擪ĐB
 *							   ̑̏ꍇ́AIɒ~B
 *  Set a mode of error recovery
 * [Inputs  ] adxt	: ADXT handle
 *			  rmode	: Method of error recovery
 *					  ADXT_RMODE_NOACT, ADXT_RMODE_STOP, ADXT_RMODE_REPLAY
 * [Outputs ] None
 * [Return  ] None
 * [Function] Sets the method that recover from error.
 *			 ADXT_RMODE_NOACT : Does not recover
 *			 ADXT_RMODE_STOP  : Stops automatically
 *			 ADXT_RMODE_REPLAY: Replay from the top of a file automatically 
 *							    when data supply from CD-ROM broke off.
 *							    Other cases stop automatically.
 */
void ADXT_SetAutoRcvr(ADXT adxt, long rmode);

/*	$func$ ĐIۂ̌
 * [@] long ADXT_IsCompleted(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] TRUE(1):ĐIAFALSE(0):Đ
 * [@@\] ĐIۂ𒲂ׂB
 *  Check whether the play finished or not
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] TRUE(1):Finished, FALSE(0):Playing
 * [Function] Checks whether the play finished or not.
 */
long ADXT_IsCompleted(ADXT adxt);

/*	$func$ enh̃T[o֐@iԂ̍XV)
 * [@] long ADXT_ExecHndl(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] enh̓ԂXVB
 *			ADXT_ExecServerĂяoB
 *  Server function of each handle
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] None
 * [Function] Update the inside status.
 *			  This function is called from 'ADXT_ExecServer' function.
 */
void ADXT_ExecHndl(ADXT adxt);

/*	$func$ T[o֐@iԂ̍XV)
 * [@] long ADXT_ExecServer(void);
 * [@] Ȃ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] Cu̓ԂXVB
 *			V-Sync ɌĂяoȂ΂ȂȂB
 *  Server function
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] None
 * [Function] Update the inside status of library.
 */
void ADXT_ExecServer(void);

/*	$func$ G[R[h̎擾
 * [@] long ADXT_GetErrCode(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] G[R[h擾B
 *  Get error code
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] None
 * [Function] Obtains the error code.
 */
long ADXT_GetErrCode(ADXT adxt);

/*	$func$ G[R[h̃NA
 * [@] void ADXT_ClearErrCode(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] G[R[hNAB
 *  Clear error code
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] None
 * [Function] Clears the error code.
 */
void ADXT_ClearErrCode(ADXT adxt);

/*	$func$ [v񐔂̎擾
 * [@] long ADXT_GetLpCnt(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] [v
 * [@@\] [v񐔂擾B
 *  Get the number of times played a loop
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] Number of times played a loop
 * [Function] Obtains the number of times that played a loop.
 */
long ADXT_GetLpCnt(ADXT adxt);

/*	$func$ [vtO̐ݒ
 * [@] void ADXT_SetLpFlg(ADXT adxt, long flg);
 * [@] adxt	: ADXTnh
 *			flg		: 1=[vA0=[vȂ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] [v邩ۂݒ肷B
 *			Đ́A[v邱Ƃ̂݉\B
 *			ēxA[vݒ肷鎞́AĐJnOɐݒ肷邱ƁB
 *  Set the loop flag
 * [Inputs  ] adxt	: ADXT handle
 *			  flg	: 1=loop, 0=not loop
 * [Outputs ] None
 * [Return  ] None
 * [Function] Sets whether play a loop or not.
 *			  You can only release looping play while playing.
 *			  If you set this flag again,
 *			  you have to set just before start playing.
 */
void ADXT_SetLpFlg(ADXT adxt, long flg);

/*	$func$ ̓Xg[WCg̎擾
 * [@] SJ ADXT_GetInputSj(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Xg[WCgnh
 * [@@\] ͗pXg[WCg擾B
 *  Get input Stream Joint
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] Stream Joint
 * [Function] Obtains Stream Joint for the input.
 */
SJ ADXT_GetInputSj(ADXT adxt);

/*	$func$ o͊Jn҂̐ݒ
 * [@] void ADXT_SetWaitPlayStart(ADXT adxt, long flg);
 * [@] adxt	: ADXTnh
 *			flg		: 1=EFCgA0=o͂𑦍ɊJn
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ̏o͂̊Jn҂ݒ肷B
 *  Set waiting for starting to output the sound
 * [Inputs  ] adxt	: ADXT handle
 *			  flg	: 1=waits, 0=starts to output sound
 * [Outputs ] None
 * [Return  ] None
 * [Function] Sets waiting for starting to output the sound.
 */
void ADXT_SetWaitPlayStart(ADXT adxt, long flg);

/*	$func$ o͊Jnۂ̔
 * [@] void ADXT_IsReadyPlayStart(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] o͊Jn̏ۂ𔻒肷B
 *  Check whether preparations completion
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] None
 * [Function] Checks whether ADXT handle was preparations completion.
 */
long ADXT_IsReadyPlayStart(ADXT adxt);

/*	$func$ ꎞ~̐ݒ
 * [@] void ADXT_Pause(ADXT adxt, long sw);
 * [@] adxt	: ADXTnh
 *			sw		: 1=ꎞ~A0=ĊJ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ꎞ~邩ۂݒ肷B
 *  Pause/Continue
 * [Inputs  ] adxt	: ADXT handle
 *			  sw	: 1=pause, 0=continue
 * [Outputs ] None
 * [Return  ] None
 * [Function] Stops temporarily by a specified switch and release temporary 
 *			  standstill.
 */
void ADXT_Pause(ADXT adxt, long sw);

/*	$func$ _CNgZhx̐ݒ
 * [@] void ADXT_SetDrctLvl(ADXT adxt, long drctlvl)
 * [@] adxt	: ADXTnh
 *			drctlvl	: _CNgZhx@(0dB ` -45dB)
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] _CNgZhxݒ肷B
 */
void ADXT_SetDrctLvl(ADXT adxt, long drctlvl);

/*	$func$ _CNgZhx̎擾
 * [@] long ADXT_GetDrctLvl(ADXT adxt)
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] _CNgZhx@(0dB ` -45dB)
 * [@@\] _CNgZhx擾B
 */
long ADXT_GetDrctLvl(ADXT adxt);

/*	$func$ GtFN^̐ݒ
 * [@] void ADXT_SetFx(ADXT adxt, long fxch, long fxlvl);
 * [@] adxt	: ADXTnh
 *			fxch	: GtFN^̓̓`lԍ (0`15)
 *			fxlvl	: GtFN^̓̓x@(0dB ` -45dB)
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] GtFN^ւ̏o͂ݒ肷B
 *  Set the effect
 * [Inputs  ] adxt	: ADXT handle
 *			  fxch	: Input channel number to Effector (0-15)
 *			  fxlvl	: Input level to Effector(from 0 to -45[dB])
 * [Outputs ] None
 * [Return  ] None
 * [Function] Sets output to the effect.
 */
void ADXT_SetFx(ADXT adxt, long fxch, long fxlvl);

/*	$func$ GtFN^ݒl̎擾
 * [@] void ADXT_GetFx(ADXT adxt, long *fxch, long *fxlvl);
 * [@] adxt	: ADXTnh
 * [o@] fxch	: GtFN^ւ̓̓`lԍ (0`15)
 *			fxlvl	: GtFN^̓̓x@(0dB ` -45dB)
 * [֐l] Ȃ
 * [@@\] GtFN^̐ݒl擾B
 *  Get the effect value
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] fxch	: Input channel number to Effector(0-15)
 *			  fxlvl	: Input level to Effector(from 0 to -45[dB])
 * [Return  ] None
 * [Function] Obtains the effect value.
 */
void ADXT_GetFx(ADXT adxt, long *fxch, long *fxlvl);

/*	$func$ tB^̐ݒ
 * [@] void ADXT_SetFilter(ADXT adxt, long coff, long q);
 * [@] adxt	: ADXTnh
 *			coff	: JbgItg
 *			q		: sx
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] tB^ւ̏o͂ݒ肷B
 *  Set the filter
 * [Inputs  ] adxt	: ADXT handle
 *			  coff	: Cut off frequency
 *			  q		: 
 * [Outputs ] None
 * [Return  ] None
 * [Function] Sets the filter.
 */
void ADXT_SetFilter(ADXT adxt, long coff, long q);

/*	$func$ tB^ݒl̎擾
 * [@] void ADXT_GetFilter(ADXT adxt, long *coff, long *q);
 * [@] adxt	: ADXTnh
 * [o@] coff	: JbgItg
 *			q		: sx
 * [֐l] Ȃ
 * [@@\] tB^ւ̏o͒l擾B
 *  Get the filter value
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] coff	: Cut off frequency
 *			  q		: 
 * [Return  ] None
 * [Function] Obtains the filter value.
 */
void ADXT_GetFilter(ADXT adxt, long *coff, long *q);

/*	$func$ gX|[Y̐ݒ
 * [@] void ADXT_SetTranspose(ADXT adxt, long transps, long detune);
 * [@] adxt	: ADXTnh
 *			transps	: gX|[Y
 *			detune	: f`[
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] gX|[Yݒ肷B
 *  Set transpose
 * [Inputs  ] adxt		: ADXT handle
 *			  transps	: Amount of transpose
 *			  detune	: Amount of detune
 * [Outputs ] None
 * [Return  ] None
 * [Function] Sets the transpose.
 */
void ADXT_SetTranspose(ADXT adxt, long transps, long detune);

/*	$func$ gX|[Y̎擾
 * [@] void ADXT_GetTranspose(ADXT adxt, long *transps, long *detune);
 * [@] adxt	: ADXTnh
 * [o@] transps	: gX|[Y
 *			detune	: f`[
 * [֐l] Ȃ
 * [@@\] gX|[Yʂ擾B
 *  Get tanspose
 * [Inputs  ] adxt		: ADXT handle
 * [Outputs ] transps	: Amount of transpose
 *			  detune	: Amount of detune
 * [Return  ] None
 * [Function] Obtains the amount of transpose.
 */
void ADXT_GetTranspose(ADXT adxt, long *transps, long *detune);

/*	$func$ G[֐̓o^
 * [@] void ADXT_EntryErrFunc(void (*func)(void *obj, char *msg),
 *																void *obj);
 * [@] func	: G[֐
 *			obj		: G[֐̑1
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] G[֐o^B
 *  Entry error callback function
 * [Inputs  ] func	: Error handling function
 *			  obj	: First argument of error handling function
 * [Outputs ] None
 * [Return  ] None
 * [Function] Entry error callback function.
 */
void ADXT_EntryErrFunc(void (*func)(void *obj, char *msg), void *obj);

/*	$func$ f[^̕
 * [@] long ADXT_DiscardSmpl(ADXT adxt, long nsmpl)
 * [@] adxt	: ADXTnh
 *			nsmpl	: Tv
 * [o@] Ȃ
 * [֐l] ̂ĂTv
 * [@@\] fR[hf[^̂ĂB
 *  Discard sound data
 * [Inputs  ] adxt	: ADXT handle
 *			  nsmpl	: Number of sample
 * [Outputs ] None
 * [Return  ] sample number discarded
 * [Function] Discards sound data decoded.
 */
long ADXT_DiscardSmpl(ADXT adxt, long nsmpl);

/***
*			tB^쐬pR[obN
*
*			fR[h閈ɓo^ꂽ֐ĂяoB
*			(*user_flt_cbf)(void *obj, long ch, void *data, long dtlen);
*			obj:	ADXT_EntryFltFunc֐̑R
*			ch:		`lԍ@(0:, 1:E)
*			data:	WJꂽf[^ (ADX̏ꍇ́A16bitPCM)
*			dtlen:	WJꂽf[^̃oCg
*			@Uo@\Ƃ͋płȂB
**/

/*	tB^R[obN֐̓o^	*/
void ADXT_EntryFltFunc(ADXT adxt,
		void (*f)(void *obj, long ch, void *data, long dtlen), void *obj);

/***
*		V[XAĐ@\
*
*		E[vݒ̖PADX f[^̂ݘAĐ\
*		Eő16t@C܂œo^\
*
***/

/*	őo^t@C									*/
/*	Number of maximum files to entry 					*/
#define	ADXT_MAX_ENTRY_FILES		(16)

/*	$func$ V[XAĐt@C̓o^
 * [@] void ADXT_EntryFname(ADXT adxt, char *fname)
 * [@] adxt	: ADXTnh
 *			fname	: t@C
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] V[XAĐp̃t@Co^B
 *			[vݒ̂ȂPADXf[^̂ݓo^łB
 *  Entry file for seamless continuous play
 * [Inputs  ] adxt	: ADXT handle
 *			  fname	: ADX File name
 * [Outputs ] None
 * [Return  ] None
 * [Function] Entry file for seamless continuous play.
 *			  You can only simple ADX data file without looping.
 */
void ADXT_EntryFname(ADXT adxt, char *fname);

/*	$func$ V[XAĐTut@C̓o^
 * [@] void ADXT_EntryAfs(ADXT adxt, long patid, long fid)
 * [@] adxt	: ADXTnh
 *			patid	: p[eBVID
 *			fid		: t@CID
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] V[XAĐp̃Tut@Co^B
 *			[vݒ̂ȂPADXf[^̂ݓo^łB
 *  Entry file for seamless continuous play
 * [Inputs  ] adxt	: ADXT handle
 *			  patid	: Partition ID
 *			  fid	: File ID
 * [Outputs ] None
 * [Return  ] None
 * [Function] Entry subfile for seamless continuous play.
 *			  You can only simple ADX data subfile without looping.
 */
void ADXT_EntryAfs(ADXT adxt, long patid, long fid);

/*	$func$ V[XAĐ̊Jn
 * [@] void ADXT_StartSeamless(ADXT adxt)
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] V[XAĐJnB
 *  Start seamless continuous play
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] None
 * [Function] Start seamless continuous play.
 */
void ADXT_StartSeamless(ADXT adxt);

/*	$func$ V[X[vĐ̐ݒ
 * [@] void ADXT_SetSeamlessLp(ADXT adxt, long flg)
 * [@] adxt	: ADXTnh
 *			flg		: 0-[vĐȂ,1-[vĐ
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] ݁Ao^Ăt@CJԂĐB
 *			t@ĈׂẴf[^ǂݏIƎIɍēxo^B
 *  Set seamless loop play
 * [Inputs  ] adxt	: ADXT handle
 *			  flg	: 0-Off, 1-On
 * [Outputs ] None
 * [Return  ] None
 * [Function] You can play all entried files with looping.
 */
void ADXT_SetSeamlessLp(ADXT adxt, long flg);

/*	$func$ V[X[vĐ̊Jn
 * [@] void ADXT_StartFnameLp(ADXT adxt, char *fname)
 * [@] adxt	: ADXTnh
 *			fname	: t@C
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] w肳ꂽt@CJԂĐB
 *  Start seamless loop play
 * [Inputs  ] adxt	: ADXT handle
 *			  fname	: ADX File Name
 * [Outputs ] None
 * [Return  ] None
 * [Function] Start seamless loop plaing your specified file (fname).
 */
void ADXT_StartFnameLp(ADXT adxt, char *fname);

/*	$func$ V[XAĐ̉
 * [@] void ADXT_ReleaseSeamless(ADXT adxt);
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] Ȃ
 * [@@\] V[XAĐ̉B
 *  Release seamless continuous play
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] None
 * [Function] Release seamless continuous play.
 */
void ADXT_ReleaseSeamless(ADXT adxt);

/*	$func$ o^t@C̎擾
 * [@] long ADXT_GetNumFiles(ADXT adxt)
 * [@] adxt	: ADXTnh
 * [o@] Ȃ
 * [֐l] o^Ăt@C
 * [@@\] o^Ăt@C擾B
 *  Get number of entried files
 * [Inputs  ] adxt	: ADXT handle
 * [Outputs ] None
 * [Return  ] Number of Entried Files
 * [Function] Get number of entried files
 */
long ADXT_GetNumFiles(ADXT adxt);

/*	AĐ̐ݒ@(1:A2:Ȃ)	*/
void ADXT_SetLnkSw(ADXT adxt, long sw);

/*	AĐ̎擾@(1:A2:Ȃ)	*/
long ADXT_GetLnkSw(ADXT adxt);

/***
*			Uo@\
***/

/*	U擾pƗ̈̑傫̌vZ	*/
long ADXT_CalcAmpWork(long maxnch);
/*	U擾pƗ̈̐ݒ	*/
void ADXT_SetAmpWork(ADXT adxt, void *work, long wksize);
/*	U̎擾	*/
long ADXT_GetAmplitude(ADXT adxt, long ch);

/*	wb_̋}	*/
void ADXT_InsertHdrSfa(ADXT adxt, long nch, long sfreq, long nsmpl);
/*	^CItZbg̐ݒ	*/
void ADXT_SetTimeOfst(ADXT adxt, long ofst);

/***
*			Sofdecpg֐
***/

/*	V-Sync荞ݗp֐			*/
/*	Shinobił́AɊ荞݂ɎIɓo^̂ŁA		*/
/*	gp܂BNaomiSofdec MovieĐꍇɂ́A			*/
/*	̊֐V-Sync荞݂sĂB						*/
void ADXT_VsyncProc(void);

/*	̒Pʂ̐ݒ@(0:Sfreq(Audio), 1:V-Sync(NTSC), 2:V-sync(PAL)	*/
void ADXT_SetTimeMode(long mode);

/* ADXwb_̔ */
long ADXT_IsHeader(char *adr, long siz, long *hdrsiz);

/* ADXIR[h̔ */
long ADXT_IsEndcode(char *adr, long siz, long *endsiz);
/*
	adr   FI|C^(ADXf[^36oCgE)
	siz   FITCY (ɕKvȃTCY͍XoCg
			܂񂪁At@C[hāAobt@
			~ςĂTCY͂܂)
	ndsizFIR[hTCYitb^TCYj
*/

/* f[^̋} */
long ADXT_InsertSilence(ADXT adxt, long nch, long nsmpl);
/*
	nsmpl @F}vTv [sample/1ch]
	֐l  F}sTv (0 ` nsmpl)
			  ADXT͗pSJɏ\ȋ󂫂 nsmpl ̒[
			  ؂̂ĂlԂB
*/

#ifdef __cplusplus
}
#endif

#endif
