/*++

  COPYRIGHT        (C) NEC        Corporation 1997 - 1999

  All rights reserved by NEC Corporation. This program must be
  used solely for the purpose for which it was furnished by NEC
  Corporation. No part of this program may be reproduced or
  disclosed to others, in any form, without the prior written
  permission of NEC Corporation.
  Use of copyright notice does not evidence publication of this
  program.

  Author     :		T.Hirata(NEC Software,Ltd.)
  Module Name:		km2api.h

  Abstract:
	KAMUI = Kamui is abstruction model that is ultimate interface for PowerVR.
	'km2api_cfg.h' defines kmSetSystemConfiguration();

  Environment:
	ANSI C Compiler.

  Notes:
	kmSetSystemConfiguration();

  Revision History:

--*/

#if !defined(__kamui2_configuration_api_h)
#define __kamui2_configuration_api_h

/*++
kmSetSystemConfiguration

proto type:
	KMSTATUS kmSetSystemConfiguration(
			PKMSYSTEMCONFIGSTRUCT pSystemConfigStruct
	)

Description:
		KMSYSTEMCONFIGSTRUCT^\̂Ɏw肵p[^ɏ]A_Ђ̃VXe\ݒ肵܂B

		 Texture/Frame Buffer Ŝ̗e  -  (w肳ꂽőeNX`gpTCY + \pFrame Buffer)
				=	 Native Buffer

Arguments:
	IN	OUT	pSystemConfigStruct
							KMSYSTEMCONFIGSTRUCT^\̂ւ̃|C^w肵܂B
							{\̂̃o͈ȉ̗lɐݒ肵܂B

				dwSize		KMSYSTEMCONFIGSTRUCT \̂̃TCY ܂B
							pSystemConfigStruct->dwSize = sizeof(KMSYSTEMCONFIGSTRUCT);

				flags		VXe̓w肵܂B
								KM_CONFIGFLAG_ENABLE_CLEAR_FRAMEBUFFER	Frame Buffer mێɃobt@̓eNA܂B
								KM_CONFIGFLAG_ENABLE_STRIPBUFFER		Strip Buffer Lɂ܂B
								KM_CONFIGFLAG_ENABLE_2V_LATENCY			2V Laytency Mode ɂ܂B
								KM_CONFIGFLAG_NOWAITVSYNC				V-SYNC ҂Ȃ[hłB

								KM_CONFIGFLAG_NOWAIT_FINISH_TEXTUREDMA	TextureDMA]ꍇɁADMȀI҂Ȃ悤ɂ܂B
								                                        DMȀIokmQueryFinishLastTextureDMAgpčsĂB
								                                        ܂ADMADMA]ւ̃ANZX͕K悤ɂĂB

				ppSurfaceDescArray/	nNumOfFrameBuffer;
							KMSURFACEDESC \̂̃|C^zւ̃|C^ƃ|C^z̗vf^܂B
							ȉ̂悤ɐݒ肵܂B

									KMSURFACEDESC Surface1;
									KMSURFACEDESC Surface2;
									PKMSURFACEDESC ppSurfaceArray[nNumOfFrameBuffer];
									ppSurfaceArray[0] = &Surface1;
									ppSurfaceArray[1] = &Surface2;

									pSystemConfigStruct->nNumOfFrameBuffer  = nNumOfFrameBuffer;
									pSystemConfigStruct->ppSurfaceDescArray = ppSurfaceArray;

				nTextureMemorySize
							gpeNX`̃TCYw肵܂B

				pBufferDesc
						KMVERTEXBUFFDESC \̂ւ̃|C^łB

				pVertexBuffer
				nVertexBufferSize;
						_obt@ւ̃x[XAhX/TCYw肵܂B

Result:
	KMSTATUS_SUCCESS			
	KMSTATUS_NOT_ENOUGH_MEMORY	Native Buffer/Frame Buffer ̂߂̃eʂ܂

--*/

KMSTATUS KMAPI
kmSetSystemConfiguration(
		IN	OUT	PKMSYSTEMCONFIGSTRUCT pSystemConfigStruct
	);
#endif
