/*++

  COPYRIGHT        (C) NEC        Corporation 1997 - 1999

  All rights reserved by NEC Corporation. This program must be
  used solely for the purpose for which it was furnished by NEC
  Corporation. No part of this program may be reproduced or
  disclosed to others, in any form, without the prior written
  permission of NEC Corporation.
  Use of copyright notice does not evidence publication of this
  program.

  Author     :		T.Hirata(NEC Software,Ltd.)
  Module Name:		km2api_clb.h

  Abstract:
	KAMUI = Kamui is abstruction model that is ultimate interface for PowerVR.
	'km2api_clb.h' define the function which is related with callback.

  Environment:
	ANSI C Compiler.

  Notes:
	This heder file defines the function which registers callback function.
	The factor of callback is shown bellow.
		- end of render
		- end of vertex
		- end of yuv
		- V-Sync
		- H-Sync

		- Texture Over flow
		- Waiting V-Sync()

		- Strip Buffer Overrun
		- Fatal Error

  Revision History:

--*/

#if !defined(__kamui2_callback_api_h__)
#define __kamui2_callback_api_h__

/*++
kmSetEORCallback

proto type:

	KMSTATUS 
	kmSetEORCallback(
			PKMCALLBACKFUNC pEORCallback,
			PVOID pCallbackArguments
		);

Description:
	_OIɌĂ΂R[obN֐o^܂B
	R[obN֐́Aȉ̌`ŃR[fBOĂB

		VOID EORCallbackFunc(PVOID pCallbackArguments);

	pCallbackArguments()Fo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pEORCallback	_OIɌĂ΂֐̃|C^w肵܂B
	IN	pCallbackArguments
						callback Ɍďo֐֓nAւ̃|C^w肵܂B


Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS  KMAPI
kmSetEORCallback(
		PKMCALLBACKFUNC pEORCallback,
		PVOID 			pCallbackArguments
	);

/*++
kmSetVSyncCallback

proto type:
	KMSTATUS
	kmSetVSyncCallback(
			PKMCALLBACKFUNC pVSyncCallback,
			PVOID pCallbackArguments
		);

Description:
	A(Vsync)˓ɌĂяoR[obN֐o^܂B
	R[obN֐́Aȉ̌`ŃR[fBOĂB

		VOID VSyncCallbackFunc(PVOID pCallbackArguments);

	pCallbackArguments()Fo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pVSyncCallback	Vsync˓ɌĂ΂֐̃|C^w肵܂B
	IN	pCallbackArguments
						callback Ɍďo֐֓nAւ̃|C^w肵܂B

Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetVSyncCallback(
		PKMCALLBACKFUNC pVSyncCallback,
		PVOID 			pCallbackArguments
	);

/*++
kmSetHSyncCallback

proto type:
	KMSTATUS
	kmSetHSyncCallback(
			PKMCALLBACKFUNC pHSyncCallback,
			PVOID pCallbackArguments
		);

Description:
	A(Hsync)˓ɌĂяoR[obN֐o^܂B
	R[obN֐́Aȉ̌`ŃR[fBOĂB

	VOID HSyncCallbackFunc(PVOID pCallbackArguments);

	pCallbackArguments()Fo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pHSyncCallback		Hsync˓ɌĂ΂֐̃|C^w肵܂B

	pCallbackArguments		callback Ɍďo֐֓nAւ̃|C^w肵܂B
							KmSetHSyncLine Ŏw肵Cԍ͓nȂ̂ŁA
							kmSetHSyncLine Őݒ肵l̃|C^̈ɕێ邩A
							܂́AkmGetCurrentScanline()gpāA݂ Scanline 擾ĂB

Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetHSyncCallback(
		PKMCALLBACKFUNC pHSyncCallback,
		PVOID pCallbackArguments
	);

/*++
kmSetTexOverflowCallback

proto type:
	KMSTATUS
	kmSetTexOverflowCallback(
			PKMCALLBACKFUNC pTexOverflowCallback,
			PVOID pCallbackArguments
		);

Description:
	eNX`cĂȂԂŁAeNX`o^悤ƂꍇɌĂ΂R[obN֐
	o^܂BR[obN֐́Aȉ̌`ŃR[fBOĂB

		VOID TexOverflowCallbackFunc(PVOID pCallbackArguments);

	pCallbackArguments()Fo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pTexOverflowCallback	eNX`I[o[t[̃R[obN֐ւ̃|C^w肵܂B
	IN	pCallbackArguments		callback Ɍďo֐֓nAւ̃|C^w肵܂B
	
Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetTexOverflowCallback(
		PKMCALLBACKFUNC pTexOverflowCallback,
		PVOID pCallbackArguments
	);

/*++
kmSetStripOverRunCallback

proto type:
	KMSTATUS
	kmSetStripOverRunCallback (
			PKMCALLBACKFUNC	pStripOverRunCallback,
			PVOID			pCallbackArguments
		);

Description:
	StripBuffeȑcTCY̕\ԒɎStrip̃_OIȂꍇɌĂ΂
	R[obN֐o^܂BR[obN֐́Aȉ̌`ŃR[fBOĂB

			VOID StripOverRunCallbackFunc(PVOID pCallbackArguments);

	pCallbackArguments()Fo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pStripOverRunCallback	R[obN֐ւ̃|C^w肵܂B
	IN	pCallbackArguments		callback Ɍďo֐֓nAւ̃|C^w肵܂B

Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetStripOverRunCallback (
		PKMCALLBACKFUNC	pStripOverRunCallback,
		PVOID			pCallbackArguments
	);

/*++
kmSetEndOfVertexCallback

proto type:
	KMSTATUS
	kmSetEndOfVertexCallback (
			PKMCALLBACKFUNC pEndOfVertexCallback,
			PKMVOID			pCallbackArguments
		);

Description:
	_Ђ烌_On[hEFAւ́A1V[̃f[^]IꍇɌĂ΂R[obN֐
	o^܂BR[obN֐́Aȉ̌`ŃR[fBOĂB

			VOID EndOfVertexCallbackFunc(PVOID pCallbackArguments);

	pCallbackArguments()Fo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pEndOfVertexCallback	R[obN֐ւ̃|C^w肵܂B
	IN	pCallbackArguments		callback Ɍďo֐֓nAւ̃|C^w肵܂B

Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetEndOfVertexCallback (
		PKMCALLBACKFUNC pEndOfVertexCallback,
		PKMVOID 		pCallbackArguments
	);

/*++
kmSetEndOfYUVCallback

proto type:
	KMSTATUS
	kmSetEndOfYUVCallback(
			PKMCALLBACKFUNC pEndOfYUVCallback,
			PVOID pCallbackArguments
		);

Description:
	YUVRo[^Ro[gIۂɔsAYUVI荞݂ɑ΂
	R[obN֐o^܂B

		VOID EndOfYUVFunc(PVOID pCallbackArguments);

	pCallbackArguments()Fo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pEndOfYUVCallback		YUVRo[gĨR[obN֐ւ̃|C^w肵܂B
	IN	pCallbackArguments		callback Ɍďo֐֓nAւ̃|C^w肵܂B
	
Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetEndOfYUVCallback(
		PKMCALLBACKFUNC pEndOfYUVCallback,
		PVOID pCallbackArguments
	);

/*++
kmSetWaitVsyncCallback

proto type:
	KMSTATUS
	kmSetWaitVsyncCallback(
			PKMCALLBACKFUNC pWaitVsyncCallback,
			PVOID pCallbackArguments
		);

Description:
	VsyncWAITɌĂ΂R[obN֐o^܂BCD-ROM̓ǂݏoobNOEh
	ōsꍇȂV񓯊s߂̃R[obNƂĎgp܂B
	A܂傫Ȋ֐AR[obNł̖[v͍sȂłB
    KAMUI Ń\|X҂ŒɂĂяo܂B
	
		VOID WaitVsyncCallbackFunc(PVOID pCallbackArguments);

	pCallbackArguments()Fo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pWaitVsyncCallback		VsyncEFCg̃R[obN֐ւ̃|C^w肵܂B
	IN	pCallbackArguments		callback Ɍďo֐֓nAւ̃|C^w肵܂B
	
Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetWaitVsyncCallback(
		PKMCALLBACKFUNC pWaitVsyncCallback,
		PVOID pCallbackArguments
	);

/*++
kmSetWaitVblankCallback

proto type:
	KMSTATUS
	kmSetWaitVblankCallback(
			PKMCALLBACKFUNC pWaitVblankCallback,
			PVOID pCallbackArguments
		);

Description:
	VsyncWAITɌĂ΂R[obN֐o^܂BCD-ROM̓ǂݏoobNOEh
	ōsꍇȂV񓯊s߂̃R[obNƂĎgp܂B
	A܂傫Ȋ֐AR[obNł̖[v͍sȂłB
    KAMUI \|X҂Œɂ͌Ăяo܂B
	
		VOID WaitVblankCallbackFunc(PVOID pCallbackArguments);

	pCallbackArguments()Fo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pWaitVblankCallback		VsyncEFCg̃R[obN֐ւ̃|C^w肵܂B
	IN	pCallbackArguments		callback Ɍďo֐֓nAւ̃|C^w肵܂B
	
Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetWaitVblankCallback(
		PKMCALLBACKFUNC pWaitVblankCallback,
		PVOID pCallbackArguments
	);

/*++
kmSetFatalErrorCallback

proto type:
	KMSTATUS
	kmSetFatalErrorCallback(
			PKMCALLBACKFUNC pFaltalErrorCallback,
			PVOID 			pCallbackArguments
		);

Description:
	_ЂQł͉񕜕s\ȃG[ꍇɌĂяo
	R[obN֐o^܂Bȉ̌`ŌĂяo܂B

		VOID FaltalErrorCallback(PVOID pCallbackArguments);

	pCallbackArguments()Fo^Ɏw肳ꂽp[^ւ̃|C^łB

Arguments:
	IN	pFaltalErrorCallback	񕜕s\ȃG[ꍇɌĂяoR[obN֐łB
	IN	pCallbackArguments		callback Ɍďo֐֓nAւ̃|C^w肵܂B

Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetFatalErrorCallback(
		IN	PKMCALLBACKFUNC pFaltalErrorCallback,
		IN	PVOID			pCallbackArguments
	);


/*++
kmSetPALEXTCallback

proto type:
	KMSTATUS
	kmSetPALEXTCallback(
			PKMCALLBACKFUNC pPalExtCallback,
			PVOID 			Reserved
		);

Description:
	kmSetDisplayMode ĂяoۂɁA	PAL ??? EXT w肵ꍇA
	c̕\䗦肷邽߂̒萔Ԃ߂̃R[obN֐łB

		VOID pPalExtCallback(PVOID pData);

	pData ɂ́AVXe KMPALEXTINFO \̂ւ̃|C^n܂B
	nPALExtMode oɑ΂ēK؂ȒlĂB
	KMPALEXTINFO \̂ nDisplayModeɂ́AkmSetDisplayMode 
	Ă܂B

Arguments:
	IN	pPalExtCallback			c\䗦肷邽߂̒萔Ԃ߂ɌĂяoR[obN֐łB
	IN	reserved				NULL ĂB

Result:
	KMSTATUS_SUCCESS		o^

--*/

KMSTATUS KMAPI
kmSetPALEXTCallback( 
		IN	PKMCALLBACKFUNC pPalExtCallback,
		IN	PVOID			pCallbackArguments
	);
#endif
