/*++

  COPYRIGHT        (C) NEC        Corporation 1997 - 1999

  All rights reserved by NEC Corporation. This program must be
  used solely for the purpose for which it was furnished by NEC
  Corporation. No part of this program may be reproduced or
  disclosed to others, in any form, without the prior written
  permission of NEC Corporation.
  Use of copyright notice does not evidence publication of this
  program.

  Author     :		T.Hirata(NEC Software,Ltd.)
  Module Name:		km2api_dev.h

  Abstract:
	KAMUI = Kamui is abstruction model that is ultimate interface for PowerVR.
	'km2api_dev.h' define Device and Display Control API.

  Environment:
	ANSI C Compiler.

  Notes:
	define Kamui's Device and Display control api proto-types.

  Revision History:

--*/

#if !defined(__kamui2_device_api_h__)
#define __kamui2_device_api_h__

/*++
kmInitDevice

proto type:

	KMSTATUS
	kmInitDevice (
				KMDEVICE nDevice
			);

Description:
	n[hEFȀs܂B

Arguments:
	IN	nDevice
		gpn[hEFAw肵܂B

			KM_DREAMCAST	... Dreamcast(tm) gB
			KM_NAOMI    	... NA@MI(tm) B


Result:

	KMSTATUS_SUCCESS				foCX
	KMSTATUS_INVALID_VIDEOMODE		sȃrfI[hw肵B
	KMSTATUS_HARDWARE_NOT_PRESENTED	n[hEFAgpłȂB

--*/
KMSTATUS KMAPI
kmInitDevice (
		IN	KMDEVICE nDevice
	);


/*++
kmUnloadDevice

proto type:

	KMSTATUS
	kmUnloadDevice (
				KMVOID
			);

Description:
	n[hEFÃA[hs܂B

Arguments:

Result:
	KMSTATUS_SUCCESS				
	KMSTATUS_ERROR					V[`Ȃǂ̗RŃA[hs

--*/
KMSTATUS KMAPI
kmUnloadDevice(
		KMVOID
	);

/*++
kmSetDisplayMode

proto type:

	KMSTATUS
	kmSetDisplayMode(
			IN	KMDISPLAYMODE	nDisplayMode,
			IN	KMBPPMODE		nBpp,
			IN	KMBOOLEAN		fDither,
			IN	KMBOOLEAN		fAntiAlias
		);

Description:
	Frame Buffer̕\[hݒ肵܂B

Arguments:
	IN	nDisplayMode
	fBXvC[hw肵܂B
		KM_DSPMODE_VGA				VGA(640x480) 60Hz
		KM_DSPMODE_NTSCNI320x240	320x240 mC^[X60Hz
		KM_DSPMODE_NTSCI320x240		320x240 C^[X 30Hz
		KM_DSPMODE_NTSCNI320x480	320x240 ^mC^[[X 60Hz
		KM_DSPMODE_NTSCNI320x480FF	320x240 ^mC^[[X 60Hz tbJ[t[
		KM_DSPMODE_NTSCI320x480		320x240 C^[X 30Hz
		KM_DSPMODE_NTSCNI640x240	640x240 mC^[X60Hz
		KM_DSPMODE_NTSCI640x240		640x240 C^[X30Hz
		KM_DSPMODE_NTSCNI640x480	640x480 ^mC^[[X 60Hz
		KM_DSPMODE_NTSCNI640x480FF	640x480 ^mC^[[X 60Hz tbJ[t[
		KM_DSPMODE_NTSCI640x480		640x480 C^[X 30Hz

		KM_DSPMODE_PALNI320x240		320x240 mC^[X50Hz
		KM_DSPMODE_PALI320x240		320x240 C^[X25Hz
		KM_DSPMODE_PALNI320x480		320x480 ^mC^[[X 50Hz
		KM_DSPMODE_PALNI320x480FF	320x480 ^mC^[[X 50Hz tbJ[t[
		KM_DSPMODE_PALI320x480		320x480 C^[X25Hz
		KM_DSPMODE_PALNI640x240		640x240 mC^[X50Hz
		KM_DSPMODE_PALI640x240	 	640x240 C^[X25Hz
		KM_DSPMODE_PALNI640x480		640x480 ^mC^[[X 50Hz
		KM_DSPMODE_PALNI640x480FF	640x480 ^mC^[[X 50Hz tbJ[t[
		KM_DSPMODE_PALI640x480		640x480 C^[X25Hz

	IN	nBpp
	FrameBuffer̃J[[hw肵܂B
	ȉ̒`ςݒ萔gp邱Ƃł܂B
		KM_DSPBPP_RGB565		RGB565 
		KM_DSPBPP_RGB555		RGB555
		KM_DSPBPP_ARGB1555		ARGB1555
		KM_DSPBPP_RGB888		RGB888
		KM_DSPBPP_ARGB8888		ARGB8888

	IN	bDither
		PowerVR  _Oʂ 16bit Frame Buffer ɏލۂ
		Dither ̗L肵܂B_O Frame Buffer  
		RGB888AARGB8888 łꍇÃtO͖܂B

			TRUE	Dither gpB
			FALSE	Dither gpȂB

	IN	bAntiAlias
		A`GAVOtB^̎gpۂ肵܂B
		A`GCAVOtB^Lɂꍇ쑬x
		ቺꍇ܂B

			TRUE 	Anti Aliasing Filter gpB
			FALSE	Anti Aliasing Filter gpȂB


Result:
	KMSTATUS_SUCCESS				
	KMSTATUS_INVALID_DISPLAY_MODE	sȃfBXvC[hw肳ꂽB
									Ɏw肳ꂽfBXvC[h
									fBXvC[hw肳ꂽB


--*/

KMSTATUS KMAPI
kmSetDisplayMode(
		IN	KMDISPLAYMODE	nDisplayMode,
		IN	KMBPPMODE		nBpp,
		IN	KMBOOLEAN		fDither,
		IN	KMBOOLEAN		fAntiAlias
	);

/*++
kmChangeDisplayFilterMode

proto type:

	KMSTATUS 
	kmChangeDisplayFilterMode(	
			KMBOOLEAN fDither,
			KMBOOLEAN fAntiAlias
		);

Description:
	kmSetDisplayMode Őݒ肵fBUA`GAVOtB^ Enable / Disable 
	ŕύXׂɎgp܂B

Arguments:
	IN	bDither
		PowerVR  _Oʂ 16bit Frame Buffer ɏލۂ
		Dither ̗L肵܂B_O Frame Buffer  
		RGB888AARGB8888 łꍇÃtO͖܂B

			TRUE	Dither gpB
			FALSE	Dither gpȂB

	IN	bAntiAlias
		A`GAVOtB^̎gpۂ肵܂B
		A`GCAVOtB^Lɂꍇ쑬x
		ቺꍇ܂B

			TRUE 	Anti Aliasing Filter gpB
			FALSE	Anti Aliasing Filter gpȂB

Result:
	KMSTATUS_SUCCESS				
	KMSTATUS_INVALID_DISPLAY_MODE	sȃfBXvC[hw肳ꂽB
									Ɏw肳ꂽfBXvC[h
									fBXvC[hw肳ꂽB

--*/

KMSTATUS  KMAPI
kmChangeDisplayFilterMode(	
		IN	KMBOOLEAN fDither,
		IN	KMBOOLEAN fAntiAlias
	);

/*++
kmChangeDisplayDitherMode

proto type:

	KMSTATUS 
	kmChangeDisplayDitherMode( 
		IN	KMBOOLEAN bEnable 
		);

Description:
	kmSetDisplayMode Őݒ肵fBU[hύXׂɎgp܂B

Arguments:
	IN	bEnable
		PowerVR  _Oʂ 16bit Frame Buffer ɏލۂ
		Dither ̗L肵܂B_O Frame Buffer  
		RGB888AARGB8888 łꍇÃtO͖܂B

			TRUE	Dither gpB
			FALSE	Dither gpȂB


Result:
	KMSTATUS_SUCCESS				

--*/
KMSTATUS KMAPI
kmChangeDisplayDitherMode( 
		IN	KMBOOLEAN bEnable 
	);


/*++
kmChangeDisplayAntiAliasMode

proto type:

	KMSTATUS 
	kmChangeDisplayAntiAliasMode(
			IN	KMBOOLEAN bEnable
		);

Description:
	kmSetDisplayMode Őݒ肵A`GAVOtB^ Enable / Disable 
	ύXׂɎgp܂B

Arguments:
	IN	bEnable
		A`GAVOtB^̎gpۂ肵܂B
		A`GCAVOtB^Lɂꍇ쑬x
		ቺꍇ܂B

			TRUE 	Anti Aliasing Filter gpB
			FALSE	Anti Aliasing Filter gpȂB

Result:
	KMSTATUS_SUCCESS				

--*/
KMSTATUS KMAPI
kmChangeDisplayAntiAliasMode( 
		IN	KMBOOLEAN bEnable 
	);

/*++
kmGetDisplayFilterMode

proto type:

	KMSTATUS 
	kmGetDisplayFilterMode( 
			OUT	PKMBOOLEAN pbEnabledDither, 
			OUT	PKMBOOLEAN pbEnableAntiAlias
		);

Description:
	kmSetDisplayMode Őݒ肵fBU[hύXׂɎgp܂B

Arguments:
	OUT	pbEnabledDither
		PowerVR  _Oʂ 16bit Frame Buffer ɏލۂ
		Dither ̗L擾܂B_O Frame Buffer  
		RGB888AARGB8888 łꍇÃtO͖Ă܂B
			TRUE	Dither gpB
			FALSE	Dither gpȂB

	OUT	pbEnableAntiAlias
		A`GAVOtB^̎gpۂ擾܂B
			TRUE 	Anti Aliasing Filter gpB
			FALSE	Anti Aliasing Filter gpȂB

Result:
	KMSTATUS_SUCCESS				

--*/

KMSTATUS KMAPI
kmGetDisplayFilterMode( 
		OUT	PKMBOOLEAN pbEnabledDither, 
		OUT	PKMBOOLEAN pbEnableAntiAlias
	);


/*++
kmGetDisplayDitherMode

proto type:

	KMSTATUS 
	kmGetDisplayDitherMode( 
		OUT	PKMBOOLEAN pbEnable
		);

Description:
	kmSetDisplayMode Őݒ肵fBU[hύXׂɎgp܂B

Arguments:
	OUT	pbEnable 
		PowerVR  _Oʂ 16bit Frame Buffer ɏލۂ
		Dither ̗L擾܂B_O Frame Buffer  
		RGB888AARGB8888 łꍇÃtO͖Ă܂B

			TRUE	Dither gpB
			FALSE	Dither gpȂB

Result:
	KMSTATUS_SUCCESS				

--*/
KMSTATUS KMAPI
kmGetDisplayDitherMode( 
		OUT	PKMBOOLEAN pbEnable 
	);


/*++
kmChangeDisplayAntiAliasMode

proto type:

	KMSTATUS 
	kmGetDisplayAntiAliasMode(
			OUT	PKMBOOLEAN pbEnable 
		);

Description:
	kmSetDisplayMode Őݒ肵A`GAVOtB^ Enable / Disable 
	擾ׂɎgp܂B

Arguments:
	OUT	pbEnabled
		A`GAVOtB^̎gpۂ擾܂B

			TRUE 	Anti Aliasing Filter gpB
			FALSE	Anti Aliasing Filter gpȂB

Result:
	KMSTATUS_SUCCESS				

--*/
KMSTATUS KMAPI
kmGetDisplayAntiAliasMode( 
		OUT	PKMBOOLEAN pbEnable
	);

/*++
kmBlankScreen

proto type:

	KMSTATUS
	kmBlankScreen(	KMBOOLEAN bBlanking	);

Description:
	t[obt@̉ʕ\𒆎~AuLOɂB
	< 1 V-Sync Callback  1̌ĂяôݑΉB>

Arguments:
	IN	bBlanking	ʂuLO邩ǂ̎wB
			TRUE 	uLOJn
            FALSE	uLO

Result:
	KMSTATUS_SUCCESS		

--*/
KMSTATUS KMAPI
kmBlankScreen(
			IN	KMBOOLEAN bBlanking
		);

/*++
kmAdjustDisplayCenter

proto type:

	KMSTATUS
	kmAdjustDisplayCenter( 	KMINT32 nXAdjust, 
							KMINT32 nYAdjust 
						);

Description:
	ʏɂFrame buffer ̕\ʒu̒s܂B

Arguments:
	IN	nXAdjust	̉ʕ`ʒu𒲐l
	IN	nYAdjust	c̉ʕ`ʒu𒲐l

Result:
	KMSTATUS_SUCCESS		
	KMSTATUS_OUT_OF_RANGE	L͈͊O̒lw肵B

--*/
KMSTATUS KMAPI
kmAdjustDisplayCenter( 
			IN	KMINT32 nXAdjust, 
			IN	KMINT32 nYAdjust 
		);


/*++
kmSetHSyncLine

proto type:
	KMSTATUS
	kmSetHSyncLine(
			KMINT32 nInterruptLine
		);

Description:
	\CڂŊ荞݂Nw肵܂B 

Arguments:
	IN	nInterruptLine	CڂŊ荞݂Nw肵܂B0`240/480̒lݒ肵ĂB 

Result:
	KMSTATUS_SUCCESS			ݒ萬
	KMSTATUS_ILLEGAL_PARAMETER	ls

--*/

KMSTATUS KMAPI
kmSetHSyncLine(
		KMINT32 nInterruptLine
	);

/*++
kmGetCurrentScanline

proto type:
	KMSTATUS
	kmGetCurrentScanline(
			PKMINT32 pScanline
		);

Description:
	݂H-SyncCǂݏo܂B 

Arguments:
	OUT	pScanline	݂H-SyncCi[KMINT32ւ̃|C^łB 

Result:
	KMSTATUS_SUCCESS			ݒ萬

--*/
KMSTATUS KMAPI
kmGetCurrentScanline(
		PKMINT32 pScanline
	);

/*++
kmWaitVBlank

proto type:
	KMSTATUS
	kmWaitVBlank(
			KMVOID
		);

Description:
	V-Sync ҂킹܂B

Arguments:

Result:
	KMSTATUS_SUCCESS			

--*/
KMSTATUS KMAPI
kmWaitVBlank( KMVOID );


/*++
kmGetDisplayColorMode

proto type:
	KMSTATUS
	kmGetDisplayColorMode(
			PKMINT32 pBpp
		);

Description:
	݂̕\J[[hCǂݏo܂B

Arguments:
	OUT	pBpp		݂̃J[[hi[KMINT32ւ̃|C^łB

Result:
	KMSTATUS_SUCCESS			擾

--*/

KMSTATUS KMAPI
kmGetDisplayColorMode(
		OUT KMINT32		pBpp
	);

/*++
kmSetVirticalFilterMode

proto type:
	KMSTATUS
	kmSetVirticalFilterMode(
			PKMINT32 pBpp
		);

Description:
	_OɎgpctB^̎ނݒ肵܂B

Arguments:
	IN	nMode		ݒ肷 ctB^̎ނłB

			KM_VIRTICAL_FILTER_NORMAL		ftHg̃[hłB
			KM_VIRTICAL_FILTER_NO_FILTER	[r[ĐȂǂɁActB^Jbg
											ꍇɎw肵܂B
			KM_VIRTICAL_FILTER_SQUARE_PIXEL ㉺؂ɂlɏcɏk܂B

Result:
	KMSTATUS_SUCCESS			擾

--*/
KMSTATUS KMAPI
kmSetVirticalFilterMode(
		IN	KM_VIRTICAL_FILETERMODE nMode
	);

/*++
kmGetVirticalFilterMode

proto type:
	KMSTATUS
	kmGetVirticalFilterMode(
			OUT	PKMINT32 pMode
		);

Description:
	݂̏ctB^̎ނǂݏo܂B

Arguments:
	OUT	pMode		ctB^̎ނi[KMINT32ւ̃|C^łB

			KM_VIRTICAL_FILTER_NORMAL		ftHg̃[hłB
			KM_VIRTICAL_FILTER_NO_FILTER	[r[ĐȂǂɁActB^Jbg
											ꍇɎw肵܂B
			KM_VIRTICAL_FILTER_SQUARE_PIXEL ㉺؂ɂlɏcɏk܂B


Result:
	KMSTATUS_SUCCESS			擾

--*/

KMSTATUS KMAPI
kmGetVirticalFilterMode(
		OUT	PKMINT32 pMode
	);

/*++
kmGetDisplaySize

proto type:
	KMSTATUS KMAPI
	kmGetDisplaySize( 
			OUT	PKMINT32	pWidth,
			OUT	PKMINT32	pHeight
		);

Description:
	ʂ̃TCY擾B

Arguments:
	OUT	pWidth		𓾂B
	OUT	pHeight		𓾂B


Result:
	KMSTATUS_SUCCESS			擾

--*/
KMSTATUS KMAPI
kmGetDisplaySize( 
		OUT	PKMINT32	pWidth,
		OUT	PKMINT32	pHeight
	);


/*++
kmGetDisplayInfo

proto type:
	KMSTATUS KMAPI
	kmGetDisplayInfo(
			IN	KMDISPLAYINFO	nIndex,
			OUT	PKMDWORD 		pInfo
		);

Description:
	ʂ̃TCY擾B

Arguments:
	IN	nIndex		
	OUT	pInfo		


Result:
	KMSTATUS_SUCCESS			擾

--*/
KMSTATUS KMAPI
kmGetDisplayInfo(
		IN	KMDISPLAYINFO	nIndex,
		OUT	PKMDWORD 		pInfo
	);


/*++
kmGetStrideWidth

proto type:
	KMINT32
	kmGetStrideWidth(KMVOID);

Description:
	XgCheNX`gṕAXgChTCY擾B

Arguments:

Result:
	lꂽXgChTCY

--*/
KMINT32 kmGetStrideWidth( KMVOID );



/*++
kmGetVsyncCount

proto type:
KMINT32
	kmGetVsyncCount( KMVOID );

Description:
	\u|rJEgl擾B

Arguments:

Result:
	lꂽ\u|rJEg

--*/
KMINT32
	kmGetVsyncCount( KMVOID );


/*++
kmGetFrameBufferBpp

proto type:
	KMBPPMODE
	kmGetFrameBufferBpp( KMVOID );

Description:
	J||h擾B

Arguments:

Result:
	lꂽJ||h

--*/
KMBPPMODE
	kmGetFrameBufferBpp( KMVOID );


/*++
kmGetLatencyModel

proto type:
	KMLATENCYMODEL
	kmGetLatencyModel( KMVOID );

Description:
	CeVf擾B

Arguments:

Result:
	lꂽCeVf

--*/
KMLATENCYMODEL
	kmGetLatencyModel( KMVOID );


/*++
kmGetCurrentDisplaySurface

proto type:
	KMSTATUS KMAPI
	kmGetCurrentDisplaySurface(
			OUT	PKMSURFACEDESC pDesc
		);

Description:
	ʂ̃TCY擾B

Arguments:
	OUT	pDesc		


Result:
	KMSTATUS_SUCCESS			擾

--*/
KMSTATUS KMAPI
kmGetCurrentDisplaySurface(
		OUT	PKMSURFACEDESC pDesc
	);

#endif
