/*++

  COPYRIGHT        (C) NEC        Corporation 1997 - 1999

  All rights reserved by NEC Corporation. This program must be
  used solely for the purpose for which it was furnished by NEC
  Corporation. No part of this program may be reproduced or
  disclosed to others, in any form, without the prior written
  permission of NEC Corporation.
  Use of copyright notice does not evidence publication of this
  program.

  Author     :		T.Hirata(NEC Software,Ltd.)
  Module Name:		km2api_misc.h

  Abstract:
	KAMUI = Kamui is abstruction model that is ultimate interface for PowerVR.
	'km2api_misc.h' define miscelaneous API which can not be classified.

  Environment:
	ANSI C Compiler.

  Notes:
	define Kamui's miscelaneous API proto-types which can not be classified. 
	fog , palette , pixel clipping etc..

  Revision History:

--*/

#if !defined(__kamui2_miscelaneous_api_h__)
#define __kamui2_miscelaneous_api_h__

/*++
kmSetWaitVsyncCount

proto type:

	KMSTATUS
	kmSetWaitVsyncCount( KMINT32 nCount );

Description:
		t[[g藦ɂ邽߂ɁAO FlipA
		Flip \ɂȂ܂łV-Syncw肵܂B

Arguments:
		IN	nCount		V-Sync ҂񐔂w肵܂BO FlipA
						Flip \ɂȂ܂łV-Syncw肵܂B

Result:
		KMSTATUS_SUCCESS			
--*/
KMSTATUS KMAPI
kmSetWaitVsyncCount(
		IN	KMINT32 nCount 
		);


/*++
kmSetCullingRegister

proto type:

	KMSTATUS
	kmSetCullingRegister(
			KMFLOAT fCullVal
		);

Description:
		 Polygon ɑ΂JÕXbVhlݒ肵܂B

Arguments:
		IN	fCullVal	ʃp[^̃f^~iglݒ肵܂B

Result:
		KMSTATUS_SUCCESS			FlipR}hs
		KMSTATUS_CANT_FLIP_SURFACE 	FlipR}hss

--*/

KMSTATUS KMAPI
kmSetCullingRegister(
		IN	KMFLOAT fCullVal
	);


/*++
kmSetColorClampValue

proto type:

	KMSTATUS
	kmSetColorClampValue(
			KMPACKEDARGB MaxVal,
			KMPACKEDARGB MinVal 
		);

Description:
	J[̃Nvlw肵܂BJ[Nv̓tHȎOiŊ|܂B

Arguments:
	IN	MaxVal			Packed ARGB 32bitJ[ŁANv̍őlw肵܂B
	IN	MinVal			Packed ARGB 32bitJ[ŁANv̍ŏlw肵܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/
KMSTATUS KMAPI
kmSetColorClampValue(
		IN	KMPACKEDARGB MaxVal,
		IN	KMPACKEDARGB MinVal 
	);

/*++
kmSetColorClampMax

proto type:
	KMSTATUS KMAPI
	kmSetColorClampMax(
			IN	KMPACKEDARGB Val
		);

Description:
	J[̃Nvlw肵܂BJ[Nv̓tHȎOiŊ|܂B

Arguments:
	IN	Val				Packed ARGB 32bitJ[ŁANv̍őlw肵܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/
KMSTATUS KMAPI
kmSetColorClampMax(
		IN	KMPACKEDARGB Val
	);

/*++
kmSetColorClampMin

proto type:
	KMSTATUS KMAPI
	kmSetColorClampMin(
			IN	KMPACKEDARGB Val
		);

Description:
	J[̃Nvlw肵܂BJ[Nv̓tHȎOiŊ|܂B

Arguments:
	IN	Val				Packed ARGB 32bitJ[ŁANv̍ŏlw肵܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/
KMSTATUS KMAPI
kmSetColorClampMin(
		IN	KMPACKEDARGB Val
	);


/*++
kmSetFogTableColor

proto type:

	KMSTATUS
	kmSetFogTableColor(
			IN	KMPACKEDARGB FogTableColor
		);

Description:
	Table gp tHOJ[w肵܂B

Arguments:
	IN	FogTableColor		FogTable ɎgpPacked32bitJ[łB

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmSetFogTableColor(
		IN	KMPACKEDARGB FogTableColor
	);

/*++
kmSetFogVertexColor

proto type:

	KMSTATUS 
	kmSetFogVertexColor(
			KMPACKEDARGB FogVertexColor
		);

Description:
	FogVertex ̃tHOJ[w肵܂B

Arguments:
	IN	FogVertexColor		FogVertexɎgpPacked32bitJ[łB

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS  KMAPI
kmSetFogVertexColor(
		IN	KMPACKEDARGB FogVertexColor
	);

/*++
kmGenerateFogTable

proto type:

	KMSTATUS
	kmGenerateFogTable(
		OUT	PKMFLOAT	pFogTable,
		IN	KMFLOAT		fFrontBorder,
		IN	KMFLOAT		fBackBorder,
		IN	KMFLOAT		fFogDensity,
		OUT	KMFLOAT		*fHWFogDensity,
		IN	KMDWORD		dwFogType
		);

Description:
	tHOe[u܂B
	tHOLƂȂԂ̑Oь㉏̉sl^ƁA
	̋ԂɂȂ炩ȃtHO悤ȃtHOe[uƃtHOW𐶐܂B 

Arguments:
	OUT	PKMFLOAT	pFogTable
		tHOe[ui[邽߂́A
		128 Gg KMFLOAT`̈ꎟzւ̃|C^łB
	IN	KMFLOAT		fFrontBorder
		tHOLƂȂԂ̑Oslw肵܂B
	IN	KMFLOAT		fBackBorder
		tHOLƂȂԂ̌㉏slw肵܂B
	IN	KMFLOAT		fFogDensity
		tHO̔Zxw肵܂B 
	OUT	KMFLOAT		*fHWFogDensity
		kmSetFogDensity PowerVRn[hEFAɐݒ肷A
		tHOW𕂓ŕԂ܂B
	IN	KMDWORD		dwFogType
		tHOe[ũ^Cvw肵܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬
	KMSTATUS_OUT_OF_RANGE	fBackBorder0.0fȉłA
							܂ fBackBorder > fFrontBorderłA
							܂ fFogDensity0.0f菬B 

--*/

KMSTATUS KMAPI
kmGenerateFogTable(
	OUT	PKMFLOAT	pFogTable,
	IN	KMFLOAT		fFrontBorder,
	IN	KMFLOAT		fBackBorder,
	IN	KMFLOAT		fFogDensity,
	OUT	KMFLOAT		*fHWFogDensity,
	IN	KMDWORD		dwFogType
	);

/*++
kmConvertFogDensity

proto type:

	KMSTATUS
	kmConvertFogDensity(
		IN	KMFLOAT		fFogDensity,
		OUT	KMDWORD		*dwFogDensity
		);

Description:
	_APowerVRn[hEFAWX^ɐݒ肷邽߂
	2 oCg̃tHOW߂܂B

Arguments:
	IN	KMFLOAT		fFogDensity
		kmGenerateFogTable Őꂽ_̃tHOWw肵܂B 
	OUT	KMDWORD		*dwFogDensity
		kmSetFogDensity Ńn[hEFAɐݒ肷Ƃ̂QoCglԂ܂B 

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmConvertFogDensity(
	IN	KMFLOAT		fFogDensity,
	OUT	KMDWORD		*dwFogDensity
	);

/*++
kmSetFogTable

proto type:

	KMSTATUS
	kmSetFogTable(
			PKMFLOAT pfFogTable
		);

Description:
	FogTableo^܂B128 floatl̊i[ꂽzւ̃|C^Ƃēn܂B

Arguments:
	IN	pfFogTable	tHOe[ulzւ̃|C^B128̃p[^w肵܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmSetFogTable(
		IN	PKMFLOAT pfFogTable
	);

/*++
kmSetFogDensity

proto type:

	KMSTATUS
	kmSetFogDensity(KMDWORD fogDensity)

Description:
	Fog ̌W^B

Arguments:
	IN	fogDensity			2 oCg Fog ̌W 

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/
KMSTATUS	KMAPI
kmSetFogDensity(
		IN	KMDWORD fogDensity
	);

/*++
kmSetPaletteMode

proto type:

	KMSTATUS 
	kmSetPaletteMode(	
			KMPALETTEMODE Palettemode
		);

Description:
	pbg̃[hw܂B
	pbgf[^`ޑOɃpbg[hݒ肷Kv܂B

Arguments:
	IN	PaletteMode		pbg BPP [h
						KM_PALETTE_16BPP_ARGB1555	16BPP[h 
						KM_PALETTE_16BPP_RGB565		16BPP[h 
						KM_PALETTE_16BPP_ARGB4444	16BPP[h 
						KM_PALETTE_32BPP_ARGB8888	32BPP[h 

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/
KMSTATUS  KMAPI
kmSetPaletteMode(	
		IN	KMPALETTEMODE Palettemode
	);

/*++
kmSetPaletteData

proto type:
	KMSTATUS
	kmSetPaletteData(
			PKMPALETTEDATA pPaletteTable
		);

Description:
	pbg̐ݒs܂B

Arguments:
	IN	pPaletteTable	Paletteݒpz̃|C^w肵܂B
						Paletteݒpz̓e͈ȉ̂悤ɂȂ܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmSetPaletteData(
		IN	PKMPALETTEDATA pPaletteTable
	);


/*++
kmSetPaletteBankData

proto type:
	KMSTATUS 
	kmSetPaletteBankData(
			IN KMINT32		PaletteEntry,
			IN KMINT32		DataSize,
			IN PKMPALETTEDATA	pPaletteTable
		);

Description:
	PalettizeeNX`Ŏgp Palette ̈ꕔA
	w肵pbgf[^ŏ܂B
	pbg̍\ɂĂkmSetPaletteDataQƊ肢܂B

	pbg[h4bpp/8bppɊւ炸 PaletteEntryɎw\ȒĺA
	01023̂ꂩłBoN̋EɊ֌WȂACӂ̃Gg
	f[^ނƂł܂BpbgPaletteEntryԖڂ̃GgA
			PaletteEntry@{@DataSizeԖڂ̃Gg
	܂łɁApPaletteTableŎẅ̐擪̃f[^珇ɃZbgĂ܂B
	pbgԍ 1023 傫pbgԍɑΉf[^͖܂B
	Ȃ킿ݒ肪ȉɎ悤ȏꍇ́Apbgԍ1023܂łŒ~܂B
			 PaletteEntry@{@DataSize@@1024@

Arguments:
	IN PaletteEntry
		f[^ރpbg̐擪Ggԍw肵܂B
		 0  1023 ̒̂ꂩw肵܂B
		w肳ꂽGgԍ̃pbg̓e܂B

	IN DataSize
		ރf[^̃TCY(Gg)w肵܂B
		1 ő1024 wł܂B

	IN pPaletteTable
		Paletteݒpz̃|C^w肵܂B
		Paletteݒpz̓e͈ȉ̂悤ɂȂ܂B

		KMPALETTEDATA		PaletteTable;

		̃pbgf[^̗vfDataSizeȏȂ΂Ȃ܂B
		ꂪDataSizeȏȂꍇ͕̓ۏ؂܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/
KMSTATUS  KMAPI
kmSetPaletteBankData(
		IN KMINT32			PaletteEntry,
		IN KMINT32			DataSize,
		IN PKMPALETTEDATA	pPaletteTable
	);

/*++
kmSetPaletteBank

proto type:
	KMSTATUS 
	kmSetPaletteBank(
		IN KMINT32				Bank,
		IN KMPALETTE_ENTRY_SIZE	DataSize,
		IN PKMDWORD				pPaletteData
		);

Description:
	PalettizeeNX`ŎgpI`bvpbǵA
	w肳ꂽ 1 oNVȃf[^ŏ܂B 

	Gg̐́ABPP̎wɂ茈肵܂B 
	DataSize KM_PALETTE_ENTRY_16w肳ꂽƂ́APUGg܂B
	̏ꍇ́ApPaletteDataɂ͂PUGg̃f[^KvłB 
	DataSizeKM_PALETTE_ENTRY_256w肳ꂽƂ́AQTUGg܂B
	̏ꍇ́ApPaletteDataɂ͂QTUGg̃f[^KvłB 

	pbg̍\ɂĂ kmSetPaletteData QƊ肢܂B 

Arguments:
	IN KMINT32				Bank
		oN̔ԍw肵܂B
		0  63 ܂ł̂ꂩw\łB 
		8BPPpbgƂĈꍇɂ́A0A16A32A48̂ꂩLłB
		ȊO̒lw肳ꂽꍇ́A 4 bit mask āA
		0,16,32,48̂ꂩɕϊĎgp܂B 

	IN KMPALETTE_ENTRY_SIZE	DataSize
		pbgf[^̃TCYw肵܂B
		ȉ̂ꂩw\łB

		KM_PALETTE_ENTRY_16 	16Gg̃f[^܂B 
								4 BPPpbgƂĈ܂B
		KM_PALETTE_ENTRY_256	256Gg̃f[^܂B 
								8 BPPpbgƂĈ܂B


	IN PKMDWORD				pPaletteData
		Paletteݒpz̃|C^w肵܂B
		̃pbgf[^̗vf DataSize ȏȂ΂Ȃ܂B
		ꂪ DataSize ȏȂꍇ͕̓ۏ؂܂B 

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/
KMSTATUS  KMAPI
kmSetPaletteBank(
		IN KMINT32				Bank,
		IN KMPALETTE_ENTRY_SIZE	DataSize,
		IN PKMDWORD				pPaletteData
	);

/*++
kmSetBorderColor

proto type:
	KMSTATUS
	kmSetBorderColor(
			KMPACKEDARGB BorderColor
		);

Description:
	{[_[(\ʊO̕)J[̐ݒs܂B

Arguments:
	IN	BorderColor		PackedARGBJ[łB

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/

KMSTATUS KMAPI
kmSetBorderColor(
		IN	KMPACKEDARGB BorderColor
	);

/*++
kmSetBackGroundRenderState

proto type:
	KMSTATUS
	kmSetBackGroundRenderState(
			PKMVERTEXCONTEXT	pVertexContext
		);

Description:
	kmProcessVertexRenderState Őݒ肵 KMVERTEXCONTEXT\̂̈ȉ̃o
	Background Plane ̃_Op[^ƂăVXeɓo^B
	{֐Ăяoȍ~ kmSetBackGroundPlane() Ŏw肷 afʂ̐ݒ́A
	ApVertexContext Őݒ肵 KMVERTEXCONTEXT ̒lLɂȂB

	QƂ郁oF
				pVertexContext->GLOBALPARAMBUFFER
				pVertexContext->ISPPARAMBUFFER
				pVertexContext->TSPPARAMBUFFER
				pVertexContext->TexturePARAMBUFFER


Arguments:
	IN	pVertexContext
						Vertex Context ւ̃|C^^B

Result:
	KMSTATUS_SUCCESS	ݒ萬

--*/

KMSTATUS KMAPI
kmSetBackGroundRenderState(
		IN	PKMVERTEXCONTEXT	pVertexContext
	);

/*++
kmSetBackGroundPlane

proto type:
	KMSTATUS
	kmSetBackGroundPlane(
				PVOID			pVertex[3],
				KMVERTEXTYPE	VertexType,
				KMINT32			StructSize
			);

Description:
	obNOEhʂ̐ݒs܂B
	̑OɁAkmSetBackGroundRenderState ĂяoKv܂B

Arguments:
	IN	pVertex[3]		obNOEhv[̍W_f[^\̂ւ̃|C^
						ڍׂ́A kmSetVertex Q

	IN	VertexType		_f[^̃f[^^CvB
						ڍׂ kmSetVertex Q
	IN	StructSize		_f[^̃f[^^CvB
						ڍׂ kmSetVertex Q

Result:
	KMSTATUS_SUCCESS			ݒ萬

--*/

KMSTATUS KMAPI
kmSetBackGroundPlane(
			IN	PVOID			pVertex[3],
			IN	KMVERTEXTYPE	VertexType,
			IN	KMINT32			StructSize
		);

/*++
kmSetBackGround

proto type:
	KMSTATUS
	kmSetBackGroundPlane(
				IN	PKMSTRIPHEAD	pStripHead,
				IN	KMVERTEXTYPE	VertexType,
				IN	PVOID			pVertex1,
				IN	PVOID			pVertex2,
				IN	PVOID			pVertex3
			);

Description:
	obNOEhʂ̐ݒs܂B

Arguments:
	IN	pStripHead		L KMSTRIPHEAD \̂ւ̃|C^n܂B
	IN	VertexType		background ʂŎgp钸_f[^̃f[^^CvB
	IN	pVertex1 / 		obNOEhv[̍W_f[^\̂ւ̃|C^
		pVertex2 /		(0-16)
		pVertex3

Result:
	KMSTATUS_SUCCESS			ݒ萬

--*/
KMSTATUS KMAPI
kmSetBackGround(
		IN	PKMSTRIPHEAD	pStripHead,
		IN	KMVERTEXTYPE	VertexType,
		IN	PVOID			pVertex1,
		IN	PVOID			pVertex2,
		IN	PVOID			pVertex3
	);

/*++
kmSetAutoSortMode

proto type:
	KMSTATUS
	kmSetAutoSortMode(
			KMBOOLEAN fEnable
		);

Description:
	ʂ̃I[g\[g[hON/OFF𐧌䂵܂B

	-> }`pXΉ̂߂ɁÅ֐͖ɂ܂B
	   kmSetSystemConfiguration gpāA
	   epX AutoSort ̗Lw肵ĂB

Arguments:
	IN	bEnable		Auto Sort mode ̗LtO
				TRUE	ʂ̃\[gɃI[g\[g[hݒ肵܂B
				FALSE	]^Ɠ\tgEFAɂ\[eBOG~[V܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬

--*/
KMSTATUS KMAPI
kmSetAutoSortMode(
		IN	KMBOOLEAN fEnable
	);

/*++
kmSetPixelClipping

proto type:
	KMSTATUS
	kmSetPixelClipping(
				KMINT32	Xmin,
				KMINT32	Ymin,
				KMINT32	Xmax,
				KMINT32	Ymax
			);

Description:
	 Frame Buffer ւ̃_Ȍo͂ɑ΂AsNZPʂ̃NbsOݒ肵܂B

Arguments:
	IN	Xmin, Ymin, Xmax, Ymax
				sNZPʂ̃NbsÖ̍AEWw肵܂B
				(Xmin,Ymin)-(Xmax,Ymax)́AʃTCY菬Ȃ΂܂B
				܂Aʃ[h24bpp̎́ANbsÖ̍W͋łȂ΂܂
				(Ȃ킿 2sNZPʂłNbsÖݒł܂)B
				łȂꍇɂ́A(Xmin,Ymin)ɑ΂Ă͎w 1 傫lA
										(Xmax,Ymax)ɑ΂Ă͎w 1 lݒ肳܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬
	KMSTATUS_INVALID_PARAMETER	p[^s

--*/

KMSTATUS KMAPI
kmSetPixelClipping(
		IN	KMINT32	Xmin,
		IN	KMINT32	Ymin,
		IN	KMINT32	Xmax,
		IN	KMINT32	Ymax
	);

/*++
kmSetRegionClipping

proto type:
	KMSTATUS
	kmSetRegionClipping(
				KMINT32	Xmin,
				KMINT32	Ymin,
				KMINT32	Xmax,
				KMINT32	Ymax
			);

Description:
	 Frame Buffer ւ̃_Ȍo͂ɑ΂A[WPʂ̃NbsOݒ肵܂B

Arguments:
	IN	Xmin, Ymin, Xmax, Ymax
				[WPʂ̃NbsÖ̍AEWw肵܂B
				(Xmin,Ymin)-(Xmax,Ymax)́AʃTCY菬Ȃ΂܂B

Result:
	KMSTATUS_SUCCESS		ݒ萬
	KMSTATUS_INVALID_PARAMETER	p[^s

--*/

KMSTATUS KMAPI
kmSetRegionClipping(
		IN	KMINT32	Xmin,
		IN	KMINT32	Ymin,
		IN	KMINT32	Xmax,
		IN	KMINT32	Ymax
	);

/*++
kmSetGlobalClipping

proto type:
	KMSTATUS
	kmSetGlobalClipping(
				KMINT32 nWidth, 
				KMINT32 nHeight
			);
Description:
	O[oNbsÖw肵܂B0,0IWWidthAHeightŎw肳ꂽ
	̈ȊÔƂɂ̓_O܂B

Arguments:
	IN	nWidth, nHeight				^CTCÝA32x32łB
									Ƃ128x64̗̈w肵ꍇɂ 
									Width = 4,Height= 2Ƃ܂B

Result:
	KMSTATUS_SUCCESS					ݒ萬
	KMSTATUS_INVALID_PARAMETER			ݒ莸s

--*/

KMSTATUS KMAPI
kmSetGlobalClipping(
		IN	KMINT32 nWidth, 
		IN	KMINT32 nHeight
	);

/*++
kmSetStrideWidth

proto type:
	KMSTATUS
	kmSetStrideWidth(
			KMINT32 nWidth
		);

Description:
	XgCheNX`̃XgChTCYw肵܂BXgChTCÝA
	32 ̔{łȂ΂ȂȂB

Arguments:
	IN	nWidth		XgChTCY͂B
					XgChTCY 32̔{łȂ΂ȂȂB

Result:
	KMSTATUS_SUCCESS			ݒ萬
	KMSTATUS_INVALID_PARAMETER	p[^s

--*/

KMSTATUS KMAPI
kmSetStrideWidth(
		KMINT32 nWidth
	);

/*++
kmResetRenderer

proto type:

	KMSTATUS
	kmResetRenderer( VOID );

Description:
	_OpCvC̃\tgEFAZbgsB

	gpꍇF
		EStripBuffergpɃXgbṽf[^`Ȃ
		  ꍇ̋ZbgB

Arguments:
	NONE

Result:

	KMSTATUS_SUCCESS				

--*/

KMSTATUS KMAPI
kmResetRenderer( VOID );

/*++
kmSetUserClipLevelAdjust

proto type:

	KMSTATUS
	kmSetUserClipLevelAdjust( KMADJUSTTYPE	Adjust,
				  PKMINT32	pLine
				 );

Description:
	̉ʕ\[hݒ肵܂B
	gp邱ƂɂÃ[U[NbsÖ̋EA
	ʂ̂قڒɗ悤ɂ邱Ƃł܂BΐQ[Ȃǂŉʂ
	㉺ 2 Ďgpꍇɐݒ肵܂B

	_Ђŉʂ㉺ 2 ɕꍇ́Å֐KM_LEVEL_ADJUST_HALFw肵ŁA
	[U[Nbv̈̂xWL̂悤ɐݒ肵ĂBƁÃNbv̈
	̋Eɗ͉ʂ̒ƂȂ悤A\̈𒲐܂B

		ʂ̏c̉𑜓x	[U[Nbv̈̂xW
			240						0 ` 119@Ɓ@120 ` 239
			480						0 ` 255@Ɓ@256 ` 479

	ȂȀꍇAʂ̏㕔C͕\ȂȂ܂B\
	ȂȂ郉ĆApLine瓾邱Ƃł܂B

Arguments:
	IN	Adjust	̉ʕ\[hw肵܂B
			ȉ̂ꂩwł܂B
			KMADJUSTTYPE
			KM_LEVEL_ADJUST_NORMAL		ʏ\p̕\[hw肵܂B
			KM_LEVEL_ADJUST_HALF		2\p̕\[hw肵܂B


	OUT	pLine
			AdjustKM_LEVEL_ADJUST_HALFw肵ꍇA_Ђ͂ɉʂ̏㉺
			VtgʂsNZŕԂ܂Bʂ̍ŏ㕔AŎw肳ꂽC
			\ȂȂ܂B_o^ɂ͊e_̂xWlɁA̒lZĂB
			pLine  NULL w肵Ă܂܂񂪁ȀꍇA[U͒_̂xWɉZׂ
			C擾邱Ƃł܂B

			AdjustKM_LEVEL_ADJUST_NORMALw肵ꍇ́ApLineẅ̓e͕ύX܂B


Result:

	KMSTATUS_SUCCESS				

--*/
KMSTATUS KMAPI
kmSetUserClipLevelAdjust(
		IN	KMADJUSTTYPE	Adjust,
		OUT	PKMINT32	pLine
	);

/*++
kmGetGunTriggerPos

proto type:
	KMSTATUS KMAPI
	kmGetGunTriggerPos(
			PKMDWORD pHPos,
			PKMDWORD pVPos
		);

Description:
	Gun Peripheral ̃gKꂽʒuԂ܂B

Arguments:
	OUT	pHPos	H-Blank Out ̐ʒu
    OUT	pVPos	V-Blank Out ̐ʒu

Result:
	KMSTATUS_SUCCESS		

--*/

KMSTATUS KMAPI
kmGetGunTriggerPos(
		OUT	PKMDWORD pHPos,
		OUT	PKMDWORD pVPos
	);

/*++
kmUseAnotherModifier

proto type:
	KMSTATUS
	kmUseAnotherModifier(
			KMLISTTYPE kmModifierListType
			);

Description:
	kmModifierListType Ŏw肵 Modifier 𑼕 
	Modifier ƂĂgpB

	-> }`pXΉ̂߂ɁÅ֐͖ɂ܂B
	   kmSetSystemConfiguration gpāAepX 
		̃Xggp@\̗Lw肵ĂB

Arguments:
	IN	kmModifierListType		KM_OPAQUE_MODIFIER	Opaque Modifier  Trans Modifier  ƂĎgpB
								KM_TRANS_MODIFIER	Trans Modifier   Opaque Modifier ƂĎgpB

Result:
	KMSTATUS_SUCCESS				ݒ萬
	KMSTATUS_INVALID_LIST_TYPE		ݒ莸s

--*/

KMSTATUS KMAPI
kmUseAnotherModifier(
		IN	KMLISTTYPE kmModifier
			);

/*++
kmSetCheapShadowMode

proto type:
	KMSTATUS
	kmSetCheapShadowMode(
			KMINT32 nIntensity
			);

Description:
	`[v(Ȉ)VhE[hI܂BCheapShadowModeƂ́APolygon Modifier Volume ɂꍇA
   ̋̕Px邱Ƃɂe\@\łB̊֐Œlݒ肳ꂽ́AׂĂModifierVolume̐ݒ
   `[vVhE[hɐݒ肳܂BV[ 2 p[^PolygonƂ̋͂ł܂B
   CheapShadowModeIɂ͈ɕ̐Ă̊֐ĂяoĂB

Arguments:
	IN	nIntensity		fBt@CA{[ɓPolygon̋Pxݒ肵܂B0255̒lgpł܂B
						ۂɂ͂256ŊlPolygoñx[XJ[ƃItZbgJ[ɏZ܂B]āA
						128w肷128/256 = 0.5Z邱ƂɂȂ܂B܂A̒l͂ꍇA
						̃V[ CheapShadowMode ̐ݒIAʏ 2 p[^PolygonLƂȂ܂B

Result:
	KMSTATUS_SUCCESS					ݒ萬
	KMSTATUS_INVALID_PARAMETER			p[^s

--*/

KMSTATUS KMAPI
kmSetCheapShadowMode(
		IN	KMINT32 nIntensity
			);


/*++
kmQueryFinishLastTextureDMA

proto type:
	KMSTATUS
	kmQueryFinishLastTextureDMA(KMVOID);

Description:
	OLoadTextureɂDMAIǂ`FbN܂B
	kmSetSystemConfigurationflagKM_CONFIGFLAG_NOWAIT_FINISH_TEXTUREDMA
	ꍇɂ̂ݗLłBȊȌꍇɂ́AKMSTATUS_SUCCESSԂ܂B

Arguments:
	Ȃ

Result:
	KMSTATUS_SUCCESS				ODMA͏IĂ
	KMSTATUS_NOT_FINISH_DMA			ODMA͏IĂȂ

--*/
KMSTATUS KMAPI
kmQueryFinishLastTextureDMA(KMVOID);


/*++
kmGetSystemMetrics

proto type:
	KMSTATUS
	kmGetSystemMetrics(
		PKMSYSTEMMETRICS pSysMetrics
		);

Description:

Arguments:
	IN	OUT	pSysMetrics				

Result:
	KMSTATUS_SUCCESS				

--*/
KMSTATUS KMAPI
kmGetSystemMetrics(
		IN OUT PKMSYSTEMMETRICS pSysMetrics
		);

/*++
kmSetPunchThroughThreshold

proto type:
	KMSTATUS KMAPI
	kmSetPunchThroughThreshold(
			IN	KMDWORD dwThreshold
		);

Description:
		Punch Through List   臒lݒ肵܂B

			0 <  < dwThreshold 	= 0
			dwThreshold  <  < 255	= 0xff

Arguments:
	IN	dwThreshold		Punch Through List   臒l
						͈ F 0 - 255

Result:
	KMSTATUS_SUCCESS				ݒ萬

--*/
KMSTATUS KMAPI
kmSetPunchThroughThreshold(
		IN	KMDWORD dwThreshold
	);


/*++
kmSetYCoefficient

proto type:
	KMSTATUS
	kmSetYCoefficient(
		IN	KMINT32				nYCoeff0,
		IN	KMINT32				nYCoeff1
		);

Description:
	_OɎgpctB^Wݒ肵܂B

Arguments:
	IN	nYCoeff0			ݒ肷 ctB^WiCO^QjłB
	IN	nYCoeff1			ݒ肷 ctB^WiCPjłB

Result:
	KMSTATUS_SUCCESS

--*/
KMSTATUS KMAPI
kmSetYCoefficient(
		IN	KMINT32				nYCoeff0,
		IN	KMINT32				nYCoeff1
	);

/*++
kmSetTimeOutCount

proto type:
	KMSTATUS KMAPI
	kmSetTimeOutCount(
			IN	KMINT32 nRenderTimeOut
		);

Description:

Arguments:
	IN	nRenderTimeOut	_OJn烌_O
						ł؂܂ł VSync

Result:
	KMSTATUS_SUCCESS				ݒ萬

--*/
KMSTATUS KMAPI
kmSetTimeOutCount(
		IN	KMINT32 nRenderTimeOut
	);

/*++
kmSetNoWaitVSyncAtDisplayModeChange

proto type:
	KMSTATUS KMAPI
	kmSetNoWaitVSyncAtDisplayModeChange(
			KMBOOLEAN bNoWait
		);

Description:

Arguments:
	IN	bNoWait	    ʃ[hςɁA
					VSync ҂ǂ̎wsB
					TRUE  ... ҂ȂB
					FALSE ... ҂(Default)

Result:
	KMSTATUS_SUCCESS				ݒ萬

--*/
KMSTATUS KMAPI
kmSetNoWaitVSyncAtDisplayModeChange(
		KMBOOLEAN bNoWait
	);

#endif
