/*++

  COPYRIGHT        (C) NEC        Corporation 1997 - 1999

  All rights reserved by NEC Corporation. This program must be
  used solely for the purpose for which it was furnished by NEC
  Corporation. No part of this program may be reproduced or
  disclosed to others, in any form, without the prior written
  permission of NEC Corporation.
  Use of copyright notice does not evidence publication of this
  program.

  Author     :		T.Hirata(NEC Software,Ltd.)
  Module Name:		km2api_render.h

  Abstract:
	KAMUI = Kamui is abstruction model that is ultimate interface for PowerVR.
	'km2api_render.h' define the function of rendering and the function 
	which is related with renderring.

  Environment:
	ANSI C Compiler.

  Notes:
	kmRender and kmRenderTexture must be among kmEndScene from kmBeginScene();
	kmRender and kmRenderTexture return RenderID.
	Therefore,RenderID must be examined in kmGetRenderStatus if wanting to know
	result of kmRender and kmRenderTexture.

  Revision History:

--*/

#if !defined(__kamui2_render_api_h__)
#define __kamui2_render_api_h__

/*++
kmRender

proto type:
	KMINT32
	kmRender( 
			IN KMDWORD dwFlipMode 
		);

Description:
	^CANZ[^ɑ΂āA1V[̒_f[^̓o^IƂ_Ђɒʒm,
	f[^WJABack Buffer ɑ΂郌_OJn܂B

Arguments:
	dwFlipMode

Result:
	KMINT32		0 < (return)	DMA lounch success. you can query finish render,
				0 > (return)	miss.

--*/

KMINT32 KMAPI
kmRender( 
		IN KMDWORD dwFlipMode
	);

/*++
kmRenderRect

proto type:
	KMINT32
	kmRenderRect( 
			IN KMDWORD dwFlipMode 
		);

Description:
	^CANZ[^ɑ΂āA1V[̒_f[^̓o^IƂ_Ђɒʒm,
	f[^WJABack Buffer ɑ΂郌_OJn܂B_OOɁA
	[WAC̍č\zs܂B

Arguments:
	dwFlipMode

Result:
	KMINT32		0 < (return)	DMA lounch success. you can query finish render,
				0 > (return)	miss.

--*/

KMINT32 KMAPI
kmRenderRect( 
		IN KMDWORD dwFlipMode
	);

/*++
kmRenderTexture

proto type:
	KMINT32
	kmRenderTexture(	
			IN	PKMSURFACEDESC pTextureSurface,
			IN  KMDWORD        dwDitherMode
		);

Description:
	^CANZ[^ɑ΂āA1V[̒_f[^̓o^IƂ_Ђɒʒm܂B
	_f[^WJA(pTextureSurface) Ŏw肳ꂽeNX`ɑ΂郌_OJn܂B(
	ȂA`Ɏw肷eNX`́ARectangle/Stride`łȂ΂Ȃ܂B

Arguments:
	OUT	pTextureSurface		_Oʂi[eNX`łB

Result:
	KMINT32		0 < (return)	DMA lounch success. you can query finish render,
				0 > (return)	miss.

--*/

KMINT32 KMAPI
kmRenderTexture(
			IN	PKMSURFACEDESC pTextureSurface,
			IN  KMDWORD        dwDitherMode
		);

/*++
kmGetRenderStatus

proto type:
	KMSTATUS
	kmGetRenderStatus(	
			IN	KMINT32			nRenderID
		);

Description:
	s_O݂ǂ̂悤ȏ󋵂𒲂ׂ܂B

Arguments:
	IN nRenderID	kmRenderkmRenderTexturesꍇ̕Ԃl͂܂B

		jkmRenderTexturekmRenderɂNO_FLIPw肵ꍇA
		@@KMSTATUS_UNDER_DISPLAY͖{֐̕ԂlƂ͂Ȃ܂B

Result:
	KMSTATUS_UNDER_DMA				wID_O͌ݒ_f[^DMA]
	KMSTATUS_FINISH_DMA				wID_O͌DMA]I
	KMSTATUS_UNDER_RENDER			wID_O͌݃_O
	KMSTATUS_FINISH_RENDER			wID_O͌݃_OI
	KMSTATUS_UNDER_DISPLAY			wID_O͌ݕ\
	KMSTATUS_FINISH_ALL_SEQUENCE	wID_Oׂ݂͌Ă̏I

--*/

KMSTATUS KMAPI
kmGetRenderStatus(	
		IN	KMINT32			nRenderID
	);

/*++
kmGetRenderStatusAll

proto type:
	KMINT32 KMAPI
	kmGetRenderStatusAll();

Description:
	s_O݂ǂ̂悤ȏ󋵂𒲂ׂ܂B
	KAMUI œo^ꂽs̑SpPbg󋵂󋵂rbgŕԂ܂B
	erbg̑gݍ킹̊mF邱Ƃɂ胊\|X̃bNԂł܂B
	SLpPbgɁAY󋵂Ȃꍇ͂OԂ܂B

Arguments:


Result:
	KMPACKET_UNDER_VERTEXDEF		_obt@ւ̒_o^
	KMPACKET_FINISH_VERTEXDEF		_obt@ւ̒_o^IAcl`]҂
	KMPACKET_UNDER_DMA				cl`]
	KMPACKET_FINISH_DMA				cl`]IA_OJn҂
	KMPACKET_UNDER_RENDER			_O
	KMPACKET_FINISH_RENDER			_OIA\Jn҂
	KMPACKET_UNDER_DISPLAY			\

--*/

KMINT32 KMAPI
kmGetRenderStatusAll();

#endif
