/*++

  COPYRIGHT        (C) NEC        Corporation 1997 - 1999

  All rights reserved by NEC Corporation. This program must be
  used solely for the purpose for which it was furnished by NEC
  Corporation. No part of this program may be reproduced or
  disclosed to others, in any form, without the prior written
  permission of NEC Corporation.
  Use of copyright notice does not evidence publication of this
  program.

  Author     :		T.Muto(NEC Software,Ltd.)
  Module Name:		km2api_tex.h

  Abstract:
	KAMUI = Kamui is abstruction model that is ultimate interface for PowerVR.
	'km2api_tex.h' define the function of texture memory manager.

  Environment:
	ANSI C Compiler.

  Notes:
	

  Revision History:

--*/

#if !defined(__kamui2_texture_api_h__)
#define __kamui2_texture_api_h__

/*++
kmCreateTextureSurface

proto type:
	KMSTATUS 
	kmCreateTextureSurface(
			PKMSURFACEDESC	pSurfaceDesc,
			KMINT32			nWidth, 
			KMINT32			nHeight, 
			KMTEXTURETYPE	nTextureType
		);

Description:
	eNX`pSurfacemۂ܂B

Arguments:
	OUT	pSurfaceDesc		KMSURFACEDESC \̗̂̈|C^łB
							mۂ Texture Surface ̏񂪕Ԃ܂B
							KMSTATUS KMSTATUS_NOT_ENOUGH_MEMORYԂꂽꍇɂ͕sƂȂ܂B

	IN	nWidth, nHeight		eNX`̉TCYAcTCYw肵܂B
								MIPMAPgpꍇɂ̓gbvx̃eNX`TCYw肵܂B
								Twiddled, VQ, PalettizedȂǂ̐`eNX`gpꍇɂ 
									nWidthɎw肵l݂̂gp܂B
								`eNX`gpꍇɂ́AnWidth, nHeightɗLłB
								HOLLY͐`eNX`TCYƂ 8x8`1024x1024܂ł̃eNX`gpł܂A
								nWidth, nHeightɎw肷l,8, 16, 32, 64, 128, 256, 512, 1024
								ꂩłȂ΂Ȃ܂B

	IN	nTextureType		eNX`̌`w肵܂B
							ȉ̃JeSR[hAsNZtH[}bgR[h
							IяoA_a(or)ė^܂

								-JeSR[h
									KM_TEXTURE_TWIDDLED			// TwiddledtH[}bg
									KM_TEXTURE_TWIDDLED_MM		// TwiddledtH[}bgMipmap
									KM_TEXTURE_VQ				// VQk`
									KM_TEXTURE_VQ_MM			// VQk`Mipmap
									KM_TEXTURE_PALETTIZE4		// 4bpppbg`
									KM_TEXTURE_PALETTIZE4_MM	// 4bpppbg`Mipmap
									KM_TEXTURE_PALETTIZE8		// 8bpppbg`
									KM_TEXTURE_PALETTIZE8_MM	// 8bpppbg`Mipmap
									KM_TEXTURE_RECTANGLE		// `

								- sNZtH[}bgR[h
									KM_TEXTURE_1555
									KM_TEXTURE_565
									KM_TEXTURE_4444
									KM_TEXTURE_YUV422
									KM_TEXTURE_BUMP
									KM_TEXTURE_8888

							)  KM_TEXTURE_8888KM_TEXTURE_PALETTIZE4or8Ƃ̑gݍ킹̂ݗLłB

Result:
		KMSTATUS_SUCCESS					eNX`mې
		KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵
		KMSTATUS_NOT_ENOUGH_MEMORY			eʂȂ
		KMSTATUS_INVALID_MIPMAPED_TEXTURE	MIPMAPłȂeNX`MIPMAPw肵B

--*/

KMSTATUS KMAPI
kmCreateTextureSurface(
		OUT	PKMSURFACEDESC	pSurfaceDesc,
		IN	KMINT32			nWidth, 
		IN	KMINT32			nHeight, 
		IN	KMTEXTURETYPE	nTextureType
	);

/*++
kmCreateCombinedTextureSurface

proto type:
	KMSTATUS 
	kmCreateCombinedTextureSurface(
			PKMSURFACEDESC	pSurfaceDesc1,
			PKMSURFACEDESC	pSurfaceDesc2,
			KMINT32			nWidth, 
			KMINT32			nHeight, 
			KMTEXTURETYPE	nTextureType
		);

Description:
	VQeNX`pSurface 2mۂ܂BnTextureTypeɂɐݒ肷eNX`JeS
	KM_TEXTURE_VQ,KM_TEXTURE_VQ_MM̂ǂ炩łȂ΂Ȃ܂B

Arguments:
	OUT	pSurfaceDesc1		KMSURFACEDESC \̗̂̈ 1 ߂̃|C^łB
							mۂ Texture Surface ̏񂪕Ԃ܂B
							KMSTATUS KMSTATUS_NOT_ENOUGH_MEMORYԂꂽꍇɂ͕sƂȂ܂B

	OUT	pSurfaceDesc2		KMSURFACEDESC \̗̂̈ 2 ߂̃|C^łB
							mۂ Texture Surface ̏񂪕Ԃ܂B
							KMSTATUS KMSTATUS_NOT_ENOUGH_MEMORYԂꂽꍇɂ͕sƂȂ܂B

	IN	nWidth, nHeight		eNX`̉TCYAcTCYw肵܂B
							MIPMAPgpꍇɂ̓gbvx̃eNX`TCYw肵܂B
							HOLLY͐`eNX`TCYƂ 8x8`1024x1024܂ł̃eNX`gpł܂A
							nWidth, nHeightɎw肷l,8, 16, 32, 64, 128, 256, 512, 1024
							ꂩłȂ΂Ȃ܂B

	IN	nTextureType		eNX`̌`w肵܂B
							ȉ̃JeSR[hAsNZtH[}bgR[h
							IяoA_a(or)ė^܂

								-JeSR[h
									KM_TEXTURE_VQ				// VQk`
									KM_TEXTURE_VQ_MM			// VQk`Mipmap

								- sNZtH[}bgR[h
									KM_TEXTURE_ARGB1555
									KM_TEXTURE_ARGB4444

Result:
		KMSTATUS_SUCCESS					eNX`mې
		KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵
		KMSTATUS_NOT_ENOUGH_MEMORY			eʂȂ

--*/

KMSTATUS KMAPI
kmCreateCombinedTextureSurface(
		OUT	PKMSURFACEDESC	pSurfaceDesc1,
		OUT	PKMSURFACEDESC	pSurfaceDesc2,
		IN	KMINT32			nWidth, 
		IN	KMINT32			nHeight, 
		IN	KMTEXTURETYPE	nTextureType
	);


/*++
kmLoadTexture

proto type:

	KMSTATUS
	kmLoadTexture(
			PKMSURFACEDESC pSurfaceDesc,
			PKMDWORD pTexture
		);

Description:
	kmCreateTextureSurfaceŊmۂeNX`̗̈ɁA 
	pTextureŎw肳ꂽC̃eNX`ǂݍ݂܂B

Arguments:
	IN	pSurfaceDesc	kmCreateTextureSurfaceŊmۂeNX`T[tFXłB
	IN	pTexture		C̃eNX`|C^łB

Result:
	KMSTATUS_SUCCESS					ǂݍݐ
	KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵

--*/
KMSTATUS KMAPI
kmLoadTexture(
	IN	PKMSURFACEDESC pSurfaceDesc,
	IN	PKMDWORD pTexture
	);

/*++
kmLoadTextureBlock

proto type:

	KMSTATUS KMAPI
	kmLoadTextureBlock(
		PKMSURFACEDESC	pSurfaceDesc,
		PKMDWORD		pTexture,
		KMUINT32		nBlockNum,
		KMUINT32		nBlockSize
	)

Description:
	kmCreateTextureSurfaceŃAP[geNX`̗̈ɁA 
	pTextureŎw肳ꂽC̃eNX`ubNǂݍ݂܂B

	eNX`f[^̃ubNɕēǂݍ݂܂B
	ɂACɑ傫ȃ[NGAmۂ邱ƂȂA
	TCY̑傫ȃeNX`ǂݍނƂł܂B

	eNX`Ŝ̃TCYubNTCYŊ؂ȂĂAǂݍ܂܂B

	ǂݍރeNX`̃tH[}bg`ATCYȂǂ́ApSurfaceDesc
	wT[tFXfBXNv^蔻f܂B
	ۂ̃eNX`̃tH[}bg`ȂǂApSurfaceDescwT[tFXfBXNv^
	̓eƈقȂĂꍇ́A\sƂȂ܂B

	ȂÅ֐Small VQ`̃eNX`ɂ͑ΉĂ܂B
	Small VQ`pSurfaceDescw肵ꍇɂ́AKMSTATUS_INVALID_TEXTURE_TYPEԂ܂B

Arguments:
	IN	pSurfaceDesc	kmCreateTextureSurface/kmCreateCombinedTextureSurface
						AP[geNX`T[tFXłB
	IN	pTexture		C̃eNX`ubN̐擪|C^łB
	IN	nBlockNum		eNX`̃ubNԍ 0  n ( n̓tH[}bg/TCYɂ)Ŏw肵܂B
	IN	nBlockSize		ubÑTCY 32oCgPʂŎw肵܂B
						ubNTCY(oCg) 32 Ŋlw肵ĂB
						ȂAeNX`Ŝ̃TCYubNTCYŊ؂Kv͂܂B

Result:
	KMSTATUS_SUCCESS					ǂݍݐ
	KMSTATUS_INVALID_BLOCKNUMBER		ubNԍs
	KMSTATUS_INVALID_ADDRESS			w肳ꂽAhX擪ɎubN
										AP[gĂȂ
	KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵

--*/

KMSTATUS KMAPI
kmLoadTextureBlock(
	IN	PKMSURFACEDESC	pSurfaceDesc,
	IN	PKMDWORD		pTexture,
	IN	KMUINT32		nBlockNum,
	IN	KMUINT32		nBlockSize
	);

/*++
kmLoadTexturePart

proto type:

	KMSTATUS KMAPI
	kmLoadTexturePart(
			PKMSURFACEDESC	pSurfaceDesc,
			PKMDWORD		pTexture,
			KMUINT32		nOffset,
			KMUINT32		nSize
		)

Description:
	kmCreateTextureSurfaceŃAP[geNX`̗̈ɁA 
	pTextureŎw肳ꂽC̃eNX`()ǂݍ݂܂B

	eNX`f[^̕ɕēǂݍ݂܂B
	ɂACɑ傫ȃ[NGAmۂ邱ƂȂA
	TCY̑傫ȃeNX`ǂݍނƂł܂B

	kmLoadTextureBlockƈقȂA̃eNX`AuTCŸقȂv
	̕ɕēǂݍނƂł܂BA܂łɓǂݍ
	eNX`̃TCY(擪̃ItZbg)́A[UŊǗ
	Kv܂B

	ǂݍރeNX`̃tH[}bg`ATCYȂǂ́ApSurfaceDesc
	Ŏw肳T[tFXfBXNv^蔻f܂B
	ۂ̃eNX`̃tH[}bg`ȂǂApSurfaceDescŎw肳
	T[tFXfBXNv^̓eƈقȂĂꍇ́A\sƂȂ܂B

	ȂÅ֐Small VQ`̃eNX`ɂ͑ΉĂ܂B
	Small VQ`pSurfaceDescw肵ꍇɂ́AKMSTATUS_INVALID_TEXTURE_TYPEԂ܂B

Arguments:
	IN	pSurfaceDesc	kmCreateTextureSurface/kmCreateCombinedTextureSurface
						AP[geNX`T[tFXłB
	IN	pTexture		C̃eNX`ubN̐擪|C^łB
	IN	nOffset			łɓǂݍ񂾃eNX`̃TCY(擪̃ItZbg)
						oCgPʂŎw肵܂B́AǂݍރeNX`f[^
						]AeNX`̈̐擪AhXƂȂ܂B
	IN	nSize			ǂݍޕ̃TCYoCgPʂŎw肵܂B
						ȂAnSizeAeNX`̎cTCY ( = eNX`TCY - nOffset)
						傫ꍇ́AcTCŶ݂𐳂ǂݍŐI܂B

Usage:
	nOffset = 0;
	nSize   = ***;
	pTextureɃeNX`f[^̍ŏnSizeoCg[h;
	while(KMSTATUS_SUCCESS == kmLoadTexturePart(...);
		nOffset = nOffset + nSize;
		nSize   = ????;
		pTextureɎnSizeoCg[h;
	}

Result:
	KMSTATUS_SUCCESS					ǂݍݐ
	KMSTATUS_INVALID_ADDRESS			nOffseteNX`TCYzĂ
	KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵

--*/

KMSTATUS KMAPI
kmLoadTexturePart(
	IN	PKMSURFACEDESC	pSurfaceDesc,
	IN	PKMDWORD		pTexture,
	IN	KMUINT32		nOffset,
	IN	KMUINT32		nSize
	);


/*++
kmLoadRectangleTexturePart

proto type:

	KMSTATUS KMAPI
	kmLoadRectangleTexturePart(
			PKMSURFACEDESC	pSurfaceDesc,
			PKMDWORD		pTexture,
			KMUINT32		width,
			KMUINT32		height,
			KMUINT32		dst_X,
			KMUINT32		dst_Y,
			KMUINT32		src_X,
			KMUINT32		src_Y,
			KMUINT32		src_U
			)

Description:
	kmCreateTextureSurfaceŃAP[gRectangle/Stride`
	eNX`̋`̈ɁApTextureŎw肳ꂽC
	̃eNX`̋`̈()݂܂B

	Rectangle/Stride`eNX`̈ꕔ邱Ƃł܂B

	]̋`̈́A( dst_X, dst_Y )-( dst_X + width, dst_Y + height )łB
	]̋`̈́A( src_X, src_Y )-( src_X + width, src_Y + height )łB
	src_U[łꍇ́A]eNX`̃TCY͋`̈̕
	(width,height)Ɠ̂Ƃ݂Ȃ܂B

	ȂÅ֐Rectangle/Stride`eNX`ɂ̂ݑΉĂ܂B
	ȊOpSurfaceDescw肵ꍇɂ́A
	KMSTATUS_INVALID_TEXTURE_TYPEԂ܂B

	`̈́A]E]eNX`̗̈ɊSɊ܂܂ĂȂ
	΂Ȃ܂B
	łȂꍇɂ́A]eNX`܂߁ÃeNX`̃f[^
	j󂳂ꍇ܂B
	_Ђł́Ã`FbN͍s܂B

Arguments:
	IN	pSurfaceDesc	kmCreateTextureSurface/kmCreateCombinedTextureSurface
						AP[gRectangle/Stride`̃eNX`T[tFXłB
						(]eNX`)
	IN	pTexture		C̃eNX`f[^̐擪|C^łB
						(]eNX`)
	IN	width,height	]`̈̕ƍeNZŎw肵܂B
	IN	dst_X,dst_Y		]eNX`ɉ`̈X,YWłB
						]eNX`̍(擪)eNZ
						΃eNZŎw肵܂B
	IN	src_X,src_Y		]eNX`ɉ`̈X,YWłB
						]eNX`̍(擪)eNZ
						΃eNZŎw肵܂B
	IN	src_U			]eNX`̕eNZŎw肵܂B
						ꂪ[łꍇ́A]eNX`̃TCY
						`̈̕ƍ(width,height)Ɠ̂Ƃ݂Ȃ܂B
						̂Ƃ́Asrc_X,src_Y̒l͖܂B(0Ƃ݂Ȃ܂)

Result:
	KMSTATUS_SUCCESS					ǂݍݐ
	KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵

--*/

KMSTATUS KMAPI
kmLoadRectangleTexturePart(
	IN	PKMSURFACEDESC	pSurfaceDesc,
	IN	PKMDWORD		pTexture,
	IN	KMUINT32		width,
	IN	KMUINT32		height,
	IN	KMUINT32		dst_X,
	IN	KMUINT32		dst_Y,
	IN	KMUINT32		src_X,
	IN	KMUINT32		src_Y,
	IN	KMUINT32		src_U
	);


/*++
kmFreeTexture

proto type:
	KMSTATUS
	kmFreeTexture(
			PKMSURFACEDESC pSurfaceDesc
		);

Description:
	w肵eNX`T[tFX܂B

Arguments:
	IN	pSurfaceDesc	kmCreateTextureSurfaceŊmۂeNX`T[tFXłB

Result:
	KMSTATUS_SUCCESS				
	KMSTATUS_INVALID_PARAMETER		sAeNX`̎w肪s

--*/

KMSTATUS KMAPI
kmFreeTexture(
	IN	PKMSURFACEDESC pSurfaceDesc
	);


/*++
kmGetFreeTextureMem

proto type:
	KMSTATUS
	kmGetFreeTextureMem(
		PKMUINT32 pSizeOfTexture,
		PKMUINT32 pMaxBlockSizeOfTexture
		);

Description:
	eNX`̎ceʂԂ܂B

Arguments:
	OUT	pSizeOfTexture
			eNX`̎ceʂԂKMDWORD̈ւ̃|C^łB
	OUT	pMaxBlockSizeOfTexture
			eNX`̋󂫃ubN̍őeʂԂKMDWORD̈ւ̃|C^łB
Result:
	KMSTATUS_SUCCESS		

--*/

KMSTATUS KMAPI
kmGetFreeTextureMem(
	OUT	PKMUINT32 pSizeOfTexture,
	OUT	PKMUINT32 pMaxBlockSizeOfTexture
	);

/*++
kmReLoadMipmap

proto type:
	KMSTATUS
	kmReLoadMipmap(
			PKMSURFACEDESC 	pSurfaceDesc,
			PKMVOID	 		pTexture,
			KMINT32	 		nMipmapCount
		);

Description:
	kmCreateTextureSurfaceŊmۂeNX`̗̈ɁA 
	pTextureŎw肳ꂽC̃~bv}bveNX`㏑ǂݍ݂܂B

Arguments:
	IN	pSurfaceDesc	kmCreateTextureSurfaceŊmۂeNX`T[tFXłB
						Reloadł

	IN	pTexture		C̃~bv}bveNX`|C^łB
						Reloadł

	IN	nMipmapCount	ǂݍރ~bv}bveNX`̃xw肵܂B
						L̂ꂩw肷邱Ƃł܂B

						nMipmapCount			Texture Size
						KM_MAPSIZE_1x1				   1x1
						KM_MAPSIZE_2x2				   2x2
						KM_MAPSIZE_4x4				   4x4
						KM_MAPSIZE_8x8				   8x8
						KM_MAPSIZE_16x16			  16x16
						KM_MAPSIZE_32x32			  32x32
						KM_MAPSIZE_64x64			  64x64
						KM_MAPSIZE_128x128			 128x128
						KM_MAPSIZE_256x256			 256x256
						KM_MAPSIZE_512x512			 512x512
						KM_MAPSIZE_1024x1024		1024x1024
	

Result:
	KMSTATUS_SUCCESS			
	KMSTATUS_INVALID_PARAMETER	p[^s
	KMSTATUS_INVALID_TEXTURE	ȃeNX`w肵

--*/
KMSTATUS KMAPI
kmReLoadMipmap(
	IN	PKMSURFACEDESC 	pSurfaceDesc,
	IN	PKMVOID		 	pTexture,
	IN	KMINT32	 		nMipmapCount
	);

/*++
kmGetTexture

proto type:

	KMSTATUS
	kmGetTexture(
		PKMDWORD		pTexture,
		PKMSURFACEDESC	pSurfaceDesc
		);

Description:
	pSurfaceDescŎw肵eNX`̃eNX`A 
	pTextureŎw肳ꂽCɓǂݏo܂B
	o͂ɂ́AKAMUIeNX`tH[}bgɏ]16oCg̃wb_t܂B

Arguments:
	OUT	pTexture		C̃eNX`ۑ̈|C^łB
	IN	pSurfaceDesc	eNX`ۑĂeNX`T[tFXłB

Result:
	KMSTATUS_SUCCESS					ǂݏo
	KMSTATUS_INVALID_ADDRESS			w肳ꂽeNX`T[tFX
										mۂĂȂ

--*/

KMSTATUS KMAPI
kmGetTexture(
	OUT	PKMDWORD		pTexture,
	IN	PKMSURFACEDESC	pSurfaceDesc
	);


/*++
kmGarbageCollectTexture

proto type:
	KMSTATUS
	kmGarbageCollectTexture( KMVOID );

Description:
	 Frame Buffer ̃Kx[WRNVs܂B

Arguments:

Result:
	KMSTATUS_SUCCESS					Kx[WRNV
	KMSTATUS_NOT_ENOUGH_MEMORY			eʂȂ

--*/

KMSTATUS KMAPI
kmGarbageCollectTexture( KMVOID );



/*++
kmSetFramebufferTexture

proto type:
	KMSTATUS 
	kmSetFramebufferTexture(
		IN	OUT	PKMSURFACEDESC	pSurfaceDesc
	);

Description:
	 Frame Buffer ̏AeNX`pSurfaceDescɓǂݏo܂B
	O Frame Buffer ̓eAStride-Rectanglar-TextureƂSurfaceDescɐݒ肳܂B
	SurfaceDescgpăeNX`}bv邱ƂɂAO Frame Buffer 
	̓eeNX`ƂĎgp邱Ƃł܂B
	eNX`ƂĎgp悤Ƃ Frame Buffer ́AL̐ݒłKv܂B

	EkmSetDisplayModeŁABitDepth L̂Âꂩw肳Ă邱ƁB
		KM_DSPBPP_ARGB1555
		KM_DSPBPP_RGB565

Arguments:
	IN	OUT	pSurfaceDesc	KMSURFACEDESC \̗̂̈|C^łB
							 Frame Buffer ̏񂪕Ԃ܂B

Result:
		KMSTATUS_SUCCESS				 Frame Buffer ̏ǂݏo
		KMSTATUS_INVALID_TEXTURE_TYPE	݂ Frame Buffer ̐ݒ̓eNX`ƂĎgpłȂ

Sample:
	kmSetStrideWidth(nScreenWidth);					// Set screen width
	....(Setup vertex)....
	kmRender();										// Generate previous Frame-Buffer
	kmSetFramebufferTexture(pSurfaceDesc);			// Get Framebuffer information
	VertexContext.pTextureSurfaceDesc	= &pSurfaceDesc;
	kmProcessVertexRenderState(&VertexContext);		// Use Framebuffer as texture
	kmSetVertexRenderState(&VertexContext);			// Set new vertex-context
	....(Setup vertex)....
	kmRender();										// Render!!

--*/
#if 0
KMSTATUS KMAPI
kmSetFramebufferTexture(
		PKMSURFACEDESC	pSurfaceDesc
	);
#endif

/*++
kmLoadVQCodebook

proto type:

	KMSTATUS
	kmLoadVQCodebook(
			PKMSURFACEDESC pSurfaceDesc,
			PKMDWORD pTexture
		);

Description:
	pSurfaceDescŎw肳ꂽVQeNX`T[tFXɁApTextureŎw肳ꂽ
	CVQeNX`̃R[hubN݂̂ǂݍ݂܂B
	[hς݂VQeNX`́AR[hubN(800hoCg)݂̂
	J[pbgʂoƂɎgp܂B

Arguments:
	IN	pSurfaceDesc	kmCreateTextureSurfaceŊmۂeNX`T[tFXłB
						̃T[tFX̃JeŚAKM_TEXTURE_VQ܂KM_TEXTURE_VQ_MM
						̂ǂ炩łȂ΂Ȃ܂B
	IN	pTexture		C̃eNX`(R[hubN)|C^łB
						͊SVQeNX`łKv͂܂񂪁A
						ȂƂ擪800hoCg̃R[hubN܂łKv܂B

Result:
	KMSTATUS_SUCCESS					ǂݍݐ
	KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵

--*/

KMSTATUS KMAPI
kmLoadVQCodebook(
	IN	PKMSURFACEDESC	pSurfaceDesc,
	IN	PKMDWORD		pTexture
	);


/*++
kmCreateContiguousTextureSurface

proto type:
	KMSTATUS 
	kmCreateContiguousTextureSurface(
			PKMSURFACEDESC	pSurfaceDesc,
			KMINT32			nTexture,
			KMINT32			nWidth, 
			KMINT32			nHeight, 
			KMTEXTURETYPE	nTextureType
		);

Description:
	 Frame Buffer ̘AAhẌɁAɕ̃eNX`pSurfacemۂ܂B
	́ATile AcceleratorYUVRo[^gpāAAĕYUV422`̃eNX`
	ǂݍނƂɎgp܂B(kmLoadYUVTextureQƂ)
	YUV422ȊÕeNX`pSurface̊mۂɂgp邱Ƃł܂B

Arguments:
	OUT	pSurfaceDesc			KMSURFACEDESC \̂̔zւ̃|C^łB
								mۂ Texture Surface ̏񂪕Ԃ܂B
								KMSTATUS KMSTATUS_NOT_ENOUGH_MEMORYԂꂽꍇɂ͕sƂȂ܂B

	IN	nTexture				AĊmۂ Texture Surface ̐w肵܂B

	IN	nWidth, nHeight			eNX`̉TCYAcTCYw肵܂B
								nWidth, nHeightɎw肷l,8, 16, 32, 64, 128, 256, 512, 1024
								ꂩłȂ΂Ȃ܂B

	IN	nTextureType			eNX`̌`w肵܂B
								ȉ̃JeSR[hAsNZtH[}bgR[h
								IяoA_a(or)ė^܂

								-JeSR[h
									KM_TEXTURE_TWIDDLED				// TwiddledtH[}bg
									KM_TEXTURE_TWIDDLED_MM			// TwiddledtH[}bgMipmap
									KM_TEXTURE_TWIDDLED_RECTANGLE	// Twiddled-Rectangle
									KM_TEXTURE_VQ					// VQktH[}bg
									KM_TEXTURE_VQ_MM				// VQktH[}bgMipmap
									KM_TEXTURE_PALETTIZE4			// 4bpppbg`
									KM_TEXTURE_PALETTIZE4_MM		// 4bpppbg`Mipmap
									KM_TEXTURE_PALETTIZE8			// 8bpppbg`
									KM_TEXTURE_PALETTIZE8_MM		// 8bpppbg`Mipmap
									KM_TEXTURE_RECTANGLE			// `
									KM_TEXTURE_STRIDE				// `(XgChwL)

								- sNZtH[}bgR[h
									KM_TEXTURE_ARGB1555
									KM_TEXTURE_RGB565
									KM_TEXTURE_ARGB4444
									KM_TEXTURE_YUV422
									KM_TEXTURE_BUMP

Result:
		KMSTATUS_SUCCESS					eNX`mې
		KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵
		KMSTATUS_NOT_ENOUGH_MEMORY			eʂȂ

--*/

KMSTATUS KMAPI
kmCreateContiguousTextureSurface(
	OUT		PKMSURFACEDESC	pSurfaceDesc,
	IN		KMINT32			nTexture,
	IN		KMINT32			nWidth,
	IN		KMINT32			nHeight,
	IN		KMTEXTURETYPE	nTextureType
	);


/*++
kmLoadYUVTexture

proto type:

	KMSTATUS
	kmLoadYUVTexture(
		PPKMSURFACEDESC	ppSurfaceDesc,
		PKMDWORD		pTexture,
		KMINT32			nWidth,
		KMINT32			nHeight,
		KMDWORD			nFormat,
		KMBOOLEAN		bWaitEndOfDMA
		);

Description:
	kmCreateTextureSurface/kmCreateCombinedTextureSurface/kmCreateContiguousTextureSurface
	ŊmۂeNX`̗̈ɁApTextureŎw肳ꂽC
	YUV420-data/YUV422-dataANon-Twiddled YUV422eNX`ɕϊēǂݍ݂܂B
	Tile Accelerator ɓĂ YUV-data converter gpāAϊȂ
	ǂݍ݂܂B

	YUV-data converter ̏o͂ Non-Twiddled ł邽߁AAPIŎw肷ǂݍݐ
	Texture Surface ̌`́Aȉ̂ꂩłȂ΂Ȃ܂B
		KM_TEXTURE_RECTANGLE | KM_TEXTURE_YUV422	// `
		KM_TEXTURE_STRIDE    | KM_TEXTURE_YUV422	// `(XgChwL)

	YUV-dataAxɘAēǂݍޏꍇ(nTexture > 1 ̎)́AX̃eNX`
	TCY16x16eNZłȂ΂Ȃ܂BAPIŎw肷ǂݍݐTexture Surface
	̃TCYwɂӂB
	܂Ȁꍇ́AǂݍݐTexture Surface Frame Buffer ŘAAhX
	mۂĂ邱ƂKvłB"kmCreateContiguousTextureSurface" APIgp
	mۂTexture Surfacew肵ĂB

Arguments:
	IN	ppSurfaceDesc	AP[gς݂̃eNX`T[tFXKMSURFACEDESC \̂ւ
						|C^z̃|C^łB
	IN	pTexture		CYUV420-data/YUV422-data|C^łB
	IN	nWidth,
	IN	nHeight,
						Aēǂݍ Texture }NubN̐cƉ̐Ŏw肵܂B
						włĺAꂼ 1  64 ̂ꂩłB
	IN	nFormat			ǂݍރf[^̌`w肵܂Bȉ̂ꂩw肵܂B
						KM_TEXTURE_YUV420		̓f[^YUV420-datał邱Ƃ܂B
						KM_TEXTURE_YUV422		̓f[^YUV422-datał邱Ƃ܂B
	IN	bWaitEndOfDMA	TRUȄꍇAYUVRo[^ւ̃f[^]DMÂ҂܂B
									DMAI܂ŁA{API͏I܂B
						FALSȄꍇADMȀI҂܂BDMȀImꍇ
									R[obN"kmSetEndOfYUVCallback"gpĂB

Result:
	KMSTATUS_SUCCESS					ǂݍݐ
	KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵

--*/

KMSTATUS KMAPI
kmLoadYUVTexture(
	IN	PKMSURFACEDESC	pSurfaceDesc,
	IN	PKMDWORD		pTexture,
	IN	KMINT32			nWidth,
	IN	KMINT32			nHeight,
	IN	KMDWORD			nFormat,
	IN	KMBOOLEAN		bWaitEndOfDMA
	);


/*++
kmCreateFixedTextureArea

proto type:

	KMSTATUS KMAPI
	kmCreateFixedTextureArea(
		OUT  PKMSURFACEDESC pSurfaceDesc,
		IN  KMINT32  nWidth,
		IN  KMINT32  nHeight,
		IN  KMTEXTURETYPE  nTextureType
		);

Description:
	kmSetSystemConfiguration 𔭍sĂȂAŒeNX`̈m
	ۂ܂BŒeNX`̈̓Q[ŜŎgptHgeNX`
	ǂüƂĎgpł܂BŊmۂ̈ 
	kmFreeFixedTextureArea֐ło܂B
	܂AŒeNX`̈̓VXeňmۂł܂B

	ۂ̌ŒeNX`̈̊mۂ́A kmSetSystemConfiguration 𔭍s
	Ƃɍs܂B̊֐śAK kmSetSystemConfiguration 
	sKv܂B܂AŒeNX`̈ւ̃f[^ǂݍ݂́A
	 kmSetSystemConfiguration ̌ɍsȂ΂Ȃ܂B
	Ȃ킿A֐̌ĂяóA
	(1)kmCreateFixedTextureAreaŌŒeNX`̈mہB
	(2)kmSetSystemConfigurationsBۂ̌Œ̈mۂ͂ōsB
	(3)kmLoadTextureȂǂŁAŒeNX`̈փeNX`f[^ǂݍށB
	ƂȂ܂B 

	kmSetSystemConfiguration 𔭍sOɁAkmFreeFixedTextureArea s
	ꂽꍇ́A܂łɔsꂽkmCreateFixedTextureArea͖ƂȂ܂
	B̏ꍇ́AŒeNX`̈͊mۂ܂B 

	ȂAŊmۂ̈̓Kx[WRNV̑ΏۂƂ͂Ȃ܂B܂
	AŒeNX`̗̈eʂ͂Slaz邱Ƃ͂ł܂B 

Arguments:
	OUT	pSurfaceDesc	KMSURFACEDESC^̍\̂ւ̃|C^łB
						̍\̂ɂ́A_ЂɂSurface񂪕Ԃ܂B
						KMSTATUS KMSTATUS_NOT_ENOUGH_MEMORYԂꂽꍇ
						͕sƂȂ܂B 
	IN	nWidth,nHeight	eNX`̉TCYAcTCYw肵܂B MIPMAP
						gpꍇɂ̓gbvx̃eNX`TCYw
						܂B`eNX`TCY8x8`1024x1024܂ł
						eNX`gpł܂A nWidth, nHeightɎw肷
						l,8, 16, 32, 64, 128, 256, 512, 1024̂ꂩ
						Ȃ΂Ȃ܂B 
	IN	nTextureType	eNX`̌`w肵܂B KmCreateTextureSurface
						̐QƂB 

Result:
	KMSTATUS_SUCCESS					ǂݍݐ
	KMSTATUS_INVALID_TEXTURE_TYPE		ȃeNX`^Cvw肵
	KMSTATUS_NOT_ENOUGH_MEMORY			ŒeNX`̗̈eʂSlaz 

--*/

KMSTATUS KMAPI
kmCreateFixedTextureArea(
	OUT	PKMSURFACEDESC	pSurfaceDesc,
	IN	KMINT32			nWidth,
	IN	KMINT32			nHeight,
	IN	KMTEXTURETYPE	nTextureType
	);


/*++
kmFreeFixedTextureArea

proto type:

	KMSTATUS KMAPI
	kmFreeFixedTextureArea( KMVOID ); 

Description:
	kmCreateFixedTextureArea ŊmۂׂĂ̌ŒeNX`̈
	B
	ۂ̌ŒeNX`̈̉́A kmSetSystemConfiguration 𔭍s
	Ƃɍs܂B̊֐śAK kmSetSystemConfiguration 
	sKv܂B 
	̊֐ł́A kmCreateTextureSurface / kmCreateCombinedTextureSurface /
	kmCreateContiguousTextureSurface Ŋmۂ̈͊Jł܂B 

Arguments:
	None

Result:
	KMSTATUS_SUCCESS					ǂݍݐ

--*/

KMSTATUS KMAPI
kmFreeFixedTextureArea( KMVOID ); 


/*++
kmGetCurrentTextureStatus

proto type:

	KMSTATUS KMAPI
	kmGetCurrentTextureStatus(
		OUT PKMFBSTATUS pFBStatus
		);

Description:
	t[obt@̊ǗɊւǂݏo܂B[U[L\
	̂Aւ̃|C^nƁÅ֐eo̓eݒ肵
	܂B 

Arguments:
	OUT	pFBStatus		FBǗ\̂ւ̃|C^ 

Result:
	KMSTATUS_SUCCESS					

--*/

KMSTATUS KMAPI
kmGetCurrentTextureStatus(
	OUT PKMFBSTATUS pFBStatus
	);

#endif
