/*
 *  Middleware Library
 *  Copyright (c) 1998,1999 SEGA
 *  
 *		MPEG Sofdec
 *
 *  Module  : Library Header File
 *  File    : SFD_MW.H
 *  Create  : 1998-07-25
 *  Modify  : 1999-10-12
 *  Note    :
 */

#ifndef	_SFD_MW_H_
#define	_SFD_MW_H_

/*	Version No.	*/
#define	MWD_SFD_VER	"2.56"

/***************************************************************************
 *      MACRO CONSTANT
 ***************************************************************************/

/*	Sofdec Error						*/
#define	MWD_PLY_ERR_SFD_INIT	(-301)
#define	MWD_PLY_ERR_SFD_NOTYPE	(-302)
#define	MWD_PLY_ERR_SFD_ERRFN	(-303)
#define	MWD_PLY_ERR_SFD_FINISH	(-304)
#define	MWD_PLY_ERR_SFD_CREATE	(-305)
#define	MWD_PLY_ERR_SFD_DSTRY	(-306)
#define	MWD_PLY_ERR_SFD_START	(-307)
#define	MWD_PLY_ERR_SFD_STOP	(-308)
#define	MWD_PLY_ERR_SFD_GETTIME	(-309)
#define	MWD_PLY_ERR_SFD_PAUSE	(-310)
#define	MWD_PLY_ERR_SFD_STANDBY	(-311)

/*	t@C^Cv						*/
/*	File type							*/
#define	MWD_PLY_FTYPE_NON		(0)
#define	MWD_PLY_FTYPE_SFD		(1)
#define	MWD_PLY_FTYPE_MPV		(2)

/*	fR[_^Cv						*/
/*	Decode type							*/
#define	MWD_DECTYP_NON			(0)
#define	MWD_DECTYP_SOFDEC		(1)

/*	\CeV						*/
/*	Display latency						*/
#define	MWD_LATENCY_2V			(2)
#define	MWD_LATENCY_3V			(3)

/*	GSCnhő吔					*/
/*	Maximum number of GSC handle		*/
#define	MWD_GSCHN_MAX			(1)

/*	̕\^Cv					*/
/*	Display type of animation			*/
#define MWD_PLY_DTYPE_AUTO	(0)
#define MWD_PLY_DTYPE_FULL	(1)
#define MWD_PLY_DTYPE_WND	(2)
#define MWD_PLY_DTYPE_SRF	(3)

/*	Px̃ftHgl					*/
/*	Default value of brightness			*/
#if 0
#define MWD_DFL_BRIGHT		(0xea)		/* mwSfd Ver1.11 */
#define MWD_DFL_BRIGHT		(0xff)
#endif
#define MWD_DFL_BRIGHT		(0xe0)		/*	Ver.1.20	*/

/*	PxItZbg̃ftHgl		*/
/*	Default value of brightness offset	*/
/*
#define MWD_DFL_BRIGHT_OFST	(0)
*/
#define MWD_DFL_BRIGHT_OFST	(6)			/*	Ver.1.20	*/

/*	\XN[̉s̃ftHgl		*/
/*	Default value of z coordinay	*/
#define MWD_DFL_DLZ			(65536.0f)

/*	[h			*/
/*	Composition Mode	*/
#define MWD_PLY_COMPO_OPEQ			(0x0000)	/*	s					*/
#define MWD_PLY_COMPO_TRNSP			(0x0001)	/*	 (_̂)		*/
#define MWD_PLY_COMPO_ADD			(0x0002)	/*	Z				*/
#define MWD_PLY_COMPO_LUMI			(0x0004)	/*	~lbZX		*/
#define MWD_PLY_COMPO_ALPH3			(0x0005)	/*	3lAt@			*/
#define MWD_PLY_COMPO_ALPH5			(0x0006)	/*	5lAt@			*/
#define MWD_PLY_COMPO_ALPH256		(0x0007)	/*	tAt@		*/
#define MWD_PLY_COMPO_SANDWICH		(0x0008)	/*	ThEBb`		*/
#define MWD_PLY_COMPO_MAT			(0x0009)	/*	}bg				*/
#define MWD_PLY_COMPO_MIX			MWD_PLY_COMPO_LUMI

/*	[h	*/
#define MWD_PLY_SYNC_NONE			(0)			//	񓯊
#define MWD_PLY_SYNC_VSYNC			(1)			//	V-Sync
#define MWD_PLY_SYNC_AUDIO			(2)			//	

/***************************************************************************
 *      Process MACRO
 ***************************************************************************/

/*	I[fBIo̓obt@̃TCY			*/
/*	Calculation of audio output buffer size	*/
#define	MWD_SFD_CALC_WORK_AUDIO_OUT(nch)	(0x2020*sizeof(short)*(nch)+32)

/*	I[fBIo̓obt@TCY(ftHgl)	*/
/*	Default size of audio output buffer			*/
#define	MWD_SFD_CALC_WORK_AUDIO_OUT0	MWD_SFD_CALC_WORK_AUDIO_OUT(2)

/*	I[fBI̓obt@TCY			*/
/*	Default size of audio input buffer size	*/
#define	MWD_SFD_CALC_WORK_AUDIO_IN			(36*2048+32)

/*	I[fBIpobt@TCY				*/
/*	Buffer size for the audio system		*/
#define	MWD_SFD_SIZE_WORK_AUDIO(nch)	( \
				MWD_SFD_CALC_WORK_AUDIO_OUT0 + \
				MWD_SFD_CALC_WORK_AUDIO_IN \
			)

/*	QƗpt[obt@TCY					*/
/*	Calculation of frame buffer size for reference	*/
#define	MWD_SFD_CALC_WORK_RFB(wc, hc, wy, hy)	\
								SFD_RFB_BUF_SIZ((wc), (hc), (wy), (hy))

/*	QƗpt[obt@TCY(ftHgl)		*/
/*	Default value of frame buffer size for reference*/
#define	MWD_SFD_CALC_WORK_RFB0 \
				MWD_SFD_CALC_WORK_RFB(	SFD_RFB_WIDTH_C, \
										SFD_RFB_HEIGHT_C, \
										SFD_RFB_WIDTH_Y, \
										SFD_RFB_HEIGHT_Y )

/*	o͗pt[obt@TCY					*/
/*	Calculation of frame buffer size for output		*/
#define	MWD_SFD_CALC_WORK_TAB(wy, hy, nfrm)	\
								SFD_TA_BUF_SIZ((wy), (hy), (nfrm))

/*	o͗pt[obt@TCY(ftHgl)		*/
/*	Default value of frame buffer size for output	*/
#define MWD_SFD_CALC_WORK_TAB0	\
				MWD_SFD_CALC_WORK_TAB(SFD_RFB_WIDTH_Y, SFD_RFB_HEIGHT_Y, 4)

#define	MWD_SFD_CALC_WORK(sx, sy, nch)	\
		MWD_SFD_CALC_WORK_AUDIO(2) +	\
		
/*	Ɨ̈̃TCY									*/
/*	Size of working area								*/
#define	MWD_SFD_SIZE_WORK		(0x00300000)

/*
 *  \CeV
 *  _o^pobt@TCY画fłB
 *  1}CiXɂ2V[eV[hB
 *	Display latency
 *	It is possible to judge from vertex buffer size.
 *	It become 2V latency mode when you turn one argument into 
 *	negative number.
 */
#define	MWD_PLY_LATENCY(op, om, tp, tm, pt) ( \
			((op) < 0) ? MWD_LATENCY_2V : \
			((om) < 0) ? MWD_LATENCY_2V : \
			((tp) < 0) ? MWD_LATENCY_2V : \
			((tm) < 0) ? MWD_LATENCY_2V : \
			((pt) < 0) ? MWD_LATENCY_2V : MWD_LATENCY_3V)


/***************************************************************************
 *      Data type declaration
 ***************************************************************************/

/*	Sofdec̏p[^\							*/
/*	Parameter structure of Sofdec initialization function	*/
typedef struct {
	/*	NinjaŎۂɐݒ肵\[hƓlݒ肵ĉ 			*/
	/*	Please set the value same as mode that you set in Ninja				*/
	Sint32		mode;			/*	ʃ[h								*/
								/*	Picture mode							*/
	Sint32		frame;			/*	t[obt@̃J[[h 			*/
								/*	Color mode of the frame buffer			*/
	Sint32		count;			/*	t[JEg						*/
								/*	Number of frame count					*/
	Sint32		latency;		/*	\CeV (2or3)					*/
								/*	Display latency(2 or 3)					*/
	Sint32		rsv[4];			/*	\ (S0ݒ肵ĉ) 			*/
								/*	Reserved(Please set 0 in all of area)	*/
} MWS_PLY_INIT_SFD;

/*	nhp[^\			*/
/*	Parameter structure of handle creation	*/
typedef struct {
	Sint32	ftype;				/*	ĐXg[̎ 				*/
								/*	File type								*/
	Sint32	max_bps;			/*	ő̃rbgXg[ʁ@(bit/sec)		*/
								/*	Maximum number of bit per second		*/
	Sint32	max_width;			/*	Đ摜TCY̍ő啝					*/
								/*	Maximum width of video stream			*/
	Sint32	max_height;			/*	Đ摜TCY̍ő卂				*/
								/*	Maximum height of video stream			*/
	Sint32	nfrm_pool_wk;		/*	VXë̃t[v[iʏ3)	*/
								/*	t[ꍇ́A̒l	*/
								/*	₵ĂB						*/
								/*	Number of frame pools in system memory.	*/
								/*	Normaly this number is 3. If frame is 	*/
								/*	droped,you have to increase this number.*/
	Sint8	*work;				/*	[N̈								*/
								/*	Address of working area					*/
	Sint32	wksize;				/*	[N̈TCY						*/
								/*	Size of working area					*/
	Sint32  dtype;				/*	\^Cv								*/
								/*	Display type							*/
	Sint32  compo_mode;			/*	[h								*/
								/*	Composition mode						*/
} MWS_PLY_CPRM_SFD;

/* fT[tFX\ */
typedef struct {
	void *srf;		/* T[tFX   	        */
	Sint32 width;	/* LT[tFXTCY    */
	Sint32 height;	/* LT[tFXTCY  */
} MWS_PLY_MVFRM;

/***************************************************************************
 *      Function Declaration
 ***************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

/*	3 Line tB^̋̐ݒ	(bright:邳0-256, val:0-1.0) */
void mwPlySetYfltVal(Sint32 bright, Float val);
/*	3 Line tB^XCb`̐ݒ	*/
void mwPlySetYfltSw(Sint32 sw);
/*	fR[ht@Coo^t@Cox̐ݒ	*/
/*	mwPlyInitSfdFx̑OɎs邱				*/
void mwPlyConfigFbrLevelSfdFx(Sint32 flvl);
/*	[h̐ݒ	*/
void mwPlySetSyncMode(MWPLY ply, Sint32 mode);


/*	VXȅ(sbInitSystem̑OɌĂԊ֐)					*/
/*	Initialization of system										*/
/*	(Call this function before 'sbInitSystem' function)				*/
void mwPlyPreInitSofdec(void);

/*	Initialization of Sofdec library for Kamui or Kamui2	*/
void mwPlyInitSfdFx(MWS_PLY_INIT_SFD *iprm);

/*	Termination of Sofdec library for Kamui or Kamui2 */
void mwPlyFinishSfdFx(void);

/*	Initialization of Sofdec library for Ninja	*/
void mwPlyInitSofdec(MWS_PLY_INIT_SFD *iprm);

/*	Termination of Sofdec library for Ninja */
void mwPlyFinishSofdec(void);

/*	Set vertex buffer to draw movie's image */
void mwPlySetVertexBuffer(void *vbuf);

/*	Create MWPLY handle for Sofdec		*/
MWPLY mwPlyCreateSofdec(MWS_PLY_CPRM_SFD *cprm);

/*	Ɨ̈TCY̌vZ				*/
/*	Calculation of working area size	*/
Sint32 mwPlyCalcWorkSofdec(
	Sint32 ftype, Sint32 max_bps, Sint32 max_sx, Sint32 max_sy, Sint32 nfb);

/*	Ɨ̈TCY̌vZ	*/
/*	Calculation of working area size from create parameter	*/
Sint32 mwPlyCalcWorkCprmSfd(MWS_PLY_CPRM_SFD *cprm);

/*	\[h̐ݒ
 *	[]
 *		mode		:ʃ[h
 *		frame		:t[obt@̃J[[h
 *		count		:t[JEg
 *		latency		:\CeV (2VCeV𐄏)
 *	[]
 *	 NinjaŎۂɐݒ肵\[hƓlݒ肵ĉB
 *	  MWS_PLY_INIT_SFD Őݒ肵ꍇÅ֐͕Kv܂B
 *	 \[hύXꍇ́Å֐ōĐݒ肷Kv܂B
 *	[l]
 *	 t[JEgɂ
 *	EC^[X̏ꍇA\XVVSYNC = 2*count ƂȂ܂B
 *	  Ⴆ΁AC^[XŃt[JEg2ȂA4V\ƂȂ܂B
 *	E1V\́A24fpsȂǁACӂ̃t[[g̓X[Yɕ\܂B
 *	E2V\́A葽CPUԂSofdecɗ^AR}̊댯y܂A
 *	  X[YɍĐłt[[g肳܂B
 *	  (NTSC,VGA:29.97fps 30fps,  PAL:25fps)
 *	E3Vȏ̕\́AĐɂ͐܂B
 *	Set display mode
 *	[Inputs]
 *		mode		:Picture mode
 *		frame		:Color mode of frame buffer
 *		count		:Number of frame count
 *		latency		:Display latency(We recommend 2V latency.)
 *	[Notes]
 *	 Please set the value same as mode that you set in Ninja.
 *	 This function is not necessary when you set MWS_PLY_INIT_SFD in 
 *	 initialize function.
 *	 You need to set if by this function again when changed display mode.
 *	[Remarks]
 *	 About number of frame count
 *	 1)V-sync number of update display is twice 'count' in case of interlace.
 *	   For example, display is 4V when the number of frame count is 2 in case
 *	   of interlace.
 *	 2)1V-display displays animation of arbitrary frame rate smoothly.
 *	   For example 24fps.
 *	 3)2V-display gives CPU time to Sofdec and reduce danger of frame drops, 
 *	   but the frame rate that can be played smoothly is limited.
 *	   (NTSC,VGA:29.97fps 30fps, PAL:25fps)
 *	 4)We do not recommend display of more than 3V in animation play.
 */
void mwPlySetDispMode(Sint32 mode, Sint32 frame, Sint32 count, Sint32 latency);

/*	n[y̐ݒ	*/
/*	Set high-speed Half Pel		*/
void mwPlySetFastHalfpel(MWPLY mwply, Sint32 sw);

/*	Px␳(-16)XCb`̐ݒ	*/
/*	Set adjust luminosity switch (if sw==1 then y = y-16)	*/
void mwPlySetAdjustY16(MWPLY mwply, Sint32 sw);

/*	o̓XCb`̐ݒ			*/
/*	Set audio output switch			*/
void mwPlySetAudioSw(MWPLY mwply, Sint32 sw);

/*	\ʒu̐ݒ				*/
/*	Set location of the display	*/
void mwPlySetDispPos(MWPLY mwply, float lx, float ly);

/*	\TCY̐ݒ			*/
/*	Set size of the display		*/
void mwPlySetDispSize(MWPLY mwply, float sx, float sy);

/*	Px̐ݒ(val= 0`255)		*/
/*	Set brightness(value=0-255)	*/
void mwPlySetBright(MWPLY mwply, Sint32 val);

/*	Px̃ItZbgݒ(val= 0`255)	*/
/*	Set brightness offset(value=0-255)	*/
void mwPlySetBrightOfst(MWPLY mwply, Sint32 val);

/*	Px̎擾					*/
/*	Get brightness				*/
Sint32 mwPlyGetBright(MWPLY mwply);

/*	PxItZbg̎擾		*/
/*	Get brightness offset		*/
Sint32 mwPlyGetBrightOfst(MWPLY mwply);

/*	\XN[̉sl̎擾	(z:1.0->65536.0)	*/
/*	Get Z coordinary of screen	(z:1.0->65536.0)		*/
float mwPlyGetDispZ(MWPLY mwply);

/*	\XN[̉sl̐ݒ	(z:1.0->65536.0)	*/
/*	Get Z coordinary of screen	(z:1.0->65536.0)		*/
void mwPlySetDispZ(MWPLY mwply, float z);

/*	f\XCb`̐ݒ									*/
/*	Set video output switch (if sw == 1 then output video)	*/
void mwPlySetVideoSw(MWPLY ply, Sint32 sw);

/*	f\XCb`̎擾									*/
/*	Get video output switch									*/
Sint32 mwPlyGetVideoSw(MWPLY ply);

/*	R}t[̎擾											*/
/*	rfI[hC^[X[h29.97, 30fps̃[r[̎̂ݗL	*/
/*	Get number of droped frame												*/
/*	If video mode is interlace and movie is 29.97 or 30 fps,				*/
/*	you can use this function.												*/
Sint32 mwPlyGetNumDropFrm(MWPLY ply);

/*	Px->ϊe[u̐ݒ	*/
void mwPlySetAlphTbl(MWPLY ply, long bno, float alph[256]);

/*	[h̐ݒ	*/
void mwPlySetCompoMode(MWPLY ply, Sint32 mode);

/*	\^Cv̕ύX (Đ~ɂ̂ݗL)	*/
void mwPlySetDtype(MWPLY ply, long dtype);

/*	}bgf[^̐ݒ	*/
void mwPlySetMat(MWPLY mwply, Uint8 *mat);

/*	[r[t[̎擾	*/
Sint32 mwPlyGetMvFrm(MWPLY ply, MWS_PLY_MVFRM *frm);

/*	}XNt[̎擾	*/
Sint32 mwPlyGetMskFrm(MWPLY ply, MWS_PLY_MVFRM *frm);

/*	[h̐ݒ	*/
void mwPlySetAsync(MWPLY ply, Sint32 sw);

/*	̓Xg[WCg̎擾	*/
SJ mwPlyGetInputSj(MWPLY ply);

/*	GtFNgR[obN֐̓o^	*/
void mwPlyEntryFxCb(MWPLY ply,
void (*fn)(void *obj, Sint32 fno, Sint32 time, Sint32 tunit), void *obj);

/*	Xg[̘A	*/
void mwPlyLinkStm(MWPLY ply, Sint32 sw);

/*	pobt@TCY̌vZ	*/
long mwPlyCalcCompoBufSize(Sint32 sx, Sint32 sy);

/*	pobt@̐ݒ	*/
void mwPlySetCompoBuf(void *buf, Sint32 size);

/*	oCjAtB^̐ݒ */
void mwPlySetBilinearFlt(MWPLY ply, Sint32 sw);

/*	fR[hς݃t[	*/
Sint32 mwPlyGetNumDecPool(MWPLY ply);
/*	fR[hSsN`	*/
Sint32 mwPlyGetNumTotalDec(MWPLY ply);
/*	XLbvSsN`	*/
Sint32 mwPlyGetNumTotalSkip(MWPLY ply);
/*	̓obt@̋󂫗eʂ̎擾	*/
Sint32 mwPlyGetNumIbufRoom(MWPLY ply);
/*	\҂t[̎擾	*/
Sint32 mwPlyGetNumDispWait(MWPLY ply);
/*	_Õt[̎擾	*/
Sint32 mwPlyGetNumRend(MWPLY ply);
/*	fprfI_̎擾	*/
void *mwPlyGetRnvImg(MWPLY ply);
/*	}XNprfI_̎擾	*/
void *mwPlyGetRnvMsk(MWPLY ply);
/*	eNX`փ[ht[	*/
Sint32 mwPlyGetNumLoadFrm(MWPLY ply);

/**
*		T[tFX֐
*		Functions of surface operation
**/

/*	T[tFX|Cgpobt@TCY̌vZ							*/
/*	Calcurate size of surface point buffer 								*/
Sint32 mwPlyCalcSrfBufSize(MWPLY ply, Sint32 npnt);

/*	T[tFX|Cgpobt@̐ݒ									*/
/*	Set surface point buffer											*/
void mwPlySetSrfPntBuf(MWPLY ply, Sint32 npnt, void *buf, Sint32 bsize);

/*	\ʒu̐ݒ														*/
/*	Set display position of surface point								*/
void mwPlySetSrfPos(MWPLY ply, Uint32 no, float lx, float ly, float lz);

/*	\ʒu̎擾														*/
/*	Get display position of surface point								*/
void mwPlyGetSrfPos(MWPLY ply, Uint32 no, float *lx, float *ly, float *lz);

/*	Px̐ݒ															*/
/*	Set brightness of surface point										*/
void mwPlySetSrfBright(MWPLY ply, Uint32 no,
									float a, float r, float g, float b);
/*	Px̎擾															*/
/*	Get brightness of surface point										*/
void mwPlyGetSrfBright(MWPLY ply, Uint32 no,
									float *a, float *r, float *g, float *b);
/*	PxItZbg̐ݒ												*/
/*	Set brightness offset of surface point								*/
void mwPlySetSrfBrightOfst(MWPLY ply, Uint32 no,
									float a, float r, float g, float b);
/*	PxItZbg̎擾												*/
/*	Get brightness offset of surface point								*/
void mwPlyGetSrfBrightOfst(MWPLY ply, Uint32 no,
									float *a, float *r, float *g, float *b);
/*	C[Wʒu̐ݒ													*/
/*	Set image position of surface point									*/
void mwPlySetImgPos(MWPLY ply, Uint32 no, float lx, float ly);
/*	C[Wʒu̎擾													*/
/*	Get image position of surface point									*/
void mwPlyGetImgPos(MWPLY ply, Uint32 no, float *lx, float *ly);
/*	C[WTCY̎擾												*/
/*	Get image size														*/
void mwPlyGetImgSize(MWPLY ply, Sint32 *isx, Sint32 *isy);

/***
*		V[XAĐ
***/

/*	V[XAĐt@C̓o^	*/
void mwPlyEntryFname(MWPLY ply, char *fname);
/*	V[XAĐt@C̓o^ (AFS)	*/
void mwPlyEntryAfs(MWPLY ply, long patid, long fid);
/*	V[XAĐ̊Jn	*/
void mwPlyStartSeamless(MWPLY ply);
/*	V[XAĐ̉	*/
void mwPlyReleaseSeamless(MWPLY ply);
/*	V[XAĐ̊Jn	*/
void mwPlySetLpFlg(MWPLY ply, long flg);
/*	V[X[vĐ̊Jn	*/
void mwPlyStartFnameLp(MWPLY ply, char *fname);
/*	ݓo^Ăt@C̎擾	*/
Sint32 mwPlyGetNumSlFiles(MWPLY ply);
/*	Sofdecnh̎擾	*/
void *mwPlyGetSfdHn(MWPLY ply);

#ifdef __cplusplus
}
#endif

#endif	/*	_SFD_MW_H_	*/
