/* 
 *  Shinobi Library
 *  Copyright (c) 1998-2000 SEGA
 *
 * File: sg_Calbk.h
 * Desc: Callback Chain library for application creaters.
 *
 * Auth: Jiro Terakwa(SYSTEM R&D)
 * Create: 2000/01/13 Jiro Terakawa: Ver. 2.00
 * Change: Changed the names, "CallBack" -> "Callback" 2000/01/17 J.T
 *         Also chagned sg_CalBk.h -> sg_Calbk.h
 *
 */

#ifndef _SG_CALBK_H_
#define _SG_CALBK_H_


#define SYD_CALLBACK_EVENT_VBLANKIN 0x0900    /* VBLANK-IN */

#define SYD_CALLBACK_EVENT_HBLANK   0x0920    /* HBLANK */


#define SYD_CALLBACK_EVENT_EOR      0x0950    /* End Of Render */
#define SYD_CALLBACK_EVENT_EOYUV    0x0960    /* End Of YUV */









#define SYD_CALLBACK_EVENT_PDPORT   0x0A00   /* pdSetIntFunction() Ɠ */

#define SYD_CALLBACK_EVENT_GDEND    0x0A40   /* gdFsEntryRdEndFunc, gdFsEntryTrEndFunc */
#define SYD_CALLBACK_EVENT_AICADM   0x0A60   /* AICA DMA End */

typedef Uint32 SYCALLBACK;
typedef Uint32 SY_CALLBACK_EVENT;

/* sD揇ʂƂĎwłl͈̔ */
#define SYD_CALLBACK_PRIORITY_MIN 0x00
#define SYD_CALLBACK_PRIORITY_MAX 0x10

/*-------------------------------------------------------
 * FUNC: syCallbackInit
 * DESC: syCallback Cȕ
 *       (łɓo^nh͍폜Ȃ)
 * ARG:  N/A
 *
 */
Void syCallbackInit(Void);


/*-------------------------------------------------------
 * FUNC: syCallbackFinish
 * DESC: syCallback CȕI
 *       o^܂ܕuꂽnhׂč폜
 * ARG:  N/A
 *
 */
Void syCallbackFinish(Void);

/*-------------------------------------------------------
 * FUNC: syCallbackAddHandler
 * DESC: R[obNւ̃[Unh̒ǉs
 *       CxgɓvCIeB[œo^Ă
 *       Ânh͍폜ꂸɁAVnhA
 *       Ânh̑Oɑ}B
 *
 * ARG:  event: R[obNv
 *       usrCallbackFunc: o^֐ւ̃|C^
 *       priority: R[obNvƂ
 *                 ĂяoԂw肷B
 *                 قǐɎsB
 *       arg: R[obN֐ĂяoƂɓnB
 *
 */
SYCALLBACK syCallbackAddHandler(SY_CALLBACK_EVENT event,
			  Void (*usrCallbackFunc)(Void *),
			  Uint8 priority,
			  Void *arg);

/*-------------------------------------------------------
 * FUNC: syCallbackAddHandler
 * DESC: R[obNXgnh폜
 *
 * ARG:  callbackId: syCallbackAddHandler ̖߂lƂ
 *                   nhB
 */
Void syCallbackDeleteHandler(SYCALLBACK callbackId);


/*-------------------------------------------------------
 * FUNC: syCallbackNestCount
 * DESC: ݂̊݃lXg̏Ԃ擾
 *       ĂяoɊ荞ݏłƁA1 ȏ̒lԂ
 *       荞ݏOŌĂяoƁA0 ԂB
 * ARG:  N/A
 */
Uint32 syCallbackGetNestCount(Void);

#endif /* _SG_CALBK_H_ */


