/*
 *  Shinobi Library
 *  Copyright (c) 1998-2000 SEGA
 *  
 *       Multi heap wrapper for Memory Management
 *
 *  Module  : Library Header File
 *  File    : sg_Malcm.h
 *  Create  : 2000-07-26
 *  Modify  : 2000-08-21 J.Terakawa: Align, Header -> SYS_MALCM_ALIGN, SYS_MALCM_HEADER
 *  Version : 1.01
 *  Note    :
 */

#ifndef _SG_MALCM_H_
#define _SG_MALCM_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct {
  Sint8 dummy[0x20];
} SYS_MALCM_ALIGN;

typedef union SYS_MALCM_HEADER {
  struct {
    union SYS_MALCM_HEADER *ptr; /* 󂫃Xg̏Ȃ玟̃ubN */
    Uint32 size;
  } s;
  SYS_MALCM_ALIGN x;
} SYS_MALCM_HEADER;

/* SYS_MALCM_IF
 *  MallocMulti ̊eAPIuƂɎgpB
 *
 */
struct _SYS_MALCM_HEAPH;

typedef struct _SYS_MALCM_IF {
  Void *(*malloc)(struct _SYS_MALCM_HEAPH *heaph, Uint32 nbytes);
  Void (*free)(struct _SYS_MALCM_HEAPH *heaph, Void *ap);
  Void *(*calloc)(struct _SYS_MALCM_HEAPH *heaph, Uint32 nobj, Uint32 size);
  Void *(*realloc)(struct _SYS_MALCM_HEAPH *heaph, Void *ap, Uint32 nbytes);
} SYS_MALCM_IF;

/* SYS_MALLOC_HEAP_OBJECT:
 *   eq[v̏ێ\
 *
 */
typedef struct _SYS_MALCM_HEAPH{
  SYS_MALCM_HEADER  Root;  /* Jn̋󂫃Xg */
  SYS_MALCM_HEADER *Freep; /* 󂫃Xg̐擪 */
  Uint32  Size;  /* q[ṽTCY */
  char   *Start; /* q[v̐擪AhX */
  struct _SYS_MALCM_IF *mallocIf; /* ̃q[vŎgpMallocMulti֐Q̃Zbg*/
} SYS_MALCM_HEAPH;

Void syMallocMultiCreate(SYS_MALCM_HEAPH *heaph, Void *heap, Uint32 size);

Void syMallocMultiDelete(SYS_MALCM_HEAPH *heaph);

Void *syMallocMulti(SYS_MALCM_HEAPH *heaph, Uint32 nbytes);

void *syReallocMulti(SYS_MALCM_HEAPH *heaph, Void *op, Uint32 nbytes);

void *syCallocMulti(SYS_MALCM_HEAPH *heaph, Uint32 nobj, Uint32 size);

Void syFreeMulti(SYS_MALCM_HEAPH *heaph, Void *ap);

Void syMallocMultiStat(SYS_MALCM_HEAPH *heaph, Uint32 *wholeFreeSize, Uint32 *biggestFreeBlockSize);

SYS_MALCM_IF *syMallocMultiChangeIF(SYS_MALCM_HEAPH *heaph, SYS_MALCM_IF *mallocIF);

#ifdef __cplusplus
	   }
#endif /* __cplusplus */

#endif /* _SG_MALCM_H_ */

/******************************* end of file *******************************/
