/*============================================================
 *
 *  Shinobi2 Library
 *  Copyright (c) 2000 SEGA
 *
 *  Name  : sg_uf.h
 *
 *  Desc  : vCCu
 *  Desc  : Play log library
 *
 *  prefix: uf / UFD / UFS
 *
 *  Revision 2.2  2000/03/31
 *  For SEGA LIB Version 2.0
 *
 *============================================================*/

#ifndef _SG_UF_H_
#define _SG_UF_H_
/*============================================================
  Include
  ============================================================*/
#include <sg_xpt.h>

/*============================================================
  Define
  ============================================================*/
/* PlayTime֐̃[h */
	/* Mode of PlayTime function */
enum {
	UFD_SAVE, UFD_LOAD, UFD_PLAY
};

/* ChangeAutoSavẽtOl */
	/* Value of the falg, ChangeAutoSave */
enum {
	UFD_OFF,
	UFD_ON,
	UFD_UNK = 255
};


/* uf_Errno ̃G[ԍ */
	/* Error code of uf_Errno */
typedef enum {
	UFD_ERR_USERFLAG_PARITY_ERROR = 1,				/* ʃtOɃpeBG[ */
										/* Parity error in common flag */
	UFD_ERR_BANKNUMBER_ERROR,					/* oNԍs */
										/* Bunk number incorrect */
	UFD_ERR_PROTECT_COMMON_FLAG,					/* ʃtOANZX֎~ɂȂĂ */
										/* Common flag access prohibited */
	UFD_ERR_PROTECT_FLAG,						/* ^Cg̓ANZX֎~ɂȂĂ */
										/* Title access prohibited */
	UFD_ERR_NO_INIT,						/* IĂȂ */
										/* Initialize not completed */
	UFD_ERR_INIT_FAIL,						/* Ɏs */
										/* Initialize faulted */
	UFD_ERR_READ_FAIL,						/* ǂݍ݂Ɏs */
										/* Read faulted */
	UFD_ERR_WRITE_FAIL,						/* ݂Ɏs */
										/* Write faulted  */
	UFD_ERR_NOT_FOUND,						/* w肵iԍ͌Ȃ */
										/* Requested Product number not found */
	UFD_ERR_NO_PACKET_LEFT,						/* ǋLpPbg̎c肪 */
										/* No writing packet available */
	UFD_ERR_MEMORY_FAIL,						/* ɕKvȃ */
										/* Not enough memory available*/
	UFD_ERR_PERIINITFAIL,						/* ytF̏IĂȂ */	
										/* Peripheral Initialize not completed */	
	UFD_ERR_REFRESHFAIL,						/* tbVɎs */
										/* Refresh falted */
	UFD_ERR_MAX
} UFS_ERROR;

/* pPbg0̒` */
/* Packet 0 definition */
#define UFD_PLAYHIST_PACKET0  \
	Uint8	version; 						/* Cũo[W */ \
										/* Library version */ \
	Uint8	AutoSave; 						/* ۑtO */ \
										/* Auto Save Flag */ \
	Uint8	ProdNum[10]; 						/* iԍ */ \
										/* Product number */ \
	Uint8	ProdName[48];						/* iipj */
										/* Product name (English) */

/* pPbg1̒` */
/* Packet 1 definition */

#define UFD_PLAYHIST_PACKET1  \
	Uint8	ProdName2[44];						/* i{ */ \
										/* Product name (Japanese) */ \
	Uint32	Kind;							/* Q[ */ \
										/* Game genre */ \
	Uint32	FirstStartTime;						/* N */ \
										/* First boot date & time */ \
	Uint16	CRC;							/* iԍ珤i܂łCRC */ \
										/* CRC for from product number to product name */ \
	Uint8	PeriIdx[6];						/* ytF */
										/* Peripheral information */


/* pPbg2̒` */
/* Packet 2 definition */
#define UFD_PLAYHIST_PACKET2  \
	Uint32	PrevStartTime;						/* ON */ \
										/* Previous boot day & time */ \
	Uint16	StartCount;						/* N */ \
										/* Number of boots */ \
	Uint16	PlayTime[24];						/* vCԗ */ \
										/* Play time history */ \
	Uint16	LoadCount;						/* [h */ \
										/* Number of loads */ \
	Uint32	Reserve_2;						/* U[u */
										/* Sega reserved */

/* pPbg3̒` */
/* Packet 3 definition */
#define UFD_PLAYHIST_PACKET3  \
	Uint16	SaveCount;						/* Z[u */ \
										/* Number of saves */ \
	Uint8	GameEst;						/* vC] */ \
										/* Play Evaluation */ \
	Uint8	GameCarry;						/* U */ \
										/* Play progress */ \
	Uint32	FirstNetPlay;						/* lbg[NvC */ \
										/* First network play day & time */ \
	Uint32	PrevNetPlay;						/* Olbg[NvC */ \
										/* Previous network play day & time */ \
	Uint16	NetPlayCount;						/* lbg[NvC */ \
										/* Number of network play */ \
	Uint16	NetPlayTotalTime;					/* Slbg[NvC() */ \
										/* Total network play time(min.) */ \
	Uint8	FreeArea[32];						/* [U[J̈ */ \
										/* User area */ \
	Uint8	Reserved2[10];						/* U[u */ \
										/* Sega reserved */ \
	Uint16	SaveOccur;						/* tbVւ̃Z[u */
										/* Number of Flash Memory saves */

/* [NTCY̒` -- oCgP */
/* Definition of work size -- bytes */
#define	UFD_WORK1_SIZ	65536						/* 64K -- KKvȃobt@̃TCY */
										/* 64K -- Minimum required buffer size */
#define	UFD_WORK2_SIZ	60						/*  60 -- KKvȓǂݍݗpobt@̃TCY */
										/*  60 -- Minimum required reading buffer size */
#define UFD_WORK3_SIZ	65536						/* 64K -- Z[ttbVɕKvȃobt@̃TCY1 */
										/* 64K -- Required buffer size for safe refresh */
#define UFD_WORK4_SIZ	32768						/* 32K -- Z[ttbVɕKvȃobt@̃TCY2 */
										/* 32K -- Required buffer size for safe refresh */
#define	UFD_REQUIRED_REST_PACKET	2				/* ŒKvȒǋL\pPbg */
										/* Minimum required number of writing packet */
#define UFD_WORK_NOCHANGE	((void *)-1)				/* ufChangeWorkBufferɃ[NύXȂ̒萔 */
										/* Constant for not-changing work while ufChangeWorkBuffer */

/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/
/* vCqXgpPbg 0 */
	/* Play history Packet 0 */
typedef struct tagUFS_Packet0 {
	UFD_PLAYHIST_PACKET0
} UFS_HistoryPacket0;

/* vCqXgpPbg 1 */
	/* Play history Packet 1 */
typedef struct tag_HistoryPacket1 {
	UFD_PLAYHIST_PACKET1
} UFS_HistoryPacket1;

/* vCqXgpPbg 2 */
	/* Play history Packet 2 */
typedef struct tagUFS_HistoryPacket2 {
	UFD_PLAYHIST_PACKET2
} UFS_HistoryPacket2;

/* vCqXgpPbg 3 */
	/* Play history Packet 3 */
typedef struct tagUFS_HistoryPacket3 {
	UFD_PLAYHIST_PACKET3
} UFS_HistoryPacket3;

/* vCqXg(pPbgP) */
	/* Play History(par Packet) */
typedef struct tagUFS_PlayHistory {
	UFS_HistoryPacket0	packet0;
	UFS_HistoryPacket1	packet1;
	UFS_HistoryPacket2	packet2;
	UFS_HistoryPacket3	packet3;
} UFS_PlayHistory;

/* vCqXg */
	/* Play History */
typedef struct tagUFS_AllPlayHistory {
	UFD_PLAYHIST_PACKET0
	UFD_PLAYHIST_PACKET1
	UFD_PLAYHIST_PACKET2
	UFD_PLAYHIST_PACKET3
} UFS_AllPlayHistory;

/*============================================================
  Global
  ============================================================*/
extern UFS_ERROR ufgErrno;							/* G[ԍ */
											/* Error code */

/*============================================================
  API
  ============================================================*/
Bool ufInitSystem(void* work1, void* work2, void* work3, void* work4);		/* ֐ */
											/* Initialize function */
Bool ufChangeWorkBuffer(void* work1, void* work2, void* work3, void* work4); 	/* [N̕ύX */
/* Work Change */
Sint32 ufPlayTime(Uint8 mode, Uint8 est, Uint8 carry, Uint8 param[32]);		/* vCԂ̍XV */
											/* Updating Play time */
Bool ufSynch(void);								/* vCf[^̏o */
											/* Writing Play data */
Bool ufAutoSynch(Uint32 count);							/* vCf[^XVԊu̎w */
											/* Play data update interval */
Bool ufReadAllProduct(Uint8* Buffer);						/* ^CgXg̏ */
											/* get Title list */ 
Bool ufReadAllHead(Uint8* ProdNum, UFS_AllPlayHistory* buff); 			/* ^CgʃvC̎Q */
											/* Refer individual Play history */
Bool ufTitleDelete(void);							/* ^CgʃvC̏ */
											/* Erase individual Play history */
Bool ufChangeAutoSave(Uint8 Flag);						/* ۑtO̕ύX */
											/* Change Auto save flag */
Bool ufConnect(Uint32 time);							/* T[oڑ̃^Cgf[^̍XV */
											/* Data update for network connect */
Bool ufDisConnect(void);							/* T[oؒf̃^Cgf[^̍XV */
											/* Data update for network disconnect */
Bool ufSafeRefresh(void);							/* tbṼtbV */
											/* Flash Memory refresh */
Bool ufGetControllerList(Uint32* list);						/* Rg[Xg̏ */
											/* get controller list */
Bool ufGetExtControllerList(Uint32* list);					/* gRg[Xg̏ */
											/* get extended controller list */
void ufExitSystem(void);							/* CuI */
											/* Exit this library */										

/*============================================================*
 *------------------------------------------------------------*
 * End of File                                                *
 *------------------------------------------------------------*
 *============================================================*/
#endif 
