/*
 *  Shinobi Library
 *  Copyright (c) 1998-2000 SEGA
 *
 *       Shinobi Library Version 2.0
 *
 *  Module  : Library Header File
 *  File    : shinobi.h
 *  Create  : 1998-03-25
 *  Modify  : 2000-08-15
 *  Version : 2.18
 *  Note    :
 */

#ifndef _SHINOBI_H_
#define _SHINOBI_H_


#include <machine.h>      /* SHC Builtin Functions                    */
#include <sg_xpt.h>       /* SEGA Library Default Definitions         */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <sg_pad.h>       /* Controller Library                       */
#include <sg_gd.h>        /* GD Library                               */
#include <sg_sytmr.h>     /* Timer Library                            */
#include <sg_syrtc.h>     /* Realtime Clock Library                   */
#include <sg_maloc.h>     /* Memory Management Library                */
#include <sg_sycfg.h>     /* Configuration Library                    */
#include <sg_sybt.h>      /* BOOT ROM Service Library                 */
#include <sg_btfnt.h>     /* BOOT ROM Font Library                    */
#include <sg_lcd.h>       /* LCD Library                              */
#include <sg_pdkbd.h>     /* Keyboard Library                         */
#include <sg_pdvib.h>     /* Vibration Library                        */
#include <sg_pdtmr.h>     /* Peripheral Timer Library                 */
#include <sg_bup.h>       /* Backup Library                           */
#include <sg_cache.h>     /* Cache Library                            */
#include <sg_uf.h>        /* Play Log     Library                     */
#include <wssip.h>        /* Sound Input  Library                     */
#include <sg_sysrt.h>     /* C++ Startup Library                      */
#include <sg_video.h>     /* Video Setting Library                    */
#include <sg_syhw.h>      /* Hardware Initialization Library          */
#include <sg_syfbr.h>     /* Fiber Library                            */
#include <sg_syfs.h>      /* Filesystem Library for Middleware        */
#include <sg_calbk.h>     /* User Chain Callback Library              */
#include <sg_symem.h>     /* Memory Copy Library                      */
#include <sg_pdms.h>      /* Mouse Library                            */
#include <sg_symng.h>     /* Middleware Manage Library                */
#include <sg_sycom.h>     /* Serial Port Access Library               */
#include <sg_exchk.h>     /* Extention check Library                  */
#include <sg_malcm.h>     /* Multiple Heap Memory Management Library  */

extern void sbInitSystem(void);
extern void sbExitSystem(void);

extern const char * sbGetVersionString(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _SHINOBI_H_ */

/******************************* end of file *******************************/
