/*----------------------------------------------------------------------------
		sbinit2.c Ver.2.06  2000/08/30
		Copyright (C) 1997-2000 SEGA Enterprises Co.,Ltd
		All Rights Reserved
----------------------------------------------------------------------------*/
/* ̋Lq́ACugp҂̃VXeɍ킹                 */
/* ύX邱Ƃł܂B                                           */
/* ύX̍ۂ͊֘AhLgQƂAeڂK؂ɏCĂ */

/* You can change a description of this place according to a system   */
/* of library user.                                                   */
/* When change it, please refer to a document concerned and revise    */
/* each item adequately.                                              */


#include <shinobi.h>     	 /* Ewb_t@C                      */
                         	 /* Shinobi library header file           */


extern Uint8* _BSS_END;   /* BSG/BSG32ZNV̏IAhX        */
                          /* End address of BSG/BSG32 section         */

#define WORK_START (0x8C000000)		/* [NRAM̐擪AhX        */
#define WORK_END   (0x8D000000)		/* [NRAM̏IAhX        */

/* [NƂė̈ŒmۂTCY                               */
/* _BSS_END  WORK_END-WORK_FIXED_SIZE ܂łq[v̈ɂȂ܂  */
/* WORK_END-WORK_FIXED_SIZE  WORK_END ܂łŒ̈ɂȂ܂    */
#define WORK_FIXED_SIZE (0x00000000)

/* syMalloc()̊Ǘɒuq[v̐擪AhXƃq[ṽTCY       */
/* The top address of the heap area and heap size                     */
#define HEAP_AREA ((((Uint32)_BSS_END | 0x80000000) + 0x1F) & 0xFFFFFFE0)
#define HEAP_SIZE (WORK_END - WORK_FIXED_SIZE - HEAP_AREA)



/* GD:ɊJƂ̂łőt@C                            */
/* GD:Maximum file number opening at the same time.                   */
#define FILES (8)

/* GD:JgfBNgobt@                                    */
/* GD:Current directory buffer                                        */
#define BUFFERS (1024)

/* FIBER:Ɏgpőt@Co(C+~hEGA+[U[)   */
/* FIBER:Max fibers(Main+MiddleWare+User)                             */
#define FIBERS (1+4+11)

/* INTERRUPT:荞ݗpX^bNTCY(byte)                           */
/* INTERRUPT:Stack size for the interrupt handler                     */
#define INTSTACK_SIZE (20 * 1024)



/* O[o[N̐錾                                             */
/* Global work area                                                   */

#define SYD_ALIGN32(x) ((void*)(((Uint32)(x) + 0x1F) & 0xFFFFFFE0))

Uint8 gMapleRecvBuf[1024 * 24 * 2 + 32];
Uint8 gMapleSendBuf[1024 * 24 * 2 + 32];

Uint8 gdfswork[GDFS_WORK_SIZE(FILES) + 32];
Uint8 gdfscurdir[GDFS_DIRREC_SIZE(BUFFERS) + 32];

Uint32 gIntStackBuf[INTSTACK_SIZE / sizeof(Uint32)];
SYS_FBR_INFO gFiberInfo[FIBERS];


/* O[oRXgN^̌Ăяo@gpRpC       */
/* ĈႤ߁AeRpCɍ킹ă}N`Ă     */
/* Global constructor/destructor (C++ using) setting                  */
/*  Please define your compile system                                 */
/*    Nothing   : Hitachi SHC V5.x                                    */
/*  __HITACHI__ : Hitachi SHC V6.x~                                   */
/*  __MWERKS__  : Metrowerks CodeWarrior                              */
/*  __GNUC__    : GNU                                                 */

/* O[oRXgN^^fXgN^Ăяo֐̐錾           */
/* Prototype of global constructor/destructor functions */
void syStartGlobalConstructorAlt( void );
void syStartGlobalDestructorAlt( void );

/*----------------------------------------------------------------------------
		AvP[V̏֐
		Initialization function of the application.
----------------------------------------------------------------------------*/
void sbInitSystem(void)
{
	/* WIȏs܂B                             */
	/* ̐ݒŁÃAvP[Vő̃ptH[}X */
	/* 邱Ƃł܂B                                       */
	/* ɗR̂ȂA̋LqCȂłB     */
	/* Cꍇ́AeCu̎dl\A       */
	/* Cugp҂̐ӔCɂďCĂB           */
	
	/* Do standard initialization.                                */
	/* By this setting, many applications can get the greatest    */
	/* performance.                                               */
	/* Without the special reason, please do not change a         */
	/* desctiption of this place.                                 */
	/* When change it, please understand specification of each    */
	/* library enough, and revise it in responsibility of library */
	/* user.                                                      */
	
	/* 荞݋֎~       */
	/* Disable interrupt. */
	set_imask(15);
	
	/* {[_[J[̐ݒ */
	/* Set border color.    */
	syVideoWaitVBlankSetBorderColor(0x00000000);
	
	/* n[hEFȀ */
	/* Initialize hardware.  */
	syHwInit( &gIntStackBuf[INTSTACK_SIZE/sizeof(Uint32)] );
	
	/* Ǘ̏            */
	/* Initialize memory management. */
	syMallocInit( (void*)HEAP_AREA, HEAP_SIZE );
	
	/* O[oRXgN^̌Ăяo */
	/* Call global constructor            */
	syStartGlobalConstructorAlt();
	
	/* t@Co[Cȕ  */
	/* Initialize fiber library.     */
	syFbrInitEx( gFiberInfo, FIBERS,
						&gIntStackBuf[INTSTACK_SIZE/sizeof(Uint32)], NULL );
	
	/* Rg[Cȕ */
	/* Initialize controller library. */
	pdInitPeripheral( PDD_PLOGIC_ACTIVE,
					SYD_ALIGN32(gMapleRecvBuf), SYD_ALIGN32(gMapleSendBuf) );
	
	/* R[obNCȕ */
	/* Initialize callback library.   */
	syCallbackInit();
	
	/* 荞݋      */
	/* Enable interrupt. */
	set_imask(0);
	
	/* GDt@CVXȅ                               */
	/* Initialize GD filesystem.                                */
	gdFsInit2(	FILES  , SYD_ALIGN32(gdfswork),
				BUFFERS, SYD_ALIGN32(gdfscurdir) );
	
	/* ~hEFAŎgpt@CVXȅ         */
	/* Initialize filesystem for middleware                     */
	syFsInit();
}


/*----------------------------------------------------------------------------
		AvP[V̏I֐
		Finalize application.
----------------------------------------------------------------------------*/
void sbExitSystem(void)
{
	/* ~hEFAŎgpt@CVXȅI       */
	/* Finalize fiber manager for middleware                    */
	syFsFinish();
	
	/* GDt@CVXȅI */
	/* Finalize GD filesystem.      */
	gdFsFinish();
	
	/* R[obNCȕI */
	/* Finalize callback library.       */
	syCallbackFinish();
	
	/* Rg[CȕI */
	/* Finalize controller library.     */
	pdExitPeripheral();
	
	/* t@Co[CȕI   */
	/* Finalize fiber library.          */
	syFbrExit();
	
	/* O[ofXgN^̌Ăяo */
	/* Call global destructor           */
	syStartGlobalDestructorAlt();
	
	/* Ǘ̏I        */
	/* Finalize memory management. */
	syMallocFinish();
	
	/* n[hEFȀI */
	/* Finalize hardware.     */
	syHwFinish();
	
	/* 荞݋֎~       */
	/* Disable interrupt. */
	set_imask(15);
}


/*----------------------------------------------------------------------------
 C++ global constructor support for All environment
----------------------------------------------------------------------------*/
#ifdef __HITACHI__
#include <_h_c_lib.h>
#endif
void syStartGlobalConstructorAlt ( void )
{
#ifdef __HITACHI__
	syStartGlobalConstructorSegaLib();
	_CALL_INIT();
#else
	#if defined(__MWERKS__) || defined(__GNUC__)
		void (*pf)();
		Uint32 *adr;
		
		for( adr = (Uint32 *) (&_START_DSG_INIT_);
			 adr < (Uint32 *) (&_END_DSG_INIT_);
			 adr++ ){
			if( !( ( *adr == 0x00000000) || ( *adr == 0xFFFFFFFF) )){
				pf = (void(*)())( *adr );
				(*pf)();
			}
		}
		#ifdef __MWERKS__
			__call_static_initializers(); /* For CodeWarrior */
		#endif /* __MWERKS__ */
		#ifdef __GNUC__
			__do_global_ctors(); /* For GCC */
		#endif /* __GNUC__ */
	#else
		syStartGlobalConstructor(); /* For SHC V5.1 (Default) */
	#endif /* __MWERKS__ or __GNUC__ */
#endif /* __HITACHI__ */
}
/*----------------------------------------------------------------------------
 C++ global destructor support for All environment 
----------------------------------------------------------------------------*/
void syStartGlobalDestructorAlt ( void )
{
#ifdef __HITACHI__
	syStartGlobalDestructorSegaLib();
	_CALL_END();
#else
	#if defined(__MWERKS__) || defined(__GNUC__)
		void (*pf)();
	    Uint32 *adr;
		
		for( adr = (Uint32 *) (&_START_DSG_END_) ;
			 adr < (Uint32 *) (&_END_DSG_END_) ;
			 adr++ ){
			if( !( ( *adr == 0x00000000) || ( *adr == 0xFFFFFFFF) )){
				pf = (void(*)())( *adr );
				(*pf)();
			}
		}
		#ifdef __MWERKS__
			__destroy_global_chain();
		#endif /* __MWERKS__ */
		#ifdef __GNUC__
			__do_global_dtors();
		#endif /* __GNUC__ */
	#else
		syStartGlobalDestructor(); /* For SHC V5.1 (Default) */
	#endif /* __MWERKS__ or __GNUC__ */
#endif /* __HITACHI__ */
}


#ifdef __HITACHI__
#ifdef __cplusplus
extern "C" 
#endif
void abort( void ){
	for(;;);
}
#endif


/*--------------------------------------------------------------------------*/
