/*---------------------------------------------------------------------------
  Shinobi Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	"Km.h"

KMSTRIPCONTEXT	StripContext;
KMSTRIPHEAD		StripHead;

/*---------------------------------------------------------------------------
		
		initialize
---------------------------------------------------------------------------*/
Sint32	UserInit(void)
{
	StripContext.nSize = sizeof( KMSTRIPCONTEXT );
	kmInitStripContext( KM_STRIPCONTEXT_SYS_GOURAUD | KM_OPAQUE_POLYGON, &StripContext );
	kmGenerateStripHead00( &StripHead, &StripContext );
	
	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		I
		exit
---------------------------------------------------------------------------*/
Sint32	UserExit(void)
{
	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		C
		main
---------------------------------------------------------------------------*/
Sint32	UserMain(void)
{
	static int cnt = 0;
	static int x = 220;
	static int y = 140;
	static int c = -1;
	KMVERTEX_00 vtx[4];
	
	c++;
	if (c>=  0&&c<100) x += 2;
	if (c>=100&&c<200) y += 2;
	if (c>=200&&c<300) x -= 2;
	if (c>=300&&c<400) y -= 2;
	if (c>=400) c = -1;
	
	vtx[0].ParamControlWord  = KM_VERTEXPARAM_NORMAL;
	vtx[0].fX                = x-100.f;
	vtx[0].fY                = y-100.f;
	vtx[0].u.fInvW           =   1.f;
	vtx[0].uBaseRGB.dwPacked = 0xffff0000;
	
	vtx[1].ParamControlWord  = KM_VERTEXPARAM_NORMAL;
	vtx[1].fX                = x-100.f;
	vtx[1].fY                = y+100.f;
	vtx[1].u.fInvW           =   1.f;
	vtx[1].uBaseRGB.dwPacked = 0xff00ff00;
	
	vtx[2].ParamControlWord  = KM_VERTEXPARAM_NORMAL;
	vtx[2].fX                = x+100.f;
	vtx[2].fY                = y-100.f;
	vtx[2].u.fInvW           =   1.f;
	vtx[2].uBaseRGB.dwPacked = 0xff0000ff;
	
	vtx[3].ParamControlWord  = KM_VERTEXPARAM_ENDOFSTRIP;
	vtx[3].fX                = x+100.f;
	vtx[3].fY                = y+100.f;
	vtx[3].u.fInvW           =   1.f;
	vtx[3].uBaseRGB.dwPacked = 0xffffffff;
	
	kmStartStrip( &VertexBufferDesc, &StripHead );
    kmSetVertex( &VertexBufferDesc, &vtx[0], KM_VERTEXTYPE_00, sizeof(KMVERTEX_00));
    kmSetVertex( &VertexBufferDesc, &vtx[1], KM_VERTEXTYPE_00, sizeof(KMVERTEX_00));
    kmSetVertex( &VertexBufferDesc, &vtx[2], KM_VERTEXTYPE_00, sizeof(KMVERTEX_00));
    kmSetVertex( &VertexBufferDesc, &vtx[3], KM_VERTEXTYPE_00, sizeof(KMVERTEX_00));
    kmEndStrip( &VertexBufferDesc );
	
	kmuPrintf( 2,2, "SHINOBI2 KAMUI2 %d", cnt++ );
	return USER_CONTINUE;
}
/*-------------------------------------------------------------------------*/
