/*----------------------------------------------------------------------------
  Shinobi2 Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
----------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	"Km.h"

extern Uint32 _NOWLOADING[];
/*----------------------------------------------------------------------------
		Now Loading ̕\
----------------------------------------------------------------------------*/

#define DISPX ( 40.f)
#define DISPY (400.f)
#define SIZEX (256.f)
#define SIZEY ( 32.f)

void DisplayNowLoading( void )
{
	KMSTRIPCONTEXT	StripContext;
	KMSTRIPHEAD		StripHead;
	KMSURFACEDESC	Texture;
	KMVERTEX_03		v[4];
	Sint32 i;
	
	kmCreateTextureSurface( &Texture, 256, 32,
							KM_TEXTURE_TWIDDLED_RECTANGLE | KM_TEXTURE_RGB565 );
	kmLoadTexture( &Texture, _NOWLOADING );
	
	StripContext.nSize = sizeof( KMSTRIPCONTEXT );
	kmInitStripContext( KM_STRIPCONTEXT_SYS_GOURAUD | KM_OPAQUE_POLYGON, &StripContext );
	StripContext.ImageControl[KM_IMAGE_PARAM1].pTextureSurfaceDesc = &Texture;
	kmGenerateStripHead03( &StripHead, &StripContext );
	
	v[0].ParamControlWord    = KM_VERTEXPARAM_NORMAL;
	v[0].fX                  = DISPX;
	v[0].fY                  = DISPY;
	v[0].u.fInvW             = 1.f;
	v[0].fU                  = 0.f;
	v[0].fV                  = 0.f;
	v[0].uBaseRGB.dwPacked   = 0xffc0c0c0;
	v[0].uOffsetRGB.dwPacked = 0x00000000;
	
	v[1].ParamControlWord    = KM_VERTEXPARAM_NORMAL;
	v[1].fX                  = DISPX;
	v[1].fY                  = DISPY + SIZEY;
	v[1].u.fInvW             = 1.f;
	v[1].fU                  = 0.f;
	v[1].fV                  = 1.f;
	v[1].uBaseRGB.dwPacked   = 0xffc0c0c0;
	v[1].uOffsetRGB.dwPacked = 0x00000000;
	
	v[2].ParamControlWord    = KM_VERTEXPARAM_NORMAL;
	v[2].fX                  = DISPX + SIZEX;
	v[2].fY                  = DISPY;
	v[2].u.fInvW             = 1.f;
	v[2].fU                  = 1.f;
	v[2].fV                  = 0.f;
	v[2].uBaseRGB.dwPacked   = 0xffc0c0c0;
	v[2].uOffsetRGB.dwPacked = 0x00000000;
	
	v[3].ParamControlWord    = KM_VERTEXPARAM_ENDOFSTRIP;
	v[3].fX                  = DISPX + SIZEX;
	v[3].fY                  = DISPY + SIZEY;
	v[3].u.fInvW             = 1.f;
	v[3].fU                  = 1.f;
	v[3].fV                  = 1.f;
	v[3].uBaseRGB.dwPacked   = 0xffc0c0c0;
	v[3].uOffsetRGB.dwPacked = 0x00000000;
	
	kmBeginScene( &SystemConfig );
	kmBeginPass( &VertexBufferDesc );
	
	kmStartStrip( &VertexBufferDesc, &StripHead );
    kmSetVertex( &VertexBufferDesc, &v[0], KM_VERTEXTYPE_03, sizeof(KMVERTEX_03));
    kmSetVertex( &VertexBufferDesc, &v[1], KM_VERTEXTYPE_03, sizeof(KMVERTEX_03));
    kmSetVertex( &VertexBufferDesc, &v[2], KM_VERTEXTYPE_03, sizeof(KMVERTEX_03));
    kmSetVertex( &VertexBufferDesc, &v[3], KM_VERTEXTYPE_03, sizeof(KMVERTEX_03));
    kmEndStrip( &VertexBufferDesc );
	
	kmEndPass( &VertexBufferDesc );
	kmRender( KM_RENDER_FLIP );
	kmEndScene( &SystemConfig );
	
	i = syTmrGetCount();
	while( syTmrCountToMicro( syTmrGetCount()-i )<16666*3 );
	
	kmFreeTexture( &Texture );
}
/*--------------------------------------------------------------------------*/
Uint32 _NOWLOADING[] = {
//	0x58494247,0x00000008,0x00000000,0x00000000,	// PVRt@CNinjap
//	0x54525650,0x00004008,0x00000d01,0x00200100,	// wb_菜
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x42083186,0x00000000,0x00000000,
	0x84104208,0xffff4208,0x00000000,0x3186528a,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffff4208,0xffff4208,0xffffffff,0xffffffff,
	0xffff4208,0xffff4208,0xffffffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0xbdf78410,0x528a1082,0xef7dffff,
	0x00000000,0x00000000,0x00000000,0x738e3186,
	0xdefb9cf3,0x630cad75,0xce79ffff,0x00002104,
	0x8410ce79,0x8410ef7d,0x00004208,0x00001082,
	0xffffffff,0xffffffff,0x8410ef7d,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00001082,0x8410ef7d,0x00000000,0x00001082,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x21040000,0x00000000,0xdefb738e,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x84100000,0xbdf70000,0x00000000,0x00000000,
	0xffff8c71,0xffffffff,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0xffffbdf7,0x8c71528a,0xad75ef7d,
	0x42088c71,0x00000000,0x00000000,0x00000000,
	0xffffdefb,0x2104738e,0xbdf7defb,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffdefb,0xdefb1082,0x00000000,0x00000000,
	0x84100000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x84101082,0x00000000,0xffffef7d,0x84101082,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xffffef7d,0xffffffff,0xffffffff,
	0x84101082,0x00000000,0xffffef7d,0x738e1082,
	0xffffffff,0xffffffff,0x8410ef7d,0xffffffff,
	0xffffffff,0xffffdefb,0xffffffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x630c0000,0x00000000,0xffffdefb,0x630c0000,
	0x00000000,0x00000000,0x00000000,0x21040000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x528a4208,0xbdf74208,0x00000000,0x00001082,
	0xffff4208,0xffff4208,0xffffffff,0x8410ef7d,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xef7d4208,0x738e4208,0x00002104,0x00000000,
	0x31863186,0x00000000,0x00000000,0x00000000,
	0x00000000,0x630c2104,0x00000000,0xef7dad75,
	0xdefbffff,0x00002104,0x528a8c71,0x00000000,
	0x8c714208,0xad75ffff,0xffffce79,0x3186738e,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x10820000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x10820000,0xef7d8410,0xbdf7630c,0xffffffff,
	0x00001082,0x8410ef7d,0x00000000,0x00001082,
	0xffffffff,0xffffffff,0x8410ef7d,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00001082,0x8410ef7d,0x00000000,0x00001082,
	0xffffffff,0xffffdefb,0xffffffff,0xffffffff,
	0x630c0000,0xad75630c,0xffffce79,0xffffef7d,
	0xffffffff,0xffffffff,0x8410ef7d,0xffffffff,
	0xffffffff,0x738ebdf7,0xdefbffff,0x00003186,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00001082,0x8410ef7d,0x00000000,0x00000000,
	0x528a9cf3,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x9cf3defb,0x00000000,0x1082528a,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x31860000,0x00000000,0x42084208,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0x00000000,0x00002104,0x00000000,0x00000000,
	0xdefbffff,0xffffffff,0x10828410,0xef7dffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00003186,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x84100000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0xffff4208,0xffffdefb,
	0x630c0000,0xdefb0000,0xffffffff,0x528aef7d,
	0x00000000,0x84100000,0xef7d528a,0xffffffff,
	0xffff9cf3,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xad75ef7d,
	0xffffffff,0xdefbffff,0xef7dffff,0x0000630c,
	0x10828410,0x00000000,0x00000000,0x00000000,
	0x31868c71,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffff3186,0xce798410,0x0000630c,0x00000000,
	0x8410bdf7,0x8410bdf7,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xdefbbdf7,0xffff8410,0x00001082,0x528ace79,
	0xffff3186,0xad750000,0xffffffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x10820000,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0x00000000,0x738e4208,0x00000000,0xdefb9cf3,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0x4208738e,0xdefbffff,0x00000000,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xbdf7bdf7,0x00000000,0xffffce79,0x21040000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x3186ef7d,0xbdf7ffff,0x00000000,0x00000000,
	0xffffffff,0xffffce79,0x00003186,0x0000630c,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xef7d1082,0xbdf70000,0x00008410,0x00008410,
	0xce790000,0xffff2104,0x00008410,0x00004208,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x528a0000,
	0x00000000,0x00000000,0x10820000,0xce791082,
	0x630c0000,0xffffbdf7,0xffffef7d,0xffffffff,
	0x8c713186,0xffffffff,0xffffdefb,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xef7dffff,0x3186ef7d,
	0xef7dffff,0x1082bdf7,0x00003186,0x00000000,
	0xffffce79,0xce79ffff,0x00002104,0x00000000,
	0x630cffff,0x0000bdf7,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00002104,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x10820000,0x00000000,0xffffdefb,0xbdf71082,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x528a3186,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xad75630c,0x00000000,0xffffef7d,0x00000000,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xce79ffff,0x00000000,0x630c9cf3,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xad754208,0xffff4208,0x00001082,0xffffffff,
	0xffff4208,0xffff4208,0xffffffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffff4208,0xffff4208,0xffffffff,0x528a8c71,
	0x84104208,0x31864208,0x00000000,0x00000000,
	0x42083186,0xffffffff,0x8410738e,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xad758410,0xffffffff,0xbdf7bdf7,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0x21044208,0xffffffff,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xbdf7ce79,0x00000000,0x8410bdf7,0x00000000,
	0x00000000,0x00000000,0x31860000,0xffff738e,
	0xffffffff,0x8410ef7d,0x738eef7d,0x00001082,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x42080000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x42084208,0x00000000,0x84108410,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0xbdf78410,0x00000000,0x0000630c,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffef7d,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xce79ffff,0x738eef7d,0x00003186,
	0x630c8410,0xad751082,0xffffbdf7,0x630cef7d,
	0xce79defb,0x10828c71,0x00003186,0x00000000,
	0x10829cf3,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xdefbffff,0x1082ad75,0x00003186,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x21042104,0x00000000,0x00000000,
	0x84104208,0xffff4208,0x00000000,0xce79bdf7,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffff4208,0xffff4208,0xffffffff,0xffffffff,
	0xffff4208,0xffff4208,0xffffffff,0x8c71defb,
	0x00000000,0x00000000,0x00000000,0x31860000,
	0x10820000,0xffffffff,0xef7d738e,0xffffffff,
	0x9cf31082,0xce79ce79,0x528aef7d,0x00002104,
	0x8410defb,0xffffffff,0x8c718410,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0x630c8410,0xffffffff,0x42084208,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0x00001082,0xbdf7ffff,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xad754208,0x42084208,0x00000000,0x00000000,
	0x00001082,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x21042104,0x00000000,0x00000000,
	0x8c714208,0xffff4208,0x630c0000,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x10820000,
	0x00000000,0x00000000,0x10820000,0xdefb3186,
	0x738e0000,0xef7dad75,0x8c71ffff,0x0000528a,
	0x00000000,0x84101082,0xdefb3186,0x8410ffff,
	0xef7ddefb,0x1082bdf7,0x00004208,0x00000000,
	0x2104bdf7,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xbdf7bdf7,0xffffffff,0xffffce79,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x42084208,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0x9cf3bdf7,0x84100000,0xffffbdf7,0x9cf3ffff,
	0xffffffff,0xef7dffff,0x9cf3ffff,0x0000630c,
	0x3186ce79,0x00001082,0x00000000,0x00000000,
	0x00000000,0x84104208,0x00000000,0x00004208,
	0xffffffff,0x3186defb,0x0000528a,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00001082,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xef7dad75,0x2104ce79,0x0000528a,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffff4208,0xef7d4208,0x738eef7d,0x00003186,
	0x630c4208,0x00001082,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x42084208,0x8c714208,0x00000000,0x00000000,
	0xffff4208,0xffff4208,0xce79ce79,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x10820000,
	0x00000000,0x630c2104,0x00000000,0xef7d9cf3,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0x84103186,0xffffffff,0xffffce79,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x42080000,0x8c710000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x9cf3528a,0x31860000,0xffffdefb,
	0x00000000,0x00000000,0x00000000,0x630c1082,
	0xbdf7738e,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0x8410bdf7,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xef7dffff,0x00003186,0x738e9cf3,0x00000000,
	0xdefb1082,0xffffdefb,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0x00000000,0x00000000,
	0xffffbdf7,0xffff4208,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffff4208,0xffff4208,0xffffffff,0xffffffff,
	0xffff4208,0xffff4208,0xef7dffff,0x0000738e,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x8c714208,0x42084208,0x00000000,0x00000000,
	0x00001082,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0xffffffff,0xbdf7ffff,
	0x528a9cf3,0x00000000,0x00001082,0x00000000,
	0xffffffff,0x3186738e,0x9cf3defb,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x10820000,0xef7d528a,
	0x00000000,0x10820000,0x00000000,0xbdf7630c,
	0xef7d8410,0xffffffff,0xffffffff,0xffffffff,
	0x1082528a,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x21040000,0x9cf30000,
	0x00000000,0x10820000,0xffff3186,0xffffce79,
	0xffff4208,0xffff528a,0x00000000,0x00000000,
	0xffff8410,0xffffce79,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0x00000000,0x00000000,
	0xffffffff,0xef7dffff,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xce791082,0x528a630c,0x9cf3ef7d,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x31860000,0xffffffff,0x42084208,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0x00002104,0xdefbffff,0x00000000,0x10828410,
	0xffffffff,0xffffffff,0xef7dffff,0xffffffff,
	0x0000528a,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00003186,0x3186ef7d,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x84100000,0xffff4208,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x630c0000,0xffffdefb,0xffffffff,
	0xdefb0000,0xffff3186,0x528aef7d,0x0000630c,
	0x84100000,0xffff9cf3,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xef7dffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0x31868c71,0xad75ef7d,0x00000000,
	0xdefbffff,0x10828410,0x0000630c,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xce798410,0x8410bdf7,0x00000000,0x00000000,
	0x8410bdf7,0xdefbbdf7,0x00000000,0x00001082,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffff8410,0xffff3186,0x528ace79,0xffffffff,
	0xad750000,0x10820000,0xffffffff,0xffffdefb,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0xffffffff,0x10820000,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0x738e4208,0xffffffff,0xdefb9cf3,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xdefbffff,
	0x4208738e,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xbdf7bdf7,0xffffffff,0xffffce79,
	0x00000000,0x00000000,0x21040000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x10820000,
	0xbdf7ffff,0xffffffff,0x00000000,0x00003186,
	0xffffce79,0xef7d1082,0x0000630c,0x00008410,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xbdf70000,0xce790000,0x00008410,0x00008410,
	0xffff2104,0xffffce79,0x00004208,0x00002104,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x8c713186,0x528a0000,0xffffdefb,
	0x00000000,0x630c0000,0xce791082,0xffffef7d,
	0xffffbdf7,0xffffffff,0xffffffff,0xef7dffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0x738eef7d,
	0xffffffff,0xef7dffff,0x3186ef7d,0x00003186,
	0x1082bdf7,0x00000000,0x00000000,0x00000000,
	0xce79ffff,0x630cffff,0x00000000,0x00000000,
	0x0000bdf7,0x00002104,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0xbdf71082,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xad75630c,0xffffffff,0xffffef7d,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xce79ffff,0xffffffff,0x630c9cf3,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x31860000,
	0x00000000,0x738e0000,0xef7d528a,0x630cffff,
	0x00000000,0x00000000,0x00000000,0xce791082,
	0x31860000,0xef7d528a,0xbdf7defb,0xbdf7ffff,
	0xef7d9cf3,0x3186ce79,0x00004208,0x00000000,
	0x00001082,0xbdf7bdf7,0x00000000,0xffffdefb,
	0x8410ef7d,0x00000000,0x00001082,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x10820000,0xce791082,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x630c0000,0xef7d9cf3,
	0x31860000,0xef7d4208,0xef7dce79,0x10829cf3,
	0x738effff,0x0000528a,0x00000000,0x00000000,
	0x84100000,0xef7d1082,0x00000000,0x00000000,
	0xffffce79,0xffffffff,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffbdf7,0x9cf30000,0x00000000,0x00000000,
	0x42080000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xce791082,0xbdf7defb,0x528affff,0x4208ffff,
	0x00009cf3,0x00000000,0x4208ffff,0x4208ffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x4208ffff,0x4208ffff,
	0x00000000,0xffffffff,0x4208ffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x42082104,0xffffffff,0x738e4208,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x10820000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x84100000,0xce790000,0x00000000,0x00000000,
	0xffffbdf7,0xffffffff,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x738e0000,0xffff9cf3,
	0xce791082,0xbdf78410,0xffffffff,0xbdf7bdf7,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0x8410bdf7,0xffffffff,0x84108410,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0x84108410,0xffffffff,0x84108410,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x21042104,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x528a4208,0x9cf34208,0x00000000,0x00000000,
	0xffff4208,0xffff4208,0xef7ddefb,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x10820000,
	0x00000000,0x630c2104,0x00000000,0xef7d9cf3,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0x84103186,0xffffffff,0xffffce79,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0x84108410,0xffffffff,0x4208528a,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0x42084208,0xffffffff,0x42084208,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0x00000000,0x00000000,
	0xffffffff,0xffff8410,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x9cf30000,0x10820000,0x00000000,0x00000000,
	0x630c0000,0x9cf30000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x9cf3528a,0x31860000,0xffffdefb,
	0x00000000,0x00000000,0x00000000,0x630c1082,
	0xbdf7738e,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0x8410ce79,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xef7dffff,0x00003186,0x84109cf3,0x00000000,
	0xef7d1082,0xffffdefb,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0x00000000,0x00000000,
	0xffffce79,0xffff528a,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffff4208,0xffff4208,0xffffffff,0xffffffff,
	0xffff4208,0xffff4208,0xdefbffff,0x00003186,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffff4208,0xffff1082,0x00002104,0x0000630c,
	0xef7d0000,0xad750000,0x3186ef7d,0xef7dffff,
	0xffffffff,0xffffffff,0xffffffff,0xbdf7ffff,
	0x528a9cf3,0x00000000,0x00001082,0x00000000,
	0xffffffff,0x3186738e,0x9cf3defb,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x0000630c,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x630c0000,0x10820000,0xffffffff,0xffffef7d,
	0x00000000,0x00000000,0xffff528a,0x630c0000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xef7dffff,0xffffffff,0x8410bdf7,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0x84108410,0xffffffff,0xbdf78c71,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xad753186,0x00000000,0xffffffff,0x528a1082,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0x84108410,0xffffffff,0x630c8410,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x1082630c,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x42080000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x528a0000,0x10820000,0xef7d9cf3,
	0x00000000,0x31860000,0xef7d3186,0xffffef7d,
	0xffff8410,0xffffffff,0xffffffff,0xdefbffff,
	0xffff4208,0xdefb630c,0x00000000,0x00000000,
	0xbdf7bdf7,0x8410ffff,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x528affff,0x0000ef7d,0x00000000,0x00000000,
	0x00008410,0x00001082,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xbdf7ffff,
	0xffffffff,0xffffffff,0x3186ffff,0x0000630c,
	0x528aef7d,0x00002104,0x00000000,0x00000000,
	0xdefbffff,0x00003186,0x0000630c,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x738e0000,0x00000000,0x00000000,
	0x9cf30000,0xef7d3186,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x21041082,0x630c4208,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xad754208,0xffff4208,0x10820000,0xffffffff,
	0xffff4208,0xffff4208,0xffffffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x21040000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0xad75738e,0x528a0000,0xffffffff,
	0x8c71528a,0xffffffff,0xffffdefb,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xef7dffff,0xffffffff,0x630c9cf3,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffff4208,0xffff4208,0xffffffff,0xad75ffff,
	0xef7d4208,0x738e4208,0x00003186,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x31864208,0x00000000,0x00000000,0x00000000,
	0x10820000,0x42084208,0x00000000,0x00000000,
	0xffffffff,0x1082630c,0x8410ce79,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00003186,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x21040000,0x00000000,0xad75738e,
	0x00000000,0x00000000,0x00000000,0x738e2104,
	0xdefb8c71,0xffffffff,0xffffffff,0xffffffff,
	0x00000000,0xef7dad75,0x9cf3528a,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xce79ffff,0x00002104,0x42088c71,0x00000000,
	0xffffffff,0xad75ef7d,0xffffffff,0x3186630c,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xdefb2104,0x00000000,0x00000000,
	0x8c710000,0x42080000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x42080000,0xffffffff,0xce798c71,0x738ead75,
	0x00000000,0x630c2104,0x21040000,0xffffad75,
	0xdefbffff,0x00003186,0x84109cf3,0x00000000,
	0x00000000,0x21040000,0x00000000,0x00000000,
	0x84100000,0xdefb1082,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffbdf7,0xffffffff,0x00000000,0x00000000,
	0xffffad75,0xbdf70000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xad754208,0xffff4208,0x00000000,0x738e8c71,
	0xffff4208,0xffff4208,0xffffffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffff4208,0xffff4208,0xffffffff,0xffffffff,
	0x42080000,0x00000000,0xffffbdf7,0x42080000,
	0x00000000,0xffffbdf7,0x8c71528a,0xad75ffff,
	0x4208bdf7,0xbdf7ffff,0x00000000,0x00004208,
	0xffffdefb,0x2104738e,0x8c71defb,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0xbdf7ffff,0xffffffff,
	0xffffffff,0xffffbdf7,0xffffffff,0xffffffff,
	0x00004208,0xbdf7ffff,0x00000000,0x00004208,
	0xffffffff,0xffffffff,0xbdf7ffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x10821082,0x00000000,0x00000000,
	0x630c4208,0xdefb4208,0x00000000,0x4208528a,
	0x42080000,0x00000000,0xffffbdf7,0x31860000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xffff9cf3,0xffffffff,0xffffffff,
	0x21040000,0x00000000,0xffff9cf3,0x21040000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x9cf3630c,0x31860000,0xffffef7d,
	0x00000000,0x00000000,0x00000000,0x630c1082,
	0xce798410,0x738ebdf7,0xef7dffff,0x00003186,
	0x0000528a,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00004208,0xbdf7ffff,0x00000000,0x00004208,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x630c0000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0xbdf7ffff,0xffffffff,
	0xffffffff,0xffff9cf3,0xffffffff,0xffffffff,
	0x00004208,0xbdf7ffff,0x00000000,0x00004208,
	0xffffffff,0xffffffff,0xbdf7ffff,0xffffffff,
	0x21040000,0xef7d9cf3,0xffffbdf7,0xce79ffff,
	0x630c9cf3,0x00000000,0x00001082,0x00000000,
	0xffffffff,0x31868410,0x9cf3ef7d,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00004208,0xbdf7ffff,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x1082630c,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffff4208,0xffff4208,0xffffffff,0x4208ce79,
	0xce794208,0x630c4208,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x21042104,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x9cf3defb,0x00000000,0x1082528a,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x21040000,
	0x00000000,0x00000000,0x00000000,0xce793186,
	0x630c0000,0xffff630c,0xffffffff,0xffffffff,
	0xad75528a,0xffffffff,0xffffef7d,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x528a0000,0xef7d1082,
	0x00000000,0x31860000,0xffffad75,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x9cf30000,0xef7d0000,0xffffffff,0x9cf3ffff,
	0xffff4208,0xffff8410,0x0000ce79,0x00004208,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xbdf7ffff,0x8410ef7d,0x00002104,
	0xffffffff,0xad75ffff,0xffffffff,0x2104630c,
	0x00001082,0x00000000,0x00000000,0x00000000,
	0x00009cf3,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x630c0000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x42084208,0x00000000,0x00004208,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0x630cad75,0xffffffff,0x00000000,0x3186ce79,
	0xffffffff,0xffffffff,0xef7dffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00003186,0x1082ef7d,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xbdf7ef7d,0x00000000,0xbdf7bdf7,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffdefb,0x10820000,0xffffffff,0xef7d8410,
	0x00000000,0x00000000,0x31860000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x528a1082,
	0x9cf3ffff,0xef7dffff,0x00000000,0x00000000,
	0xffffef7d,0xffff4208,0x00004208,0x0000738e,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xdefb0000,0xbdf70000,0x00008410,0x00008410,
	0xef7d0000,0xffff8c71,0x00008410,0x00004208,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xdefb9cf3,0x8c71bdf7,0x00000000,0x00000000,
	0x8410bdf7,0x8c71bdf7,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xdefb8c71,0xffff630c,0x00000000,0x0000738e,
	0xffff2104,0xffff0000,0x9cf3ffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x84100000,0x84100000,
	0x00000000,0x00000000,0x84100000,0x84100000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00003186,0xef7dffff,0x00000000,0x2104ad75,
	0x00000000,0x00000000,0x84100000,0x84100000,
	0x00000000,0x00000000,0x84100000,0x84100000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffff738e,0x00002104,0x8c71bdf7,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x2104528a,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x21040000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00004208,0xbdf7ef7d,0x31860000,0xffffef7d,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xbdf7738e,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0xffffffff,
	0xffffffff,0xffffffff,0xffffffff,0x8410ce79,
	0x10829cf3,0x00002104,0x00000000,0x00000000,
	0xef7dffff,0x00003186,0x630c9cf3,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xffffffff,0xdefbffff,0x00002104,0x00000000,
	0x9cf3ffff,0x3186ffff,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00001082,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x10820000,0x738e1082,0xffffef7d,
	0x738e0000,0x738e0000,0xffffffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x10820000,0x00000000,0xffffef7d,0x738e1082,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x1082738e,0xef7dffff,0x00000000,0x00001082,
	0xffffffff,0xffffffff,0x0000738e,0x0000738e,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xef7dffff,0x1082738e,0x00001082,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x10820000,0x738e1082,0xffffef7d,
	0x738e0000,0x738e0000,0xffffffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x10820000,0x00000000,0xffffef7d,0x738e1082,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x1082738e,0xef7dffff,0x00000000,0x00001082,
	0xffffffff,0xffffffff,0x0000738e,0x0000738e,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xef7dffff,0x1082738e,0x00001082,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x10820000,0x738e1082,0xffffef7d,
	0x738e0000,0x738e0000,0xffffffff,0xffffffff,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x10820000,0x00000000,0xffffef7d,0x738e1082,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x1082738e,0xef7dffff,0x00000000,0x00001082,
	0xffffffff,0xffffffff,0x0000738e,0x0000738e,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0xef7dffff,0x1082738e,0x00001082,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000,
};
