//-----------------------------------------------------------------------------
// {Rg[
//-----------------------------------------------------------------------------

#ifndef _NWCONTROL_H_
#define _NWCONTROL_H_

#define DefMsgProc(x) NWCONTROL::MsgProc(x)

//-----------------------------------------------------------------------------

class NWCONTROL: public NWCLASS {
private:
	void _init( void );
	void _sort( PNWCONTROL pCtrl );
	void _preinit( PNWCONTROL pRootControl );
protected:
	NWRECT			sRect;						// `
	NWRECT			sAlignRect;					// ACp`
	int				nAlignWidth;				// AC
	NWALIGN			eAlign;						// ACRg[
	
	int				bEnabled;					// LtO
	int				bVisible;					// tO
	NWCURSORNO		eCursorNo;					// J[\
	
	NWCONTROL( void );
	virtual void SetChildRect( int nX, int nY );
	virtual void AlignChild( void );
	virtual void Align( PNWRECT pR );
public:
	PNWCONTROL		pRoot;						// eRg[
	PNWCONTROL		pRootForm;					// etH[
	PNWLIST			pControls;					// qRg[
	PNWPOPUPMENU	pPopupMenu;					// |bvAbvj[
	
	int				nTag;						// ^O
	int				nTabOrder;					// ^uI[_[
	int				bTabStop;					// ^uXgbv
	int				nZorder;					// ZI[_[
	
	NWCONTROL( PNWCONTROL pRootControl );
	~NWCONTROL( void );
	
	void Dump( int n );
	
	int CheckRect( PNWPOINT p );
	int CheckRectEx( PNWPOINT p );
	void SetRect( PNWRECT pNewR );
	void SetRectClip( PNWRECT pNewR );
	NWRECT GetRect( void );
	void SetAlign( NWALIGN eNewAlign );
	NWALIGN GetAlign( void );
	void SetCursorNo( NWCURSORNO eNewNo );
	NWCURSORNO GetCursorNo( void );
	
	int IsVisible( void );
	int IsEnabled( void );
	
	void Show( void );
	void Hide( void );
	void ScreenToClient( PNWPOINT p );
	void ClientToScreen( PNWPOINT p );
	void SetZorder( int nZ );
	
	virtual void Enable( void );
	virtual void Disable( void );
	
	virtual int MsgProc( PNWMESSAGE pMessage );
	virtual int MsgShortCut( PNWMESSAGE pMessage );
	
	virtual int MsgIdle( PNWMESSAGE pMessage )			{ return 0; };
	virtual int MsgPaint( PNWMESSAGE pMessage )			{ return 0; };
	virtual int MsgMouseDown( PNWMESSAGE pMessage )		{ return 0; };
	virtual int MsgMouseUp( PNWMESSAGE pMessage )		{ return 0; };
	virtual int MsgMouseMove( PNWMESSAGE pMessage )		{ return 0; };
	virtual int MsgKeyDown( PNWMESSAGE pMessage )		{ return 0; };
	virtual int MsgKeyUp( PNWMESSAGE pMessage )			{ return 0; };
	virtual int MsgDialog( PNWMESSAGE pMessage )		{ return 0; };
	virtual int MsgResize( PNWMESSAGE pMessage )		{ return 0; };
	virtual int MsgShow( PNWMESSAGE pMessage )			{ return 0; };
	virtual int MsgHide( PNWMESSAGE pMessage )			{ return 0; };
};

//-----------------------------------------------------------------------------

#endif
