//-----------------------------------------------------------------------------
// O[o
//-----------------------------------------------------------------------------

#ifndef _NWGLOBAL_H_
#define _NWGLOBAL_H_

//-----------------------------------------------------------------------------
class NWGLOBAL: public NWCLASS {
	friend class NWDESKTOP;
protected:
	int				nGlobalIndex;
	float			fZDepth;
	int				nCurrentFont;
	
	PNWBITMAP		pIcon;
	PNWCURSOR		pCursor;
	PNWBITMAP		pFontBM;
	PNWFONT			pFontSmall;
	PNWFONT			pFontNormal;
	PNWFONT			pFontLarge;
	PNWLIST			pFontSet;
	PNWLIST			pFormList;
	
	PNWLIST			pCallbackCtx;
	PNWLIST			pCallbackFunc;
	
	PNWDESKTOP		pDesktop;
	PNWFORM			pActiveForm;
	PNWFORM			pTopForm;
public:
	int				nTime;
	int				nReturnCode;
	long			nNindowsTime;
	long			nNindowsIn;
	long			nNindowsOut;
	PNWRING			pMesQueue;
	PNWPOPUPMENU	pGlobalPopup;
	PNWCOMMAND		pCommand;
	
	int				nScreenW;
	int				nScreenH;
	float			fScreenAX;
	float			fScreenAY;
	float			fAspectX;
	float			fAspectY;
	
	int				nMouseXaxis;
	int				nMouseYaxis;
	int				nMouseZaxis;
	int				nMousePress;
	int				nMouseRelease;
	int				nMouseOn;
	
	NWGLOBAL( void );
	~NWGLOBAL( void );
	
	void RegistCallback( NWCALLBACKCONTEXT eCtx, PNWCALLBACK pFunc );
	void UnregistCallback( NWCALLBACKCONTEXT eCtx, PNWCALLBACK pFunc );
	void RequestCallback( NWCALLBACKCONTEXT eCtx, void* pParam );
	
	void Initialize( void );
	void Execute( void );
	void Draw( void );
	int GetGlobalIndex( void );
	float GetZDepth( void );
	void SetZDepth( float fZ );
	
	PNWDESKTOP GetDesktop( void );
	PNWFONT GetCurrentFont( void );
	PNWBITMAP GetCurrentIcon( void );
	void GetCursorPos( PNWPOINT p );
	void SetCursorPos( PNWPOINT p );
	void HideGlobalPopup( void );
	PNWCONTROL GetCapture( void );
	
	void SetActiveForm( PNWFORM pForm );
	PNWFORM GetActiveForm( void );
	
	void CreatedForm( PNWFORM pForm );
	void DestroyedForm( PNWFORM pForm );
	
	void BringToFront( PNWFORM pForm );
	void SystemForm( PNWFORM pForm, int bShow );
	void UserForm( PNWFORM pForm, int bShow );
	
	void SelectSystemFont( int nFont );
};

extern NWGLOBAL *pGlobal;
//-----------------------------------------------------------------------------
#endif
