//-----------------------------------------------------------------------------
// j[
//-----------------------------------------------------------------------------

#ifndef _NWMENU_H_
#define _NWMENU_H_

//-----------------------------------------------------------------------------
class NWPOPUPMENU: public NWGRAPHIC {
	friend class NWMENUITEM;
protected:
	PNWPOPUPMENU	pSubMenu;
	NWCOLOR			sMenuColor[4];
	NWCOLOR			sFontNormal;
	NWCOLOR			sFontNormalR;
	NWCOLOR			sFontDisable;
	
	void CalcMenuSize( PNWRECT pR );
	NWPOPUPMENU( void );
public:
	int				bAutoPopup;
	
	NWPOPUPMENU( PNWCONTROL pRootControl, PNWMENUTEMPLATE *ppTemplate );
	~NWPOPUPMENU( void );
	
	void Hide( void );
	void Popup( PNWPOINT pPos );
	void SubMenuPopup( PNWMENUITEM pSender, PNWPOPUPMENU pSub );
	
	PNWMENUITEM AddMenuItem( PNWMENUTEMPLATE pMenu );
	void DelMenuItem( PNWMENUITEM pMenuItem );
	int MsgPaint( PNWMESSAGE pMessage );
};

class NWMENUITEM: public NWGRAPHIC {
	friend class NWPOPUPMENU;
protected:
	int				nIconIndex;
	int				nAccelKey;
	NWCMD			eCommand;
	char			xCaption[256];
	PNWPOPUPMENU	pSubMenu;
	
	NWMENUITEM( void );
public:
	NWMENUITEM( PNWCONTROL pRootControl, PNWMENUTEMPLATE pTemplate );
	~NWMENUITEM( void );
	
	void SetCaption( char* pStr );
	char* GetCaption( void );
	
	void SetIconIndex( int nIndex );
	int GetIconIndex( void );
	
	PNWMENUITEM AddSubMenuItem( PNWMENUTEMPLATE pMenu );
	void DelSubMenuItem( PNWMENUITEM pMenuItem );
	
	int MsgPaint( PNWMESSAGE pMessage );
	int MsgMouseDown( PNWMESSAGE pMessage );
	int MsgMouseUp( PNWMESSAGE pMessage );
	int MsgMouseMove( PNWMESSAGE pMessage );
};
//-----------------------------------------------------------------------------
#endif
