/*---------------------------------------------------------------------------
  Shinobi Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	"Nj.h"

#define UPPER (0)
#define LOWER (0)
#define UU (0.02f)
#define VV (0.02f)

extern NJS_CNK_OBJECT  object_cube_cube1_cube1[];

Sint32 Mode;

Angle RX;
Angle RY;
Angle RZ;

Angle AR;
Angle RR;
Angle FF;

Angle CR[3];
Angle CG[3];
Angle CB[3];

NJS_TEXINFO stexinfo;
NJS_TEXNAME stexname;
NJS_TEXLIST stexlist = { &stexname, 1 };

void *pWork;

/*---------------------------------------------------------------------------
		
		initialize
---------------------------------------------------------------------------*/
Sint32	UserInit(void)
{
	NJS_POINT2 p[2];
	
	pWork = syMalloc(1024*512*2);
	
	njSetTextureInfo(&stexinfo , pWork, NJD_TEXFMT_RGB_565 | NJD_TEXFMT_STRIDE, 1024,512);
	njSetTextureName(&stexname , &stexinfo, 0, NJD_TEXATTR_TYPE_MEMORY | NJD_TEXATTR_GLOBALINDEX);
	if(nuLoadTexture( &stexlist ) < 0){
		return USER_EXIT;
	}
	
	njSetRenderWidth( 640 );
	njSetFrameBufferTextureNumG( 0, pWork, UPPER, LOWER );
	
	p[0].x = 0;
	p[0].y = UPPER;
	p[1].x = 0;
	p[1].y = 480-LOWER;
	njClip2D( p );
	
	njCnkSetSimpleLight( 0.6f, -0.6f, -0.6f );
	njCnkSetSimpleLightIntensity( 0.6f,0.5f );
	njCnkSetSimpleLightColor( 1.f, 1.f, 1.f );
	
	njSetBackColor( 0,0,0 );
	
	RX = 0;
	RY = 0;
	RZ = 0;
	
	AR = 0;
	RR = 0;
	FF = 0;
	
	CR[0] = 0x2000;
	CG[0] = 0x1000;
	CB[0] = 0xe000;
	CR[1] = 0;
	CG[1] = 0x8000;
	CB[1] = 0;
	CR[2] = 0;
	CG[2] = 0;
	CB[2] = 0x8000;
	
	Mode = 0;
	njFrameBufferTextureTurboMode( Mode );
	
	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		I
		exit
---------------------------------------------------------------------------*/
Sint32	UserExit(void)
{
	njStopFrameBufferTexture();
	
	njReleaseTexture( &stexlist );
	syFree( pWork );
	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		C
		main
---------------------------------------------------------------------------*/
Sint32	UserMain(void)
{
	float r;
	Sint32 i;
	
	if (Per->press&PDD_DGT_TX) {
		Mode = 1 - Mode;
		njFrameBufferTextureTurboMode( Mode );
	}
#if DEBUG
	if (Mode==0)
		njPrint( NJM_LOCATION( 2,2 ), "X: TURBO OFF" );
	else
		njPrint( NJM_LOCATION( 2,2 ), "X: TURBO ON" );
#endif
	
	AR += 600;
	RR += 400;
	
	RX += 250;
	RY += 270;
	RZ += 260;
	
	r = njSin( RR ) * 11.f + 16.f;
	
	njPushMatrixEx();
		njTranslate( NULL, 0.f, 0.f, -90.f );
		
		for( i=0; i<6; i++ ) {
			njPushMatrixEx();
			njRotateZ( NULL, AR + NJM_DEG_ANG(i*60) );
			njTranslate( NULL, 0.f, r, 0.f );
			njRotateXYZ( NULL, RX, RY, RZ );
			njCnkSimpleDrawObject( object_cube_cube1_cube1 );
			njPopMatrixEx();
		}
	njPopMatrixEx();
 	
	{
		NJS_TEXTURE_VTX v[4];
		Uint32 alpha;
		
		FF += 110;
		alpha = njSin( FF )*20.f + 230.f;
		
		v[0].x   = 0.f;
		v[0].y   = UPPER;
		v[0].z   = 1.f;
		v[0].u   = 0.f							- UU + UU;
		v[0].v   = 0.f							+ VV + VV;
		v[0].col = 0x00ffffff | (alpha<<24);
		
		v[1].x   = 0.f;
		v[1].y   = 480.f-LOWER;
		v[1].z   = 1.f;
		v[1].u   = 0.f							+ UU + UU;
		v[1].v   = (480.f-LOWER-UPPER)/512.f	+ VV - VV;
		v[1].col = 0x00ffffff | (alpha<<24);
		
		v[2].x   = 640.f;
		v[2].y   = UPPER;
		v[2].z   = 1.f;
		v[2].u   = 640.f/1024.f					- UU - UU;
		v[2].v   = 0.f							- VV + VV;
		v[2].col = 0x00ffffff | (alpha<<24);
		
		v[3].x   = 640.f;
		v[3].y   = 480.f-LOWER;
		v[3].z   = 1.f;
		v[3].u   = 640.f/1024.f					+ UU - UU;
		v[3].v   = (480.f-LOWER-UPPER)/512.f	- VV - VV;
		v[3].col = 0x00ffffff | (alpha<<24);
		
		njSetTextureNumG( 0 );
		njTextureFilterMode( NJD_TEXTUREFILTER_BILINEAR );
		njDrawTextureEx( v, 4, TRUE);
	}
	{
		NJS_COLOR c[3];
		
		CR[0] += 111;
		CG[0] += 155;
		CB[0] += 135;
		CR[1] += 160;
		CG[1] += 188;
		CB[1] += 195;
		CR[2] += 144;
		CG[2] += 101;
		CB[2] += 167;
		
		for( i=0; i<3; i++ ) {
			c[i].argb.r = njSin( CR[i] ) * 127.f + 128.f;
			c[i].argb.g = njSin( CG[i] ) * 127.f + 128.f;
			c[i].argb.b = njSin( CB[i] ) * 127.f + 128.f;
		}
		njSetBackColor( c[0].color, c[1].color, c[2].color );
	}
	return USER_CONTINUE;
}
/*-------------------------------------------------------------------------*/
