/*---------------------------------------------------------------------------
  Shinobi2 Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	"Nj.h"

#define TEXLIST texlist
extern NJS_TEXLIST TEXLIST[];

static	Uint8	*startaddr = (Uint8*)0x8c000000;

NJS_QUAD_TEXTURE	quad;
NJS_QUAD_TEXTURE_EX	quadex;
NJS_TEXTURE_VTX		tex[4];

Sint8	cc[16] = {
	'0',
	'1',
	'2',
	'3',
	'4',
	'5',
	'6',
	'7',
	'8',
	'9',
	'A',
	'B',
	'C',
	'D',
	'E',
	'F',
};	

/*---------------------------------------------------------------------------
		
		initialize
---------------------------------------------------------------------------*/
Sint32	UserInit(void)
{
	if(nuLoadTexture( TEXLIST ) < 0){
		return USER_EXIT;
	}
	njSetTexture( TEXLIST );

	tex[0].z = 1.0f;
	tex[0].col = 0xffffffff;

	tex[1].z = 1.0f;
	tex[1].col = 0xffffffff;

	tex[2].z = 1.0f;
	tex[2].col = 0xffffffff;

	tex[3].z = 1.0f;
	tex[3].col = 0xffffffff;
	
	quadex.z = 1.0f;
	quadex.vx1 = 8.0f;
	quadex.vy1 = 0.0f;
	quadex.vx2 = -4.0f;
	quadex.vy2 = 8.0f;
	quadex.vu1 = 0.0625f;
	quadex.vv1 = 0.0f;
	quadex.vu2 = 0.0f;
	quadex.vv2 = 0.0625f;

	return USER_CONTINUE;
}
/*---------------------------------------------------------------------------
		I
		exit
---------------------------------------------------------------------------*/
Sint32	UserExit(void)
{
	return USER_CONTINUE;
}

void	drawchar( Sint32 x, Sint32 y, Sint32 c )
{
#if 1
	quad.x1 = (Float)x;
	quad.y1 = (Float)y;
	quad.x2 = quad.x1 + 8.f;
	quad.y2 = quad.y1 + 8.f;
	quad.u1 = (Float)(c & 0x0f) * 0.0625f;
	quad.v1 = (Float)(c >> 4) * 0.0625f;
	quad.u2 = quad.u1 + 0.0625f;
	quad.v2 = quad.v1 + 0.0625f;

	njDrawQuadTexture( &quad, 1.0f );
#else
	quadex.x = (Float)x;
	quadex.y = (Float)y;
	quadex.u = (Float)(c & 0x0f) * 0.0625f;
	quadex.v = (Float)(c >> 4) * 0.0625f;

	njDrawQuadTextureEx( &quadex );
#endif
}

void	drawchar2( Sint32 x, Sint32 y, Sint32 c )
{
	register	Float	x1,y1,u,v;
	
	x1 = (Float)x;
	y1 = (Float)y;
	u  = (Float)(c & 0x0f) * 0.0625f;
	v  = (Float)(c >> 4) * 0.0625f;
	
	tex[0].x = x1;
	tex[0].y = y1;
	tex[0].u = u;
	tex[0].v = v;

	tex[1].x = x1;
	tex[1].y = y1 + 8.0f;
	tex[1].u = u;
	tex[1].v = v + 0.0625f;

	tex[2].x = x1 + 8.0f;
	tex[2].y = y1;
	tex[2].u = u + 0.0625f;
	tex[2].v = v;

	tex[3].x = x1 + 8.0f;
	tex[3].y = y1 + 8.0f;
	tex[3].u = u + 0.0625f;
	tex[3].v = v + 0.0625f;

	njSetTextureNum( 0 );
	njDrawTextureEx( tex, 4, TRUE );
}

/*---------------------------------------------------------------------------
		C
		main
---------------------------------------------------------------------------*/
Sint32	UserMain(void)
{
	Sint32	x,y,i,j;
	Uint8	*p,d;
	Uint32	add;
	static	mode = 1;
	
	p = startaddr;

	if( mode ) {
		njQuadTextureStart( TRUE );
		njSetQuadTexture( 0, 0xffffffff );
		
		for( i=0; i<60; i++ ) {
			y = i*8;
			add = (Uint32)p;
			for( j=7; j>=0; j-- ) {
				drawchar( j*8+16, y, cc[add & 0x0f]);
				add >>= 4;
			}
			for( j=0; j<16; j++ ) {
				d = *p++;
				drawchar( (12 + j*3)*8, y, cc[d >> 4] );
				drawchar( (13 + j*3)*8, y, cc[d & 0x0f] );
				drawchar( (62 + j)*8, y, d );
			}
		}
		
		njQuadTextureEnd();
	}
	else {
		for( i=0; i<60; i++ ) {
			y = i*8;
			add = (Uint32)p;
			for( j=7; j>=0; j-- ) {
				drawchar2( j*8+16, y, cc[add & 0x0f]);
				add >>= 4;
			}
			for( j=0; j<16; j++ ) {
				d = *p++;
				drawchar2( (12 + j*3)*8, y, cc[d >> 4] );
				drawchar2( (13 + j*3)*8, y, cc[d & 0x0f] );
				drawchar2( (62 + j)*8, y, d );
			}
		}
	}


	if( Per->press & PDD_DGT_ST ) mode = 1-mode;
	
	if( Per->on & PDD_DGT_TA ) i = 32;
	else 					   i = 16;
	if( Per->on & PDD_DGT_KU ) startaddr -= i;
	if( Per->on & PDD_DGT_KD ) startaddr += i;
	if( Per->on & PDD_DGT_KL ) startaddr -= i*30;
	if( Per->on & PDD_DGT_KR ) startaddr += i*30;

	if( Per->on & PDD_DGT_TX ) startaddr = (Uint8*)0x8c000000;
	if( Per->on & PDD_DGT_TY ) startaddr = (Uint8*)0x8c800000;
	if( Per->on & PDD_DGT_TB ) startaddr = (Uint8*)(0x8d000000-16*60);

	if( (Uint32)startaddr < 0x8c000000 ) startaddr = (Uint8*)0x8c000000;
	if( (Uint32)startaddr > (0x8d000000-16*60) ) startaddr = (Uint8*)(0x8d000000-16*60);

	return USER_CONTINUE;
}
/*-------------------------------------------------------------------------*/
