#include	<shinobi.h>
#include	<Ninja.h>
#include	"Nj.h"
#include	"Movie.h"

/*	tOON/OFF̔]		*/
/*	Turn over flag(ON/OFF)	*/
#define NOT_FLAG(flag)		(((flag) == OFF) ? ON : OFF)

/*	Convert from sampling frequency and counter to time(hour,min,sec,frame)	*/
void UsrSfcnt2time(Sint32 sf, Sint32 ncnt, Sint32 *hh, Sint32 *mm, Sint32 *ss, Sint32 *ff)
{
	register Sint32 nf = (Sint32)((Float)ncnt/(Float)sf*100.0);

	*hh = nf/(60*60*100);
	*mm = nf/(60*100) - *hh*60;
	*ss = nf/100 - *hh*60*60 - *mm*60;
	*ff = nf%100;
}

/*	~hEFÃG[ɋN֐			*/
/*	Callback function when an error occur in middleware	*/
void ap_mw_err_func(void *obj, char *errmsg)
{
	AP ap=(AP)obj;

	for (;;);
}

/*	~hEFȀ				*/
/*	Initialize Middleware				*/
void ApInitMw(AP ap)
{
	MWS_PLY_INIT_SFD	iprm;
	void *vtxbuf;

	memset(&iprm, 0, sizeof(iprm));	/*	\񃁃õ[ݒ			*/
									/*	initialize reserved member		*/
	iprm.mode		= njGetDisplayMode();			/*	Resolution, NTSC, PAL, VGA		*/
	iprm.frame		= NJD_FRAMEBUFFER_MODE_ARGB8888;/*	RGB565, ARGB8888				*/
	iprm.count		= 2;			/*	Game period by the V-Sync count */
	iprm.latency	= 2;		/*	Latency (2V or 3V)				*/
	mwPlyInitSfdFx(&iprm);
	vtxbuf = njGetVertexBuffDesc();
	mwPlySetVertexBuffer(vtxbuf);
	mwPlyEntryErrFunc(ap_mw_err_func, ap);
	
}

/*	~hEFȀI					*/
/*	Finalize Middleware					*/
void ApFinishMw(AP ap)
{
	mwPlyFinishSfdFx();
}

/*	AvP[VJn	*/
/*	Start application		*/
void ApStart(AP ap)
{
	MWS_PLY_CPRM_SFD		*cprm=&ap->cprm;

	/*	nh̐	*/
	/*	Create handle	*/
	memset(cprm, 0, sizeof(cprm));		/*	\񃁃õ[ݒ			*/
										/*	To initialize reserved member	*/
	cprm->compo_mode = MWD_PLY_COMPO_OPEQ;
	cprm->ftype	= MWD_PLY_FTYPE_SFD;
	cprm->dtype	= MWD_PLY_DTYPE_AUTO;	/*	AUTO̕掿ǂ			*/
										/*	Quality is good in case 
										 *	of specified 'AUTO'.			*/
	cprm->max_bps = 450*1024*8;		/*	őrbgXg[(bit/sec)
									 *	ۂȂ邱Ƃ\B
									 *	[r[rŃt[YƂ
									 *	̒l𑝂₵ĂB			*/
									/*	Maximum number of bit per second
									 *	You can reduce it than a fact.
									 *	Increase this value when the movie
									 *	stops on the way.					*/
	cprm->max_width = 288;			/*	Đ摜TCY̍ő啝				*/
									/*	Maximum width of video stream		*/
	cprm->max_height = 160;			/*	Đ摜TCY̍ő卂			*/
									/*	Maximum height of video stream		*/
	cprm->nfrm_pool_wk = 8;			/*	VXë̃t[v[
									 *	WIɂ͂RŗǂAׂ
									 *	ϓɂR}ꍇ
									 *	₵ĂB					*/
									/*	Size of working area
									 *	It is good with 3 normally. But please
									 *	increase it when frame drop occurs by
									 *	processing load change.				*/
	/*	Ɨ̈̑傫̌vZ				*/
	/*	Calculation of working area size	*/
	cprm->wksize = mwPlyCalcWorkCprmSfd(cprm);
	/*	Ɨ̈̊m						*/
	/*	Allocation of working area			*/
	cprm->work = syMalloc(cprm->wksize);
	if(cprm->work == NULL){
		for (;;) ;
	}
	ap->ply = mwPlyCreateSofdec(cprm);
	if (ap->ply == NULL) {
		for (;;) ;
	}
	mwPlySetVideoSw(ap->ply, ap->video_flag);
	mwPlyStartFname(ap->ply, ap->fname);/*	ĐJn						*/
										/*	Start to play middleware		*/
}

/*	AvP[V~	*/
/*	Stop application		*/
void ApStop(AP ap)
{
	mwPlyStop(ap->ply);					/*	Đ~ 					*/
										/*	Stop to play middleware		*/
	mwPlyDestroy(ap->ply);				/*	nh				*/
										/*	Destroy handle				*/
	ap->ply = NULL;
	syFree(ap->cprm.work);				/*	Ɨ̈̊J				*/
										/*	Release work area			*/
	ap->cprm.work = NULL;

}

/*	̕\			*/
/*	Display infomation	*/
void ap_disp_info(AP ap)
{
	Sint32	time, tunit, hh, mm, ss, ff;

	mwPlyGetTime(ap->ply, &time, &tunit);
	UsrSfcnt2time(tunit, time, &hh, &mm, &ss, &ff);
#if DEBUG
	njPrint(NJM_LOCATION( 2,2 ), "File: %s  Time:%02d:%02d:%02d.%02d", 
							ap->fname, hh, mm, ss, ff);
#endif
}

/*	̍Đ					*/
/*	Playing the animation file	*/
Sint32 ApExec(AP ap)
{
	MWPLY					ply=ap->ply;
	MWE_PLY_STAT			stat;

	if (Per->press & PDD_DGT_ST) {
		ap->pause = NOT_FLAG(ap->pause);
		mwPlyPause(ply, ap->pause);		/*	ꎞ~			*/
										/*	Release pause status	*/
	}
	if (Per->press & PDD_DGT_TA)
		ap->disp_flag = NOT_FLAG(ap->disp_flag);
	if (Per->press & PDD_DGT_TB)
		return FALSE;
	if (Per->press & PDD_DGT_TX) {
		ap->video_flag = NOT_FLAG(ap->video_flag);
		mwPlySetVideoSw(ply, ap->video_flag);
	}

	/*	Checking status												*/
	stat = mwPlyGetStat(ply);
	if ((stat == MWE_PLY_STAT_PLAYEND) || (stat == MWE_PLY_STAT_ERROR))
		return FALSE;
	if ( ap->disp_flag == ON )
		ap_disp_info(ap);

	return TRUE;
}

void ApSetMvSurface(AP ap,NJS_TEXLIST *texlist,Sint32 tex_no)
{
	/*	T[tFX̐ݒ				*/
	/*	Set movie surface to Ninja texture	*/
	void *srf;
	MWS_PLY_MVFRM frm;
	MWPLY					ply=ap->ply;

	if ( mwPlyGetMvFrm(ply, &frm) == 1 )
		njSetTextureSurface(texlist, tex_no, 0,frm.srf);

	return;
}

/*	GDt@CVXẽG[ɋN֐			*/
/*	Callback function when an error occur in GD file system	*/
void ApGdErrFunc(void *obj, Sint32 errcode)
{
	AP ap=(AP)obj;
	if (errcode == GDD_ERR_TRAYOPEND || errcode == GDD_ERR_UNITATTENT)
		ap->term_flag = ON;			/*	AvP[V̏I		*/
									/*	Terminate application		*/
}

