/*---------------------------------------------------------------------------
  Shinobi2 Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/
#include	<shinobi.h>
#include	"Nj.h"
#include	"TexMain.h"
#include	"TexMalloc.h"

Sint32 SetTextureManageNum(Uint32 globalIndex,Uint32 bank,NJS_PVRHEADERDATA *pvrh)
{
	Sint32 no;
	Sint32 ret;
	NJS_TEXMANAGE *texmanage;
	NJS_TEXSYSTEM *texsystem;

	
	/* _nj_texsystem󂢂ĂƂT */
	no = njGetTexManageNum(&texmanage,&texsystem);
	if(no < 0){
		return -1;
	}
	texmanage->texsys = texsystem;

	/* pvrhT[tFX擾 */
	if(njCheckTextureFormatManageNum(no,pvrh) < 0){
		return -1;
	}
	
	/* texfixedarea󂢂Ă̈擾Đݒ肷 */
	//texsystem->texsurface.TextureSize ->njCheckTextureFormat֐sŒl͐ݒ肳Ă
	//texsystem->texsurface.pSurface	->̗̈texfixedarea擾̈ݒ肷

	if((texsystem->texsurface.pSurface = TexMalloc(texsystem->texsurface.TextureSize)) == NULL){
		texmanage->texsys = NULL;
		return -1;
	}
	/******************************************************/
	
	/* O[oCfbNX̐ݒ */
	if(globalIndex != NJD_GLOBAXINDEX_FIRST_VAL)
		texmanage->texsys->globalIndex = globalIndex;
	
	/* pbg̐ݒ */
	if(njCheckPaletteType(pvrh->nTextureType)){
		texmanage->bank = bank;
	}
	else{
		texmanage->bank = NJD_BANK_FIRST_VAL;
	}
	
	/* p[^̐ݒ */
	njSetTextureParamEx(texmanage);
	texmanage->count = 1;
	texmanage->texsys->count = 1;
	_nj_tex_count++;
	
	return no;
}


Sint32 EntryTextureManageNum(NJS_TEXLIST *texlist,Sint32 n,Uint32 globalIndex,Uint32 bank,NJS_PVRHEADERDATA *pvrh,Sint32 *texmng_no)
{
	Sint32 ret;
	ret = njSearchTextureManageNum(globalIndex,bank,pvrh->nTextureType,texmng_no);

	switch(ret){
	case -1:
		return -1;
	case 0:
		*texmng_no = SetTextureManageNum(globalIndex,bank,pvrh);
		if(*texmng_no < 0){
			return -1;
		}
		njLinkTexlist(texlist,n,*texmng_no);
		return 0;
	case 1:
		njLinkTexlist(texlist,n,*texmng_no);
		return 1;
	}
}

/*
	SmallVQ̓[hȂłB
*/
Sint32 LoadFileTexture(NJS_TEXLIST *texlist,Uint32 n)
{
	Sint32 ret;
	GDFS fp;
	Sint32 file_sect_size;
	Sint32 buffer_sect_size;
	Sint32 read_sect_size;
	Uint32 globalIndex;
	Uint32 globalIndex0;
	Uint32 bank;
	NJS_PVRHEADERDATA pvrh;
	Sint8 * tex_start;
	Sint8 filename2[32];
	Sint32 texmng_no;
	Uint32 size,offset;
	Sint8 *texbuf;
	Int texbuf_size;
	
	njInitTextureErrStat();
	/*
		NJD_TEXATTR_TEXCONTINUE,
		NJD_TEXATTR_GLOBALINDEX,
		NJD_TEXATTR_PALGLOBALINDEX̏
	*/
	ret = njCheckAttrGlobalIndex(texlist,n,&globalIndex0,&bank);
	if(ret){
		/* 0ȊȌꍇ */
		/*  1: NJD_TEXATTR_TEXCONTINUE*/
		/* -1: G[                 */
		return ret;
	}

	/* t@C̕ύX */
	njCheckFileName(filename2,texlist->textures[n].filename,".PVR");

	if((fp = gdFsOpen(filename2,NULL)) == NULL){
		/* t@CI[vG[@*/
		_nj_texerr_.texerr = NJD_TEXERR_FILEOPEN;
		return -1;
	}

	/* t@C̃ZN^TCY̌vZ */
	gdFsGetFileSctSize(fp,&file_sect_size);
	/* eNX`obt@̎擾 */
	nuGetTextureBuffer(&texbuf,&texbuf_size);
	buffer_sect_size = texbuf_size/NJD_GD_SECT_SIZE;


	/* [hZN^vZ */
	if(buffer_sect_size >= file_sect_size){
		/* obt@̕傫ꍇ@*/
		/* When a sector of a buffer is bigger than a sector loading it. */
		read_sect_size = file_sect_size;
	}
	else{
		/* obt@̕ꍇ@*/
		/* When a sector of a buffer is smaller than a sector loading it.*/
		read_sect_size = buffer_sect_size;
	}


	if((ret = gdFsRead(fp,read_sect_size,texbuf)) != GDD_ERR_OK){
		/* t@C[hG[@*/
		gdFsClose(fp);
		NUM_FREAD_ERR(fp,NJD_TEXERR_FILELOAD)
		return -1;
	}

	if((tex_start = njLoadPvrHeader(&pvrh,&globalIndex,texbuf)) == NULL){
		/* wb_f[^Ȃ@*/
		gdFsClose(fp);
		return -1;
	}

	if(globalIndex0 != NJD_GLOBAXINDEX_FIRST_VAL){
		globalIndex = globalIndex0;
	}
	
	
	/*
		nuLoadFileTexture֐ƂႤ
	*/
	ret = EntryTextureManageNum(texlist,n,globalIndex,bank,&pvrh,&texmng_no);
	
	if(ret){
		gdFsClose(fp);
		return ret;
	}

	offset = 0;
	size = read_sect_size*NJD_GD_SECT_SIZE - ((Uint32)tex_start - (Uint32)texbuf);
	do{
		if(njLoadTexturePartManageNum(texmng_no,tex_start,offset,size)== -1){
			/*
				nuLoadFileTexture֐ƂႤ
			*/
			ReleaseTexture(texlist,n);
			texlist->textures[n].attr &= ~NJD_TEXATTR_REGISTRATION;
			texlist->textures[n].texaddr = 0;
			/* eNX`[hG[@*/
			gdFsClose(fp);
			_nj_texerr_.texerr = NJD_TEXERR_TEXMEMLOAD;
			return -1;
		}
		offset += size;
		file_sect_size -= read_sect_size;
		
		if(buffer_sect_size >= file_sect_size){
			/* obt@̕傫ꍇ@*/
			read_sect_size = file_sect_size;
		}
		else{
			/* obt@̕ꍇ@*/
			read_sect_size = buffer_sect_size;
		}
		
		if((ret = gdFsRead(fp,read_sect_size,texbuf)) != GDD_ERR_OK){
			/*
				nuLoadFileTexture֐ƂႤ
			*/
			ReleaseTexture(texlist,n);
			texlist->textures[n].attr &= ~NJD_TEXATTR_REGISTRATION;
			texlist->textures[n].texaddr = 0;
			NUM_FREAD_ERR(fp,NJD_TEXERR_FILELOAD)
			/* t@C[hG[@*/
			gdFsClose(fp);
			return -1;
		}
		tex_start = texbuf;
		size = read_sect_size*NJD_GD_SECT_SIZE;
		while(njLoadTextureFinishDMA() != 1);
	}while(file_sect_size > 0);
	
	gdFsClose(fp);

	return 1;
}

/*
	SmallVQ̓[hȂłB
*/
Sint32 LoadTexture(NJS_TEXLIST *texlist)
{
    Uint32 n;
	
    if(texlist->nbTexture <= 0){
		_nj_texerr_.texerr = NJD_TEXERR_OTHER;
        return (-1);
     }

    for(n = 0;n < texlist->nbTexture;n++){
		if(LoadFileTexture(texlist,n) < 0){
			_nj_texerr_.n = n;
			return -1;
		}
	}
	
	return 1;

}


/*
	LoadTexture֐Ń[heNX`[X
*/
Sint32 ReleaseTexture(NJS_TEXLIST *texlist,Uint32 n)
{
	NJS_TEXMANAGE *pmng;

	if(!(texlist->textures[n].attr & NJD_TEXATTR_REGISTRATION)){
		_nj_texerr_.n = n;
		return -1;
	}
	pmng = (NJS_TEXMANAGE*)texlist->textures[n].texaddr;
	
   	if(pmng->texsys == NULL){
   		return -1;
   	}

    if(pmng->count > 0){
	    pmng->count--;
    }

    if(pmng->texsys->count > 0){
		pmng->texsys->count--;
	   	if(pmng->texsys->count == 0){
			TexFree((Sint8*)pmng->texsys->texsurface.pSurface);
	   	}
	}

	njFreeTexManage(pmng);

	texlist->textures[n].attr &= ~NJD_TEXATTR_REGISTRATION;
	texlist->textures[n].texaddr = 0;/* 2000.3.21*/
	
	return 1;

}