/*---------------------------------------------------------------------------
  Shinobi2 Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/
#include	<shinobi.h>
#include	"Nj.h"
#include	"TexMain.h"
#include	"TexMalloc.h"

ALLOC_AREA head,tail;
ALLOC_AREA texblock[TEXMEM_BLOCK_NUM];
ALLOC_AREA *max_area;
ALLOC_AREA *space_area;




/*
	head
	Enext		ALLOC_AREA̐擪
	Ebefore	NULL
	Eflag		A󂫗e
	Eaddr		eNX`Œ̈̐擪|C^
	Esize		eNX`Œ̈̍vTCY
	
	texblock
	Enext		ALLOC_AREA̗̎̈̃|C^
	Ebefore	ALLOC_AREȂÖ̗̃|C^
	Eflag		̈̎gpAgptO
	Eaddr		gp̃|C^Agp̃|C^
	Esize		gp̃TCYBgp̃TCY
	
*/
Sint32 InitTexFixedArea(Uint32 size)
{
	Int i;
	
	if(njTexMallocFixedArea(size,&head.addr) < 0){
		return -1;
	}
	head.flag = size;
	head.size = size;
	head.next = &texblock[0];
	head.before = NULL;
	
	for(i = 0;i < TEXMEM_BLOCK_NUM;i++){
		texblock[i].next = &texblock[i+1];
		texblock[i].before = NULL;
		texblock[i].flag = FALSE;
		texblock[i].addr = NULL;
		texblock[i].size = 0;
	}
	texblock[TEXMEM_BLOCK_NUM - 1].next = NULL;

	max_area = &texblock[0];
	space_area = &texblock[1];

	return 1;
}

void SetTexFixedArea(void)
{
	texblock[0].addr = head.addr;
	texblock[0].size = head.size;
	texblock[0].next = &tail;
	tail.next = NULL;
}


/* 
	TexMalloc֐́A擾̎n߂
	Ɋ蓖Ă邾̊ȒPȂ̂łB
	
	eNX`[XƂ́A蓖Ă
	

*/
Sint8* TexMalloc(Uint32 size)
{
	ALLOC_AREA *ptr;
	ALLOC_AREA *ptr2;
	ALLOC_AREA *space_ptr;
	
	if(size == 0) return NULL;
	
	/* A󂫗eʂłɂȂƂ*/
	if(head.flag < size) return NULL;
	
	ptr = head.next;
	/* vĂTCYƂ҂̃TCY邩n߂ɒT */
	while(ptr->next != NULL){
		if((ptr->size == size) && (!ptr->flag)){
			ptr->flag = TRUE;/* tOgpɕύX */
			if(head.flag == size){
				/* MAXA󂫗eʂT */
				head.flag = 0;
				ptr2 = head.next;
				while(ptr2->next != NULL){
					if((head.flag < ptr2->size) && (!ptr2->flag)) {
						max_area = ptr2;
						head.flag = ptr2->size;
					}
					ptr2 = ptr2->next;
				}
			}
			return ptr->addr;
		}
		ptr = ptr->next;
	}
	
	/* ҂̃TCY݂ȂƂ͑傫Ƃ납擾 */
	if(head.flag > size){
		/* gp̗̈Ǝc̗̈ɕ */
		/* 󂢂ĂtexblockT */
		space_ptr = space_area;
		/* ̈悪Ȃ */
		if(space_ptr == NULL) return NULL;
		space_area = space_area->next;
	
		ptr = max_area;
		space_ptr->next = ptr->next;
		space_ptr->before = ptr;
		space_ptr->flag = FALSE;
		space_ptr->addr = ptr->addr + size;
		space_ptr->size = ptr->size - size;
		
		ptr->next = space_ptr;
		ptr->flag= TRUE;
		ptr->size = size;
	
		/* MAXA󂫗eʂT */
		head.flag = 0;
		ptr2 = head.next;
		while(ptr2->next != NULL){
			if((head.flag < ptr2->size) && (!ptr2->flag)) {
				max_area = ptr2;
				head.flag = ptr2->size;
			}
			ptr2 = ptr2->next;
		}

		return ptr->addr;
	}
	
	return NULL;
}

void TexFree(Sint8 *addr)
{
	ALLOC_AREA *ptr;
	ALLOC_AREA *ptr2;

	ptr = head.next;

	while((ptr->next != NULL) && (ptr->addr != addr)){
		ptr=ptr->next;
	}
	
	if(ptr->addr == addr){

		ptr->flag = FALSE;

		if(ptr->before){
			while(!ptr->before->flag){
				/* O󂫂̏ꍇ͂Ȃ */
				ptr2 = ptr;
				ptr = ptr->before;
				ptr->size += ptr->next->size;
				ptr->next = ptr->next->next;
				ptr->next->before = ptr;
				
				
				ptr2->next = space_area->next;
				ptr2->flag = FALSE;
				ptr2->before = NULL;
				ptr2->addr = NULL;
				ptr2->size = 0;
				space_area = ptr2;

				if(max_area->size < ptr->size){
					max_area = ptr;
					head.flag = ptr->size;
					
				}
				if(!ptr->before){
					break;
				}
			}
		}
	
		if(ptr->next != &tail){
			while(!ptr->next->flag){
				/* 낪󂫂̏ꍇȂ */
				if(max_area == ptr->next){
					max_area = ptr;
					head.flag = ptr->size;
				}

				ptr2 = ptr->next;
				ptr->size += ptr->next->size;
				ptr->next = ptr->next->next;
				ptr->next->before = ptr;
				
				ptr2->next = space_area->next;
				ptr2->flag = FALSE;
				ptr2->before = NULL;
				ptr2->addr = NULL;
				ptr2->size = 0;
				space_area = ptr2;

				if(max_area->size < ptr->size){
					max_area = ptr;
					head.flag = ptr->size;
				}

				if(ptr->next == &tail){
					break;
				}
			}
		}
	}
}