/*
	Ninja Library
	
	COPYRIGHT ( C ) SEGA ENTERPRISES, LTD.
*/
#include "NuMotionMake.h"

/****************************************************************/
/*																*/
/*	NINJA MOTION֐											*/
/*																*/
/*	Copyright ( C ) 1997 Sega 									*/
/*	Produced by Sega, SystemR&D 								*/
/*																*/
/*	Create 1997-03-15 SEGA System R&D							*/
/*																*/
/****************************************************************/

/*************************   J֐   *************************/

/*
	func:	w肳ꂽt[̃J[V̈ʒuȂǂ擾B
	
	in:		camera	= ⊮f[^ꍇ̃ftHg̃f[^w肷B
			data	= ʒuf[^擾̈w肷B
	
	:	[V͂OԃXbggpB
*/
void nuGetCameraMotion( const NJS_CAMERA *camera, const NUS_MOTION *motion, NUS_CMOTION_DATA *data, Float frame )
{
	Uint32				data_type;
	Float				*pPos	= data->pos;
	Float				*pVect	= data->vect;
	Sangle				*pRoll	= data->roll;
	Sangle				*pAng	= data->ang;
	
	
	nuSetCurMotionInfoSlot( 0 );
	
	nuStartMotionEx( motion, frame );
	
	
	data_type			= _nu_motinfo_ptr_->type;
	
	
	if ( data_type & NUD_MTYPE_POS_0 ) {
		//	J̈ʒũ[V
		if ( !_nuGetMotionFloat3( pPos ) ) {
			pPos[0]	= camera->px;
			pPos[1]	= camera->py;
			pPos[2]	= camera->pz;
		}
	}
	else {
		pPos[0]	= camera->px;
		pPos[1]	= camera->py;
		pPos[2]	= camera->pz;
	}
	
	if (( data_type & NUD_MTYPE_ANG_1 ) || ( data_type & NUD_MTYPE_SANG_1 ) || ( data_type & NUD_MTYPE_QUAT_1 )){
		_nu_motinfo_ptr_->cnt++;		//SKIP
	}
	if ( data_type & NUD_MTYPE_SCL_2 ) {
		_nu_motinfo_ptr_->cnt++;		//SKIP
	}
	
	if ( data_type & NUD_MTYPE_TARGET_3 ) {
		//	^[Qbg̃[V
		if ( _nuGetMotionFloat3( pVect ) ) {
			pVect[0]	-= pPos[0];
			pVect[1]	-= pPos[1];
			pVect[2]	-= pPos[2];
		}
		else {
			pVect[0]	= camera->vx;
			pVect[1]	= camera->vy;
			pVect[2]	= camera->vz;
		}
	}
	else if ( data_type & NUD_MTYPE_VEC_3 ) {
		//	xNg̃[V
		if ( !_nuGetMotionFloat3( pVect ) ) {
			pVect[0]	= camera->vx;
			pVect[1]	= camera->vy;
			pVect[2]	= camera->vz;
		}
	}
	else {
		pVect[0]	= camera->vx;
		pVect[1]	= camera->vy;
		pVect[2]	= camera->vz;
	}
	if ( data_type & NUD_MTYPE_EVENT_4 ) {
		_nu_motinfo_ptr_->cnt++;		//SKIP
	}

	/* 5 */
	
	if ( data_type & NUD_MTYPE_ROLL_6 ) {
		//	Rollp̃[V
		if ( _nuGetMotionSangle1( pRoll ) ) {
			//*pRoll	+= camera->roll;			//??? : nuGetCameraMotionOld
		}
		else {
			*pRoll	= camera->roll;
		}
	}
	if ( data_type & NUD_MTYPE_ANGLE_7 ) {
		//	p̃[V
		if ( !_nuGetMotionSangle1( pAng ) ) {
			*pAng		= camera->ang;
		}
	}
	else {
		*pAng		= camera->ang;
	}
}

/*
	func:	J[VsB
			Epݒ肳B
			EJg}gbNXύXB
	
	in:		camera		= ⊮f[^ꍇ̃ftHg̃f[^w肷B
			motion		= J[V
			frame		= t[ԍ
			
	:		[V͂OԃXbggpB
*/
void nuCameraMotion( const NJS_CAMERA *camera, const NUS_MOTION *motion, Float frame )
{
	
	NJS_CAMERA	dst_camera;
	NUS_CMOTION_DATA data;
	
	//	⊮f[^̎擾
	data.pos = &dst_camera.px;
	data.vect = &dst_camera.vx;
	data.roll = &dst_camera.roll;
	data.ang = &dst_camera.ang;

	nuGetCameraMotion( camera, motion, &data, frame );
	/*
		EJ\̂̓eJg}gbNXɔfB
		Epݒ肷B
	*/
	njSetCamera( &dst_camera );
}

void nuCameraAction( const NUS_CACTION *caction, Float frame )
{
	nuCameraMotion( caction->camera, caction->motion, frame );
}

void nuGetCameraAction( const NUS_CACTION *caction, NUS_CMOTION_DATA *data, Float frame )
{
	nuGetCameraMotion( caction->camera, caction->motion, data, frame );
}
