/*
	Ninja Library
	
	COPYRIGHT ( C ) SEGA ENTERPRISES, LTD.
*/

#include "NuMotionMake.h"



/*	[V\́iXbgj		*/
NUS_CUR_MOTION_INFO		_nu_motion_info_[NUD_MOTION_INFO_MAX];

/*	ݏ̃[V		*/
NUS_CUR_MOTION_INFO		*_nu_motinfo_ptr_;

/*
	func:	NUS_MDATA(n) źAunv w肷B
	
	in:		_nu_motinfo_ptr_->mdata		= motion->mdata;		//NUS_MDATA(n) ̐擪
			(NUS_MDATA(n) zւ̎Qƃ|C^)
			
			MDataCnt						= gp MATA(n)  n
			
	note:	E|C^ 4 oCgłƉ肷B
			ENUS_MDATA(n)	͎̌`ł邱Ƃ肷B
			
			typedef struct {
				void		*p[n];
				Uint32		nb[n];
			} NUS_MDATA(n);
*/


void (*_nu_motion_callback_)(NJS_CNK_OBJECT *obj) = NULL;

#pragma	inline(_nuSetMDataCnt)
static void _nuSetMDataCnt( int MDataCnt )
{
	unsigned char			*pMData;
	
	MDataCnt		*= 4;
	
	_nu_motinfo_ptr_->mdata_nbkeys_ofs	= MDataCnt;
	_nu_motinfo_ptr_->mdata_size		= MDataCnt + MDataCnt;
	
	
	pMData			= (unsigned char *)_nu_motinfo_ptr_->mdata;
	
	_nu_motinfo_ptr_->key			= (void **)(pMData);
	_nu_motinfo_ptr_->nbkeys		= (Uint32 *)(pMData + _nu_motinfo_ptr_->mdata_nbkeys_ofs);
	_nu_motinfo_ptr_->cnt			= 0;
}

/*
	func:	NUS_MDATA(n) zւ̎Qƃ|C^i߂B
			IuWFNg[VɂāÃm[hɐiނ߂ɎgpB
	
	note:	_nuSetMDataCnt( MDataCnt );		ĂяoĂƁB
*/
void nuSetNextMotionNodeEx( void )
{
	unsigned char			*pMData;
	
	pMData						= (unsigned char *)_nu_motinfo_ptr_->mdata;
	pMData						+= _nu_motinfo_ptr_->mdata_size;
	_nu_motinfo_ptr_->mdata		= (void *)pMData;
	
	_nu_motinfo_ptr_->key		= (void **)(pMData);
	_nu_motinfo_ptr_->nbkeys	= (Uint32 *)(pMData + _nu_motinfo_ptr_->mdata_nbkeys_ofs);
	_nu_motinfo_ptr_->cnt		= 0;
}


/*
	func:	݂̃[Vp[^ݒ肷B
			NUS_MDATA(n) zւ̎Qƃ|C^A̐擪ɃZbgB
			
	in:		_nu_motinfo_ptr_	= [V\̂ւ̃|C^ie͂ǂł悢j
			
			motion		= [V
			frame		= t[ԍ
			
	out:	_nu_motinfo_ptr_	= [V
	
	:	̊֐́A_nu_motinfo_ptr_ ɑ΂ďo͂sB
			nuSetCurMotionInfoSlot() ȂǂpĕK邱ƁB
*/
void nuStartMotionEx( const NUS_MOTION *motion, Float frame )
{
	int							spline_type;
    static const NUS_MOTION		DummyMotion = {
        NULL,           //mdata
        0,				//nbFrame
        (Uint16)0,		//type
        (Uint16)0		//inp_fn
    };
    
    if ( motion == NULL ) {
        motion  = &DummyMotion;
    }
	
	
	/*
		motion->type	= NUD_MTYPE_POS Ȃ
		motion->inp_fn	= ⊮W(NUD_MTYPE_LINEAR Ȃ)  NUS_MDATA(n)  n
	*/
	spline_type					= ( motion->inp_fn & NUD_MTYPE_MASK ) > 0;
	
	_nu_motinfo_ptr_->mdata		= motion->mdata;
	_nu_motinfo_ptr_->nbframes	= motion->nbFrame;
	_nu_motinfo_ptr_->type		= (Uint32)motion->type;
	
	_nu_motinfo_ptr_->frame		= frame;
	_nu_motinfo_ptr_->cnt		= 0;
	
	
	_nuSetMDataCnt( motion->inp_fn & ( ~NUD_MTYPE_MASK ) );
	
	//	Float3 ⊮֐̑I
	_nu_motinfo_ptr_->int_f3_func_p		= _nu_motion_int_f3_func_table_[spline_type];
	
	//	Angle3 ⊮֐̑I
	_nu_motinfo_ptr_->int_a3_func_p		= _nu_motion_int_a3_func_table_[spline_type];
	
	//	Angle1 ⊮֐̑I
	_nu_motinfo_ptr_->int_a1_func_p		= _nu_motion_int_a1_func_table_[0];

	//	Sangle3 ⊮֐̑I
	_nu_motinfo_ptr_->int_sa3_func_p		= _nu_motion_int_sa3_func_table_[spline_type];

}

#if	0
/*
	func:	_nuSetMotionKeySlot	ĂяoOɌĂяoB
			motion->type QƂAOԂ SlotMax Ŏw肳ꂽL[Xbgԍ|P܂ł
			SL[Xbg̈ʒuvZA_nu_motinfo_ptr_->slot_loc Ɋi[B
*/
void _nuInitMotionKeySlot( const NUS_MOTION *motion, int SlotMax )
{
	int				i;
	Uint16			data_type;
	Uint32			Location;
	Uint32			*pSlotLoc;
	Uint32			*pTypeBits;
	static Uint32	TypeBits[NUD_MTYPE_SLOT_MAX]	= {
		NUD_MTYPE_POS_0 | NUD_MTYPE_VEC_0,
		NUD_MTYPE_ANG_1 | NUD_MTYPE_QUAT_1 | NUD_MTYPE_SANG_1,
		NUD_MTYPE_SCL_2,
		NUD_MTYPE_VEC_3 | NUD_MTYPE_TARGET_3,
		0,
		0,
		NUD_MTYPE_ROLL_6,
		NUD_MTYPE_ANGLE_7,
		NUD_MTYPE_RGB_8,
		NUD_MTYPE_INTENSITY_9|NUD_MTYPE_POINT_9,
		NUD_MTYPE_SHAPEID,
	};
	
	data_type				= motion->type;
	
	Location	= 0;
	pSlotLoc	= &_nu_motinfo_ptr_->slot_loc[0];
	pTypeBits	= &TypeBits[0];
	for ( i = 0; i < SlotMax; i++ ) {
		*pSlotLoc++		= Location;
		
		if ( data_type & (*pTypeBits++) ) {
			Location++;
		}
	}
}

/*
	func:	炩߁A_nuInitMotionKeySlot	ĂяoĂB
			 KeySlot Ŏw肳ꂽXbgJgXbgɂB
			
			{֐ĂяoȂ΁AXbgQƂ֐ĂяoтɎ̃Xbg
			QƂ悤ɐB
*/
void _nuSetMotionKeySlot( int KeySlot )
{
	_nu_motinfo_ptr_->cnt	= _nu_motinfo_ptr_->slot_loc[KeySlot];
}
#endif

/*
	func:	[V֐Qǂݏ郂[V\̂w肷B
	
	expl.:	̎ẃAɂ̊֐AnuSetCurMotionInfoSlot() Ăяo܂
			LłB
*/
void nuSetCurMotionInfoPtr( const NUS_CUR_MOTION_INFO *motion_info_ptr )
{
	_nu_motinfo_ptr_	= motion_info_ptr;
}

/*
	func:	[V֐Qǂݏ郂[V\̂̃Xbgԍw肷B
	
	in:		Slot	= [V\̂̃Xbgԍ
					  0 ` NUD_MOTION_INFO_MAX - 1
	
	expl.:	̎ẃAɂ̊֐AnuSetCurMotionInfoPtr() Ăяo܂
			LłB
*/
void nuSetCurMotionInfoSlot( int Slot )
{
	_nu_motinfo_ptr_	= &_nu_motion_info_[Slot];
}

//	_nuMotionSearchKey : ̃t@Cł̓CCWJ邪AOɂ֐錾̂Ŋ֐ĂяooB
#pragma	inline(_nuMotionSearchKey)
Uint32 _nuMotionSearchKey( const void *key, int KeySize, Uint32 nbkeys, Uint32 frame )
{
	Uint32		nb_a;
	Uint32		nb_b;
	Uint32		nb_mid;
	
	nb_a	= 0;
	nb_b	= nbkeys;
	while ( nb_b - nb_a > 1 ) {
		nb_mid = ( nb_a + nb_b ) >> 1;
		
		if ( frame >= *(Uint32*)( ((unsigned char *)key) + (nb_mid*KeySize) ) ) {
			nb_a = nb_mid;
		}
		else {
			nb_b = nb_mid;
		}
	}
	
	return	nb_a;
}

void _nuGetMotionLinearKeys( const void *key, int KeySize, Uint32 nbkeys, Float frame,
							 const void **pKey1, const void **pKey2, Float *pRate )
{
	Uint32			keyno;
	Sint32			DiffKeyNo;
	Uint32			keyframe1;
	Uint32			keyframe2;
	Uint32			*key1;
	Uint32			*key2;
	
	keyno	= _nuMotionSearchKey( key, KeySize, nbkeys, (Uint32)frame );
	
	key1	= (Uint32 *)( ((unsigned char *)key) + keyno * KeySize );
	if ( keyno < nbkeys - 1 ) {
		key2	= (Uint32 *)( ((unsigned char *)key) + (keyno+1) * KeySize );
	}
	else {
		key2	= (Uint32 *)key;
	}
	//key2	= (Uint32 *)( ((unsigned char *)key) + ((keyno+1) % nbkeys) * KeySize );
	
	*pKey1	= key1;
	*pKey2	= key2;
	
	keyframe1	= *key1;
	keyframe2	= *key2;
	
	if ( ( DiffKeyNo = (Sint32)keyframe2 - (Sint32)keyframe1 ) > 0 ) {
		*pRate	= ( frame - (Float)keyframe1 ) / (Float)DiffKeyNo;
	}
	else {
		*pRate	= frame - (Float)keyframe1;
	}
}


#pragma	inline(_nuMotionSearchKey16)
Uint32 _nuMotionSearchKey16( const void *key, int KeySize, Uint32 nbkeys, Uint16 frame )
{
	Uint32		nb_a;
	Uint32		nb_b;
	Uint32		nb_mid;
	
	nb_a	= 0;
	nb_b	= nbkeys;
	while ( nb_b - nb_a > 1 ) {
		nb_mid = ( nb_a + nb_b ) >> 1;
		
		if ( frame >= *(Uint16*)( ((unsigned char *)key) + (nb_mid*KeySize) ) ) {
			nb_a = nb_mid;
		}
		else {
			nb_b = nb_mid;
		}
	}
	
	return	nb_a;
}

void _nuGetMotionLinearKeys16( const void *key, int KeySize, Uint32 nbkeys, Float frame,
							 const void **pKey1, const void **pKey2, Float *pRate )
{
	Uint32			keyno;
	Sint16			DiffKeyNo;
	Uint16			keyframe1;
	Uint16			keyframe2;
	Uint16			*key1;
	Uint16			*key2;
	
	keyno	= _nuMotionSearchKey16( key, KeySize, nbkeys, (Uint16)frame );
	
	key1	= (Uint16 *)( ((unsigned char *)key) + keyno * KeySize );
	if ( keyno < nbkeys - 1 ) {
		key2	= (Uint16 *)( ((unsigned char *)key) + (keyno+1) * KeySize );
	}
	else {
		key2	= (Uint16 *)key;
	}
	//key2	= (Uint32 *)( ((unsigned char *)key) + ((keyno+1) % nbkeys) * KeySize );
	
	*pKey1	= key1;
	*pKey2	= key2;
	
	keyframe1	= *key1;
	keyframe2	= *key2;
	
	if ( ( DiffKeyNo = (Sint16)keyframe2 - (Sint16)keyframe1 ) > 0 ) {
		*pRate	= ( frame - (Float)keyframe1 ) / (Float)DiffKeyNo;
	}
	else {
		*pRate	= frame - (Float)keyframe1;
	}
}

void
nuSetMotionCallback( void (*func)(NJS_CNK_OBJECT *obj) )
{
	_nu_motion_callback_ = func;
}
