/*
	Ninja Library
	
	COPYRIGHT ( C ) SEGA ENTERPRISES, LTD.
*/

#include "NuMotionMake.h"


NUS_CUR_MOTIONLINK_INFO			_nu_motionlink_info_;




void nuStartMotionLink( const NUS_MOTION_LINK *motion_link, Float rate )
{
	//	ȂׂJg[V񂪃Xbg 0 ŏI悤ɂ邽 1,0 ̏ɂĂB
	nuSetCurMotionInfoSlot( 1 );
	nuStartMotionObjEx( motion_link->motion[1], motion_link->frame[1] );
	
	nuSetCurMotionInfoSlot( 0 );
	nuStartMotionObjEx( motion_link->motion[0], motion_link->frame[0] );
	
	_nu_motionlink_info_.rate	= rate;
}


void nuSetNextMotionLinkNode( void )
{
	nuSetCurMotionInfoSlot( 1 );
	nuSetNextMotionNodeEx();
	
	nuSetCurMotionInfoSlot( 0 );
	nuSetNextMotionNodeEx();
}

int nuGetMotionLinkNodeData( const NJS_CNK_OBJECT *cnkobj, Float pos[3], Angle ang[3], Float scl[3], NJS_QUATERNION *qua )
{
	Float				pos0[3];
	Float				scl0[3];
	Angle				ang0[3];
	NJS_QUATERNION		qua0;
	int					MotRot0;
	Float				rate0;
	
	Float				pos1[3];
	Float				scl1[3];
	Angle				ang1[3];
	NJS_QUATERNION		qua1;
	int					MotRot1;
	Float				rate1;
	Uint16				event_val;
	
	rate1	= _nu_motionlink_info_.rate;
	rate0	= 1.0f - rate1;
	
	//	ȂׂJg[V񂪃Xbg 0 ŏI悤ɂ邽 1,0 ̏ɂĂB
	nuSetCurMotionInfoSlot( 1 );
	MotRot1 = nuGetMotionNodeData( cnkobj, pos1, ang1, scl1, &qua1 );
	
	/* EventMotioñobNAbv */
	if(_nu_motion_event_flag_){
		event_val = _nu_motion_event_val_;
	}
	
	nuSetCurMotionInfoSlot( 0 );
	MotRot0 = nuGetMotionNodeData( cnkobj, pos0, ang0, scl0, &qua0 );
	
	/* EventMotionN */
	if(_nu_motion_event_flag_){
		if(rate1 < 1.0f){
			_nu_motion_event_val_ = event_val;
		}
	}
	
	if ( MotRot0 != NUD_MROT_QUATERNION ) {
		//	R[^jIɒĂ⊮
		if ( MotRot0 == NUD_MROT_ANGLEXYZ ) {
			//	XYZ
			njXYZAngleToQuaternion( ang0, &qua0 );
		}
		else {
			//	ZXY
			njZXYAngleToQuaternion( ang0, &qua0 );
		}
	}
	if ( MotRot1 != NUD_MROT_QUATERNION ) {
		//	R[^jIɒĂ⊮
		if ( MotRot1 == NUD_MROT_ANGLEXYZ ) {
			//	XYZ
			njXYZAngleToQuaternion( ang1, &qua1 );
		}
		else {
			//	ZXY
			njZXYAngleToQuaternion( ang1, &qua1 );
		}
	}
	
	pos[0]	= pos0[0] * rate0 + pos1[0] * rate1;
	pos[1]	= pos0[1] * rate0 + pos1[1] * rate1;
	pos[2]	= pos0[2] * rate0 + pos1[2] * rate1;
	
	scl[0]	= scl0[0] * rate0 + scl1[0] * rate1;
	scl[1]	= scl0[1] * rate0 + scl1[1] * rate1;
	scl[2]	= scl0[2] * rate0 + scl1[2] * rate1;
	
	njInterpolateQuaternion( &qua0, &qua1, rate1, qua );
	
	
	
	return	NUD_MROT_QUATERNION;
}

/*
	func:	݂̃[VNp[^ɂẮAJgm[h̃}gbNX쐬AJg}gbNX
			EZB
			
	in:		cnkobj					= NUS_MDATA(n)ւ̎Qƃ|C^ƑΉ NJS_CNK_OBJECT \̂ւ̃|C^B
									  [Vf[^ꍇɂ̍\̂pos,ang,scloQƂB
	
	out:	cur'		= cur [Jgm[h̃}gbNX]
	
	expl.:	̊֐́AJgm[h̃}gbNX쐬B
			
			 cnkobj ɂ́ANUS_MDATA(n) ւ̎Qƃ|C^ɑΉ NJS_CNK_OBJECT \̂ւ̃|C^w肷B
			
			w肳ꂽ cnkobj  evalflags o NJD_EVAL_SKIP w肳ĂȂꍇ:
				ENUS_MDATA(n) zւ̎Qƃ|C^wL[t[z̕⊮f[^̗pB
				ENUS_MDATA(n) zւ̎Qƃ|C^͂Pi߂B
			
			w肳ꂽ cnkobj  evalflags o NJD_EVAL_SKIP w肳Ăꍇ:
				EΉ郂[Vf[^Ƃ݂ȂA[Vf[^́ANUS_MDATA(n)z ͎QƂꂸ
				  cnkobj ̒pos,ang,sclô܂܍̗pB
				ENUS_MDATA(n) zւ̎Qƃ|C^͐i߂ȂB
			
*/
void nuMotionLinkTransformEx( const NJS_CNK_OBJECT *cnkobj )
{
	Float				pos[3];
	Float				scl[3];
	Angle				ang[3];
	NJS_QUATERNION		qua;
	int					MotRot;
	
	MotRot	= nuGetMotionLinkNodeData( cnkobj, pos, ang, scl, &qua );
	
	njTranslateEx( (NJS_VECTOR *)pos );
	
	switch( MotRot ) {
	case NUD_MROT_ANGLEXYZ :
		njRotateEx( ang, 0 );
		break;
	case NUD_MROT_ANGLEZXY :
		njRotateEx( ang, 1 );
		break;
	default:
		njQuaternionEx( &qua );
		break;
	}
	
	njScaleEx( ( NJS_VECTOR *)scl );
}
