/*
	Ninja Library
	
	COPYRIGHT ( C ) SEGA ENTERPRISES, LTD.
*/

#include "NuMotionMake.h"



/*	[V\́iXbgj		*/
NUS_CUR_OBJMOTION_INFO	_nu_obj_motion_info_[NUD_OBJMOTION_INFO_MAX];

/*	ݏ̃[V		*/
NUS_CUR_OBJMOTION_INFO	*_nu_objmotinfo_ptr_	= &_nu_obj_motion_info_[0];

Sint32 _nu_motion_event_flag_ = OFF;
Uint16 _nu_motion_event_val_ = 0;

/*		vg^Cv錾	*/
static int		_nuGetMotionFloat3Dummy( Float pos[3] );
static int		_nuGetMotionAngle3Dummy( Angle ang[3] );

/*
	func:	IuWFNg̃[Vp[^ݒ肷B
			NUS_MDATA(n) zւ̎Qƃ|C^A̐擪ɃZbgB
			
	in:		motion		= [V
			frame		= t[ԍ
			
	:	[V͂OԃXbgɊi[BȌ̃[V͂OԃXbgQƂB
			
			nuSetCurMotionInfoSlot() ֐QƂĂB
*/
void nuStartMotionObj( const NUS_MOTION *motion, Float frame )
{
	nuSetCurMotionInfoSlot( 0 );
	nuStartMotionObjEx( motion, frame );
}

/*
	func:	IuWFNg̃[Vp[^ݒ肷B
			NUS_MDATA(n) zւ̎Qƃ|C^A̐擪ɃZbgB
			
	in:		motion		= [V
			frame		= t[ԍ
	
	:	[V̓Jg̃[V\̂ɏo͂B
			
			nuSetCurMotionInfoSlot() ֐QƂĂB
*/
void nuStartMotionObjEx( const NUS_MOTION *motion, Float frame )
{
	Uint32					data_type;
	
	nuStartMotionEx( motion, frame );
	
	data_type				= _nu_motinfo_ptr_->type;
	
	//	pos ̃[VL邩ǂŊ֐I
	if ( data_type & NUD_MTYPE_POS_0 ) {
		_nu_motinfo_ptr_->get_pos_func_p	= _nuGetMotionFloat3;
	}
	else {
		_nu_motinfo_ptr_->get_pos_func_p	= _nuGetMotionFloat3Dummy;
	}
	
	//	ang ̃[VL邩ǂŊ֐I
	if ( data_type & NUD_MTYPE_ANG_1 ) {
		_nu_motinfo_ptr_->get_ang_func_p	= _nuGetMotionAngle3;
		_nu_motinfo_ptr_->get_qua_func_p	= NULL;
		_nu_motinfo_ptr_->get_sang_func_p	= NULL;
	}
	else if( data_type & NUD_MTYPE_SANG_1 ) {
		_nu_motinfo_ptr_->get_ang_func_p	= NULL;
		_nu_motinfo_ptr_->get_qua_func_p	= NULL;
		_nu_motinfo_ptr_->get_sang_func_p	= _nuGetMotionSangle3;
	}
	else if ( data_type & NUD_MTYPE_QUAT_1 ) {
		_nu_motinfo_ptr_->get_ang_func_p	= NULL;
		_nu_motinfo_ptr_->get_qua_func_p	= _nuGetMotionQuaternion;
		_nu_motinfo_ptr_->get_sang_func_p	= NULL;
	}
	else {
		_nu_motinfo_ptr_->get_ang_func_p	= _nuGetMotionAngle3Dummy;
		_nu_motinfo_ptr_->get_qua_func_p	= NULL;
		_nu_motinfo_ptr_->get_sang_func_p	= NULL;
	}
	
	//	scl ̃[VL邩ǂŊ֐I
	if ( data_type & NUD_MTYPE_SCL_2 ) {
		_nu_motinfo_ptr_->get_scl_func_p	= _nuGetMotionFloat3;
	}
	else {
		_nu_motinfo_ptr_->get_scl_func_p	= _nuGetMotionFloat3Dummy;
	}
	
	if (( data_type & NUD_MTYPE_VEC_3 ) || ( data_type & NUD_MTYPE_TARGET_3 )){
		_nu_motinfo_ptr_->cnt++;		//SKIP
	}
	
	if ( data_type & NUD_MTYPE_EVENT_4 ){
		_nu_motion_event_flag_ = ON;
		_nu_motion_event_val_ = 0;
	}
	else{
		_nu_motion_event_flag_ = OFF;
		_nu_motion_event_val_ = 0;
	}
}

/*
	func:	݂̃[Vp[^ɂẮAJgm[h̃}gbNX쐬AJg}gbNX
			EZB
			
	in:		cnkobj					= NUS_MDATA(n)ւ̎Qƃ|C^ƑΉ NJS_CNK_OBJECT \̂ւ̃|C^B
									  [Vf[^ꍇɂ̍\̂pos,ang,scloQƂB
	
	out:	cur'		= cur [Jgm[h̃}gbNX]
	
	expl.:	̊֐́AJgm[h̃}gbNX쐬B
			
			 cnkobj ɂ́ANUS_MDATA(n) ւ̎Qƃ|C^ɑΉ NJS_CNK_OBJECT \̂ւ̃|C^w肷B
			
			w肳ꂽ cnkobj  evalflags o NJD_EVAL_SKIP w肳ĂȂꍇ:
				ENUS_MDATA(n) zւ̎Qƃ|C^wL[t[z̕⊮f[^̗pB
				ENUS_MDATA(n) zւ̎Qƃ|C^͂Pi߂B
			
			w肳ꂽ cnkobj  evalflags o NJD_EVAL_SKIP w肳Ăꍇ:
				EΉ郂[Vf[^Ƃ݂ȂA[Vf[^́ANUS_MDATA(n)z ͎QƂꂸ
				  cnkobj ̒pos,ang,sclô܂܍̗pB
				ENUS_MDATA(n) zւ̎Qƃ|C^͐i߂ȂB
			
*/
void nuMotionTransformEx( const NJS_CNK_OBJECT *cnkobj )
{
	Float				pos[3];
	Float				scl[3];
	Angle				ang[3];
	NJS_QUATERNION		qua;
	int					MotRot;
	
	MotRot	= nuGetMotionNodeData( cnkobj, pos, ang, scl, &qua );
	
	
	njTranslateEx( (NJS_VECTOR *)pos );
	
	switch( MotRot ) {
	case NUD_MROT_ANGLEXYZ :
		njRotateEx( ang, 0 );
		break;
	case NUD_MROT_ANGLEZXY :
		njRotateEx( ang, 1 );
		break;
	default:
		njQuaternionEx( &qua );
		break;
	}
	
	njScaleEx( ( NJS_VECTOR *)scl );
}

/*
	func:	݂̃[Vp[^ɂẮAJgm[h pos, angi܂qua), scl 擾B
			Ή郂[Vf[^ꍇ́Aw肳ꂽ cnkobj ̌Œp[^ԂB
			pxp[^ɂĂ͂Rʂ̕ԂA߂lɂċʂłB
			
	in:		cnkobj					= NUS_MDATA(n)ւ̎Qƃ|C^ƑΉ NJS_CNK_OBJECT \̂ւ̃|C^B
									  [Vf[^ꍇɂ̍\̂pos,ang,scloQƂB
			pos						= ʒůi[
			ang						= px Angle `̊i[
			scl						= g嗦̊i[
			qua						= px NJS_QUATERNION `̊i[
			
	out:	pos[0],pos[1],pos[2]	= Jgm[ḧʒu
			ang[0],ang[1],ang[2]	= Jgm[h̊pxAngle\(c.f.߂lQƁj
			scl[0],scl[1],scl[2]	= Jgm[h̊g嗦
			*qua					= Jgm[h̊pxQuaternion\(c.f.߂lQ)
			
	return:	Ԃꂽ]p[^̎
			NUD_MROT_ANGLEXYZ	: ]p[^́AXYZ-Angle `ň ang ɕԂB
			NUD_MROT_ANGLEZXY	: ]p[^́AZXY-Angle `ň ang ɕԂB
			NUD_MROT_QUATERNION	: ]p[^́ANJS_QUATERNION `ň qua ɕԂB
	
	expl.:	̊֐ĂԑOɁAnuStartMotionObj() ֐ŁAJg̃[Vp[^ݒ肵ĂƁB
			
			̊֐́AJgm[h̊pxʒuԂB
			
			w肳ꂽ cnkobj  evalflags o NJD_EVAL_SKIP w肳ĂȂꍇ:
				ENUS_MDATA(n) zւ̎Qƃ|C^wL[t[z񂪎QƂB
				ENUS_MDATA(n) zւ̎Qƃ|C^Pi߂B
			w肳ꂽ cnkobj  evalflags o NJD_EVAL_SKIP w肳Ăꍇ:
				EΉ郂[Vf[^Ƃ݂ȂA[Vf[^́ANUS_MDATA(n)z͎QƂꂸ
				   cnkobj ̒pos,ang,sclô܂܈ɃRs[B
				ENUS_MDATA(n) zւ̎Qƃ|C^͐i߂ȂB
			
	note:	Eȉ̐ɂāA鍀ڂ̃L[t[݂Ƃ́Amotion->type ̑Ή NUD_MTYPE_???
			  rbg ON łAAJgm[hɑΉ NUS_MDATA(n)z񒆂̎ۂ̂̃L[zւ̃|
			  C^ NULL ł͂ȂƂłB
			
			EJgt[ pos L[ꍇ́AO pos L[⊮ĈposɕԂB
			  ꍇ́Acnkobj->pos posɕԂB
			EJgt[ scl L[ꍇ́AO scl L[⊮ĈsclɕԂB
			  ꍇ́Acnkobj->scl sclɕԂB
			EJgt[ ang L[ꍇ́AO ang L[⊮ĈangɕԂB
			  ꍇ́Acnkobj->ang angɕԂB̏ꍇ̖߂ĺANUD_MROT_ANGLE??? łB
			EJgt[ qua L[ꍇ́AO qua L[⊮ĈquaɕԂB
			  ̏ꍇA߂ĺANUD_MROT_QUATERNION ɂȂB
			  ꍇ́Acnkobj->ang angɕԂB̏ꍇ̖߂ĺANUD_MROT_ANGLE??? łB
			
			E߂lƂāANUD_MROT_ANGLE??? ԂƂ́A
			  cnkobj->evalflags  NJD_EVAL_ZXY_ANG w肳Ă΁ANUD_MROT_ANGLEZXYAw肳ĂȂ
			  NUD_MROT_ANGLEXYZ ƂȂB
*/
int nuGetMotionNodeData( const NJS_CNK_OBJECT *cnkobj, Float pos[3], Angle ang[3], Float scl[3], NJS_QUATERNION *qua )
{
	int					rc;
	Sangle 				sang[3];
	
	if ( !( cnkobj->evalflags & NJD_EVAL_SKIP ) ) {
		//	ʒu
		if ( !(*_nu_motinfo_ptr_->get_pos_func_p)( pos ) ) {
			//	ʒűKlRs[
			pos[0]	= cnkobj->pos[0];
			pos[1]	= cnkobj->pos[1];
			pos[2]	= cnkobj->pos[2];
		}
		
		//	]
		if ( _nu_motinfo_ptr_->get_ang_func_p != NULL ) {
			//	[V Angle`̏ꍇ
			if ( (*_nu_motinfo_ptr_->get_ang_func_p)( ang ) ) {
				//	Angle L[ۂɑ݂ꍇ
				rc	= (cnkobj->evalflags & NJD_EVAL_ZXY_ANG) ? NUD_MROT_ANGLEZXY : NUD_MROT_ANGLEXYZ;
			}
			else {
				//	Angle L[ NULL ꍇ
				
				//	]̋KlRs[
				
				if ( cnkobj->evalflags & NJD_EVAL_QUATERNION ) {
					qua->re		= cnkobj->re_quat;
					qua->im[0]	= *(Float *)&cnkobj->ang[0];
					qua->im[1]	= *(Float *)&cnkobj->ang[1];
					qua->im[2]	= *(Float *)&cnkobj->ang[2];
					
					rc	= NUD_MROT_QUATERNION;
				}
				else {
					ang[0]	= cnkobj->ang[0];
					ang[1]	= cnkobj->ang[1];
					ang[2]	= cnkobj->ang[2];
					
					rc	= (cnkobj->evalflags & NJD_EVAL_ZXY_ANG) ? NUD_MROT_ANGLEZXY : NUD_MROT_ANGLEXYZ;
				}
			
			}
		}
		else if( _nu_motinfo_ptr_->get_sang_func_p != NULL ){
			//	[V Angle`̏ꍇ
			if ( (*_nu_motinfo_ptr_->get_sang_func_p)( sang ) ) {
				//	Sangle L[ۂɑ݂ꍇ
				ang[0]	= (Angle)sang[0];
				ang[1]	= (Angle)sang[1];
				ang[2]	= (Angle)sang[2];
				rc	= (cnkobj->evalflags & NJD_EVAL_ZXY_ANG) ? NUD_MROT_ANGLEZXY : NUD_MROT_ANGLEXYZ;
			}
			else {
				//	Sangle L[ NULL ꍇ
				
				//	]̋KlRs[
				
				if ( cnkobj->evalflags & NJD_EVAL_QUATERNION ) {
					qua->re		= cnkobj->re_quat;
					qua->im[0]	= *(Float *)&cnkobj->ang[0];
					qua->im[1]	= *(Float *)&cnkobj->ang[1];
					qua->im[2]	= *(Float *)&cnkobj->ang[2];
					
					rc	= NUD_MROT_QUATERNION;
				}
				else {
					ang[0]	= cnkobj->ang[0];
					ang[1]	= cnkobj->ang[1];
					ang[2]	= cnkobj->ang[2];
					
					rc	= (cnkobj->evalflags & NJD_EVAL_ZXY_ANG) ? NUD_MROT_ANGLEZXY : NUD_MROT_ANGLEXYZ;
				}
			
			}
		}
		else {
			//	[VR[^jI`̏ꍇ
			if ( (*_nu_motinfo_ptr_->get_qua_func_p)( qua ) ) {
				//	̃m[h̃R[^jĨL[ꍇ
				rc	= NUD_MROT_QUATERNION;
			}
			else {
				//	̃m[h̃R[^jĨL[ NULL ꍇ
				
				//	]̋KlRs[
				
				if ( cnkobj->evalflags & NJD_EVAL_QUATERNION ) {
					qua->re		= cnkobj->re_quat;
					qua->im[0]	= *(Float *)&cnkobj->ang[0];
					qua->im[1]	= *(Float *)&cnkobj->ang[1];
					qua->im[2]	= *(Float *)&cnkobj->ang[2];
					
					rc	= NUD_MROT_QUATERNION;
				}
				else {
					ang[0]	= cnkobj->ang[0];
					ang[1]	= cnkobj->ang[1];
					ang[2]	= cnkobj->ang[2];
					
					rc	= (cnkobj->evalflags & NJD_EVAL_ZXY_ANG) ? NUD_MROT_ANGLEZXY : NUD_MROT_ANGLEXYZ;
				}
			}
		}
	
		//	XP[O
		if ( !(*_nu_motinfo_ptr_->get_scl_func_p)( scl ) ) {
			//	XP[ŐKlRs[
			scl[0]	= cnkobj->scl[0];
			scl[1]	= cnkobj->scl[1];
			scl[2]	= cnkobj->scl[2];
		}

		if ( _nu_motion_event_flag_){
			if(!_nuGetMotionEvent(&_nu_motion_event_val_)){
				if(*(Uint32*)&cnkobj->evalflags & NJD_EVAL_HIDE){
					_nu_motion_event_val_ |= NUD_EVENT_HIDE;
				}
				else{
					_nu_motion_event_val_ &= (~NUD_EVENT_HIDE);
				}
			}
		}
	
		//	̃m[hɐi
		nuSetNextMotionNodeEx();
	}
	else {
		//	KlRs[
		
		//	ʒűKlRs[
		pos[0]	= cnkobj->pos[0];
		pos[1]	= cnkobj->pos[1];
		pos[2]	= cnkobj->pos[2];
		
		//	XP[ŐKlRs[
		scl[0]	= cnkobj->scl[0];
		scl[1]	= cnkobj->scl[1];
		scl[2]	= cnkobj->scl[2];
		
		//	]̋KlRs[
		if ( cnkobj->evalflags & NJD_EVAL_QUATERNION ) {
			qua->re		= cnkobj->re_quat;
			qua->im[0]	= *(Float *)&cnkobj->ang[0];
			qua->im[1]	= *(Float *)&cnkobj->ang[1];
			qua->im[2]	= *(Float *)&cnkobj->ang[2];
			
			rc	= NUD_MROT_QUATERNION;
		}
		else {
			ang[0]	= cnkobj->ang[0];
			ang[1]	= cnkobj->ang[1];
			ang[2]	= cnkobj->ang[2];
			
			rc	= (cnkobj->evalflags & NJD_EVAL_ZXY_ANG) ? NUD_MROT_ANGLEZXY : NUD_MROT_ANGLEXYZ;
		}
	}
	
	return	rc;
}

static int _nuGetMotionFloat3Dummy( Float pos[3] )
{
	return	FALSE;
}

static int _nuGetMotionAngle3Dummy( Angle ang[3] )
{
	return	FALSE;
}


/*
	func:	EVENT[VꍇAnuMotionTransformEx֐Ŏ擾EVENTtO̓e
			IuWFNgɔf
			
	in:		cnkobj				= NUS_MDATA(n)ւ̎Qƃ|C^ƑΉ NJS_CNK_OBJECT \̂ւ̃|C^B
									IuWFNgf[^͏
			
	expl.:	̊֐ĂԑOɁAnuMotionTransformEx֐s
			
	note:	IuWFNg̓e܂BĂ͍ꍇ́Å֐sO
			IuWFNgۑĂĂB݂EVALFLAGHIDEύXĂȂB
*/

void nuChangeMotionObject( NJS_CNK_OBJECT *cnkobj)
{

	if ( _nu_motion_event_flag_){
		if(_nu_motion_event_val_ & NUD_EVENT_HIDE){
			*(Uint32*)&cnkobj->evalflags |= NJD_EVAL_HIDE;
		}
		else{
			*(Uint32*)&cnkobj->evalflags &= (~NJD_EVAL_HIDE);
		}
	}
}

/*
	func:	EVENT[VtǑʂԂ
	return:	TRUE,FALSE

	expl.:	̊֐ĂԑOɁAnuMotionTransformEx֐s
			
	note:	
*/

Sint32	nuGetMotionEventFlag( void )
{
	return _nu_motion_event_flag_;
}
