/*
	Ninja Library
	
	COPYRIGHT (C) SEGA ENTERPRISES,LTD.
*/

#include "NuMotionMake.h"


static void		_nuCnkPushPopGetMotionDataArray( const NJS_CNK_OBJECT *cnkobj );

/*************************   J֐   *************************/

/*
	֐	nuGetDrawMotion
	
	@  \	w肵t[ɂ郂[V pos,ang,scl 擾B
	
	  	object		= IuWFNg
			motion		= [V
			frame		= t[ԍ
	
	o  	data->pos	= pos̗
			data->ang	= ang̗iR[^jÎƂ́ARi[j
			data->scl	= scl̗
	
	߂l	Ȃ
	
	T@v
	
	@l
*/
void nuGetDrawMotion( const NJS_CNK_OBJECT *object, const NUS_MOTION *motion, NUS_MOTION_DATA *data, Float frame )
{
	_nu_objmotinfo_ptr_->pos_buf_ptr = data->pos;
	_nu_objmotinfo_ptr_->ang_buf_ptr = data->ang;
	_nu_objmotinfo_ptr_->scl_buf_ptr = data->scl;
	
	nuStartMotionObj( motion, frame );
	
	_nuCnkPushPopGetMotionDataArray( object );
}


/*************************   ֐   *************************/

/*
	func:	pos, ang, scl obt@ɏo͂B
			
			̊֐ĂԑO
			  _nu_objmotinfo_ptr_->pos_buf_ptr
			  _nu_objmotinfo_ptr_->ang_buf_ptr
			  _nu_objmotinfo_ptr_->scl_buf_ptr
			  ɂꂼ̊i[ꏊ̃|C^ݒ肵ĂB
			
			NH[^jĨm[h͋R ang Ɋi[B
*/
static void _nuCnkPushPopGetMotionDataArray( const NJS_CNK_OBJECT *cnkobj )
{
	do {
		NJS_QUATERNION		qua;
		int					MotRot;
		
		MotRot		= nuGetMotionNodeData( cnkobj,
									   _nu_objmotinfo_ptr_->pos_buf_ptr,
									   _nu_objmotinfo_ptr_->ang_buf_ptr,
									   _nu_objmotinfo_ptr_->scl_buf_ptr,
									   &qua );
		
		_nu_objmotinfo_ptr_->pos_buf_ptr	+= 3;
		_nu_objmotinfo_ptr_->scl_buf_ptr	+= 3;
		
		if ( MotRot == NUD_MROT_QUATERNION ) {
			//	̃m[hɃR[^jĨL[ꍇ
			*_nu_objmotinfo_ptr_->ang_buf_ptr++		= *( ( Angle * )&qua.im[0] );
			*_nu_objmotinfo_ptr_->ang_buf_ptr++		= *( ( Angle * )&qua.im[1] );
			*_nu_objmotinfo_ptr_->ang_buf_ptr++		= *( ( Angle * )&qua.im[2] );
		}
		else {
			_nu_objmotinfo_ptr_->ang_buf_ptr	+= 3;
		}
		
		
		if ( cnkobj->child != NULL ) {
			_nuCnkPushPopGetMotionDataArray( ( const NJS_CNK_OBJECT* )cnkobj->child );
		}
		
		cnkobj = cnkobj->sibling;
		
	} while ( cnkobj != NULL );
}
