/*
	Ninja Library
	
	COPYRIGHT ( C ) SEGA ENTERPRISES, LTD.
*/

#include "NuMotionMake.h"



/*	VF[v\́iXbgj		*/
NUS_CUR_SHAPE_INFO		_nu_shape_info_[NUD_SHAPE_INFO_MAX];

/*	ݏ̃VF[v		*/
NUS_CUR_SHAPE_INFO		*_nu_shpinfo_ptr_;

NUS_SHAPE_GROUP_COEFF	*_nu_shape_buf_;
NUS_CSHAPELIST *_nu_shape_list_;

/*
	func:	NUS_MDATA(n) zւ̎Qƃ|C^i߂B
			IuWFNg[VɂāÃm[hɐiނ߂ɎgpB
	
	note:	_nuSetShapeMDataCnt( MDataCnt );		ĂяoĂƁB
*/
void nuSetNextShapeNodeEx( void )
{
	_nu_shpinfo_ptr_->mdata		+= 1;
	_nu_shpinfo_ptr_->cnt		= _nu_shpinfo_ptr_->mdata->nb[0];
	_nu_shpinfo_ptr_->group		= _nu_shpinfo_ptr_->mdata->p[0];
}


/*
	func:	݂̃VF[vp[^ݒ肷B
			NUS_MDATA(n) zւ̎Qƃ|C^A̐擪ɃZbgB
			
	in:		_nu_shpinfo_ptr_	= VF[v\̂ւ̃|C^ie͂ǂł悢j
			
			shape		= VF[v
			frame		= t[ԍ
	
	out:	_nu_shpinfo_ptr_	= VF[v
	
	:	̊֐́A_nu_shpinfo_ptr_ ɑ΂ďo͂sB
			nuSetCurShapeInfoSlot() ȂǂpĕK邱ƁB
*/
void nuStartShapeEx( const NUS_MOTION *shape, Float frame )
{
	_nu_shpinfo_ptr_->mdata		= shape->mdata;
	_nu_shpinfo_ptr_->nbframes	= shape->nbFrame;
	_nu_shpinfo_ptr_->frame		= frame;
	_nu_shpinfo_ptr_->checkID	++;

	_nu_shpinfo_ptr_->cnt		= _nu_shpinfo_ptr_->mdata->nb[0];
	_nu_shpinfo_ptr_->group		= _nu_shpinfo_ptr_->mdata->p[0];
}

/*
	func:	[V֐Qǂݏ郂[V\̂w肷B
	
	expl.:	̎ẃAɂ̊֐AnuSetCurShapeInfoSlot() Ăяo܂
			LłB
*/
void nuSetCurShapeInfoPtr( const NUS_CUR_SHAPE_INFO *shape_info_ptr )
{
	_nu_shpinfo_ptr_	= shape_info_ptr;
}

/*
	func:	[V֐Qǂݏ郂[V\̂̃Xbgԍw肷B
	
	in:		Slot	= [V\̂̃Xbgԍ
					  0 ` NUD_SHAPE_INFO_MAX - 1
	
	expl.:	̎ẃAɂ̊֐AnuSetCurShapeInfoPtr() Ăяo܂
			LłB
*/
void nuSetCurShapeInfoSlot( int Slot )
{
	_nu_shpinfo_ptr_	= &_nu_shape_info_[Slot];
}

/*
	̊֐́AVF[vO[vID̕ԌWi[obt@mۂ
*/
void nuInitShape( void *buf, Sint32 size )
{
	Sint32	i;
	NUS_SHAPE_GROUP_COEFF *p;
	
	_nu_shape_buf_ = buf;

	p = buf;
	size  = size / ( sizeof(NUS_SHAPE_GROUP_COEFF) );
	
	for( i=0; i<size; i++ ) {
		p->checkID = 0;
	}
}

/*
	VF[vXgݒ
*/
void nuSetShapeList( const NUS_CSHAPELIST *shape_list )
{
	_nu_shape_list_ = shape_list;
}

/*
	fVlistɃVF[vf[^vZĖߍ݂܂
*/
void nuCalcShapeVlist( const NJS_CNK_MODEL *cnkmodel )
{
	Sint32	i;
	Uint16	*vlist;
	Uint32	vtype,size;
	

	vlist = (Uint16*)cnkmodel->vlist;

	//Pm[hŕ`Nɕ܂
	for( i=0; i<_nu_shpinfo_ptr_->cnt; i++ ) {
		nuGetShapeGroupID();

		vtype = *vlist++ & 0x00ff;
		size = *vlist++;		/* size */
		vlist++;				/* offset */
		vlist++;				/* vertex num */

		//IWiVlistƃVF[vf[^|C^Ńf[^𖄂ߍ݂܂
		nuSetShapeVlist( (Uint32*)vlist, vtype );
		
		//̃VF[vf[^
		_nu_shpinfo_ptr_->group += 1;
		//̃`N
		vlist += size * 2 - 2;
	}
}

/*
	Jg̃L[O[vID`FbNA
	ԌWZbg
*/
void nuGetShapeGroupID( void )
{
	Uint32	id,group;
	NUS_MKEY_SHAPEID	*key1,*key2;
	Float	Rate;
	
	id = _nu_shpinfo_ptr_->group->keys->shapeId;
	
	group = _nu_shape_list_->shapes[id].groupId;
	_nu_shpinfo_ptr_->KeyGroupID = group;
	
	//ԌWłɌvZĂ邩
	if( _nu_shape_buf_[group].checkID != _nu_shpinfo_ptr_->checkID ) {
		
		_nuGetMotionLinearKeys( _nu_shpinfo_ptr_->group->keys, sizeof( NUS_MKEY_SHAPEID ), _nu_shpinfo_ptr_->group->nbKey,
								_nu_shpinfo_ptr_->frame, (void**)&key1, (void**)&key2, &Rate );
		
		_nu_shape_buf_[group].checkID  = _nu_shpinfo_ptr_->checkID;
		_nu_shape_buf_[group].ShapeID1 = key1->shapeId;
		_nu_shape_buf_[group].ShapeID2 = key2->shapeId;
		_nu_shape_buf_[group].rate     = Rate;
	}
}
