/*
	Ninja Library
	
	COPYRIGHT (C) SEGA ENTERPRISES,LTD.

	Create 2000.03.01

*/
#include <Ninja.h>
#include <Njutil.h>
#include <stdio.h>
#include <string.h>

/****************************************************************/
/*  ֐FnuGetWord								  		    */
/*  @  \F[hŎo							        */
/*    ́Fchar *src									        */
/*  o  ́FSint16 *dst                                         */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/****************************************************************/
static void nuGetWord(Sint16 *dst,char *src)
{
	Sint8 *dst8;

	dst8 = (Sint8*)dst;
	*dst8++ = *src++;
	*dst8 = *src;

}

/****************************************************************/
/*  ֐FnuGetLong								  		    */
/*  @  \FOŎo							        */
/*    ́Fchar *src									        */
/*  o  ́FSint32 *dst                                         */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/****************************************************************/
static void nuGetLong(Sint32 *dst,char *src)
{
	Sint8 *dst8;

	dst8 = (Sint8*)dst;
	*dst8++ = *src++;
	*dst8++ = *src++;
	*dst8++ = *src++;
	*dst8 = *src;

}

/****************************************************************/
/*  ֐FnuCalcPvmStatusSize						  		    */
/*  @  \FPVM STATUS̃f[^oCg邩vZ	        */
/*    ́FUint16 pvmstatus 	PVMSTATUStO			        */
/*  o  ́FȂ                                                */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/****************************************************************/
static Sint32 nuCalcPvmStatusSize(Uint16 pvmstatus)
{
	Sint32 read_size=2;
	
	if(pvmstatus & NUD_PVMH_PS_PVRNAME){
		read_size += 28;
	}
	if(pvmstatus & NUD_PVMH_PS_CATEGORYCODE){
		read_size += 2;
	}
	if(pvmstatus & NUD_PVMH_PS_ENTRYINFO){
		read_size += 2;
	}
	if(pvmstatus & NUD_PVMH_PS_GLOBALINDEX){
		read_size += 4;
	}

	return read_size;
}

/****************************************************************/
/*  ֐FnuSetTexListToPvm						  		    */
/*  @  \FeNX`XgɃf[^ݒ肷			        */
/*    ́FNJS_TEXLIST *texlist 	eNX`Xg	        */
/*			Sint32 read_size 1oɑ΂ă[hoCg	*/
/*			NUS_PVM_PVMH_HEAD *pmh PVMH`Nwb_			*/
/*  o  ́FȂ                                                */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
Sint32 nuSetTexListToPvm(NJS_TEXLIST *texlist,Sint32 read_size,NUS_PVM_PVMH_HEAD* pmh)
{
	Uint8 phinfo[40];
	NJS_TEXNAME *texname;
	Sint32 count;
	Sint16 entrycount;
	Uint16 pvmstatus;
	Uint16 entryid;
	Sint32 i;
	Uint32 globalIndex;
	Uint16 bank;
	Int ln;

	pvmstatus = pmh->pvmstatus;
	entrycount = pmh->entrycount;

	/* Gg[h */
	for(i = 0;i < entrycount;i++){
		if(nuTexFread(phinfo,read_size) < 0){
			return -1;
		}
	
		texname = (NJS_TEXNAME *)&texlist->textures[i];
	
		/* attř2oCgentryIdĂ */
		nuGetWord((Sint16*)&entryid,(Sint8*)phinfo);
		texname->attr = ((texname->attr)&0xFFFF0000)|(entryid&0x0000FFFF);
		count = 2;
		
		if(pvmstatus & NUD_PVMH_PS_PVRNAME){
			/* t@C28oCg[h */
			ln = strlen((Sint8*)&phinfo[count]);
			if(ln > 0)
				syMemCopy(texname->filename,&phinfo[count],ln);
			count += 28;
		}

		/* JeS[R[h͍͓ǂݔ΂ */
		if(pvmstatus & NUD_PVMH_PS_CATEGORYCODE){
			/*nuGetWord(&categorycode,&phinfo[count]);*/
			count += 2;
		}
		
		/* GgCtH͍͓ǂݔ΂ */
		if(pvmstatus & NUD_PVMH_PS_ENTRYINFO){
			/*nuGetWord(&entryinfo,&phinfo[count]);*/
			count += 2;
		}
		/* pbg[h */
		if(pvmstatus & NUD_PVMH_PS_BANKID){
			/* O[oCfbNX[hAtexaddrɓĂ */
			if(pvmstatus & NUD_PVMH_PS_GLOBALINDEX){
				/* bank(31 - 26)globalIndex(25 - 0)*/
				nuGetLong((Sint32*)&texname->texaddr,(Sint8*)&phinfo[count]);
				texname->attr |= NJD_TEXATTR_PALGLOBALINDEX;
			}
		}
		else{
			/* O[oCfbNX[hAtexaddrɓĂ */
			if(pvmstatus & NUD_PVMH_PS_GLOBALINDEX){
				nuGetLong((Sint32*)&texname->texaddr,(Sint8*)&phinfo[count]);
				texname->attr |= NJD_TEXATTR_GLOBALINDEX;
			}
		}
	}
		
		return 1;
}

/****************************************************************/
/*  ֐FnuSearchPvrChunk						  		    */
/*  @  \F`NTĒlZbg				        */
/*    ́FȂ										        */
/*  o  ́FȂ                                                */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
Sint32 nuSearchPvrChunk(void)
{
	Uint32 ch;
	Sint32 nextptr;
	NUS_PALETTE_HEADR	ph;
	Sint32 palette[1024];
	NJS_TEXPALETTE pl;
	Sint32 byte;
	
	/* ̑̃`N[h */
	do{
		/* `Nǂ SoCg */
		if(nuTexFread(&ch,4) < 0){
			return -1;
		}
		switch(ch){
		case NUD_PVM_MDLN_TAG:
		case NUD_PVM_CONV_TAG:
		case NUD_PVM_PVMI_TAG:
		case NUD_PVM_IMGC_TAG:
		case NUD_PVM_COMM_TAG:
			if(nuTexFread(&nextptr,4) < 0){
				return -1;
			}
			nuTexFseek(nextptr,SEEK_CUR);
			break;
		case NUD_PVM_PVPL_TAG:
			/* wb_̃[h */
			if(nuTexFread(&ph,12) != 1){
				return -1;
			}
			/* oN̐ݒ */
			njSetPaletteBank(ph.mode);
			switch(ph.mode){
			case NJD_TEXFMT_ARGB_8888:
				byte = 4;
				break;
			default:
				byte = 2;
				break;
			}
			if(nuTexFread(palette,(Uint32)(ph.entrycount*byte)) < 0){
				return -1;
			}
			nextptr = (ph.nextptr - 8) - ph.entrycount*byte;
			nuTexFseek((Uint32)(nextptr),SEEK_CUR);
			/* pbgJ[[h̐ݒ */
			njSetPaletteMode((Uint32)ph.mode);
			/* pbg[h*/
			njSetPaletteData((Sint32)(ph.entryoffset+ph.bank*16),(Sint32)(ph.entrycount),palette);
			break;
		case NUD_PVM_PVRT_TAG:
			nuTexFseek(-4,SEEK_CUR);
			break;
		default:
			if(nuTexFread(&nextptr,4) < 0){
				return -1;
			}
			nuTexFseek(nextptr,SEEK_CUR);
			break;
		}
		/* PVRT^O烋[vI */
	}while(ch != NUD_PVM_PVRT_TAG);
	
	return 1;
}

/****************************************************************/
/*  ֐FnuLoadTexturePvmFile					            */
/*  @  \FPVMt@C[hAeNX`XgɃZbg */
/*    ́Fconst char filename pvmt@C			        */
/*          NJS_TEXLIST *texlist eNX`Xg				*/
/*  o  ́F P s[P                                    */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF                                                    */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTexturePvmFile(const char *filename,NJS_TEXLIST *texlist)
{
	char filename2[32];
	Uint32 ch;
	Sint16 entrycount;
	Uint16 pvmstatus;
	NUS_PVM_PVMH_HEAD pmh;
	Uint32 globalIndex;
	Sint32 ret;
	Sint32 i,n;
	Sint32 read_size;
	Sint32 size,offset;
	Sint32 nextptr;
	Uint32 bank = NJD_BANK_FIRST_VAL;
	Sint8 *tex_start;
	NUS_PVR_PVRT_HEAD pvrh;
	Sint32 texmng_no;
	Sint8 *texbuf;
	Int texbuf_size;
	
	
	njInitTextureErrStat();

	/* gq̊mF */
	njCheckFileName(filename2,filename,".PVM");
	
	/* t@C̃I[v */
	if((ret = nuTexFopen(filename2)) < 0){
		return -1;
	}

	/* `Nǂ 12oCg */
	if(nuTexFread(&pmh,12) < 0){
		nuTexFclose();
		return -1;
	}

	/* PVMH`N */
	if(pmh.chunk != NUD_PVM_PVMH_TAG){
		/* PVMH`N擪ɖꍇ̓G[ */
		_nj_texerr_.texerr = NJD_TEXERR_HEADER;
		nuTexFclose();
		return -1;
	}

	pvmstatus = pmh.pvmstatus;
	entrycount = pmh.entrycount;
	texlist->nbTexture = entrycount;
	/* Ggꂽf[^oCgvZ */
	read_size = nuCalcPvmStatusSize(pvmstatus);
	/* eNXXgɃf[^Zbg */
	nuSetTexListToPvm(texlist,read_size,&pmh);
	/* fobO */
	nuTexFseek(pmh.nextptr+8,SEEK_SET);

	/* ̑̃`N[hAPVR`NT */
	if(nuSearchPvrChunk() < 0){
		nuTexFclose();
		return -1;
	}

	/* eNX`obt@̎擾 */
	nuGetTextureBuffer(&texbuf,&texbuf_size);
	
	/* PVRT`NFGgJEg̐[v */
	for(i = 0;i < entrycount;i++){
		/* nuSetTexListToPvm֐Őݒ肵entryIdeNX`XgT */
		for(n = 0;n < entrycount;n++){
			if((texlist->textures[n].attr&0x0000FFFF) == i){
				break;
			}
		}

		ret = njCheckAttrGlobalIndex(texlist,n,&globalIndex,&bank);
		if(ret == -1){
			_nj_texerr_.texerr = NJD_TEXERR_MAINMEMORY;
			nuTexFclose();
			return -1;
		}

		if(nuTexFread(&pvrh,16) < 0){
			nuTexFclose();
			return -1;
		}

		if(pvrh.chunk != NUD_PVM_PVRT_TAG){
			_nj_texerr_.texerr = NJD_TEXERR_HEADER;
			return -1;
		}

		if(ret == 0){
			ret = njEntryTextureManageNum(texlist,n,globalIndex,bank,&pvrh.data,&texmng_no);

			switch(ret){
			case -1:
				nuTexFclose();
				_nj_texerr_.texerr = NJD_TEXERR_SURFACE;
				return -1;
				break;
			case 1:
				nuTexFseek(pvrh.nextptr - 8,SEEK_CUR);
				break;
			case 0:
				read_size = njCalcTextureSize2(&pvrh.data);
				nextptr = pvrh.nextptr - 8;
				if(nextptr > read_size){
					nextptr = nextptr - read_size;
				}
				else{
					read_size = nextptr;
					nextptr = 0;
				}

				offset = 0;
				do{
					if(read_size <= texbuf_size){
						size = read_size;
					}
					else{
						size = texbuf_size;
					}
				
					if(nuTexFread(texbuf,size) < 0){
						njReleaseTextureManageNum(texmng_no);
						texlist->textures[n].attr &= ~NJD_TEXATTR_REGISTRATION;
						texlist->textures[n].texaddr = 0;
						nuTexFclose();
						return -1;
					}
					syCacheOCWB(texbuf,size);
					
					if(njLoadTexturePartManageNum(texmng_no,texbuf,offset,size)== -1){
						njReleaseTextureManageNum(texmng_no);
						texlist->textures[n].attr &= ~NJD_TEXATTR_REGISTRATION;
						texlist->textures[n].texaddr = 0;
						/* eNX`[hG[@*/
						nuTexFclose();
						return -1;
					}
					read_size -= size;
					offset += size;
					while(njLoadTextureFinishDMA() != 1);
				}while(read_size > 0);
				
				if(nextptr > 0){
					nuTexFseek(nextptr,SEEK_CUR);
				}
				break;
			}
		}
		else{
			/* pbgeNX`Ȃ̂ŃeNX`ǂݔ΂ */
			nuTexFseek(pvrh.nextptr - 8,SEEK_CUR);
		}
		
	}	
		
	nuTexFclose();
	
	return 1;

}

