/*
	Ninja Library
	
	COPYRIGHT (C) SEGA ENTERPRISES,LTD.

	Create 2000.03.01

*/
#include <Ninja.h>
#include <Njutil.h>
#include <string.h>

static Sint8 *_st_ptr_;
static Sint8 *_r_ptr_;

/****************************************************************/
/*  ֐FnuMOpen									  		    */
/*  @  \FAhX̐ݒ								        */
/*    ́Fvoid *addr									        */
/*  o  ́FȂ		                                        */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/****************************************************************/
static void nuMOpen(void *addr)
{
	_st_ptr_ = (Sint8*)addr;
	_r_ptr_ = _st_ptr_;

}

/****************************************************************/
/*  ֐FnuMRead									  		    */
/*  @  \F݂̃AhXԂ						        */
/*    ́FSint32 size									        */
/*  o  ́FȂ		                                        */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/****************************************************************/
static void* nuMRead(Sint32 size)
{
	void *ptr;
	
	ptr = _r_ptr_;
	_r_ptr_ = (Sint8*)((Uint32)_r_ptr_ + size);

	return ptr;
}

/****************************************************************/
/*  ֐FnuMSeek									  		    */
/*  @  \FV[N										        */
/*    ́FSint32 size									        */
/*			Int type											*/
/*  o  ́FȂ		                                        */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/****************************************************************/
static void nuMSeek(Sint32 size,Int type)
{
	switch(type){
	case SEEK_CUR:
		_r_ptr_ = (Sint8*)((Uint32)_r_ptr_ + size);
		break;
	case SEEK_SET:
		_r_ptr_ = (Sint8*)((Uint32)_st_ptr_ + size);
		break;
	}
}

/****************************************************************/
/*  ֐FnuMGetPtr								  		    */
/*  @  \F݈ʒũAhX擾				        */
/*    ́FȂ										        */
/*  o  ́FȂ		                                        */
/*  ߂lF݈ʒũAhX									*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/****************************************************************/
static void *nuMGetPtr(void)
{
	return _r_ptr_;
}

/****************************************************************/
/*  ֐FnuGetWord								  		    */
/*  @  \F[hŎo							        */
/*    ́Fchar *src									        */
/*  o  ́FSint16 *dst                                         */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/****************************************************************/
static void nuGetWord(Sint16 *dst,char *src)
{
	Sint8 *dst8;

	dst8 = (Sint8*)dst;
	*dst8++ = *src++;
	*dst8 = *src;

}

/****************************************************************/
/*  ֐FnuGetLong								  		    */
/*  @  \FOŎo							        */
/*    ́Fchar *src									        */
/*  o  ́FSint32 *dst                                         */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/****************************************************************/
static void nuGetLong(Sint32 *dst,char *src)
{
	Sint8 *dst8;

	dst8 = (Sint8*)dst;
	*dst8++ = *src++;
	*dst8++ = *src++;
	*dst8++ = *src++;
	*dst8 = *src;

}

/****************************************************************/
/*  ֐FnuSetTexListToPvmM						  		    */
/*  @  \FeNX`XgɃf[^ݒ肷			        */
/*    ́FNJS_TEXLIST *texlist 	eNX`Xg	        */
/*			Sint32 read_size 1oɑ΂ă[hoCg	*/
/*			NJS_PVM_PVMH *pmh PVMH`Nwb_				*/
/*  o  ́FȂ                                                */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
void nuSetTexListToPvmM(NJS_TEXLIST *texlist,Sint32 read_size,NUS_PVM_PVMH_HEAD* pmh)
{
	Sint8 *phinfo;
	NJS_TEXNAME *texname;
	Sint32 count;
	Sint16 entrycount;
	Uint16 pvmstatus;
	Uint16 entryid;
	Sint32 i;
	Uint32 globalIndex;
	Uint16 bank;
	Int ln;

	pvmstatus = pmh->pvmstatus;
	entrycount = pmh->entrycount;

	/* Gg[h */
	for(i = 0;i < entrycount;i++){
		phinfo = nuMRead(read_size);
	
		texname = (NJS_TEXNAME *)&texlist->textures[i];
	
		/* attř2oCgentryIdĂ */
		nuGetWord((Sint16*)&entryid,(Sint8*)phinfo);
		texname->attr = ((texname->attr)&0xFFFF0000)|(entryid&0x0000FFFF);
		phinfo += 2;
		
		if(pvmstatus & NUD_PVMH_PS_PVRNAME){
			/* t@C28oCg[h */
			ln = strlen(phinfo);
			if(ln > 0)
				syMemCopy(texname->filename,phinfo,ln);
			phinfo += 28;
		}

		/* JeS[R[h͍͓ǂݔ΂ */
		if(pvmstatus & NUD_PVMH_PS_CATEGORYCODE){
			/*nuGetWord(&categorycode,phinfo);*/
			phinfo += 2;
		}
		
		/* GgCtH͍͓ǂݔ΂ */
		if(pvmstatus & NUD_PVMH_PS_ENTRYINFO){
			/*nuGetWord(&entryinfo,phinfo);*/
			phinfo += 2;
		}
		
		/* 
			NJD_TEXATTR_GLOBALINDEX,NJD_TEXATTR_PALGLOBALINDEXݒ肳Ăꍇ
			̐ݒD悷
		*/
		if(!((texname->attr & NJD_TEXATTR_GLOBALINDEX)||(texname->attr & NJD_TEXATTR_PALGLOBALINDEX))){//<--2000/7/31 ǉ
			/* pbg[h */
			if(pvmstatus & NUD_PVMH_PS_BANKID){
				/* O[oCfbNX[hAtexaddrɓĂ */
				if(pvmstatus & NUD_PVMH_PS_GLOBALINDEX){
					/* bank(31 - 26)globalIndex(25 - 0)*/
					nuGetLong((Sint32*)&texname->texaddr,phinfo);
					texname->attr |= NJD_TEXATTR_PALGLOBALINDEX;
				}
			}
			else{
				/* O[oCfbNX[hAtexaddrɓĂ */
				if(pvmstatus & NUD_PVMH_PS_GLOBALINDEX){
					nuGetLong((Sint32*)&texname->texaddr,phinfo);
					texname->attr |= NJD_TEXATTR_GLOBALINDEX;
				}
			}
		}
	}
		
}

/****************************************************************/
/*  ֐FnuCalcPvmStatusSize						  		    */
/*  @  \FPVM STATUS̃f[^oCg邩vZ	        */
/*    ́FUint16 pvmstatus 	PVMSTATUStO			        */
/*  o  ́FȂ                                                */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/****************************************************************/
static Sint32 nuCalcPvmStatusSize(Uint16 pvmstatus)
{
	Sint32 read_size=2;
	
	if(pvmstatus & NUD_PVMH_PS_PVRNAME){
		read_size += 28;
	}
	if(pvmstatus & NUD_PVMH_PS_CATEGORYCODE){
		read_size += 2;
	}
	if(pvmstatus & NUD_PVMH_PS_ENTRYINFO){
		read_size += 2;
	}
	if(pvmstatus & NUD_PVMH_PS_GLOBALINDEX){
		read_size += 4;
	}

	if(pvmstatus & NUD_PVMH_PS_BANKID){
		read_size += 2;
	}

	return read_size;
}


/****************************************************************/
/*  ֐FnuSearchPvrChunkM						  		    */
/*  @  \F`NTĒlZbg				        */
/*    ́FȂ										        */
/*  o  ́FȂ                                                */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
void nuSearchPvrChunkM(void)
{
	Uint32 *ch;
	Sint32 *nextptr;
	Sint32 next;
	NUS_PALETTE_HEADR	*ph;
	Sint32 *palette;
	Sint32 byte;

	/* ̑̃`N[h */
	do{
		/* `Nǂ SoCg */
		ch = nuMRead(4);
		switch(*ch){
		case NUD_PVM_MDLN_TAG:
		case NUD_PVM_CONV_TAG:
		case NUD_PVM_PVMI_TAG:
		case NUD_PVM_IMGC_TAG:
		case NUD_PVM_COMM_TAG:
			nextptr = nuMRead(4);
			nuMSeek(*nextptr,SEEK_CUR);
			break;
		case NUD_PVM_PVPL_TAG:
			/* wb_̃[h */
			ph = nuMRead(12);
			/* oN̐ݒ */
			njSetPaletteBank(ph->mode);
			switch(ph->bank){
			case NJD_TEXFMT_ARGB_8888:
				byte = 4;
				break;
			default:
				byte = 2;
				break;
			}
			palette = nuMRead((Uint32)(ph->entrycount*byte));
			next = (ph->nextptr - 8) - ph->entrycount*byte;
			nuMSeek(next,SEEK_CUR);
			/* pbgJ[[h̐ݒ */
			njSetPaletteMode((Uint32)ph->mode);
			/* pbg[h*/
			njSetPaletteData((Sint32)(ph->entryoffset+ph->bank*16),(Sint32)(ph->entrycount),palette);
			break;
		case NUD_PVM_PVRT_TAG:
			nuMSeek(-4,SEEK_CUR);
			break;
		default:
			nextptr = nuMRead(4);
			nuMSeek(*nextptr,SEEK_CUR);
			break;
		}
		/* PVRT^O烋[vI */
	}while(*ch != NUD_PVM_PVRT_TAG);
}

/****************************************************************/
/*  ֐FnuLoadTexturePvmMemory						        */
/*  @  \FPVM`eNX`XgɃZbg 		*/
/*    ́FSint8 *pTexture								        */
/*          NJS_TEXLIST *texlist eNX`Xg				*/
/*  o  ́F P s[P                                    */
/*  ߂lFȂ												*/
/*  T@vF                                                    */
/*  @lF                                                    */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTexturePvmMemory(Sint8 *pTexture,NJS_TEXLIST *texlist)
{
	Uint32 globalIndex;
	Sint32 ret;
	Sint32 i,n;
	Sint32 read_size;
	Uint32 bank = NJD_BANK_FIRST_VAL;
	Sint8 *tex_start;
	NUS_PVM_PVMH_HEAD *pmh;
	NUS_PVR_PVRT_HEAD *pvrh;
	Sint32 texmng_no;
	Sint32 entrycount;
	
	njInitTextureErrStat();
	
	if(pTexture == NULL){
		_nj_texerr_.texerr = NJD_TEXERR_OTHER;
		return -1;
	}
	nuMOpen(pTexture);

	/* `Nǂ SoCg */
	pmh = nuMRead(12);

	/* PVMH`N */
	if(pmh->chunk != NUD_PVM_PVMH_TAG){
		/* PVMH`N擪ɖꍇ̓G[ */
		_nj_texerr_.texerr = NJD_TEXERR_HEADER;
		return -1;
	}

	texlist->nbTexture = pmh->entrycount;
	/* Ggꂽf[^oCgvZ */
	read_size = nuCalcPvmStatusSize(pmh->pvmstatus);
	/* eNXXgɃf[^Zbg */
	nuSetTexListToPvmM(texlist,read_size,pmh);

	nuMSeek(pmh->nextptr+8,SEEK_SET);

	/* ̑̃`N[hAPVR`NT */
	nuSearchPvrChunkM();

	entrycount = texlist->nbTexture;
	/* PVRT`NFGgJEg̐[v */
	for(i = 0;i < entrycount;i++){
		/* njSetTexListToPvm֐Őݒ肵entryIdeNX`XgT */
		for(n = 0;n < entrycount;n++){
			if((texlist->textures[n].attr&0x0000FFFF) == i){
				break;
			}
		}

		ret = njCheckAttrGlobalIndex(texlist,n,&globalIndex,&bank);
		if(ret == -1){
			_nj_texerr_.texerr = NJD_TEXERR_MAINMEMORY;
			return -1;
		}
		/* PVRTwb_`FbN */
		pvrh = nuMRead(16);
		if(pvrh->chunk != NUD_PVM_PVRT_TAG){
			_nj_texerr_.texerr = NJD_TEXERR_HEADER;
			return -1;
		}
		tex_start = nuMRead(pvrh->nextptr - 8);
		
		if(ret == 0){
			ret = njEntryTextureManageNum(texlist,n,globalIndex,bank,&pvrh->data,&texmng_no);

			switch(ret){
			case -1:
				_nj_texerr_.texerr = NJD_TEXERR_SURFACE;
				return -1;
				break;
			case 0:
				if(njLoadTextureManageNum(texmng_no,tex_start)== -1){
					njReleaseTextureManageNum(texmng_no);
					texlist->textures[n].attr &= ~NJD_TEXATTR_REGISTRATION;
					texlist->textures[n].texaddr = 0;
					return -1;
				}

				while(njLoadTextureFinishDMA() != 1);
				break;
			/* case 1:́@Ȃ*/
			}
		}
	}	

	return 1;

}
