/*
	Ninja Library
	
	COPYRIGHT (C) SEGA ENTERPRISES,LTD.

	Create 2000.03.01

*/
#include <Ninja.h>
#include <Njutil.h>
#include <sg_gd.h>

/********************************************************************************/
/*	[h֐																	*/
/********************************************************************************/
Sint32 nuLoadTextureReqLN(NJS_TEXLIST *texlist,Uint32 n);
Sint32 nuLoadTextureReqStart(void);
Sint32 nuLoadTextureReqFileOpen(void);
Sint32 nuLoadTextureReqFileRead(void);
Sint32 nuLoadTextureReqFileReadWait(void);
Sint32 nuLoadTextureReqFileHeader(void);
Sint32 nuLoadTextureReqMemoryHeader(void);
Sint32 nuLoadTextureReqGetSurface(void);
Sint32 nuLoadTextureReqLoad(void);
Sint32 nuLoadTextureReqLoadWaitDma(void);


/********************************************************************************/
/*	[hA[h															*/
/********************************************************************************/
#define FILE_TYPE		(0)
#define MEMORY_TYPE		(1)
/********************************************************************************/
/*	[h																	*/
/********************************************************************************/

/********************************************************************************/
/*	TEXTUREDMA҂																	*/
/********************************************************************************/
#define DMA_WAIT_ERR_COUNT	10

/********************************************************************************/
/*	FILE҂																	*/
/********************************************************************************/
#define FILE_WAIT_ERR_COUNT	1000

/********************************************************************************/
/*	t@C̒															*/
/********************************************************************************/
#define FILE_NAME_NUM		(32)


#define LOOP_TRUE			1
#define LOOP_FALSE			0
/********************************************************************************/
/*	}N																		*/
/********************************************************************************/
#define NEXT_MODE(mode)	_nu_loadtexreq_mode_ = (mode)


#define ERR_MODE(err)		{\
							loop_mode = loop_false;\
							_nu_loadtexreq_mode_ = NUD_TEX_MODE_OPEN;\
							/*********** G[R[hԂ ************/\
							/********* Turn over error code ************/\
							_nj_texerr_.n = (load_n);\
							_nj_texerr_.texerr = (err);\
							}

#define FREAD_ERR			{\
								_nj_texerr_.gdstat = gdFsGetStat(tex_loadreq_fp);\
								_nj_texerr_.gderr = gdFsGetErrStat(tex_loadreq_fp);\
							}\

#define ERR_CLOSE			{\
							/* 擾ĂT[tFX̃[X@*/\
							/* Release of the SurfaceDesc which acquired it. */\
							njReleaseTextureManageNum(load_texmng_no);\
							load_list->textures[load_n].attr &= ~NJD_TEXATTR_REGISTRATION;\
							load_list->textures[load_n].texaddr = 0;\
							/* t@C̃N[Y@*/\
							/* Closing of a file. */\
							if(load_src == FILE_TYPE){\
								gdFsClose(tex_loadreq_fp);\
							}\
							}

/********************************************************************************/
/*	^`																		*/
/********************************************************************************/
typedef Sint32 (*TEXFUNC)(void);


/********************************************************************************/
/*	ϐ`																	*/
/********************************************************************************/
Int _nu_loadtexreq_mode_;
Uint32 _nu_loadtexreq_i_;
static Int loop_mode = LOOP_TRUE;	/* Ċ֐s邩̃tO */
static Int loop_true = LOOP_TRUE;	/* ̃tOLOOP_FALSEɂ1֐Âs */
static Int loop_false = LOOP_FALSE;
static GDFS tex_loadreq_fp;
static Int load_src = FILE_TYPE;
static Int load_dst = MEMORY_TYPE;
static NJS_TEXLIST *load_list = NULL;
static NJS_TEXNAME *load_texname = NULL;
static Uint32 load_n = 0;
static Sint32 load_texmng_no = 0;
static Uint32 load_globalIndex = NJD_GLOBAXINDEX_FIRST_VAL;
static Uint32 load_bank = NJD_GLOBAXINDEX_FIRST_VAL;
static NJS_PVRHEADERDATA pvrh;


static Sint32 file_sect_size;	/* t@C̃ZN^TCY */
static Sint32 buffer_sect_size;	/* obt@̃ZN^TCY */
static Sint32 r_sect_size;		/* c̃ZN^TCY */
static Sint32 file_offset=0;	/* t@C̐擪̃ItZbg */
static Sint32 read_size;		/* [hoCg */
static Sint8 *read_start;		/* X^[gAhX */
static Sint32 dma_count;		/* DMA[v */
static Sint32 file_count;		/* FILEWAIT[v */
static Sint8 *texbuf;			/* eNX`obt@AhX */
static Int texbuf_size;			/* eNX`obt@TCY */


TEXFUNC func;


static TEXFUNC FuncTable[] = 
{
	NULL,
	nuLoadTextureReqStart,
	nuLoadTextureReqFileOpen,
	nuLoadTextureReqFileRead,
	nuLoadTextureReqFileReadWait,
	nuLoadTextureReqFileHeader,
	nuLoadTextureReqMemoryHeader,
	nuLoadTextureReqGetSurface,
	nuLoadTextureReqLoad,
	nuLoadTextureReqLoadWaitDma,
};

/****************************************************************/
/*  ֐FnuLoadTextureReq						  		    */
/*  @  \FÃeNX`[h							*/
/*    ́FNJS_TEXLIST *texlist								*/
/*  o  ́FȂ                                                */
/*  ߂lFI@P@p@O@G[@|P				*/
/*  T@vF                                                    */
/*  @lF		                                            */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTextureReq(NJS_TEXLIST *texlist)
{
	static Sint32 Mode;
	
	Mode = nuLoadTextureReqLN(texlist,_nu_loadtexreq_i_);
	switch(Mode){
	case NUD_TEX_STAT_ERR:
		_nu_loadtexreq_i_ = 0;
		return NUD_TEX_STAT_ERR;
	case NUD_TEX_STAT_END:
		if(_nu_loadtexreq_i_ < (texlist->nbTexture - 1)){
			_nu_loadtexreq_i_++;
			return NUD_TEX_STAT_READ;
		}
		else{
			_nu_loadtexreq_i_ = 0;
			return NUD_TEX_STAT_END;
		}
	case NUD_TEX_STAT_READ:
		return NUD_TEX_STAT_READ;
	}

}

/****************************************************************/
/*  ֐FnuLoadTextureReqLN						  		    */
/*  @  \FÃeNX`[h							*/
/*    ́FNJS_TEXLIST *texlist								*/
/*          Uint32 n                                            */
/*  o  ́FȂ                                                */
/*  ߂lFI@P@p@O@G[@|P				*/
/*  T@vF                                                    */
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTextureReqLN(NJS_TEXLIST *texlist,Uint32 n)
{
	Sint32 ret;
	
	if(_nu_loadtexreq_mode_ == NUD_TEX_MODE_OPEN){
		/* G[̏@*/
		njInitTextureErrStat();
		load_list = texlist;
		load_texname = &texlist->textures[n];
		load_n = n;
		loop_true = LOOP_TRUE;
//		loop_true = LOOP_FALSE;
		NEXT_MODE(NUD_TEX_MODE_START);
	}

	do{
		func = FuncTable[_nu_loadtexreq_mode_];
		ret = func();
	}while(loop_mode != LOOP_FALSE);
	
	return ret;

}

/****************************************************************/
/*  ֐FnuLoadTextureReqStart					  		    */
/*  @  \FATTR̃`FbN										*/
/*    ́FȂ												*/
/*  o  ́FȂ                                                */
/*  ߂lFNJD_TEXATTR_TEXCONTINUȄꍇ	NUD_TEX_STAT_END	*/
/*			̑							NUD_TEX_STAT_READ	*/
/*  T@vFNJD_TEXATTR_TEXCONTINUE,NJD_TEXATTR_GLOBALINDEX,	*/
/*			NJD_TEXATTR_PALGLOBALINDEX݂Čʂ𔽉f	*/
/*			̌At@CeNX`eNX`	*/
/*			f											*/
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTextureReqStart(void)
{
	Sint32 ret;
	/*
		njCheckAttrGlobalIndex֐ɂ
		
		NJD_TEXATTR_GLOBALINDEX̏ꍇ
			Eload_globalIndextexname.texaddrɐݒ肳Ă
			O[oCfbNXݒ肳
			Eload_bankɂNJD_BANK_FIRST_VALݒ肳
		
		NJD_TEXATTR_PALGLOBALINDEX̏ꍇ
			Eload_globalIndextexname.texaddr̉26rbg
			O[oCfbNXƂĐݒ肳
			Eload_bankɂtexname.texaddr6rbgoNƂĐݒ肳
		
		NJD_TEXATTR_TEXCONTINUȄꍇ
			Eload_listload_n-1ɓeNX`[hĂƂtOȂ̂
			load_n|1̏Rs[oNύXďIB
			gpoŃAtexname.texaddr6rbgɐݒ肳ĂoNgp
	
	*/
	ret = njCheckAttrGlobalIndex(load_list,load_n,&load_globalIndex,&load_bank);
	if(ret == 1){
		/* NJD_TEXATTR_TEXCONTINUȄꍇ */
		loop_mode = LOOP_FALSE;
		NEXT_MODE(NUD_TEX_MODE_OPEN);
		return NUD_TEX_STAT_END;
	}
	else{
		if(ret == -1){
			ERR_MODE(NJD_TEXERR_MAINMEMORY)
			return NUD_TEX_STAT_ERR;
		}
	}

	if(load_texname->attr & NJD_TEXATTR_TYPE_MEMORY){
		/* eNX`̏ꍇ@*/
		load_src = MEMORY_TYPE;
		loop_mode = LOOP_TRUE;
		NEXT_MODE(NUD_TEX_MODE_MEMORYHEADER);
	}
	else{
		/* eNX`t@C̏ꍇ@*/
		load_src = FILE_TYPE;
		loop_mode = LOOP_TRUE;
		NEXT_MODE(NUD_TEX_MODE_FILEOPEN);
	}
	
	return NUD_TEX_STAT_READ;
}

/****************************************************************/
/*  ֐FnuLoadTextureReqFileOpen				  		    */
/*  @  \Ft@C̃I[v									*/
/*    ́FȂ												*/
/*  o  ́FȂ                                                */
/*  ߂lFt@CI[vG[			NUD_TEX_STAT_ERR	*/
/*										NUD_TEX_STAT_READ	*/
/*  T@vFt@CI[văTCYvZ              */
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTextureReqFileOpen(void)
{

	Sint8 filename2[FILE_NAME_NUM];

	/* [ht@C̎擾@*/
	/* .PVRtĂ邩mF@*/
	njCheckFileName(filename2,load_texname->filename,".PVR");
	if((tex_loadreq_fp = gdFsOpen(filename2,NULL)) != NULL){
		/* t@C̃ZN^TCY̌vZ */
		gdFsGetFileSctSize(tex_loadreq_fp,&file_sect_size);
		/* eNX`obt@̎擾 */
		nuGetTextureBuffer(&texbuf,&texbuf_size);
		/* t@Cobt@̃ZN^TCY̌vZ */
		buffer_sect_size = texbuf_size/NJD_GD_SECT_SIZE;
		/* c̃ZN^TCY */
		r_sect_size = file_sect_size;
		file_offset = 0;
		/* ̃[hݒ */
		NEXT_MODE(NUD_TEX_MODE_FILEREAD);
	}
	else{
		/* t@CI[vłȂꍇ */
		/*********** G[R[hԂ ************/
		ERR_MODE(NJD_TEXERR_FILEOPEN)
		return NUD_TEX_STAT_ERR;
	}
	
	loop_mode = loop_true;
	return NUD_TEX_STAT_READ;
}


/****************************************************************/
/*  ֐FnuLoadTextureReqFileRead				  		    */
/*  @  \Ft@C̃[hiAj						*/
/*    ́FȂ												*/
/*  o  ́FȂ                                                */
/*  ߂lFt@C[hG[			NUD_TEX_STAT_ERR	*/
/*										NUD_TEX_STAT_READ	*/
/*  T@vFTCYvZAt@C[h	            */
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTextureReqFileRead(void)
{
	Sint32 read_sect;

	/* [hZN^vZ */
	if(buffer_sect_size >= r_sect_size){
		/* obt@̕傫ꍇ@*/
		read_sect = r_sect_size;
	}
	else{
		/* obt@̕ꍇ@*/
		read_sect = buffer_sect_size;
	}
	
	/* A[h@*/
	read_start = texbuf;
	if(gdFsReqRd32(tex_loadreq_fp,read_sect,read_start) < 0){
		FREAD_ERR
		gdFsClose(tex_loadreq_fp);
		/*********** G[R[hԂ ************/
		/********* Turn over error code ************/
		ERR_MODE(NJD_TEXERR_FILELOAD)
		return NUD_TEX_STAT_ERR;
	}

	r_sect_size -= read_sect;
	read_size = read_sect*NJD_GD_SECT_SIZE;
	NEXT_MODE(NUD_TEX_MODE_FILEREADWAIT);
	loop_mode = loop_true;
	file_count = 0;

	return NUD_TEX_STAT_READ;

}

/****************************************************************/
/*  ֐FnuLoadTextureReqFileReadWait			  		    */
/*  @  \Ft@C̃[hEGCg							*/
/*    ́FȂ												*/
/*  o  ́FȂ                                                */
/*  ߂lFt@CԃG[				NUD_TEX_STAT_ERR	*/
/*										NUD_TEX_STAT_READ	*/
/*  T@vF[hI邩mFBIȂꍇ͏I*/
/*			܂ŎsBG[̏ꍇ͏I				*/
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTextureReqFileReadWait(void)
{

	switch(gdFsGetStat(tex_loadreq_fp)){
	case GDD_STAT_COMPLETE:
		if(file_offset == 0){
			NEXT_MODE(NUD_TEX_MODE_FILEHEADER);
		}
		else{
			NEXT_MODE(NUD_TEX_MODE_LOAD);
		}
		loop_mode = loop_true;
		break;
	case GDD_STAT_READ:
	case GDD_STAT_IDLE:
	case GDD_STAT_SEEK:
	case GDD_STAT_BUSY:
		file_count++;
		if(file_count > FILE_WAIT_ERR_COUNT){
			FREAD_ERR
			gdFsClose(tex_loadreq_fp);
			/*********** G[R[hԂ ************/
			ERR_MODE(NJD_TEXERR_FILELOAD)
			return NUD_TEX_STAT_ERR;
		}
		else{
			NEXT_MODE(NUD_TEX_MODE_FILEREADWAIT);
		}
		loop_mode = loop_false;
		break;
	case GDD_STAT_ERR:
		/* G[̏ꍇ */
		FREAD_ERR
		gdFsClose(tex_loadreq_fp);
		/*********** G[R[hԂ ************/
		ERR_MODE(NJD_TEXERR_FILELOAD)
		return NUD_TEX_STAT_ERR;
		break;
	}
	
	return NUD_TEX_STAT_READ;
}


/****************************************************************/
/*  ֐FnuLoadTextureReqFileHeader				  		    */
/*  @  \Ft@C̃wb_擾						*/
/*    ́FȂ												*/
/*  o  ́FȂ                                                */
/*  ߂lFt@Cwb_Ȃ			NUD_TEX_STAT_ERR	*/
/*										NUD_TEX_STAT_READ	*/
/*  T@vFwb_擾								*/
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTextureReqFileHeader(void)
{
	Sint8 *pTexture;
	Uint32 global;

	/* wb_f[^擾 pTextureɂ̓f[^̐擪AhXԂ@*/
	if((pTexture = njLoadPvrHeader(&pvrh,&global,read_start)) != NULL){
		/* [hTCY̏C */
		read_size -= (Sint32)((Uint32)pTexture - (Uint32)read_start);
		read_start = pTexture;
		/*
			nuLoadTextureReqStart֐ŃO[oCfbNX
			ݒ肳Ăꍇ́Agp
		*/
		if(load_globalIndex == NJD_GLOBAXINDEX_FIRST_VAL){
			/* O[oCfbNXȂꍇ̓t@C
				O[oCfbNXgp
			*/
			if(global == NJD_GLOBAXINDEX_FIRST_VAL){
				/* t@CɂȂꍇɂ́A[UO[oCfbNX
				O[oCfbNXt@*/
				load_globalIndex = (_nj_user_globalIndex--);
			}
			else{
				load_globalIndex = global;
			}
		}
	}
	else{
		/* t@CɃwb_񂪂Ȃꍇ̓G[*/
		gdFsClose(tex_loadreq_fp);
		/*********** G[R[hԂ ************/
		ERR_MODE(NJD_TEXERR_HEADER)
		return NUD_TEX_STAT_ERR;
	}

	NEXT_MODE(NUD_TEX_MODE_GETSURFACE);
	loop_mode = loop_true;
	return NUD_TEX_STAT_READ;
}

/****************************************************************/
/*  ֐FnuLoadTextureReqMemoryHeader			  		    */
/*  @  \F̃wb_擾								*/
/*    ́FȂ												*/
/*  o  ́FȂ                                                */
/*  ߂lF							NUD_TEX_STAT_READ	*/
/*  T@vF[hI邩mFBIȂꍇ͏I*/
/*			܂ŎsBG[̏ꍇ͏I				*/
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTextureReqMemoryHeader(void)
{
	Sint8 *pTexture;
	NJS_TEXINFO *info;
	Uint32 global;

	/* filenameɃeNX`ݒ肳Ă邩[hĂ݂ */
	read_start = njLoadPvrHeader(&pvrh,&global,load_texname->filename);
	if(read_start == NULL){
		/* filenameɂȂꍇ́ANinja1܂łƓݒɂȂĂ͂ */
		read_start = njLoadPvrHeader(&pvrh,&global,((NJS_TEXINFO*)load_texname->filename)->texaddr);
		if(read_start == NULL){
			/* łwb_mFłȂꍇ́Awb_͂ȂƂ݂Ȃ */
			info = (NJS_TEXINFO*)load_texname->filename;
			pvrh.nWidth = info->texsurface.nWidth;
			pvrh.nHeight = info->texsurface.nHeight;
			pvrh.nTextureType = info->texsurface.Type;
			read_start = ((NJS_TEXINFO*)load_texname->filename)->texaddr;
		}
	}

	if(load_globalIndex == NJD_GLOBAXINDEX_FIRST_VAL){
		/* O[oCfbNXȂꍇ@*/
		if(global == NJD_GLOBAXINDEX_FIRST_VAL){
			/* O[oCfbNXt@*/
			load_globalIndex = (_nj_user_globalIndex--);
		}
		else{
			load_globalIndex = global;
		}
	}
	
	/* eϐɒlݒ肷 */
	file_offset = 0;
	r_sect_size = 0;
	read_size = njCalcTextureSize2(&pvrh);

	NEXT_MODE(NUD_TEX_MODE_GETSURFACE);
	loop_mode = loop_true;

	return NUD_TEX_STAT_READ;
}


/****************************************************************/
/*  ֐FnuLoadTextureReqGetSurface				  		    */
/*  @  \FT[tFX̎擾									*/
/*    ́FȂ												*/
/*  o  ́FȂ                                                */
/*  ߂lFT[tFXATEXMNGATEXSYSɋ󂫂Ȃꍇ			*/
/*											NUD_TEX_STAT_ERR	*/
/*										NUD_TEX_STAT_READ	*/
/*  T@vFT[tFX擾AeNX`}l[Wg\̂*/
/*			ݒ肷											*/
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTextureReqGetSurface(void)
{
	Sint32 ret;
	
	ret = njEntryTextureManageNum(load_list,load_n,load_globalIndex,load_bank,&pvrh,&load_texmng_no);

	switch(ret){
	case 1:
		if(load_src == FILE_TYPE){
			gdFsClose(tex_loadreq_fp);
		}
		NEXT_MODE(NUD_TEX_MODE_OPEN);
		loop_mode = loop_false;
		return NUD_TEX_STAT_END;
		break;
	case 0:
		NEXT_MODE(NUD_TEX_MODE_LOAD);
		loop_mode = loop_true;
		return NUD_TEX_STAT_READ;
		break;
	case -1:
		/* 󂫂Ȃꍇ̓G[ŏI */
		if(load_src == FILE_TYPE){
			gdFsClose(tex_loadreq_fp);
		}
		/*********** G[R[hԂ ************/
		ERR_MODE(NJD_TEXERR_HEADER)
		return NUD_TEX_STAT_ERR;
		break;
	}

}

/****************************************************************/
/*  ֐FnuLoadTextureReqLoad					  		    */
/*  @  \FeNX`ւ̃[hiAj				*/
/*    ́FȂ												*/
/*  o  ́FȂ                                                */
/*  ߂lF[hG[					NUD_TEX_STAT_ERR	*/
/*										NUD_TEX_STAT_READ	*/
/*  T@vF													*/
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTextureReqLoad(void)
{
	Sint32 ret;
	
	if((ret = njLoadTexturePart(&_nj_texmanage[load_texmng_no].texsys->texsurface,read_start,file_offset,read_size)) == -1){
		/* eNX`[hG[@*/
		ERR_CLOSE
		/*********** G[R[hԂ ************/
		ERR_MODE(NJD_TEXERR_TEXMEMLOAD)
		return NUD_TEX_STAT_ERR;
	}

	file_offset += read_size;
	dma_count = 0;
	NEXT_MODE(NUD_TEX_MODE_LOADWAITDMA);
	loop_mode = loop_true;
	
	return NUD_TEX_STAT_READ;
}


/****************************************************************/
/*  ֐FnuLoadTextureReqLoadWaitDma				  		    */
/*  @  \F[h̏ImF									*/
/*    ́FȂ												*/
/*  o  ́FȂ                                                */
/*  ߂lFDMA_WAIT_ERR_COUNT񐔈ȏサĂIȂƂ		*/
/*											NUD_TEX_STAT_ERR	*/
/*			S[hĂȂƂ			NUD_TEX_STAT_READ	*/
/*			S[hƂ				NUD_TEX_STAT_END	*/
/*  T@vF													*/
/*  @lF֐                                            */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTextureReqLoadWaitDma(void)
{
	/* DMAI̊mF@*/
	loop_mode = loop_false;
	if(njLoadTextureFinishDMA()==1){
		dma_count = 0;
		if(r_sect_size <= 0){
			/* ׂẴ[hI@*/
			if(load_src == FILE_TYPE){
				gdFsClose(tex_loadreq_fp);
			}
			NEXT_MODE(NUD_TEX_MODE_OPEN);

			return NUD_TEX_STAT_END;
		}
		else{
			/* c肪̂Ŏ̃[hց@*/
			NEXT_MODE(NUD_TEX_MODE_FILEREAD);

			return NUD_TEX_STAT_READ;
		}
	}
	else{
		dma_count++;
		if(dma_count > DMA_WAIT_ERR_COUNT){
			/* DMA_WAIT_ERR_COUNT(10)񐔗Ă[hȂꍇ̓G[Ƃ*/
			ERR_CLOSE
			/*********** G[R[hԂ ************/
			ERR_MODE(NJD_TEXERR_OTHER)
			return NUD_TEX_STAT_ERR;
		}
		return NUD_TEX_STAT_READ;
	}

}

/****************************************************************/
/*  ֐FnuGetLoadTextureReqMode					  		    */
/*  @  \F݂̃[h̎擾									*/
/*    ́FȂ												*/
/*  o  ́FȂ                                                */
/*  ߂lF݂̃[h										*/
/*  T@vFG[̂Ƃ̊֐gpĂ߂łBG[	*/
/*			ꏊ͓ł܂								*/
/*  @lF			                                        */
/*                                                              */
/****************************************************************/
Sint32 nuGetLoadTextureReqMode(void)
{
	return _nu_loadtexreq_mode_;
}

/****************************************************************/
/*  ֐FnuLoadTextureReqStop					  		    */
/*  @  \FA[h֐̒~							*/
/*    ́FȂ												*/
/*  o  ́FȂ                                                */
/*  ߂lF@1 s@|P									*/
/*  T@vF													*/
/*  @lF			                                        */
/*                                                              */
/****************************************************************/
Sint32 nuLoadTextureReqStop(void)
{
	Sint32 ret;
	
	njInitTextureErrStat();

	_nu_loadtexreq_i_ = 0;
	if(_nu_loadtexreq_mode_ == NUD_TEX_MODE_LOADWAITDMA){
		_nu_loadtexreq_mode_ = NUD_TEX_MODE_OPEN;
		ret = gdFsStopRd(tex_loadreq_fp);
		gdFsClose(tex_loadreq_fp);
		if(ret != GDD_ERR_OK){
			_nj_texerr_.n = load_n;
			_nj_texerr_.gderr = ret;
			_nj_texerr_.texerr = NJD_TEXERR_OTHER;
			NEXT_MODE(NUD_TEX_MODE_OPEN);
			return -1;
		}
	}

	_nu_loadtexreq_mode_ = NUD_TEX_MODE_OPEN;
	NEXT_MODE(NUD_TEX_MODE_OPEN);

	return 1;
	
}
