/*
	Ninja Library
	
	COPYRIGHT (C) SEGA ENTERPRISES,LTD.

	Create 2000.03.01

*/
#include <Ninja.h>
#include <Njutil.h>

/****************************************************************/
/*  ֐FnuReLoadVQCodebookNum				                */
/*  @  \FVQR[hubÑ[h                            */
/*    ́FUint32 n											*/
/* 		    void *texaddr t@C or eNX`AhX*/
/*			Uint32 attr memory or file							*/
/*  o  ́FȂ                                                */
/*  ߂lFȂ				                                */
/*  T@vF                                                    */
/*  @lF                                                    */
/*                                                              */
/****************************************************************/
Sint32 nuReLoadVQCodebookNum(Uint32 n,void *texaddr,Uint32 attr)
{
	Sint8 *pTexture;
	char  filename[32];
	Sint8 *texbuf;
	Int texbuf_size;

	if(attr & NJD_TEXATTR_TYPE_MEMORY){
		pTexture = texaddr;
	}
	else{
		njCheckFileName(filename,(char*)texaddr,".PVR");
		nuGetTextureBuffer(&texbuf,&texbuf_size);

		if(nuTexFreadAll(filename,texbuf,texbuf_size) < 0){
			return -1;
		}
	
		pTexture = texbuf;
	}
	
	return njReLoadVQCBNum(n,pTexture);
}

/****************************************************************/
/*  ֐FnuReLoadVQCodebookNumG				                */
/*  @  \FVQR[hubÑ[h                            */
/*    ́FUint32 globalIndex									*/
/* 		    void *texaddr t@C or eNX`AhX*/
/*			Uint32 attr memory or file							*/
/*  o  ́FȂ                                                */
/*  ߂lFȂ				                                */
/*  T@vF                                                    */
/*  @lF                                                    */
/*                                                              */
/****************************************************************/
Sint32 nuReLoadVQCodebookNumG(Uint32 globalIndex,void *texaddr,Uint32 attr)
{
	Sint32 ret;
	Sint8 *pTexture;
	char  filename[32];
	Sint8 *texbuf;
	Int texbuf_size;
	

	if(attr & NJD_TEXATTR_TYPE_MEMORY){
		pTexture = texaddr;
	}
	else{
		njCheckFileName(filename,(char*)texaddr,".PVR");
		nuGetTextureBuffer(&texbuf,&texbuf_size);

		if(nuTexFreadAll(filename,texbuf,texbuf_size) < 0){
			return -1;
		}
		
		pTexture = texbuf;

	}
	
	return njReLoadVQCBNumG(globalIndex,pTexture);
}

