/*
	Ninja Library
	
	COPYRIGHT (C) SEGA ENTERPRISES,LTD.

	Create 2000.03.01

*/
#include <Ninja.h>
#include <Njutil.h>
#include <sg_gd.h>
#include <stdio.h>

#define READ_INIT		0
#define READ_WAIT		1
#define READ_WAIT_DMA	2
#define READ_END		3
#define READ_ERR		4

#define FILE_BUFFER		0
#define USER_BUFFER		1

#define NUD_FILE_BUFFER_SIZE	(2048+31)

#define CALC_SECT_BYTE(sect)	((sect) << 11)
#define CALC_BYTE_SECT(byte)	((byte) >> 11)
#define CALC_BUFFER_POS(byte)	((byte) & 0x000007FF)

Sint8   _nu_file_buffer[NUD_FILE_BUFFER_SIZE];		/* t@Cobt@					*/
GDFS _nu_file_ptr_;									/* t@C|C^					*/

Sint8 *_nu_buffer_st_ptr_;							/* t@Cobt@̐擪|C^	*/
Sint32 _nu_buffer_sect_;							/* t@Cobt@̐擪ZN^ɂ邩̈ʒu	*/
Sint32 _nu_buffer_sect_size_= NUD_FILE_BUFFER_SIZE/NJD_GD_SECT_SIZE;
													/* obt@̃ZN^TCY			*/
Sint32 _nu_buffer_size_ = CALC_BYTE_SECT(NUD_FILE_BUFFER_SIZE/NJD_GD_SECT_SIZE);
													/* obt@̃oCgTCY			*/
Sint32 _nu_buffer_r_sect_size_;						/* obt@Ƀ[hZN^TCY	*/
Sint32 _nu_buffer_r_size_;							/* obt@̎cĂoCgTCY	*/
Sint32 _nu_file_max_size_ = 0;						/* t@C̃TCY					*/
Sint32 _nu_sect_max_size_=0;						/* t@C̃ZN^TCY 			*/
Sint32 _nu_buffer_byte_ptr_ = 0;					/* obt@̉oCgڂɂ邩 	*/
Sint32 _nu_fread_request_flag_ = 0;					/* t@Cobt@Ƀ[h[Uobt@Ƀ[h̃tO */
Sint32 _nu_fread_status_ = 0;						/* ݂̃[ht@C̏	*/
Sint32 _nu_file_sect_ptr_ = 0;						/* t@C̃ZN^ʒu */
Sint32 _nu_file_byte_ptr_ = 0;						/* t@C̃oCgʒu@t@C̐擪̃oCg */
Sint32	_nu_fread_size_ = 0;							/* [hTCY						*/
void *_nu_fread_buf_ = NULL;							/* [h̃|C^				*/

Sint32 nuFReadRequestBuffer(Sint32 n);
void nuFReadStatus(void);

/****************************************************************/
/*  ֐FnuTexFopen											*/
/*  @  \Ft@C̃I[v									*/
/*    ́FSint8 *filename	t@C							*/
/*  o  ́FȂ												*/
/*  ߂lF@P@s@|P								*/
/*  T@vFt@C̃I[vBN[Y܂1̃t@C	*/
/*			I[vł܂B							*/
/*  @lF													*/
/*                                                              */
/****************************************************************/
Sint32 nuTexFopen(const char* filename)
{

	_nu_buffer_st_ptr_ = (Sint8*)(((Uint32)_nu_file_buffer + 0x1f) & 0xffffffe0);

	/* t@C̃I[v */
	if((_nu_file_ptr_ = gdFsOpen(filename,NULL))==NULL){
		_nj_texerr_.texerr = NJD_TEXERR_FILEOPEN;
		return -1;
	}
	
	if(gdFsGetFileSize(_nu_file_ptr_,&_nu_file_max_size_) == FALSE){
		_nj_texerr_.texerr = NJD_TEXERR_FILEOPEN;
		return -1;
	}
	
	/* ő剽ZN^邩vZĂ */
	_nu_sect_max_size_ = gdFsCalcSctSize(_nu_file_max_size_);

	/* obt@̐擪ʒu */
	_nu_buffer_byte_ptr_ = 0;
	/* t@C̈ʒu */
	_nu_file_byte_ptr_ = 0;
	_nu_file_sect_ptr_ = 0;

	/* obt@֘Aϐ̏ */
	_nu_buffer_sect_ = -1;
	_nu_buffer_r_sect_size_ = 0;
	_nu_buffer_r_size_ = 0;

	
	if(nuFReadRequestBuffer(0) < 0){
		return -1;
	}
	_nu_fread_status_ = READ_INIT;

	return 0;
}

/****************************************************************/
/*  ֐FnuTexFclose											*/
/*  @  \Ft@C̃N[Y									*/
/*    ́FȂ												*/
/*  o  ́FȂ												*/
/*  ߂lFȂ												*/
/*  T@vFnuTexFopenŃI[vt@CN[Y		*/
/*  @lF													*/
/*                                                              */
/****************************************************************/
void nuTexFclose(void)
{
	gdFsClose(_nu_file_ptr_);

}

/****************************************************************/
/*  ֐FnuFReadRequestBuffer								*/
/*  @  \Fw肳ꂽZN^[h						*/
/*    ́FSint32 n	ZN^									*/
/*  o  ́FȂ												*/
/*  ߂lF@P@s@|P								*/
/*  T@vFnuTexFopenŃI[vt@CN[Y		*/
/*  @lF֐											*/
/*                                                              */
/****************************************************************/
Sint32 nuFReadRequestBuffer(Sint32 n)
{
	Sint8 *start_buffer_ptr;
	Sint32 read_sect;
	Sint32 n0,m,d;
	
	if((n >= _nu_sect_max_size_) || ( n < 0)){
		return -1;
	}


	d = n / _nu_buffer_sect_size_;
	n0 = d * _nu_buffer_sect_size_;

	if(n0 != _nu_buffer_sect_){
		_nu_buffer_sect_ = n0;
		
		if(_nu_sect_max_size_ > (n0 + _nu_buffer_sect_size_)){
			_nu_buffer_r_sect_size_ = _nu_buffer_sect_size_;
			_nu_buffer_r_size_ = CALC_SECT_BYTE(_nu_buffer_r_sect_size_);
		}
		else{
			_nu_buffer_r_sect_size_ = _nu_sect_max_size_ - n0;
			_nu_buffer_r_size_ = _nu_file_max_size_ - CALC_SECT_BYTE(n0);
		}

		gdFsSeek(_nu_file_ptr_,n0,GDD_SEEK_SET);
		_nu_file_sect_ptr_ = n;

		if(gdFsReqRd32(_nu_file_ptr_,_nu_buffer_r_sect_size_,_nu_buffer_st_ptr_) < 0){
			NUM_FREAD_ERR(_nu_file_ptr_,NJD_TEXERR_FILELOAD)
			return -1;
		}
		_nu_fread_status_ = READ_WAIT_DMA;
		_nu_fread_request_flag_ = FILE_BUFFER;

	}
	
	return 0;
}

/****************************************************************/
/*  ֐FnuFReadRequest										*/
/*  @  \Fw肳ꂽZN^TCY[h				*/
/*    ́FSint32 n	ZN^									*/
/*  o  ́FȂ												*/
/*  ߂lF@P@s@|P								*/
/*  T@vFnuTexFopenŃI[vt@CN[Y		*/
/*  @lF֐											*/
/*                                                              */
/****************************************************************/
Sint32 nuFReadRequest(Sint32 n,Sint32 size)
{
	Sint32 read_sect;

	if((size >= NUD_FILE_BUFFER_SIZE) && (!((Uint32)_nu_fread_buf_ & 0x0000001F))){
	
		/* [hTCYNUD_FILE_BUFFER_SIZEȏ̏ꍇ */
		if((n >= _nu_sect_max_size_) || ( n < 0)){
			/* [hs */
			return -1;
		}

		read_sect = CALC_BYTE_SECT(size);
		if(_nu_file_sect_ptr_ != n){
			gdFsSeek(_nu_file_ptr_,n,GDD_SEEK_SET);
		}
		_nu_file_sect_ptr_ = n;
		if(gdFsReqRd32(_nu_file_ptr_,read_sect,_nu_fread_buf_) < 0){
			NUM_FREAD_ERR(_nu_file_ptr_,NJD_TEXERR_FILELOAD)
			return -1;
		}
		_nu_fread_status_ = READ_WAIT_DMA;
		_nu_fread_request_flag_ = USER_BUFFER;
		
	}
	else{
		/* ꍇ̓t@Cobt@֓] */
		return nuFReadRequestBuffer(n);
	}

	/* [h */
	return 0;

}

/****************************************************************/
/*  ֐FnuFReadStatus										*/
/*  @  \F[hXe[^X̃`FbN							*/
/*    ́FȂ												*/
/*  o  ́FȂ												*/
/*  ߂lFȂ												*/
/*  T@vF݂̏Ԃ_nu_fread_status_ɕԂ					*/
/*			READ_INIT:t@C܂[hĂȂ*/
/*			READ_WAIT:t@C[h						*/
/*			READ_END :t@C[hI						*/
/*			READ_ERR :t@C[hG[						*/
/*  @lF֐											*/
/*                                                              */
/****************************************************************/
void nuFReadStatus(void)
{
	Sint32 read_size;
	Sint32 ret;

	if(_nu_fread_status_ == READ_WAIT_DMA){
		ret = gdFsGetStat(_nu_file_ptr_);

		switch(ret){
		case GDD_STAT_COMPLETE:
			if(_nu_fread_request_flag_ == USER_BUFFER){
				/* [U[obt@ɒړ]ꍇ */
				read_size = gdFsGetNumRd(_nu_file_ptr_);
				_nu_fread_size_ -= read_size;
				_nu_file_byte_ptr_ += read_size;
				_nu_fread_buf_ = (void*)((Uint32)_nu_fread_buf_ + read_size);
				if(_nu_fread_size_ <= 0){
					_nu_fread_status_ = READ_END;
				}
				else{
					_nu_fread_status_ = READ_WAIT;
				}
			}
			else{
				/* t@Cobt@ɓ]ꍇ */
				_nu_fread_status_ = READ_WAIT;
				_nu_buffer_byte_ptr_ = 0;
			}
			break;
		case GDD_STAT_IDLE:
		case GDD_STAT_READ:
		case GDD_STAT_SEEK:
		case GDD_STAT_BUSY:
			break;
		case GDD_STAT_ERR:
			_nu_fread_status_ = READ_ERR;
		break;
		}
		
	}
	else{
		if(_nu_fread_status_ == READ_INIT){
			ret = gdFsGetStat(_nu_file_ptr_);

			switch(ret){
			case GDD_STAT_COMPLETE:
					/* t@Cobt@ɓ]ꍇ */
					_nu_fread_status_ = READ_END;
					_nu_buffer_byte_ptr_ = 0;
				break;
			case GDD_STAT_IDLE:
			case GDD_STAT_READ:
			case GDD_STAT_SEEK:
			case GDD_STAT_BUSY:
				break;
			case GDD_STAT_ERR:
				_nu_fread_status_ = READ_ERR;
			break;
			}
		}
	}
}


/****************************************************************/
/*  ֐FnuFReadCheckBuffer									*/
/*  @  \FZN^̃`FbN									*/
/*    ́FSint32 sect											*/
/*  o  ́FȂ												*/
/*  ߂lFȂ												*/
/*  T@vFsectt@Cobt@ɂ邩`FbN		*/
/*  @lF֐											*/
/*                                                              */
/****************************************************************/
Sint32 nuFReadCheckBuffer(Sint32 sect)
{
	Sint32 n0,n1;
	
	n0 = _nu_buffer_sect_;
	n1 = n0 + (_nu_buffer_r_sect_size_ - 1);
	if(n0 < 0){
		return -1;
	}
	if((n0 <= sect ) && (sect <= n1)){
		return 1;
	}
	else{
		return -1;
	}

}

/****************************************************************/
/*  ֐FnuTexFreadReq										*/
/*  @  \FÃoCg[h								*/
/*    ́FSint32 size	[hTCY							*/
/*  o  ́Fvoid *buf	[ȟ							*/
/*  ߂lF[hI@P	[h@O	[hG[@|P	*/
/*  T@vFnuTexFopenŃI[vt@C[h		*/
/*  @lF[hI܂ŉĂ						*/
/*                                                              */
/****************************************************************/
Sint32 nuTexFreadReq(void* buf,Sint32 size)
{
	Sint32 bsize;

	/* TCY0̏ꍇ */
	if(size == 0){
		return 1;
	}

	/* t@C̏Ԃ擾 */
	nuFReadStatus();
	
	switch(_nu_fread_status_){
	case READ_WAIT_DMA:
		return 0;
		break;
	case READ_END:
		_nu_fread_size_ = size;
		_nu_fread_buf_ = buf;
		_nu_fread_status_ = READ_WAIT;
	case READ_WAIT:
		while(_nu_fread_status_ != READ_END){
			/* t@C̃TCY傫TCYw肵ꍇ */
			if(_nu_file_max_size_ < (_nu_file_byte_ptr_+_nu_fread_size_)){
				/* t@CTCY̓[h */
				_nu_fread_size_ = _nu_file_max_size_ - _nu_file_byte_ptr_;
			}
		
			/* t@C|C^ZN^ڂɂ邩vZ */
			_nu_file_sect_ptr_ = CALC_BYTE_SECT(_nu_file_byte_ptr_);
			/* t@C|C^obt@̉oCgڂɂ邩vZ */
			_nu_buffer_byte_ptr_ = CALC_BUFFER_POS(_nu_file_byte_ptr_);

			if(_nu_file_sect_ptr_ > _nu_sect_max_size_){
				NUM_FREAD_ERR(_nu_file_ptr_,NJD_TEXERR_FILELOAD)
				return -1;
			}
			
			/* obt@ɂ邩ׂ */
			if(nuFReadCheckBuffer(_nu_file_sect_ptr_) > 0){
				/* Cobt@ɂׂĂꍇ */
				if(_nu_fread_size_ <= (_nu_buffer_r_size_ - _nu_buffer_byte_ptr_)){
					syMemCopy(_nu_fread_buf_,(void*)((Uint32)_nu_buffer_st_ptr_+_nu_buffer_byte_ptr_),_nu_fread_size_);
					_nu_file_byte_ptr_ += _nu_fread_size_;
					_nu_fread_size_ = 0;
					_nu_fread_buf_ = NULL;
					_nu_fread_status_ = READ_END;
					/* t@C|C^ZN^ڂɂ邩vZ */
					_nu_file_sect_ptr_ = CALC_BYTE_SECT(_nu_file_byte_ptr_);
					/* t@C|C^obt@̉oCgڂɂ邩vZ */
					_nu_buffer_byte_ptr_ = CALC_BUFFER_POS(_nu_file_byte_ptr_);
					/* S[hĂ܂Ƃ */
					if(_nu_buffer_byte_ptr_ == 0){
						/* ̃ZN^[h*/
						if(_nu_file_sect_ptr_ < _nu_sect_max_size_){
							nuFReadRequestBuffer(_nu_file_sect_ptr_);
							_nu_fread_status_ = READ_INIT;
						}
					}
					return 1;
				}
				else{
					/* obt@ɂׂđ݂Ȃꍇ */
					/* obt@ɂ邾Rs[ */
					bsize = (_nu_buffer_r_size_ - _nu_buffer_byte_ptr_);
					syMemCopy(_nu_fread_buf_,(void*)((Uint32)_nu_buffer_st_ptr_+_nu_buffer_byte_ptr_),bsize);
					_nu_file_byte_ptr_ += bsize;
					_nu_fread_size_ -= bsize;
					_nu_fread_buf_ = (void*)((Uint32)_nu_fread_buf_ + bsize);
				}
			}
			else{
				/* ǂɂȂꍇ@[h */
				return nuFReadRequest(_nu_file_sect_ptr_,_nu_fread_size_);
			}
		}
		break;
		case READ_INIT:
			return 0;
		break;
		case READ_ERR:
			NUM_FREAD_ERR(_nu_file_ptr_,NJD_TEXERR_FILELOAD)
			return -1;
		break;
	}
}

/****************************************************************/
/*  ֐FnuTexFread											*/
/*  @  \FÃoCg[h								*/
/*    ́FSint32 size	[hTCY							*/
/*  o  ́Fvoid *buf	[ȟ							*/
/*  ߂lFPF[hI	|PF[hG[					*/
/*  T@vFnuTexFopenŃI[vt@C[h		*/
/*  @lFA֐I܂ő҂						*/
/*                                                              */
/****************************************************************/
Sint32 nuTexFread(void* buf,Sint32 size)
{
	Sint32 ret = 0;
	
	while(ret == 0){
		ret = nuTexFreadReq(buf,size);
		if(ret < 0) return -1;
	}

	return 1;
}

/****************************************************************/
/*  ֐FnuTexFseek											*/
/*  @  \Ft@C̃V[N									*/
/*    ́FSint32 size	[hTCY							*/
/*			Int	type	SEEK_CURASEEK_SETASEEK_END			*/
/*  o  ́FȂ												*/
/*  ߂lFȂ												*/
/*  T@vF													*/
/*  @lF													*/
/*                                                              */
/****************************************************************/
void nuTexFseek(Sint32 size,Int type)
{
	switch(type){
	case SEEK_CUR:
		_nu_file_byte_ptr_ += size;
		break;
	case SEEK_SET:
		_nu_file_byte_ptr_ = size;
		break;
	case SEEK_END:
		_nu_file_byte_ptr_ = (_nu_file_max_size_ - size);
		break;
	}
}

/****************************************************************/
/*  ֐FnuTexFreadAll										*/
/*  @  \Ft@CS[h							*/
/*    ́Fconst char *filename	[ht@C			*/
/*			void *buf				[h					*/
/*			Int	size				[h̃obt@TCY	*/
/*  o  ́FȂ												*/
/*  ߂lF@P@s@|P								*/
/*  T@vF													*/
/*  @lF													*/
/*                                                              */
/****************************************************************/
Sint32 nuTexFreadAll(const char *filename,void *buf,Int size)
{
	GDFS	fp;
	Sint32	file_sect_size;
	Sint32	buff_sect_size;

	njInitTextureErrStat();

	if((fp = gdFsOpen(filename,NULL)) == NULL){
		/* t@CI[vG[@*/
		_nj_texerr_.texerr = NJD_TEXERR_FILEOPEN;
		return -1;
	}
	
	gdFsGetFileSctSize(fp,&file_sect_size);
	buff_sect_size = CALC_BYTE_SECT(size); 
	if(buff_sect_size < file_sect_size){
		_nj_texerr_.texerr = NJD_TEXERR_MAINMEMORY;
		gdFsClose(fp);
		return -1;
	}
	if(gdFsRead(fp,file_sect_size,buf) != GDD_ERR_OK){
		_nj_texerr_.texerr = NJD_TEXERR_FILELOAD;
		gdFsClose(fp);
		return -1;
	}
	gdFsClose(fp);

	return 1;
}
