#ifndef _FNTDISP_H_
#include <shinobi.h>

#define KANJI_BUFF_W    (32)		/* width of texture buffer: 2^n */
#define KANJI_BUFF_H    (32)		/* height of texture buffer: 2^n */
#define KANJI_BUFF_SIZE (KANJI_BUFF_W*KANJI_BUFF_H*2)	/* size of texture buffer for KANJI */

typedef struct SMS_FNT_MODE_TAG {
	Sint16 code;
	Sint16 currentCode;
	Sint32 cursor;
	Sint32 currentDrawIndex;
	SYE_BT_FNT_FONTSET currentFontset;
	Sint32 mode;
	void *bootRomAddr;
	SYE_BT_FNT_FONTSET fontset;
} SMS_FNT_MODE_OBJ, *SMS_FNT_MODE;

enum {
	SMD_FNT_MODE_INIT,
	SMD_FNT_MODE_CHANGE,
	SMD_FNT_MODE_STATIC,
	SMD_FNT_MODE_FLIP,
	SMD_FNT_MODE_MAX
};

void initFntMode( SMS_FNT_MODE fntMode );
void initFontTexture( void );
void chooseFont( SMS_FNT_MODE fntMode );
void displayFont( SMS_FNT_MODE fntMode );


#endif /* _FNTDISP_H_ */