/********************************************************************
 *  Shinobi Library Sample
 *  Copyright (c) 1998-2000 SEGA
 *
 *  Library : Backup Library
 *  Module  : Library Sample
 *  File    : buptest.c
 *  Date    : 2000-02-09
 *  Version : 2.00
 *
 ********************************************************************/

#include <shinobi.h>
#include <ninja.h>
#include "nj.h"
#include "backup.h"


/*-------------------------------------------------------------------------*/
/* }N` */


/*-------------------------------------------------------------------------*/
/* O[oϐ錾 */

/*-------------------------------------------------------------------------*/
/* X^eBbNϐ錾 */

/*-------------------------------------------------------------------------*/
/* X^eBbN֐vg^Cv */
static void DispBackupRAMInfo(Sint32 x, Sint32 y, Sint32 drive);

/*-------------------------------------------------------------------------*/
/*  */
void bup_init(void)
{
	BupInit();
}

/*-------------------------------------------------------------------------*/
/* I */
void bup_exit(void)
{
	BupExit();
}

/*-------------------------------------------------------------------------*/
/* C */
void bup_main(void)
{
	Sint32 drive;
	Sint32 x, y;

	x = 2;
	y = 2;
	for (drive = 0; drive < 8; drive++) {
		y = drive * 2 + 6;
		DispBackupRAMInfo(x, y, drive);
	}

	/* [J[hɏݒł΃\tgZbg֎~ɂ */
	bExitEnable = !BupIsWriting();
}


/*===============================================================*/
/* [J[h̏Ԃ\                                */
/* ڑĂȂ΁u---vAtH[}bgĂȂ   */
/* uUNFORMATvAtH[}bgĂꍇ͋󂫗eʂƍő    */
/* eʂ\܂B                                            */
/* Display information of memory card.                           */
/* If memory card is not connected, "---" is displayed.          */
/* If memory card is not formatted, "UNFORMAT", is displayed.    */
/* if memory card is formatted, free volume and maximum volume   */
/* is displayed.                                                 */
/*===============================================================*/

static void DispBackupRAMInfo(Sint32 x, Sint32 y, Sint32 drive)
{
	const BACKUPINFO* binfo;
	BUS_DISKINFO* diskinfo;

	binfo = BupGetInfo(drive);
	diskinfo = &binfo->DiskInfo;

	njPrint(NJM_LOCATION(x, y), "MEMORY CARD #%d",drive);

	if (binfo->Ready) {
		if (binfo->IsFormat) {
			njPrint(NJM_LOCATION(x + 15, y), "%04d/%04d BLOCKS",
				diskinfo->free_user_blocks,
				diskinfo->total_user_blocks);
		} else {
			njPrint(NJM_LOCATION(x + 15, y), "UNFORMAT        ");
		}
	} else {
		if (binfo->Operation == BUD_OP_MOUNT) {
			njPrint(NJM_LOCATION(x + 15, y), "CHECKING...     ");
		} else {
			njPrint(NJM_LOCATION(x + 15, y), "----------------");
		}
	}
}

/*-------------------------------------------------------------------------*/

