/********************************************************************
 *  Shinobi Library Sample
 *  Copyright (c) 1998-2000 SEGA
 *
 *  Library : Backup Library
 *  Module  : Library Sample Header
 *  File    : backup.h
 *  Date    : 2000-02-09
 *  Version : 2.00
 *
 ********************************************************************/

#ifndef _BACKUP_H_
#define _BACKUP_H_

#include <shinobi.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/******** R[obN֐ *************************************************/
/******** Callback function ************************************************/
typedef void (*BUPFUNC)(Sint32 drive, Sint32 op, Sint32 stat);

/******** J[h\ *******************************************/
/******** Memory card information structure ********************************/
typedef struct {
	Uint16 Ready;               /* J[hڑĂ邩          */
	                            /* Is memory card connected ?              */
	Uint16 IsFormat;            /* tH[}bgĂ邩ǂ          */
	                            /* Is memory card formatted ?              */
	Uint32 LastError;           /* ŌɔG[R[h              */
	                            /* Error code which occured last.          */
	Uint32 ProgressCount;       /* o߃JEg                        */
	                            /* Operation progress count.               */
	Uint32 ProgressMax;         /* o߃JEgő                    */
	                            /* Operattion progress count maximum.      */
	Uint32 Operation;           /* ̃Iy[VR[h            */
	                            /* Operation code in handling now.         */
	BUS_DISKINFO DiskInfo;      /* hCu                            */
	                            /* Drive information.                      */
	BUPFUNC func;               /* R[obN֐                        */
	                            /* Callback function                       */
} BACKUPINFO;



void BupInit(void);
void BupExit(void);
const BACKUPINFO* BupGetInfo(Sint32 drive);
const char* BupGetErrorString(Sint32 err);
const char* BupGetOperationString(Sint32 op);
Sint32 BupLoad(Sint32 drive, const char* fname, void* buf, BUPFUNC func);
Sint32 BupSave(Sint32 drive, const char* fname, void* buf,
											Sint32 nblock, BUPFUNC func);
Sint32 BupDelete(Sint32 drive, const char* fname, BUPFUNC func);
Sint32 BupIsWriting(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _BACKUP_H_ */

/******************************* end of file *******************************/
