#ifndef _GUN_H_
#define _GUN_H_

#include <shinobi.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define GUN_A            0  /* Gun Controller A                            */
#define GUN_B            1  /* Gun Controller B                            */
#define GUN_C            2  /* Gun Controller C                            */
#define GUN_D            3  /* Gun Controller D                            */

#define GUN_VGA          0  /* VGA                                         */
#define GUN_NTSC_640x480 1  /* NTSC 640x480                                */
#define GUN_NTSC_320x240 2  /* NTSC 320x240                                */

#define GUN_RAPID_OFF    0  /* A˃[hOFF                               */
#define GUN_RAPID_ON     1  /* gKĂԘA                  */
#define GUN_RAPID_AUTO   2  /* gKĂȂĂA              */

/******** K\ ***************************************************/
/******** Gun information structure ****************************************/
typedef struct {
	Sint32 IsGun;           /* KڑĂ邩ǂ                */
	                        /* Is gun connected ?                          */
	Sint32 OnScreen;        /* KʓĂ邩                  */
	                        /* Does the muzzle point to the inside of      */
	                        /* a screen ?                                  */
	Sint32 x, y;            /* KW                                    */
	                        /* Gun position                                */
	Sint32 rawX, rawY;      /* KW(f[^)                          */
	                        /* Gun position(raw data)                      */
	Sint32 trigger;         /* gK                                  */
	                        /* Is the trigger pressed ?                    */
} GUNINFO;

/******** KW␳pp[^ *****************************************/
/******** Gun position adjust parameter.                                   */
typedef struct {
	Sint32 min;             /* Wŏl                                  */
	                        /* Minimum position                            */
	Sint32 cen;             /* Wl                                  */
	                        /* Center position                             */
	Sint32 max;             /* Wől                                  */
	                        /* Maximum position                            */
} GUNADJ;


void GunInit(Sint32 tvmode, Sint32 gunmode);
void GunSetPort(Sint32 gunmode);
void GunMain(void);
void GunExit(void);
const GUNINFO* GunGetInfo(Uint32 port);
void GunSetRapid(Sint32 gunno, Sint32 flag);
void GunAdjust(Sint32 gunno, const GUNADJ* adjx, const GUNADJ* adjy,
									const GUNADJ* scrx, const GUNADJ* scry);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _GUN_H_ */
