/*---------------------------------------------------------------------------
  Shinobi Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	<Ninja.h>
#include	"Nj.h"

/*-------------------------------------------------------------------------*/
void PrintPeripheralInfo(Sint32 x, Sint32 y, Uint32 port);

/*-------------------------------------------------------------------------*/
Uint32 gFrameCount;

/*---------------------------------------------------------------------------
		
		initialize
---------------------------------------------------------------------------*/
Sint32	UserInit(void)
{
	gFrameCount = 0;
	njSetBackColor(0x00004080, 0x00004080, 0x004080);

	/* L[{[hCu  */
	/* Initialize keyboard library */
	pdKbdInit();

	return USER_CONTINUE;
}

/*---------------------------------------------------------------------------
		I
		exit
---------------------------------------------------------------------------*/
Sint32	UserExit(void)
{
	/* L[{[hCuI  */
	/* Finalize keyboard library */
	pdKbdExit();

	return USER_CONTINUE;
}

/*---------------------------------------------------------------------------
		C
		main
---------------------------------------------------------------------------*/
Sint32	UserMain(void)
{
	const PDS_KEYBOARD* kbd;

	njPrintC(NJM_LOCATION(2, 2), "KEYBOARD SAMPLE #1");
	njPrintH(NJM_LOCATION(30, 2), gFrameCount, 8);

	/* L[{[hf[^擾       */
	/* Get data from the keyboard */
	kbd = pdKbdGetData(PDD_PORT_D0);

	if (kbd) {
		njPrint(NJM_LOCATION(2, 4),
				"CONTROL=%02X LED=%02X", kbd->ctrl, kbd->led);
		njPrint(NJM_LOCATION(2, 5),
				"DATA=%02X %02X %02X %02X %02X %02X",
				kbd->key[0], kbd->key[1], kbd->key[2],
				kbd->key[3], kbd->key[4], kbd->key[5]);
		if (kbd->ctrl & PDD_KEY_CTRL_LGUI) {
			njPrintC(NJM_LOCATION(2, 8), "LEFT GUI");
		}
		if (kbd->ctrl & PDD_KEY_CTRL_LALT) {
			njPrintC(NJM_LOCATION(2, 9), "LEFT ALT");
		}
		if (kbd->ctrl & PDD_KEY_CTRL_LSHIFT) {
			njPrintC(NJM_LOCATION(2, 10), "LEFT SHIFT");
		}
		if (kbd->ctrl & PDD_KEY_CTRL_LCTRL) {
			njPrintC(NJM_LOCATION(2, 11), "LEFT CTRL");
		}
		if (kbd->ctrl & PDD_KEY_CTRL_RGUI) {
			njPrintC(NJM_LOCATION(14, 8), "RIGHT GUI");
		}
		if (kbd->ctrl & PDD_KEY_CTRL_RALT) {
			njPrintC(NJM_LOCATION(14, 9), "RIGHT ALT");
		}
		if (kbd->ctrl & PDD_KEY_CTRL_RSHIFT) {
			njPrintC(NJM_LOCATION(14, 10), "RIGHT SHIFT");
		}
		if (kbd->ctrl & PDD_KEY_CTRL_RCTRL) {
			njPrintC(NJM_LOCATION(14, 11), "RIGHT CTRL");
		}
	} else {
		njPrintC(NJM_LOCATION(2, 6), "CONNECT KEYBOARD TO PORT D");
	}

	gFrameCount++;

	return USER_CONTINUE;
}


/*-------------------------------------------------------------------------*/
