/*---------------------------------------------------------------------------
  Shinobi Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	<Ninja.h>
#include	"Nj.h"


/*===============================================================*/
/* 荞݂Ńpbhf[^擾邽߂̃obt@                */
/* Data buffer to get the peripheral data by interrupt.          */
/*===============================================================*/
PDS_PERIPHERAL PadBuf[4];

void PadIntFunc(void);
void PrintPeripheralInfo(Sint32 x, Sint32 y, const PDS_PERIPHERAL* per);
/*-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
Uint32 gFrameCount;

/*---------------------------------------------------------------------------
		
		initialize
---------------------------------------------------------------------------*/
Sint32	UserInit(void)
{
	gFrameCount = 0;
	njSetBackColor(0x00004080, 0x00004080, 0x004080);

	memset(PadBuf, 0, sizeof(PadBuf));

	/* 荞݊֐̓o^            */
	/* Register an interrupt handler */
	pdSetIntFunction(PadIntFunc);

	return USER_CONTINUE;
}

/*---------------------------------------------------------------------------
		I
		exit
---------------------------------------------------------------------------*/
Sint32	UserExit(void)
{
	return USER_CONTINUE;
}

/*---------------------------------------------------------------------------
		C
		main
---------------------------------------------------------------------------*/
Sint32	UserMain(void)
{
	njPrintC(NJM_LOCATION(4,  2), "PERIPHERAL INTERRUPT SAMPLE");
	njPrintH(NJM_LOCATION(34,  2), gFrameCount, 4);

	PrintPeripheralInfo( 2,  4, &PadBuf[0]);
	PrintPeripheralInfo(22,  4, &PadBuf[1]);
	PrintPeripheralInfo( 2, 17, &PadBuf[2]);
	PrintPeripheralInfo(22, 17, &PadBuf[3]);

	gFrameCount++;

	return USER_CONTINUE;
}



/*===============================================================*/
/* Rg[f[^擾(荞݃nh)                    */
/* Get the controller data (Interrupt handler)                   */
/*   EpdGetPeripheralDirect()gp邱ƂɂAŏ */
/*     CeVŃRg[f[^擾邱Ƃł܂B  */
/*   ]pdGetPeripheral()gpĂAf[^     */
/*     Õt[̂̂ƂȂ܂̂ŒӂĂB        */
/*===============================================================*/

void PadIntFunc(void)
{
	pdGetPeripheralDirect(PDD_PORT_A0, &PadBuf[0], NULL, NULL);
	pdGetPeripheralDirect(PDD_PORT_B0, &PadBuf[1], NULL, NULL);
	pdGetPeripheralDirect(PDD_PORT_C0, &PadBuf[2], NULL, NULL);
	pdGetPeripheralDirect(PDD_PORT_D0, &PadBuf[3], NULL, NULL);

/*
	mdmWrite(hMdm, &PadBuf[0], sizeof(PadBuf[0]));
	mdmWrite(hMdm, &PadBuf[1], sizeof(PadBuf[1]));
	mdmWrite(hMdm, &PadBuf[2], sizeof(PadBuf[2]));
	mdmWrite(hMdm, &PadBuf[3], sizeof(PadBuf[3]));
*/

}

/*---------------------------------------------------------------------------
		ytF̕\
		print peripheral info
---------------------------------------------------------------------------*/
void PrintPeripheralInfo(Sint32 x, Sint32 y, const PDS_PERIPHERAL* per)
{
	njPrintC(NJM_LOCATION(x, y +  0), "SUPPORT:");
	njPrintC(NJM_LOCATION(x, y +  1), "ON     :");
	njPrintC(NJM_LOCATION(x, y +  2), "OFF    :");
	njPrintC(NJM_LOCATION(x, y +  3), "PRESS  :");
	njPrintC(NJM_LOCATION(x, y +  4), "RELEASE:");
	njPrintC(NJM_LOCATION(x, y +  5), "R      :");
	njPrintC(NJM_LOCATION(x, y +  6), "L      :");
	njPrintC(NJM_LOCATION(x, y +  7), "X1     :");
	njPrintC(NJM_LOCATION(x, y +  8), "Y1     :");
	njPrintC(NJM_LOCATION(x, y +  9), "X2     :");
	njPrintC(NJM_LOCATION(x, y + 10), "Y2     :");

	x += 8;
	njPrintH(NJM_LOCATION(x, y), per->support, 8);
	njPrintH(NJM_LOCATION(x, y + 1), per->on, 8);
	njPrintH(NJM_LOCATION(x, y + 2), per->off, 8);
	njPrintH(NJM_LOCATION(x, y + 3), per->press, 8);
	njPrintH(NJM_LOCATION(x, y + 4), per->release, 8);
	njPrintD(NJM_LOCATION(x + (per->r  >= 0), y + 5), per->r, 5);
	njPrintD(NJM_LOCATION(x + (per->l  >= 0), y + 6), per->l, 5);
	njPrintD(NJM_LOCATION(x + (per->x1 >= 0), y + 7), per->x1, 5);
	njPrintD(NJM_LOCATION(x + (per->y1 >= 0), y + 8), per->y1, 5);
	njPrintD(NJM_LOCATION(x + (per->x2 >= 0), y + 9), per->x2, 5);
	njPrintD(NJM_LOCATION(x + (per->y2 >= 0), y + 10), per->y2, 5);
}

/*-------------------------------------------------------------------------*/
