/*---------------------------------------------------------------------------
  Shinobi Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.
---------------------------------------------------------------------------*/

#include	<shinobi.h>
#include	<Ninja.h>
#include	"Nj.h"

/*-------------------------------------------------------------------------*/
void DrawLcdImageToScreen(Sint32 x, Sint32 y, const Uint8* data);
void DrawLcd(Uint32 port);

/*-------------------------------------------------------------------------*/
Uint32 gFrameCount;
extern const Uint8 cgdata[];

/*---------------------------------------------------------------------------
		
		initialize
---------------------------------------------------------------------------*/
Sint32	UserInit(void)
{
	gFrameCount = 0;
	njSetBackColor(0x00004080, 0x00004080, 0x004080);
	njPrintSize(8);

	return USER_CONTINUE;
}

/*---------------------------------------------------------------------------
		I
		exit
---------------------------------------------------------------------------*/
Sint32	UserExit(void)
{
	return USER_CONTINUE;
}

/*---------------------------------------------------------------------------
		C
		main
---------------------------------------------------------------------------*/
Sint32	UserMain(void)
{
	njPrintC(NJM_LOCATION(4,  2), "LCD SAMPLE #1");
	njPrintH(NJM_LOCATION(30,  2), gFrameCount, 8);

	/* tڑĂ邩ǂׂ */
	/* Is Visual Memory LCD connected ?   */
	if (!pdVmsLcdIsReady(PDD_PORT_A1)) {
		njPrintC(NJM_LOCATION(18, 50),
				"PLEASE CONNECT VISUAL MEMORY TO PORT A-1.");
	} else {
		njPrintC(NJM_LOCATION(21, 50),
				"PRESS UP-DOWN KEY TO MOVE LCD GRAPHIC.");
		DrawLcd(PDD_PORT_A1);
	}


	gFrameCount++;

	return USER_CONTINUE;
}


/*===============================================================*/
/* ʂւ̕\                                                  */
/* Display LCD image to screen.                                  */
/*===============================================================*/

void DrawLcdImageToScreen(Sint32 x, Sint32 y, const Uint8* data)
{
	Sint32 i, j;

	for (i = 0; i < 32; i++) {
		for (j = 0; j < 48; j++, data++) {
			if (*data & 0x08) {
				njPrintC(NJM_LOCATION(x + j, y + i), "O");
			} else {
				njPrintC(NJM_LOCATION(x + j, y + i), " ");
			}
		}
	}
}


/*===============================================================*/
/* tւ̕\                                                  */
/* Display LCD.                                                  */
/*===============================================================*/

void DrawLcd(Uint32 port)
{
	const PDS_PERIPHERAL* per;
	static Sint32 ofs = 0;
	Sint32 ret;
	Uint32 dir, flag;

	per = pdGetPeripheral(PDD_PORT_A0);

	if (per->on & PDD_DGT_KU) ofs -= 48;
	if (per->on & PDD_DGT_KD) ofs += 48;

	if (ofs < 0) ofs = 0;
	if (ofs > 48 * (256 - 32)) ofs = 48 * (256 - 32);

	/* ť𒲂ׂ        */
	/* Get the direction of LCD. */
	dir = pdLcdGetDirection(port);

	switch (dir) {
		case PDD_LCD_DIRECTION_NORMAL:
			njPrintC(NJM_LOCATION(34, 46), "DIRECTION:NORMAL");
			flag = PDD_LCD_FLAG_NOFLIP;
			break;
		case PDD_LCD_DIRECTION_FLIP:
			njPrintC(NJM_LOCATION(34, 46), "DIRECTION:FLIP");
			flag = PDD_LCD_FLAG_HVFLIP;
			break;
		case PDD_LCD_DIRECTION_LEFT:
			njPrintC(NJM_LOCATION(34, 46), "DIRECTION:LEFT");
			flag = PDD_LCD_FLAG_NOFLIP;
			break;
		case PDD_LCD_DIRECTION_RIGHT:
			njPrintC(NJM_LOCATION(34, 46), "DIRECTION:RIGHT");
			flag = PDD_LCD_FLAG_NOFLIP;
			break;
	}

	/* tɃf[^𑗂(2INT1) */
	/* Send data to LCD.(One time per 2 frames) */
	if (gFrameCount & 1) {
		ret = pdVmsLcdWrite(port, &cgdata[ofs], flag);
		if (ret != PDD_LCDERR_OK) {
			njPrintC(NJM_LOCATION(30, 22), "LCD ERROR");
		}
	}
	DrawLcdImageToScreen(16, 8, &cgdata[ofs]);
}

/*-------------------------------------------------------------------------*/
